c =============================================================================================================
c     Martin Groenewegen 7-8 July 2009
c     include DUSTY within minimisation routine
c     version 1; standard DUSTY with fitting to SED and SPECTRA
c     based on earlier version based on MG own radiative transfer code.

c     MG 8-14 July 2009
c     version 2
c     -include fitting to INTENSITY DISTRIBUTION. A plot is made.
c     -added 'distribution of hollow spheres' DHS calculation of Qabs/Qsca
c      (search for "dhs" and uncomment the choice between exact Mie theory
c       of spherical particles, or DHS.
c       The maximuum vacuum volume fraction is hardcoded in subr. dhs.    Search for "fmax= ")
c     -read file of stellar atmosphere model from inputfile, and
c      transfer Teff to variable InpStar (generic value was 10000 K when not Blackbody !!).

c     MG 16-27 July 2009
c     version 3 (made when working specifically on CW Leo)
c     -changed format for submm/mm fluxes. Input data expected in milli-Jy.
c      actual computations in 10log(flux).
c     -added format SWS/LWS spectra in readspec (IC=2)
c     -added single grain size as 4th fit parameter.
c     -added new filters to PSCfoldORIG (zeropoints calibrated externally).
c     -made PlotMyDusty.f to plot SED and spectra. Zeropoints have to be in sync with PSCfoldORIG
c     -compute and write to file (.itbc) the absolute numbers of the
c      convoled intensity distributions, and compute the deconvolved FWHM.
c     -imposed maxima to Qabs and Qsca for DHS distribution for large (2 pi a/lambda) values.
c     -corrected the definition and implementation of the BIC (Bayesian Information Criteria).
c     -corrected a bug in v1,2,3. Use a new common block PARAMS, and clean-ed up NEEDED.
c
c     29.07.09 after correcting a bug in the DUSTY visibility calculation,
c              and re-checking with v1 and v2 for object MSXLMC1308 (qabsdustytest, Rout= 41)
c
c     (In version 3 the minimalisation of the intensity curve data is actually not correct,
c      as the value of the angular diameter used is not consistent with the actual model value
c      in that iteration)


c     MG  version 4
c     -31.07: added format IRAS LRS spectra in readspec (IC=3)
c     -06.08: changed format for IC=2 (read in error bar as well) in readspec
c     -07.08: write outer radius in arcmin to final .inp file
c     -09.08: intensity distribution: integrate surface brightness over finite pixel size.
c                                   [Needs further testing on more observed intensity distributions.]
c                    [Implemented for fitting is still the old way of calculation (search on 09.08).]
c     -09.08: added power of density distribution (pp) as input parameter
c     -10.08: arbitrary number of powerlaws with transition radii ( pp(npow), Router(npow) )
c     -10.08: added PACS and SPIRE filters       [FILTERCURVES AND CALIBRATION NEED UPDATING]
c     -10.08: read in Qabs/Qsca file directly    [will render a(4) = grain size irrelevant parameter]
c     -17.08: write Stellar radius in units of Rsun and in mas to final .inp file
c     -22.08: based on AFGL190, introduced minimum error of 3% for IC=2 type spectra

c     MG  version 5
c     -24.08: PACS filters and calibration updated (Lambda_eff= 68.8 /97.3/ 153.1)
c      sed -e  's/ 70./ 69./g' int_afgl2343.dat | sed -e  's/160./153./g' | sed -e  's/100\./ 98./g' > tmp
c      mv tmp int_afgl2343.dat
c
c     -26.08: Added convolution with Bessell function
c             (see ConvertGaussBessell.ksh & int_*.dat.gaussian and .bessell files)

c     MG  version 6
c     -27.08: Add jumps in powerlaw density distributions.
c             Depending on level of jumps, "EtaRat" has to be set to large value.
c             Add additional points in Ygrid routine.

c             Visualisation of NORMALISED density structure, in IDL: readcol,'aqand.rtb',off,eta

c                                                                   plot, off,eta,/ylog,/xlog,xrange=[1000,5000]

c     MG  version 7
c     -30.09: Changed the way Theta1 is passed so that minimalisation over I(r) is correct


c     MG  version 8
c     -02.10: add the fitting to visibility curves
c     -05 10: apply proper scaling of Theta1 to visibility curve
c     -06.10: allow for limited FOV of telescopes

c     MG  version 9
c     -07.10: use r^-n, with n as 4th fit parameter.
c     -07.10: use minimum wavelength (wavecut) in the phot&spectral fitting, based on condition Qsca >= Qabs,
c             or, use hard coded value .

c     MG  version 10
c     -09.10: grain size as fifth parameter
c     -13.10: BB temp as sixth parameter
c             Back to Gaussian PSF
c     -16.10+21.10: bug corrected in readint (corrected in versions 7,8,9,10)
c     -20.10: bug corrected in makedusty when NO visibilities NOR intensity profiles (corrected in versions 7,8,9,10)

c     MG 11.08.2010 took exisitng latest version (renamed as level 10) as basis ==> go back to version 9 level
c     - 12.08  REMOVED the   "if (nns .ne. 0 .or. nnv .ne. 0) then"  block
c     - 13.08  Put the 'if then' back in, but changed the 'then' part
c     - 23.08  modelatmos set to character*200
c     - 23.08  set wavecut= 0.4 (because of ARINGER models)

c     MyDustyPLATO.f version of 13 Aug
c     -without visibility, and intensity, without PGPLOT
c     -on PLATO:   change martin/ to marting/
c     -Aug 30-31, Sep 1: converted to DOUBLE PRECISION ....
c     -Sep 1: ifort on PLATO with -O:  caught 'unprotected' sqrt

c     MG  version 11: back from MyDustyPLATO.f with PGPLOT, visib and intensity
c     -05.09: bug! dydai => dydav [also correced in MyDustyPLATO]
c     -28.09: when observed Intensity has radii larger than convolved: added "if (xint(k) .gt. off(ni)) l= ni-1"
c     -29.09: added an inset in the final intensity plot, highlighting small normalised intensities.
c     -08.10:  some debugging of plotting the inset.
c     -08.10: increase 'nh' and 'ncav' for low temperatues. Changed Pgrid distribution 'expn' (search MG 08.10)
c     -09.10: a(4) NO LONGER FITTED AS LOGARITHMIC QUANTITY! to allow r^(positive)==> r^(- (negative a(4)))
c     -04.11: added VISTA filters [REMINDER: add new filters at the END OF THE LIST in file 41 !]
c     -05.11: caught the case when rel_max was NaN; force 10x more points

c     MG  version 11E/ 17.11.10: changed the format of the magnitudes/fluxes in SED2 files! 
c     -23.11: added visibility IC=4 (rad^-1, V^2, error V^2)
c     -23.11: subr visibili; enlarged N2 to 23 and changed calculation to get larger qtheta.
c     -04.12:                enlarged N2 to 24 and changed calculation to get larger qtheta.

c     MG  version 12/ 11.12.10: included Chiar & Tielens (2006) interstellar extinction in 10 mu region
c     -25.12.10: more robust error estimate of spectra (to catch the case e.g. of outlier 
c                low LRS flux which, with default 5% error, would dominate fitting.

c     MG  version 13
c     -26.12.10: allow plot symbols for individual datapoints in visibility data to allow for more datasets plotted per panel
c      open   square= 6, open   triangle= 7, open   circle= 4
c      filled square=16, filled triangle=13, filled circle=17

c      -26.03.11 updated new laptop 

c     -Dec 2011 Added WISE and Photographic filters
c     -Jan 2012 Added 'log g' to final *inp file
c     -Jan 2012 Added MassLossRate' to final *inp file
c     -Jan 2012 Allow monochromatic fluxdensities as input
c               FORMAT:  wavelength in micron and fluxdensity in mJy ! 
cCOBE5    19000.0    15000.
cirac36       0.951      0.039
c1.0    1111111.1     1111.111
c10.0    222222.      2222.2

c     -28 Feb 2012 Added some COBE + VISIR filters
c     - 08.03 increased npL from 235 to 290 (lambda_grid.dat)
c     - 09.03 increased npL from 290 to 306 (lambda_grid.dat, userpar.inc)

c     MG version 14
c     -update and correct filters and ZPs
c     -align with _v13S
c     - 13.06 updated the pgplot windows in plotint & plotvis (comment by A&A publisher)
c     - 20.12: corrected MLR calculation

c     MG version 15
c     10/10/14: Added GALEX, MACHO and CN/TiO filters
c     10/10/14: increased npL tot 515 (adding UV)
c     05/12/14: Added EROS filters
c               no=129 to 139
c     14/12/14: increased npY to 109 in userpar.inc
c     20/12/14: Added Cousins RI
c               nin= 450 to 600

c     MG version 16
c     12/02/16: grain size was not correct in case of using cdeIron of size 0.01, while others were larger size.
c               fixed in subroutine MLrate.
c     31.03.16  include JWST filters, and, increase no=169
c     31.03.16  Based on test with _v16S and S Sct, in Conv2D chanhed Nphi from 9 to 108 !
c     20.04.16  Added COBE-DIRBE filter 1 and 2
c     10.05.16  Added ACS and WFC3 filters; no=189
c     23.05.16  in *_allmags filter shave to be ordered, so COBE 1/2 as 163, 164th entry
c     14.07.16  Added Gaia filters
c     20.07.16  Revision of Vega model, check filters, update ZPs
c     21.07.16  update userpar.inc   npL to 573
c     24.10.17  LRS spectra; new format of the flux on Kevin Volks new website.

c     gfortran -fbounds-check -O -o MyDusty.exe  MyDusty_v16.f -lpgplot


c    MyDusty.exe cwleo_in

c =============================================================================================================

c**************************************************************************************************
c     This is the block data with optical constants for the supported
c     grain types. It has to be at the beginning of the program.
c     The data was compiled from different sources by Z. Ivezic (1996).
c                                                          [MN, Apr'98]
c**************************************************************************************************
      BLOCK DATA
      IMPLICIT none
      INTEGER npY, npP, npL, npG, npL1
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, npL1= npL+1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER npLnk
      PARAMETER (npLnk=98)
      DOUBLE PRECISION n_sil_ow(npLnk),k_sil_ow(npLnk),n_sil_oc(npLnk),
     &       k_sil_oc(npLnk), n_sil_dl(npLnk), k_sil_dl(npLnk),
     &       n_amc_hn(npLnk), k_amc_hn(npLnk), n_sic_pg(npLnk),
     &       k_sic_pg(npLnk), n_gr1_dl(npLnk), k_gr1_dl(npLnk),
     &       n_gr2_dl(npLnk), k_gr2_dl(npLnk), lam_nk(npLnk)
      COMMON /nkdat/ n_sil_ow, k_sil_ow, n_sil_oc, k_sil_oc,
     &               n_sil_dl, k_sil_dl, n_amc_hn, k_amc_hn,
     &               n_sic_pg, k_sic_pg, n_gr1_dl, k_gr1_dl,
     &               n_gr2_dl, k_gr2_dl, lam_nk
      DATA lam_nk/1.00E-02,2.00E-02,3.00E-02,4.00E-02,5.00E-02,
     &   6.00E-02,8.00E-02,1.00E-01,1.20E-01,1.50E-01,2.00E-01,2.50E-01,
     &   3.00E-01,3.60E-01,4.40E-01,5.50E-01,7.00E-01,8.50E-01,1.00E+00,
     &   1.15E+00,1.30E+00,1.70E+00,2.00E+00,2.20E+00,2.70E+00,3.00E+00,
     &   3.50E+00,4.00E+00,4.50E+00,5.00E+00,5.50E+00,6.00E+00,6.50E+00,
     &   7.00E+00,7.50E+00,8.00E+00,8.50E+00,9.00E+00,9.40E+00,9.55E+00,
     &   9.70E+00,9.85E+00,1.00E+01,1.05E+01,1.10E+01,1.13E+01,1.16E+01,
     &   1.20E+01,1.25E+01,1.30E+01,1.35E+01,1.40E+01,1.45E+01,1.50E+01,
     &   1.60E+01,1.70E+01,1.80E+01,1.90E+01,2.00E+01,2.20E+01,2.30E+01,
     &   2.40E+01,2.50E+01,2.60E+01,2.70E+01,2.80E+01,3.00E+01,3.50E+01,
     &   4.00E+01,4.50E+01,5.00E+01,5.50E+01,6.00E+01,6.50E+01,7.00E+01,
     &   7.50E+01,8.00E+01,8.50E+01,9.00E+01,9.50E+01,1.00E+02,1.05E+02,
     &   1.10E+02,1.20E+02,1.30E+02,1.40E+02,1.50E+02,2.00E+02,2.50E+02,
     &   3.00E+02,4.00E+02,5.00E+02,7.00E+02,1.30E+03,4.00E+03,1.30E+04,
     &   2.00E+04,3.60E+04/
      DATA n_sil_ow/1.81E+00,1.81E+00,1.81E+00,1.81E+00,1.81E+00,
     &   1.81E+00,1.81E+00,1.81E+00,1.81E+00,1.81E+00,1.81E+00,1.81E+00,
     &   1.81E+00,1.81E+00,1.82E+00,1.84E+00,1.85E+00,1.85E+00,1.85E+00,
     &   1.85E+00,1.85E+00,1.87E+00,1.88E+00,1.88E+00,1.89E+00,1.89E+00,
     &   1.88E+00,1.87E+00,1.87E+00,1.85E+00,1.83E+00,1.81E+00,1.79E+00,
     &   1.75E+00,1.71E+00,1.64E+00,1.55E+00,1.45E+00,1.40E+00,1.43E+00,
     &   1.44E+00,1.46E+00,1.51E+00,1.73E+00,1.91E+00,2.00E+00,2.11E+00,
     &   2.21E+00,2.21E+00,2.16E+00,2.09E+00,2.06E+00,2.03E+00,1.98E+00,
     &   1.91E+00,1.90E+00,1.96E+00,2.04E+00,2.12E+00,2.27E+00,2.34E+00,
     &   2.36E+00,2.38E+00,2.40E+00,2.42E+00,2.43E+00,2.45E+00,2.60E+00,
     &   2.66E+00,2.70E+00,2.74E+00,2.76E+00,2.77E+00,2.79E+00,2.80E+00,
     &   2.81E+00,2.82E+00,2.83E+00,2.85E+00,2.86E+00,2.87E+00,2.87E+00,
     &   2.87E+00,2.87E+00,2.88E+00,2.88E+00,2.88E+00,2.89E+00,2.90E+00,
     &   2.90E+00,2.90E+00,2.90E+00,2.91E+00,2.91E+00,2.91E+00,2.91E+00,
     &   2.91E+00,2.91E+00/
      DATA k_sil_ow/9.99E-02,9.99E-02,9.99E-02,9.99E-02,9.99E-02,
     &   9.99E-02,9.99E-02,9.99E-02,9.99E-02,9.99E-02,9.99E-02,9.99E-02,
     &   9.99E-02,9.99E-02,9.08E-02,7.17E-02,6.03E-02,5.64E-02,5.46E-02,
     &   6.12E-02,6.75E-02,7.23E-02,7.33E-02,6.96E-02,6.19E-02,5.88E-02,
     &   5.48E-02,5.24E-02,5.07E-02,5.14E-02,5.24E-02,5.50E-02,5.79E-02,
     &   6.36E-02,7.07E-02,9.03E-02,1.31E-01,2.63E-01,4.31E-01,4.96E-01,
     &   5.60E-01,6.30E-01,7.12E-01,8.10E-01,7.94E-01,7.86E-01,7.68E-01,
     &   6.13E-01,4.93E-01,3.98E-01,3.74E-01,3.69E-01,3.66E-01,3.72E-01,
     &   4.39E-01,5.63E-01,6.68E-01,7.23E-01,7.51E-01,7.55E-01,7.34E-01,
     &   7.10E-01,6.85E-01,6.61E-01,6.37E-01,6.44E-01,6.58E-01,6.28E-01,
     &   5.78E-01,5.23E-01,4.69E-01,4.34E-01,4.13E-01,3.92E-01,3.70E-01,
     &   3.49E-01,3.28E-01,3.06E-01,2.85E-01,2.64E-01,2.42E-01,2.37E-01,
     &   2.32E-01,2.22E-01,2.12E-01,2.02E-01,1.92E-01,1.42E-01,1.00E-01,
     &   9.09E-02,7.24E-02,5.39E-02,3.79E-02,2.15E-02,7.26E-03,2.39E-03,
     &   2.39E-03,2.39E-03/
      DATA n_sil_oc/1.77E+00,1.77E+00,1.77E+00,1.77E+00,1.77E+00,
     &   1.77E+00,1.77E+00,1.77E+00,1.77E+00,1.77E+00,1.77E+00,1.77E+00,
     &   1.77E+00,1.77E+00,1.79E+00,1.82E+00,1.83E+00,1.82E+00,1.81E+00,
     &   1.81E+00,1.81E+00,1.84E+00,1.85E+00,1.86E+00,1.87E+00,1.88E+00,
     &   1.88E+00,1.87E+00,1.86E+00,1.85E+00,1.83E+00,1.80E+00,1.78E+00,
     &   1.74E+00,1.69E+00,1.62E+00,1.51E+00,1.39E+00,1.34E+00,1.36E+00,
     &   1.37E+00,1.39E+00,1.44E+00,1.67E+00,1.86E+00,1.96E+00,2.08E+00,
     &   2.22E+00,2.23E+00,2.17E+00,2.09E+00,2.04E+00,2.01E+00,1.92E+00,
     &   1.78E+00,1.73E+00,1.80E+00,1.98E+00,2.17E+00,2.40E+00,2.48E+00,
     &   2.53E+00,2.58E+00,2.63E+00,2.69E+00,2.70E+00,2.74E+00,2.90E+00,
     &   2.95E+00,2.98E+00,3.01E+00,3.02E+00,3.03E+00,3.03E+00,3.03E+00,
     &   3.04E+00,3.04E+00,3.05E+00,3.05E+00,3.05E+00,3.06E+00,3.06E+00,
     &   3.06E+00,3.06E+00,3.06E+00,3.06E+00,3.06E+00,3.07E+00,3.07E+00,
     &   3.07E+00,3.07E+00,3.08E+00,3.08E+00,3.08E+00,3.08E+00,3.08E+00,
     &   3.08E+00,3.08E+00/
      DATA k_sil_oc/8.95E-02,8.95E-02,8.95E-02,8.95E-02,8.95E-02,
     &   8.95E-02,8.95E-02,8.95E-02,8.95E-02,8.95E-02,8.95E-02,8.95E-02,
     &   8.95E-02,8.95E-02,8.23E-02,6.64E-02,5.09E-02,4.46E-02,4.69E-02,
     &   6.37E-02,7.89E-02,9.62E-02,1.03E-01,1.00E-01,9.27E-02,8.97E-02,
     &   8.50E-02,8.14E-02,7.85E-02,7.80E-02,7.77E-02,8.06E-02,8.40E-02,
     &   8.91E-02,9.51E-02,1.10E-01,1.48E-01,2.95E-01,4.78E-01,5.49E-01,
     &   6.19E-01,6.96E-01,7.87E-01,9.11E-01,9.10E-01,9.14E-01,9.07E-01,
     &   7.40E-01,5.94E-01,4.74E-01,4.39E-01,4.28E-01,4.20E-01,4.35E-01,
     &   5.35E-01,7.36E-01,9.52E-01,1.10E+00,1.13E+00,1.07E+00,1.04E+00,
     &   1.01E+00,0.97E+00,0.94E+00,8.98E-01,8.77E-01,8.42E-01,7.52E-01,
     &   6.60E-01,5.68E-01,4.75E-01,4.25E-01,4.04E-01,3.82E-01,3.60E-01,
     &   3.39E-01,3.17E-01,2.96E-01,2.74E-01,2.52E-01,2.31E-01,2.26E-01,
     &   2.21E-01,2.12E-01,2.02E-01,1.92E-01,1.83E-01,1.35E-01,9.44E-02,
     &   8.56E-02,6.82E-02,5.07E-02,3.57E-02,2.02E-02,6.82E-03,2.29E-03,
     &   2.29E-03,2.29E-03/
      DATA n_sil_dl/8.66E-01,8.66E-01,8.66E-01,8.25E-01,7.81E-01,
     &   8.90E-01,1.29E+00,1.60E+00,1.87E+00,2.26E+00,1.93E+00,1.80E+00,
     &   1.76E+00,1.74E+00,1.73E+00,1.72E+00,1.72E+00,1.71E+00,1.71E+00,
     &   1.71E+00,1.71E+00,1.71E+00,1.71E+00,1.71E+00,1.70E+00,1.70E+00,
     &   1.69E+00,1.68E+00,1.66E+00,1.64E+00,1.60E+00,1.57E+00,1.52E+00,
     &   1.47E+00,1.34E+00,1.21E+00,1.16E+00,1.11E+00,1.20E+00,1.24E+00,
     &   1.30E+00,1.35E+00,1.39E+00,1.57E+00,1.75E+00,1.82E+00,1.90E+00,
     &   2.00E+00,2.04E+00,2.09E+00,2.04E+00,2.00E+00,1.91E+00,1.82E+00,
     &   1.73E+00,1.69E+00,1.71E+00,1.78E+00,1.89E+00,2.04E+00,2.11E+00,
     &   2.18E+00,2.26E+00,2.30E+00,2.35E+00,2.40E+00,2.50E+00,2.63E+00,
     &   2.76E+00,2.89E+00,3.02E+00,3.07E+00,3.13E+00,3.18E+00,3.23E+00,
     &   3.25E+00,3.27E+00,3.29E+00,3.31E+00,3.33E+00,3.35E+00,3.35E+00,
     &   3.36E+00,3.37E+00,3.38E+00,3.39E+00,3.40E+00,3.41E+00,3.42E+00,
     &   3.42E+00,3.43E+00,3.43E+00,3.43E+00,3.43E+00,3.43E+00,3.43E+00,
     &   3.43E+00,3.43E+00/
      DATA k_sil_dl/1.39E-01,1.39E-01,1.39E-01,2.55E-01,4.29E-01,
     &   6.73E-01,8.78E-01,9.26E-01,7.22E-01,5.30E-01,5.32E-02,2.77E-02,
     &   2.84E-02,2.88E-02,2.91E-02,2.94E-02,2.97E-02,3.00E-02,3.03E-02,
     &   3.06E-02,3.09E-02,3.21E-02,3.31E-02,3.39E-02,3.60E-02,3.72E-02,
     &   3.94E-02,4.11E-02,4.25E-02,4.40E-02,4.72E-02,5.05E-02,5.36E-02,
     &   5.66E-02,1.14E-01,1.71E-01,3.68E-01,5.66E-01,7.65E-01,8.29E-01,
     &   8.71E-01,8.97E-01,9.24E-01,9.63E-01,1.00E+00,9.65E-01,9.28E-01,
     &   8.78E-01,7.71E-01,6.63E-01,5.70E-01,4.77E-01,4.83E-01,4.88E-01,
     &   5.83E-01,7.14E-01,8.55E-01,9.76E-01,1.05E+00,1.08E+00,1.10E+00,
     &   1.11E+00,1.13E+00,1.12E+00,1.12E+00,1.12E+00,1.11E+00,1.06E+00,
     &   1.01E+00,9.66E-01,9.19E-01,8.66E-01,8.13E-01,7.59E-01,7.06E-01,
     &   6.72E-01,6.38E-01,6.03E-01,5.69E-01,5.35E-01,5.00E-01,4.83E-01,
     &   4.67E-01,4.33E-01,3.99E-01,3.65E-01,3.32E-01,2.48E-01,2.06E-01,
     &   1.65E-01,1.32E-01,9.87E-02,7.04E-02,3.83E-02,2.46E-02,2.46E-02,
     &   2.46E-02,2.46E-02/
      DATA n_amc_hn/8.40E-01,8.40E-01,8.40E-01,8.40E-01,7.40E-01,
     &   6.90E-01,9.30E-01,1.53E+00,1.74E+00,1.55E+00,1.22E+00,1.40E+00,
     &   1.60E+00,1.71E+00,1.78E+00,1.85E+00,1.94E+00,2.01E+00,2.11E+00,
     &   2.21E+00,2.31E+00,2.50E+00,2.63E+00,2.70E+00,2.82E+00,2.86E+00,
     &   2.95E+00,3.03E+00,3.04E+00,3.04E+00,3.09E+00,3.15E+00,3.16E+00,
     &   3.16E+00,3.25E+00,3.35E+00,3.38E+00,3.42E+00,3.47E+00,3.49E+00,
     &   3.51E+00,3.53E+00,3.55E+00,3.59E+00,3.63E+00,3.65E+00,3.67E+00,
     &   3.70E+00,3.73E+00,3.75E+00,3.79E+00,3.84E+00,3.86E+00,3.88E+00,
     &   3.96E+00,3.99E+00,4.10E+00,4.14E+00,4.18E+00,4.26E+00,4.31E+00,
     &   4.34E+00,4.36E+00,4.42E+00,4.47E+00,4.50E+00,4.57E+00,4.77E+00,
     &   4.94E+00,5.11E+00,5.25E+00,5.32E+00,5.44E+00,5.49E+00,5.67E+00,
     &   5.71E+00,5.85E+00,5.90E+00,5.99E+00,5.94E+00,6.32E+00,6.70E+00,
     &   6.79E+00,6.99E+00,7.17E+00,7.37E+00,7.55E+00,8.50E+00,9.32E+00,
     &   1.01E+01,1.15E+01,1.25E+01,1.41E+01,1.65E+01,1.65E+01,1.65E+01,
     &   1.65E+01,1.65E+01/
      DATA k_amc_hn/1.08E-01,1.08E-01,1.08E-01,1.08E-01,1.77E-01,
     &   3.80E-01,9.00E-01,8.40E-01,5.60E-01,1.77E-01,3.21E-01,7.40E-01,
     &   7.20E-01,6.86E-01,6.70E-01,6.95E-01,7.70E-01,8.25E-01,9.00E-01,
     &   9.38E-01,9.60E-01,9.95E-01,1.02E+00,1.01E+00,9.96E-01,9.90E-01,
     &   1.01E+00,1.04E+00,1.04E+00,1.03E+00,1.09E+00,1.15E+00,1.20E+00,
     &   1.25E+00,1.34E+00,1.42E+00,1.44E+00,1.47E+00,1.50E+00,1.51E+00,
     &   1.52E+00,1.53E+00,1.54E+00,1.57E+00,1.60E+00,1.61E+00,1.62E+00,
     &   1.63E+00,1.66E+00,1.69E+00,1.71E+00,1.74E+00,1.76E+00,1.78E+00,
     &   1.83E+00,1.89E+00,1.95E+00,1.95E+00,1.98E+00,2.05E+00,2.08E+00,
     &   2.13E+00,2.19E+00,2.23E+00,2.27E+00,2.32E+00,2.40E+00,2.60E+00,
     &   2.77E+00,2.92E+00,3.00E+00,3.18E+00,3.31E+00,3.50E+00,3.70E+00,
     &   3.80E+00,4.00E+00,4.15E+00,4.30E+00,4.48E+00,4.59E+00,4.70E+00,
     &   4.79E+00,4.97E+00,5.15E+00,5.33E+00,5.51E+00,6.41E+00,7.17E+00,
     &   7.92E+00,9.43E+00,1.04E+01,1.25E+01,1.41E+01,1.41E+01,1.41E+01,
     &   1.41E+01,1.41E+01/
      DATA n_sic_pg/7.06E-01,7.06E-01,7.06E-01,7.06E-01,7.06E-01,
     &   7.06E-01,7.06E-01,7.06E-01,9.69E-01,2.07E+00,4.29E+00,5.16E+00,
     &   4.75E+00,3.42E+00,2.59E+00,2.55E+00,2.51E+00,2.50E+00,2.47E+00,
     &   2.49E+00,2.50E+00,2.51E+00,2.55E+00,2.58E+00,2.65E+00,2.69E+00,
     &   2.73E+00,2.76E+00,2.76E+00,2.77E+00,2.74E+00,2.71E+00,2.67E+00,
     &   2.63E+00,2.57E+00,2.51E+00,2.42E+00,2.33E+00,2.17E+00,2.11E+00,
     &   2.04E+00,1.96E+00,1.88E+00,1.56E+00,1.25E+00,1.47E+00,1.69E+00,
     &   1.99E+00,3.07E+00,4.14E+00,4.21E+00,4.28E+00,4.11E+00,3.93E+00,
     &   3.71E+00,3.59E+00,3.52E+00,3.49E+00,3.46E+00,3.43E+00,3.42E+00,
     &   3.40E+00,3.39E+00,3.39E+00,3.39E+00,3.38E+00,3.38E+00,3.38E+00,
     &   3.39E+00,3.39E+00,3.39E+00,3.40E+00,3.41E+00,3.41E+00,3.42E+00,
     &   3.42E+00,3.43E+00,3.43E+00,3.44E+00,3.44E+00,3.45E+00,3.45E+00,
     &   3.46E+00,3.46E+00,3.47E+00,3.48E+00,3.49E+00,3.51E+00,3.52E+00,
     &   3.52E+00,3.52E+00,3.52E+00,3.52E+00,3.52E+00,3.52E+00,3.52E+00,
     &   3.52E+00,3.52E+00/
      DATA k_sic_pg/1.53E+00,1.53E+00,1.53E+00,1.53E+00,1.53E+00,
     &   1.53E+00,1.53E+00,1.53E+00,1.43E+00,1.28E+00,1.06E+00,3.50E-01,
     &   2.50E-01,1.62E-01,1.04E-01,1.13E-01,1.21E-01,1.30E-01,1.44E-01,
     &   1.62E-01,1.80E-01,2.17E-01,2.63E-01,2.76E-01,2.77E-01,2.78E-01,
     &   2.51E-01,2.23E-01,1.88E-01,1.53E-01,1.22E-01,9.08E-02,8.07E-02,
     &   7.06E-02,6.69E-02,6.31E-02,6.59E-02,6.87E-02,9.61E-02,1.05E-01,
     &   1.09E-01,1.24E-01,1.38E-01,5.43E-01,9.48E-01,1.40E+00,1.85E+00,
     &   2.45E+00,2.45E+00,2.45E+00,1.69E+00,9.19E-01,7.00E-01,4.80E-01,
     &   3.62E-01,2.90E-01,2.80E-01,2.82E-01,2.70E-01,2.57E-01,2.51E-01,
     &   2.45E-01,2.38E-01,2.35E-01,2.32E-01,2.29E-01,2.23E-01,2.13E-01,
     &   2.04E-01,1.94E-01,1.84E-01,1.80E-01,1.75E-01,1.71E-01,1.66E-01,
     &   1.63E-01,1.60E-01,1.57E-01,1.54E-01,1.51E-01,1.48E-01,1.46E-01,
     &   1.43E-01,1.39E-01,1.34E-01,1.29E-01,1.25E-01,1.01E-01,9.22E-02,
     &   8.30E-02,8.30E-02,8.30E-02,8.30E-02,8.30E-02,8.30E-02,8.30E-02,
     &   8.30E-02,8.30E-02/
      DATA n_gr1_dl/9.81E-01,9.25E-01,8.48E-01,7.72E-01,7.23E-01,
     &   7.65E-01,9.91E-01,1.39E+00,2.57E+00,1.94E+00,1.61E+00,1.56E+00,
     &   1.93E+00,2.17E+00,2.35E+00,2.34E+00,2.29E+00,2.25E+00,2.23E+00,
     &   2.21E+00,2.20E+00,2.19E+00,2.18E+00,2.17E+00,2.17E+00,2.16E+00,
     &   2.16E+00,2.15E+00,2.15E+00,2.14E+00,2.13E+00,2.13E+00,2.12E+00,
     &   2.11E+00,2.10E+00,2.09E+00,2.08E+00,2.07E+00,2.06E+00,2.06E+00,
     &   2.05E+00,2.05E+00,2.04E+00,2.03E+00,2.01E+00,1.98E+00,2.05E+00,
     &   2.01E+00,1.99E+00,1.97E+00,1.96E+00,1.95E+00,1.93E+00,1.92E+00,
     &   1.89E+00,1.87E+00,1.84E+00,1.82E+00,1.80E+00,1.76E+00,1.74E+00,
     &   1.73E+00,1.72E+00,1.72E+00,1.71E+00,1.71E+00,1.71E+00,1.76E+00,
     &   1.83E+00,1.92E+00,2.02E+00,2.11E+00,2.21E+00,2.30E+00,2.40E+00,
     &   2.49E+00,2.57E+00,2.66E+00,2.74E+00,2.82E+00,2.90E+00,2.97E+00,
     &   3.05E+00,3.19E+00,3.33E+00,3.46E+00,3.58E+00,4.15E+00,4.65E+00,
     &   5.10E+00,5.90E+00,6.59E+00,7.80E+00,9.33E+00,9.33E+00,9.33E+00,
     &   9.33E+00,9.33E+00/
      DATA k_gr1_dl/3.08E-03,2.78E-02,9.28E-02,2.09E-01,3.70E-01,
     &   5.39E-01,9.54E-01,1.65E+00,6.55E-01,1.94E-01,2.75E-01,6.38E-01,
     &   8.16E-01,6.57E-01,4.79E-01,2.55E-01,1.41E-01,9.41E-02,6.96E-02,
     &   5.51E-02,4.60E-02,3.33E-02,2.87E-02,2.68E-02,2.42E-02,2.35E-02,
     &   2.32E-02,2.36E-02,2.44E-02,2.57E-02,2.72E-02,2.91E-02,3.13E-02,
     &   3.41E-02,3.74E-02,4.14E-02,4.61E-02,5.16E-02,5.65E-02,5.85E-02,
     &   6.05E-02,6.26E-02,6.47E-02,7.23E-02,8.11E-02,8.83E-02,9.49E-02,
     &   9.92E-02,1.10E-01,1.22E-01,1.34E-01,1.47E-01,1.61E-01,1.75E-01,
     &   2.07E-01,2.42E-01,2.79E-01,3.20E-01,3.63E-01,4.55E-01,5.04E-01,
     &   5.55E-01,6.06E-01,6.59E-01,7.11E-01,7.64E-01,8.68E-01,1.11E+00,
     &   1.33E+00,1.52E+00,1.69E+00,1.85E+00,1.99E+00,2.11E+00,2.23E+00,
     &   2.34E+00,2.44E+00,2.54E+00,2.63E+00,2.72E+00,2.81E+00,2.89E+00,
     &   2.97E+00,3.12E+00,3.27E+00,3.40E+00,3.53E+00,4.12E+00,4.62E+00,
     &   5.08E+00,5.88E+00,6.58E+00,7.79E+00,9.32E+00,9.32E+00,9.32E+00,
     &   9.32E+00,9.32E+00/
      DATA n_gr2_dl/9.80E-01,9.20E-01,8.39E-01,7.64E-01,5.55E-01,
     &   5.43E-01,1.01E+00,2.08E+00,1.87E+00,1.27E+00,6.88E-01,1.25E+00,
     &   2.39E+00,2.58E+00,2.66E+00,2.74E+00,2.87E+00,3.03E+00,3.19E+00,
     &   3.34E+00,3.47E+00,3.76E+00,3.94E+00,4.05E+00,4.29E+00,4.43E+00,
     &   4.64E+00,4.82E+00,4.99E+00,5.14E+00,5.29E+00,5.43E+00,5.57E+00,
     &   5.69E+00,5.80E+00,5.90E+00,6.01E+00,6.11E+00,6.20E+00,6.22E+00,
     &   6.25E+00,6.28E+00,6.31E+00,6.39E+00,6.47E+00,6.52E+00,6.56E+00,
     &   6.62E+00,6.67E+00,6.74E+00,6.81E+00,6.89E+00,6.96E+00,7.03E+00,
     &   7.15E+00,7.26E+00,7.36E+00,7.46E+00,7.53E+00,7.83E+00,7.99E+00,
     &   8.13E+00,8.25E+00,8.47E+00,8.73E+00,9.01E+00,9.60E+00,1.14E+01,
     &   1.35E+01,1.59E+01,1.88E+01,2.13E+01,2.33E+01,2.48E+01,2.59E+01,
     &   2.66E+01,2.70E+01,2.70E+01,2.66E+01,2.62E+01,2.56E+01,2.46E+01,
     &   2.34E+01,2.05E+01,1.75E+01,1.49E+01,1.33E+01,1.33E+01,1.68E+01,
     &   2.11E+01,3.02E+01,3.89E+01,5.47E+01,7.40E+01,7.40E+01,7.40E+01,
     &   7.40E+01,7.40E+01/
      DATA k_gr2_dl/3.09E-03,2.79E-02,9.38E-02,1.36E-01,3.62E-01,
     &   7.20E-01,1.48E+00,1.24E+00,3.38E-01,2.77E-01,1.09E+00,2.27E+00,
     &   2.08E+00,1.67E+00,1.56E+00,1.56E+00,1.68E+00,1.82E+00,1.94E+00,
     &   2.03E+00,2.12E+00,2.33E+00,2.48E+00,2.58E+00,2.82E+00,2.96E+00,
     &   3.18E+00,3.39E+00,3.60E+00,3.79E+00,4.00E+00,4.19E+00,4.37E+00,
     &   4.55E+00,4.72E+00,4.91E+00,5.09E+00,5.27E+00,5.41E+00,5.46E+00,
     &   5.50E+00,5.55E+00,5.60E+00,5.77E+00,5.94E+00,6.04E+00,6.14E+00,
     &   6.27E+00,6.44E+00,6.63E+00,6.82E+00,7.00E+00,7.17E+00,7.35E+00,
     &   7.69E+00,8.05E+00,8.42E+00,8.80E+00,9.24E+00,1.01E+01,1.05E+01,
     &   1.10E+01,1.15E+01,1.20E+01,1.24E+01,1.29E+01,1.38E+01,1.59E+01,
     &   1.76E+01,1.90E+01,1.95E+01,1.92E+01,1.83E+01,1.73E+01,1.62E+01,
     &   1.50E+01,1.38E+01,1.26E+01,1.16E+01,1.08E+01,9.98E+00,9.24E+00,
     &   8.73E+00,8.70E+00,9.94E+00,1.24E+01,1.54E+01,2.94E+01,3.95E+01,
     &   4.78E+01,6.08E+01,7.09E+01,8.61E+01,1.03E+02,1.03E+02,1.03E+02,
     &   1.03E+02,1.03E+02/

      END
c =====================================================================
*23456789012345678901234567890123456789012345678901234567890123456789012

	program test

c       MG 07.07.09
c       write minimalisation program for DUSTY model, based on rtrtspec.f

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

        parameter (npL=573,npL1=npL+1,nmax= 6,nfit=4)
        parameter (no=189,ns= 2000,nin=600)

        double precision a(nfit), afin(nfit), erra(nfit)
	double precision ysel(no), zsel(no), q1(ns), q2(ns), w1(ns)
        double precision wve(npL1), flx(npL1)
	double precision xspec(ns), yspec(ns), zspec(ns)
	double precision xint(nin), yint(nin), zint(nin),duma(ns)
	double precision xvis(ns), yvis(ns), zvis(ns)
	double precision xobs(ns+no+nin+ns)
        double precision yobs(ns+no+nin+ns), zobs(ns+no+nin+ns)
        double precision alpha(nfit, nfit), covar(nfit, nfit)
        double precision chisq(nmax), chir(nmax), bic, ochisq
        double precision waveint(nin), fwhmint(nin), pxl(nin), D1(nin)
        double precision wavevis(ns), fwhmvis(ns)
        double precision allchisq(no+ns+nin)
        double precision pp(nfit), Router(nfit), scl(nfit)
        double precision chiphot,chispec,chiint,chivis
        double precision wavecut, alamda
        double precision av,teff,dist,Rst, chichi
        double precision wism(ns),avism(ns), dummy
        double precision splam(no),spmag(no),sperrmag(no)
        real pltintm(nin)

        integer ia(nfit), xsel(no),intsep(nin), vissep(ns), svis(ns)
        integer nism

	character*80 rtinname,starname,name,path,absscafile
        character*200 cdum,modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/needed/rinner,router,pp,scl,av,teff,dist,npow
        common/fluxes/wve,flx,xspec,xint,xvis,xsel,
     c                nvisib,nfl,nspec,nsel,nint
	common/final/afin,erra,chichi,bic,ifinal,npar
        common/intensity/waveint,fwhmint,intsep,yint,zint,pxl,D1,
     c                   pltintm,nns
        common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis
        common/allchi/allchisq,chiphot,chispec,chiint,chivis
        common/observations/xobs,yobs,zobs
        common/params/a,ia
        common/chiar/ wism,avism,nism
        common/special/splam,spmag,sperrmag,nsp

        external funcs

c     minimum fractional change in chi^2 for iteration
        del= 0.001d0

c     initialise
        do i= 1,nfit
           a(i) = 0.d0
           ia(i)= 0
        enddo

c     not yet final
        ifinal= 0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     read filename with all inputs
	call getarg (1, rtinname)

c     open it and read in parameters/data, etc
	open(10, file= rtinname)

c     root name of object. Most in- and out-put files are based on this root-name
	read(10,'(a80)') starname

c     A_V
	read(10,*) av
c     file with Qabs and Qsca data
        read(10,'(a80)') absscafile
c     file with stellar model atmosphere
	read(10,'(a200)') modelatmos
c     Teff of this energy distribution
	read(10,*) Teff
c     Distance (kpc)
	read(10,*) dist

c     number of shells with powerlaw density distribution
        read(10,*) npow
c     Transition & Outer radius in units of the inner radius
        read(10,*) (Router(i), i= 1,npow)
c     power of density distribution, r^{- pp}
        read(10,*) (pp(i), i= 1,npow)
c     scaling of density distribution, scale * r^{- pp}
        read(10,*) (scl(i), i= 1,npow)

c     FREE PARAMETERS initial guesses
c     luminosity (Lsol) & fit
	read(10,*) a(1), ia(1)
c     optical depth at 0.55 micron & fit
	read(10,*) a(2), ia(2)
c     condensation temperature (K)  & fit
	read(10,*) a(3), ia(3)
c     pp(1)  & fit
	read(10,*) a(4), ia(4)

        close(10)
c     finished reading inputs

c     fit paramters are actually 10log values to ensure positive numbers
	nno=0
	do i= 1,nfit
	   if (i .eq. 1) a(i)= dlog10(a(i))
	   if (i .eq. 2) a(i)= dlog10(a(i))
	   if (i .eq. 3) a(i)= dlog10(a(i))
c	   if (i .eq. 4) a(i)= dlog10(a(i))
	   if (ia(i) .eq. 0) nno=nno+1
	enddo

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     IS extinction curve of Chiar & Tielens 2006 ApJ637, 774
	open(10, file= 'Av.txt')
        do i= 1,15
             read(10,*) cdum
        enddo
c     LOCAL ISM  A(l)/A(K-band); then aposteriori correction A(l)/A(V) w.r.t. Cardelli et al
        nism= 258
        do i= 1,nism
           read(10,*) wism(i), dummy, avism(i)
           avism(i)= avism(i) *0.118
        enddo
        close(10)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     check Qabs Qsca file for wavelength were Qsca becomes >= Qabs
	open(10, file= absscafile)
        read(10,*) cdum
        read(10,*) cdum
        read(10,*) cdum
        j=0
 200    j=j+1
        read(10, * ,err=201,end=201) w1(j), q1(j), q2(j)
	goto 200
 201	continue
        nfl= j-1
        close(10)

        do i= nfl,1,-1
           if (q2(i) .ge. q1(i)) then
              j= i
              goto 202
           endif
        enddo
 202    wavecut= w1(j)
        wavecut= 0.1
c        wavecut= 0.4d0
c        wavecut= 1.0

	open(10, file= 'wavecut')
        write(10,*) wavecut
        close(10)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     stellar radius in solar units
        Rst= sqrt(10** a(1) / (Teff/5770.d0)**4)

c     estimate inner dust radius in units of the stellar radius
        dum= 0.5d0*(Teff/ 10**a(3))**2

c     estimate ANGULAR DIAMETER inner dust radius in arcsec
c     Estimate is updated while DUSTY is running
        thetaest= 2.d0*dum*Rst* 6.96d5 / (dist *3.0921d16) *206265.d0
        write(*,*) 'Rstar, Rinner, theta (arcsec) ', Rst, dum, thetaest
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       for debugging
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'_debug.dat',name)

	open(80,file= name)

        write(80,*) i, wavecut
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       read in observed magnitudes and error
c       xsel contains the index to that magnitude in the model
	call readphot(xsel,ysel,zsel,nsel)
        do i=1,nsp
          write(80,*) splam(i),spmag(i),sperrmag(i)
        enddo

	do i= 1,nsel
	   xobs(i)= xsel(i)
	   yobs(i)= ysel(i)
	   zobs(i)= zsel(i)
   	   write(80,*)'pht', i, nsel,xobs(i),yobs(i),zobs(i)
	enddo
        nobs= nsel

c	read in observed spectra
	call readspec(xspec,yspec,zspec,nspec)
	do i= 1,nspec
	   xobs(nobs+i)= xspec(i)
	   yobs(nobs+i)= yspec(i)
	   zobs(nobs+i)= zspec(i)
   	write(80,*)'spc',i,nobs+i,xobs(nobs+i),yobs(nobs+i),zobs(nobs+i)
	enddo
	nobs= nsel+nspec

c     read in the observed intensity profiles
        call readint1(xint,yint,zint,nint)
	do i= 1,nint
	   xobs(nobs+i)= xint(i)
	   yobs(nobs+i)= yint(i)
	   zobs(nobs+i)= zint(i)
   	write(80,*)'int',i,nobs+i,xobs(nobs+i),yobs(nobs+i),zobs(nobs+i)
	enddo
	nobs= nsel+nspec+nint

c     read in the observed visibility curves
        call readvis(xvis,yvis,zvis,nvisib)
	do i= 1,nvisib
	   xobs(nobs+i)= xvis(i)
	   yobs(nobs+i)= yvis(i)
	   zobs(nobs+i)= zvis(i)
   	write(80,*)'vis',i,nobs+i,xobs(nobs+i),yobs(nobs+i),zobs(nobs+i)
	enddo
	nobs= nsel+nspec+nint+nvisib

        write(*,*) nns, waveint, fwhmint, intsep
        write(*,*) nvisib, wavevis, fwhmvis, vissep
        write(80,*) nns, nnv
c        write(*,*) 'deliberate stop line 386'
c        stop

*23456789012345678901234567890123456789012345678901234567890123456789012
c     start minimising routine

        ma= nfit

        alamda= -1.0d0
        ochisq= 0.0d0
        nca= ma

        nitt= 0
 77     nitt= nitt+1
        if (nitt .eq. nmax) goto 88
        write(*,*)  'start iteration ', nitt, a, ia
        write(80,*) 'start iteration ', nitt, a, ia

        call mrqmin(xobs, yobs, zobs, nobs,
     c                  a,ia,ma, covar,alpha,nca,ochisq,
     c                  funcs,alamda,BIC)

        chisq(nitt)= ochisq
	chir(nitt)= ochisq/ (nobs-nfit+nno)
        bic= BIC + (nfit-nno)*alog(real(nobs))
	npar= nfit-nno

        if (nitt .eq. 1) then
           write(*,*) 'chi ',  chisq(nitt), chir(nitt), nitt
           write(80,*)'chi: ', chisq(nitt), chir(nitt), nitt
           goto 77
        else
           write(*,*) 'chi ', chisq(nitt-1),chisq(nitt), chir(nitt),nitt
           write(80,*)'chi: ', chisq(nitt-1),chisq(nitt),chir(nitt),nitt
           if (abs(chisq(nitt-1)-chisq(nitt))/chisq(nitt).ge.del)goto 77
       endif

 88     continue


c     calculate covariance matrix
        alamda= 0.0
        call mrqmin(xobs, yobs, zobs, nobs,
     c                  a,ia,ma, covar,alpha,nca,ochisq,
     c                  funcs,alamda, BIC)

 357    format(7(e10.3,1x))
        do i= 1,nfit
           write(80,*) 'a err-a: ' , a(i), sqrt(covar(i,i))
           write(80,357) (covar(i,j), j=1,nfit)

	   if (i.eq.1) then
	      afin(i)= 10**a(i)
	      erra(i)= 10**(a(i)+sqrt(covar(i,i)))-10**a(i)
	   endif
	   if (i.eq.2) then
	      afin(i)= 10**a(i)
	      erra(i)= 10**(a(i)+sqrt(covar(i,i)))-10**a(i)
	   endif
	   if (i.eq.3) then
	      afin(i)= 10**a(i)
	      erra(i)= 10**(a(i)+sqrt(covar(i,i)))-10**a(i)
           endif
	   if (i.eq.4) then
c	      afin(i)= 10**a(i)
c	      erra(i)= 10**(a(i)+sqrt(covar(i,i)))-10**a(i)
	      afin(i)= a(i)
	      erra(i)= sqrt(covar(i,i))
	   endif

        enddo
        write(80,*) 10**a(1) , 10**(a(1)+sqrt(covar(1,1)))-10**a(1)
        write(80,*) 10**a(2) , 10**(a(2)+sqrt(covar(2,2)))-10**a(2)
        write(80,*) 10**a(3) , 10**(a(3)+sqrt(covar(3,3)))-10**a(3)
c        write(80,*) 10**a(4) , 10**(a(4)+sqrt(covar(4,4)))-10**a(4)
        write(80,*) a(4) , sqrt(covar(4,4))

c        write(80,*) a(3)*1000., 1000.*sqrt(covar(3,3))


c	chichi= chisq(nitt)
	chichi= chir(nitt)

        chiphot= 0.d0
        chispec= 0.d0
        chiint=  0.d0
        chivis=  0.d0
        chiphot= allchisq(nsel)
        chispec= allchisq(nsel+nspec)-allchisq(nsel)
        chiint = allchisq(nsel+nspec+nint)-allchisq(nsel+nspec)
        chivis = allchisq(nsel+nspec+nint+nvisib)-
     c           allchisq(nsel+nspec+nint)
       write(*,*) 'chis ', chiphot,chispec,chiint,chivis,
     c                              nsel,nspec,nint,nvisib,nobs
        if (nsel   .ne. 0) chiphot= chiphot/real(nsel)
        if (nspec  .ne. 0) chispec= chispec/real(nspec)
        if (nint   .ne. 0) chiint = chiint/real(nint)
        if (nvisib .ne. 0) chivis = chivis/real(nvisib)

        ifinal= 1
	call makedusty(a)
	call Dusty
	write(80,*) 'end dusty final'
	call pscfold(a)
	write(80,*) 'end pscfold final'
	call compareint(duma)
	call comparevis(duma)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        close(80)
        stop
        end

*23456789012345678901234567890123456789012345678901234567890123456789012

      subroutine Dusty
c =====================================================================
c This program solves the continuum radiative transfer problem for a
c spherically symmetric envelope or for a plane-parallel slab. Only this
c file needs to be compiled. It is assumed that all input data are given
c in files named *.inp, and that the list of these files is given in a
c master input file dusty.inp. For details see the Manual.
c                                                       [Z.I. and M.N.]
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      CHARACTER*4 version
      CHARACTER*230 path, apath
      CHARACTER*235 nameIn, nameOut, nameQ(npG), nameNK(10)
      INTEGER error, nG, model, Nmodel, GridType,  Empty, lpath,
     &        iL, Nrec, Nlam

c     Added MG
	character*80 starname,absscafile
        character*200 modelatmos
        double precision wavecut
	common/fnames/starname,modelatmos,absscafile,wavecut
c     Added MG

c     Nrec is the max number of records for TAUgrid in a file
      PARAMETER (Nrec = 1000)
      DOUBLE PRECISION ETAzp(npP,npY), TAUin(Nrec), TAU1, TAU2, RDINP
      LOGICAL Equal
      Equal = .True.
c ----------------------------------------------------------------------
c     **************************
c     *** ABOUT THIS VERSION ***
c     **************************
      version= '2.01'
c     Updated versions of Dusty(2.0) with minor changes and bug fixes
c     start from 2.01.

c     Version (2.0) is the first public release. The code has been
c     significantly improved in terms of speed and I/O options. All
c     suggestions of the users of version(1.0) had been taken into
c     consideration. Finished Oct.'99

c     Version 1.0 is a beta version sent to a few people before the
c     first public release.  Finished Nov,'96.
c **********************************************************************
c     *** MAIN ***
c     first open the file with lambda grid and check that the grid satisfies
c     certain conditions (the wavelengths are in microns) :
      open(4, file='lambda_grid.dat', status = 'OLD')
      Nlam = RDINP(Equal,4)
      IF (Nlam.NE.npL) THEN
       write(*,*)' *************** A BIG ERROR !!! ***************** '
       write(*,*)'  The number of wavelengths in lambda_grid.dat is  '
       write(*,*)'  not equal to the specified npL in userpar.inc    '
       write(*,*)'  Make sure the numbers are the same, recompile    '
       write(*,*)'  and try again.                                   '
       write(*,*)' ************************************************* '
       goto 999
      END IF
c     Initialize lambda array
      read(4,*,END=99) (lambda(iL), iL = 1, npL)
 99   close(4)
      CALL sort(lambda,npL)
c     Check the ends of the lambda grid :
      IF(lambda(1).GT.0.01d0) THEN
       write(*,*)' *************** WARNING! ********************** '
       write(*,*)'  The shortest wavelength in lambda_grid.dat has '
       write(*,*)'  to be 0.01 microns. Correct this and try again!'
       write(*,*)' *********************************************** '
       goto 999
      END IF
      IF(lambda(npL).LT.36000.d0) THEN
       write(*,*)' *************** WARNING! ******************* '
       write(*,*)'  The longest wavelength in lambda_grid.dat   '
       write(*,*)'  has to be 36 mm. Correct this and try again!'
       write(*,*)' ******************************************** '
       goto 999
      END IF
c     Check the resolution:
      DO iL = 2, npL
        IF (lambda(iL)/lambda(iL-1).GT.1.51d0) THEN
          write(*,*)' ***************** WARNING!  *******************'
          write(*,*)' The ratio of two consecutive wavelengths in the'
          write(*,*)' grid has to be no bigger than 1.5. You have    '
          write(*,'(2(a4,1p,e8.2))') '    ',lambda(iL)/lambda(iL-1),
     &                                ' at ', lambda(iL)
          write(*,*)' Correct this and try again!                    '
          write(*,*)' ***********************************************'
          goto 999
        END IF
      END DO



100     apath= starname

        CALL Clean(apath, path, lpath)
c       if not EOF and if line is not empty, or commented, proceed
        IF (Empty(path).NE.1) THEN
c         get input/output file names
          CALL ATTACH(path,lpath,'.inp',nameIn)
          CALL ATTACH(path,lpath,'.out',nameOut)

          write(*,*) path, nameIn
c         read input data
          CALL Input(nameIn,nG,nameOut,nameQ,nameNK,
     &               TAU1,TAU2,TAUin,Nrec,GridType,Nmodel,error,version)

c           IF (iVerb.GT.0)
c     &          write(*,'(a24,a80)') ' Working on Input File: ',nameIn

           IF (iVerb.EQ.2) write(*,*) 'Done with Reading Input'
c         if an error reading files go to the next input file
c         error=3 means some files are missing
          IF (error.EQ.3) goto 100
c         get optical properties
          CALL getOptPr(nG,nameQ,nameNK,error)
c         if an error reading files go to the next input file
          IF (error.EQ.3) goto 100
          IF (iVerb.EQ.2) write(*,*) 'Done with getOptPr'
c         solve for every model
          DO model = 1, Nmodel
c           IF (iVerb.GT.0)  write(*,'(a9,i4)') ' model = ',model
           IF (error.EQ.0) THEN
c            open output files
             CALL Oppen(model,path,lpath)
c            calculate optical depth for current model
             CALL GetTau(model,nG,TAU1,TAU2,TAUin,Nrec,GridType,Nmodel)
             IF (iVerb.EQ.2)
     &          write(*,*) 'Done with GetTau. Going to Solve'
c            solve
             CALL Solve(model,nG,error,ETAzp)
             IF (error.EQ.0) THEN
c              calculate spectral characteristics
               CALL Spectral(model,denstyp,nL,Lambda)
c              write results out
               CALL PrOut(model)
             ELSE
              goto 100
             END IF
c            close output files
             CALL Cllose(error,model,Nmodel)
           END IF
           IF (iVerb.EQ.2) write(*,*) ' ----------- '
           IF (iVerb.EQ.2) write(*,*) '    '
c         end of the loop over models
          END DO
        END IF

c     end this run
      goto 999
c     to execute if the master input file is missing
998   write(*,*)' *********** FATAL ERROR IN DUSTY ***********'
      write(*,*)' * Master input file dusty.inp is missing!? *'
      write(*,*)' ********************************************'
c ----------------------------------------------------------------------
999   return
      END
c **********************************************************************

c =======================================================================
c This is the include file with I/O subroutines              [MN, Apr'99]
c =======================================================================
C     Table of Contents
C
C     CLLOSE
C     INPSTAR
C     INPUT
C     OPPEN
C     PROUT
C     RDINP
C     VAL
c =======================================================================

c ***********************************************************************
      SUBROUTINE CLLOSE(error,model,Nmodel)
c =======================================================================
c This subroutine closes output files.             [ZI,Feb'96; MN,Apr'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      CHARACTER*72 su1, su2, s3, s4
      INTEGER  error, model, Nmodel
c -----------------------------------------------------------------------
c     Close the default output file:
      IF (iERROR.NE.0.AND.iOUT.EQ.1) THEN
        write(12,'(a42,i4)')
     &                 ' There are some error messages for model:',model
        write(12,*)
     &         ' Please check m## file (if not produced then rerun)'
      END IF
      IF (iWARNING.NE.0.AND.iOUT.EQ.1.AND.iERROR.EQ.0) THEN
        write(12,'(a36,i4)')
     &  ' There are some warnings for model:',model
        write(12,*)
     &         ' Please check m## file (if not produced then rerun)'
      END IF
      iCUMM = iCUMM + iERROR + iWARNING
      IF (model.EQ.Nmodel.OR.error.EQ.3.OR.error.EQ.4) THEN
      IF (error.NE.3) THEN
       su1=' =========================================================='
       su2='============================'
        IF(denstyp.eq.4.OR.RDW) THEN
          write(12,'(a59,a28)')su1,su2
        ELSE
         IF(denstyp.NE.0) THEN
           write(12,'(a59)')su1
         ELSE
          su1=' ====================================================='
          IF(ksi.GT.0) THEN
           su2='=============='
           write(12,'(a54,a14)')su1,su2
          ELSE
           su2='====='
           write(12,'(a54,a5)')su1,su2
          END IF
         END IF
        END IF
        write(12,'(a23,1p,e8.1,a8)')'   (1) Optical depth at',lamfid,
     &                              ' microns'
        IF(denstyp.eq.0) THEN
c  ----------  for slab output ----------------------------
         write(12,*)
     &'  (2) Bol.flux of the left-side source at the slab left boundary'
         write(12,*)
     & '  (3) f1=F/Fe1, where F is the overall bol.flux in the slab'
         write(12,*)
     & '  (4) Position of the left slab boundary for L=1E4 Lsun'
         write(12,*)
     & '  (5) Dust temperature at the right slab face'
         write(12,*)
     & '  (6) Effective temperature of the left source (in K)'
         IF(ksi.GT.0) THEN
           write(12,*)
     & '  (7) Effective temperature of the right source (in K)'
           write(12,*)'  (8) Maximum error in flux conservation (%)'
         ELSE
           write(12,*)'  (7) Maximum error in flux conservation (%)'
         END IF
        ELSE
c    ---------- for spherical shell ----------------------------
         write(12,*)'  (2) Bolometric flux at the inner radius '
         write(12,*)'  (3) Inner radius for L=1E4 Lsun'
         write(12,*)'  (4) Ratio of the inner to the stellar radius'
         write(12,*)'  (5) Angular size (in arcsec) when Fbol=1E-6 W/m2'
         write(12,*)'  (6) Dust temperature at the outer edge (in K)'
         write(12,*)'  (7) Maximum error in flux conservation (%)'
         IF(denstyp.eq.4.OR.RDW) THEN
          write(12,*)'  (8) Mass-loss rate (in Msun/yr)'
          write(12,*)'  (9) Terminal outflow velocity (in km/s)'
          write(12,*)'  (10) Upper limit of the stellar mass (in Msun)'
         END IF
        END IF
        write(12,*)'================================================='
        IF(iCUMM.EQ.0) write(12,*)' Everything is OK for all models'
        IF(iSPP.NE.0) THEN
         IF(denstyp.eq.0.AND.iSPP.eq.3) THEN
          write(12,*)
     & ' Tables with spectral properties are in files *.spp and *.zpp'
         ELSE
          write(12,*)' Table with spectral properties is in file *.spp'
         END IF
        END IF
       IF(iA.NE.0) THEN
        IF (iA.EQ.1) THEN
          write(12,*)' All spectra are in file *.stb'
        ELSE
         IF (denstyp.EQ.0.AND.iA.EQ.3) THEN
           write(12,*)' Spectra are in files *.s## and *.z##'
         ELSE
           write(12,*)' Spectra are in files *.s##'
         END IF
        END IF
       END IF
       IF (denstyp.NE.0.AND.iC.NE.0) THEN
        IF (abs(iC).EQ.1) THEN
          write(12,*)' All imaging quantities are in file *.itb'
        ELSE
          write(12,*)' Images are in files *.i##'
          IF (iV.NE.0.AND.abs(iC).EQ.3)
     &      write(12,*)' Visibility curves are in files *.v##'
        END IF
        IF (iC.EQ.-3.AND.iPSF.NE.0) THEN
          write(12,*)' Convolved images are in files *.c##'
          IF (psftype.LT.4)
     &    write(12,*)' Point spread functions are in file *.psf'
        END IF
       END IF
       IF(iB.NE.0) THEN
        IF (iB.EQ.1) THEN
          write(12,*)' All radial profiles are in file *.rtb'
        ELSE
          write(12,*)' Radial profiles are in files *.r##'
        END IF
       END IF
       IF (iX.EQ.1)
     &     write(12,*)' All run-time messages are in file *.mtb'
       IF (iX.GT.1)
     &     write(12,*)' Run-time messages are in files *.m##'
      ELSE
        write(12,*)' Ending calculations for this input file'
      END IF
      END IF

      IF (model.EQ.Nmodel.OR.error.EQ.3.OR.error.EQ.4) THEN
        write(12,*)
     &    '========== THE END =============================='
      END IF

c     Table with spectral properties
      IF (iSPP.NE.0) THEN
c       In case of slab: add the zpp table after the spp (if desired)
        IF(denstyp.eq.0.AND.model.eq.Nmodel.AND.iSPP.NE.3) THEN
          s3='###   tau0      Psi      fV       fK       f12    C21  '
          s4=' C31   C43  b8-13 b14-22 B9.8 B11.4  R9.8-18  '
          write(19,'(a49)')
     &              '# ==============================================='
          write(19,'(a49)')
     &              '# Properties of Spectra from the slab left side  '
          write(19,'(a49)')
     &              '# -----------------------------------------------'
          write(19,'(a55,a46)')s3,s4
          DO model = 1, Nmodel
            write(19,'(a100)') zline(model)
          END DO
         Close(19)
         Close(24)
        END IF
      END IF
      IF (model.EQ.1.OR.error.EQ.3) THEN
        IF (iPSF.EQ.1.AND.psftype.LT.4) Close(23)
      END IF
c     conditionally close the spectral files
      IF(iA.EQ.1) THEN
       IF(model.EQ.Nmodel) close(15)
      ELSE
       close(15)
      END IF
c     conditionally close the radial files
      IF(iB.EQ.1) THEN
       IF(model.EQ.Nmodel) close(16)
      ELSE
       close(16)
      END IF
c     conditionally close the imaging files
      IF(abs(iC).EQ.1) THEN
       IF(model.EQ.Nmodel) close(17)
      ELSE
       close(17)
      END IF
      IF(iX.EQ.1) THEN
       IF(model.EQ.Nmodel) close(18)
      ELSE
       close(18)
      END IF

      IF (iPSF.NE.0) Close(21)
      IF (iV.NE.0) Close(22)
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

      SUBROUTINE InpStar(error,is,nameIn)
c =======================================================================
c     This subroutine is for reading the stellar input parameters
c                                                             [MN,Mar'99]
c =======================================================================
      IMPLICIT none
      integer nfit
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nfit=4)
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      CHARACTER strg*40, nameIn*(*)
      INTEGER error, i, is
      DOUBLE PRECISION RDINP, sum
      LOGICAL Equal, NoEqual
c -----------------------------------------------------------------------
c     MG 14.07.09
      double precision av,teff,dist,rinner
      double precision pp(nfit), Router(nfit), scl(nfit)
      integer npow
      common/needed/rinner,router,pp,scl,av,teff,dist,npow

c -----------------------------------------------------------------------
      Equal = .True.
      NoEqual = .False.

      error = 0
c     generic temperature for cases other than BB or Engelke-Marengo shape.
      Tstar = 10000.0d0

c     MG 14.07.09 Overwrite. Use Teff read in from input file
      Tstar= dble(Teff)


c     flag for the external spectrum
      startyp(is) = RDINP(Equal,1)
c     if stellar flag is not btw.1 and 6 stop:
      IF(startyp(is).LT.1 .OR. startyp(is).GT.6) THEN
       CALL MSG(11)
       error = 3
       goto 999
      END IF
c     #1: black body(ies) for startyp=1
      IF (startyp(is).EQ.1) THEN
c       number of black bodies
        nBB(is) = RDINP(Equal,1)
c       stellar temperature(s)
        Tbb(is,1) = RDINP(Equal,1)
        IF (nBB(is).GT.1) THEN
c       multiple black bodies
          Tstar = 0.0d0
          DO i = 2, nBB(is)
            Tbb(is,i) = RDINP(NoEqual,1)
            IF (Tbb(is,i).LE.0.d0) THEN
              CALL MSG(8)
              error = 1
              GOTO 999
            END IF
          END DO
c         read in relative luminosities
          rellum(is,1) = RDINP(Equal,1)
          sum = rellum(is,1)
          DO i = 2, nBB(is)
            rellum(is,i) = RDINP(NoEqual,1)
            sum = sum + rellum(is,i)
          END DO
          IF (sum.LE.0.d0) THEN
             CALL MSG(7)
             error = 1
             GOTO 999
          END IF
c         normalize to 1
          DO i = 1, nBB(is)
            rellum(is,i) = rellum(is,i) / sum
            Tstar = Tstar + rellum(is,i)*Tbb(is,i)**4
          END DO
          Tstar= Tstar**0.25d0
        ELSE
c         this is for a single black body - Tbb(is,1)
          IF(is.eq.1) THEN
           Tstar = Tbb(1,1)
           rellum(1,1) = 1.0d0
          ELSE
           Tstar = Tbb(2,1)
           rellum(2,1) = 1.0d0
          END IF
          IF (Tbb(is,1).LE.0.d0) THEN
             CALL MSG(8)
             error = 1
             GOTO 999
          ELSE
c        end if for first or second source
         END IF
c       end if for one or many BB
        END IF
c     end if for BB-type
      END IF

c     #2: Engelke-Marengo function for startyp=2
      IF (startyp(is).EQ.2) THEN
c        effective stellar temperature
         Tbb(is,1) = RDINP(Equal,1)
         Tstar = Tbb(is,1)
c        depth of SiO abs.feature in %
         xSiO = RDINP(Equal,1)
         IF (xSiO.LE.0.d0) xSiO = 0.0001d0
         IF (xSiO.GT.100.d0) xSiO = 100.0d0
      END IF

c     #3: power-law(s) for startyp=3
      IF (startyp(is).EQ.3) THEN
c       number of transitions
        Nlamtr(is)= RDINP(Equal,1)
        IF (Nlamtr(is).GT.0) THEN
          lamtr(is,1) = RDINP(Equal,1)
          DO i = 2, Nlamtr(is)+1
            lamtr(is,i) = RDINP(NoEqual,1)
            IF (lamtr(is,i).LT.lamtr(is,i-1)) THEN
             CALL MSG(6)
             error = 1
             GOTO 999
            END IF
          END DO
          klam(is,1) = RDINP(Equal,1)
          IF (Nlamtr(is).GT.1) THEN
            DO i = 2, Nlamtr(is)
              klam(is,i) = RDINP(NoEqual,1)
            END DO
          END IF
        ELSE
          startyp(is) = 1
          Tstar = 10000.d0
        END IF
      END IF

c     spectrum from a file for startyp=4,5,6
c     startyp.EQ.4 - file gives lambda*L_lambda
c     startyp.EQ.5 - file gives L_lambda
c     startyp.EQ.6 - file gives Lnu = lambda**2*L_lambda
      IF (startyp(is).EQ.4.OR.startyp(is).EQ.5.OR.startyp(is).EQ.6) THEN
        strg = 'spectral shape of external radiation:'
        CALL FileMSG(nameStar(is),strg)
      END IF

999   RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE INPUT(nameIn,nG,nameOut,nameQ,nameNK,TAU1,TAU2,TAUin,
     &                 Nrec,GridType,Nmodel,error,version)
c =======================================================================
c This subroutine reads input data from the file 'filename'. It
c utilizes the subroutine RDINP written by Moshe Elitzur.
c                                                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7,kk
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1,xpsf, ypsf
      CHARACTER LamStr(20)*72, strpow*72, strg*40, version*4, strscl*72
      CHARACTER*(*) nameIn, nameOut, nameQ(npG), nameNK(10), namePSF*70,
     &         nameTAU*70
      INTEGER iG, nG, Nmodel, i, EtaOK, error, GridType, istop,
     &        ioverflw, Nrec, Nmax
c     Nmax is the size of user supplied ETA file
      PARAMETER (Nmax= 1000)
      DOUBLE PRECISION RDINP, TAU1, TAU2, sum, a, b, x(Nmax), e(Nmax),
     &       aa(Nmax), bb(Nmax), TAUin(Nrec), Ceta, x1, psf1
      LOGICAL Equal, NoEqual
      Equal = .True.
      NoEqual = .False.
c -----------------------------------------------------------------------
      error = 0
c     open output file
      open(12,file=nameOut,STATUS='UNKNOWN')
      write(12,*)'==========================='
      write(12,*)' Output from program Dusty '
      write(12,*)' Version: ',version
      write(12,*)'==========================='
      write(12,*)' '
      write(12,*)' INPUT parameters from file:'
      write(12,'(2x,a70)')nameIn
      write(12,*)' '
c     open input file
      open(1,ERR=998,file=nameIn,STATUS='OLD')
      rewind(1)

c     *************************
c     ** PHYSICAL PARAMETERS **
c     *************************

c     1) EXTERNAL RADIATION
      CALL InpStar(error,1,nameIn)
      IF(error.NE.0) goto 996

c     2) DUST PROPERTIES
c     # of different dust grains, to be used in a future version
c     nG = RDINP(Equal,1)
      nG = 1
c     2.1 Chemical Composition
c     type of optical properties
      top = RDINP(Equal,1)
      IF (top.NE.1.AND.top.NE.2.AND.top.NE.3) THEN
        CALL MSG(9)
        error = 1
        GOTO 999
      END IF
c     for top.LT.3 read in abundances for supported grains
      IF (top.LT.3) THEN
        xC(1) = RDINP(Equal,1)
        IF (xC(1).LT.0.d0) xC(1) = 0.0d0
        sum = xC(1)
        DO i = 2, 7
c         special care to be taken of graphite (1/3-2/3 rule):
          IF (i.NE.5) THEN
            xC(i) = RDINP(NoEqual,1)
            IF (xC(i).LT.0.d0) xC(i) = 0.0d0
c           graphite (perpendicular to c axis) :
            IF (i.EQ.4) xC(i) = 2.d0*xC(i)/3.d0
          ELSE
c           graphite (parallel to c axis) :
            xC(i) = 0.5d0 * xC(i-1)
          END IF
          sum = sum + xC(i)
        END DO
      END IF
c     user supplied n and k:
      IF (top.EQ.2) THEN
        Nfiles = RDINP(Equal,1)
c       file names
        strg = 'optical constants:'
        DO i = 1, Nfiles
          CALL FileMSG(nameNK(i),strg)
        END DO
        IF(error.NE.0) goto 996
c       abundances
        xCuser(1) = RDINP(Equal,1)
        IF (xCuser(1).LT.0.d0) xCuser(1) = 0.0d0
        sum = sum + xCuser(1)
        IF (Nfiles.GT.1) THEN
          DO i = 2, Nfiles
            xCuser(i) = RDINP(NoEqual,1)
            IF (xCuser(i).LT.0.d0) xCuser(i) = 0.0d0
            sum = sum + xCuser(i)
          END DO
        END IF
      END IF
      IF (top.LT.3) THEN
        IF (sum.LE.0.0d0) THEN
          CALL MSG(5)
          error = 1
          GOTO 999
        END IF
c       normalize abundances for supported grains:
        DO i = 1, 7
          xC(i) = xC(i) / sum
        END DO
c       normalize abundances for user supplied grains
        IF (top.EQ.2) THEN
          DO i = 1, Nfiles
            xCuser(i) = xCuser(i) / sum
          END DO
        END IF
      END IF
c     user supplied cross-sections:
      IF (top.EQ.3) THEN
c       filename for Qabs and Qsca
        strg= 'abs. and scatt. cross-sections:'
        DO iG = 1, nG
          CALL FileMSG(nameQ(iG),strg)
        END DO
      END IF

c     2.2 Grain size distribution
      IF (top.NE.3) THEN
c       type of size distribution
        szds = RDINP(Equal,1)
        IF (szds.NE.1.AND.szds.NE.2.AND.szds.NE.3) THEN
          CALL MSG(10)
          error = 1
          GOTO 999
        END IF
c       grain sizes
        IF (szds.GT.1) THEN
          qsd = RDINP(Equal,1)
          a1 = RDINP(Equal,1)
          IF (a1.LE.0.0d0) a1 = 0.0001d0
          a2 = RDINP(Equal,1)
          IF (szds.EQ.2.AND.a2.LT.a1) a2 = a1
        ELSE
          qsd = 3.5d0
          a1 = 0.005d0
          a2 = 0.25d0
        END IF
      END IF

c     2.3 Dust temperature on inner boundary
      DO iG = 1, nG
        Tsub(iG) = RDINP(Equal,1)
      END DO

c     3) DENSITY DISTRIBUTION

c     parameter describing eta function:
      denstyp = RDINP(Equal,1)
c     WriteOut prints all input data, read so far, in fname.out 	
c     It has to be placed here b/c geometry (spherical or slab) is not determine
c     until denstyp is read [MN,Sep'99].
      CALL WriteOut(1,nG,nameQ,nameNK)
c     The following transfers are caused by the change of order
c     of density types [Dec'96]
      IF (denstyp.EQ.1) THEN
        denstyp = 2
        ELSE
        IF (denstyp.EQ.2) THEN
          denstyp = 3
          ELSE
          IF (denstyp.EQ.3) THEN
            denstyp = 5
            ELSE
            IF (denstyp.EQ.4) THEN
              denstyp = 4
              ELSE
              IF (denstyp.EQ.5) denstyp = 7
            END IF
          END IF
        END IF
      END IF
c     initialize the logical variable RDW (in 'denstyp.inc', used in ChkSplin)
      IF(denstyp.eq.5.OR.denstyp.eq.6) THEN
        RDW = .true.
      ELSE
        RDW = .false.
      END IF

      EtaOK = 0
      Ntr = 0
c     Read parameters for each type of density distribution
c     slab geometry
      IF (denstyp.EQ.0) THEN
        EtaOK = 1
        write(12,'(a33)') ' Calculation in planar geometry:'
        mu1 = RDINP(Equal,1)
        IF (mu1.GT.1.0d0) mu1 = 1.0d0
        IF (mu1.LT.0.0d0) mu1 = -1.0d0
        write(12,'(a35,1p,e11.3)')
     &                ' cos of left illumination angle = ',mu1
        ksi = RDINP(Equal,1)
        IF (ksi.LT.0.0d0) ksi = 0.0d0
        IF (ksi.GT.1.0d0) THEN
          ksi = 1.0d0
        END IF
        write(12,'(a6,1p,e11.3)')'  R = ',ksi
        IF(ksi.GT.0.d0) THEN
c         in case of additional source on the right
          mu2 = RDINP(Equal,1)
          IF (mu2.GT.1.0d0) mu2 = 1.0d0
          IF (mu2.LT.0.0d0) mu2 = -1.0d0
          write(12,'(a36,1p,e10.3)')
     &                ' cos of right illumination angle = ',mu2
          CALL InpStar(error,2,nameIn)
          CALL WriteOut(2,nG,nameQ,nameNK)
        ELSE
c         even if no second source is supplied, mu2 needs a value
c         of 1 to avoid crashing in the formulae in SLBStar [MN]
          mu2 = 1.d0
        END IF
      ELSE
        ksi = 0.d0
      END IF
c     smooth or broken power laws
c     MG 27.08.09 Added a scaling of the broken power laws
      IF (denstyp.EQ.1.OR.denstyp.EQ.2) THEN
        EtaOK = 1
        Ntr = RDINP(Equal,1)
c       changed definition
        Ntr = Ntr - 1
c       read in transition radii
        IF (Ntr.GT.0) THEN
          Ytr(1) = RDINP(Equal,1)
          IF (Ntr.GT.1) THEN
            DO i = 2, Ntr
              Ytr(i) = RDINP(NoEqual,1)
            END DO
          END IF
          Yout = RDINP(NoEqual,1)
        ELSE
          Yout = RDINP(Equal,1)
        END IF
        IF (Yout.LE.1.0d0) Yout = 1.001d0
c       read in powers
        pow = RDINP(Equal,1)
        IF (Ntr.GT.0) THEN
          DO i = 1, Ntr
            ptr(i) = RDINP(NoEqual,1)
          END DO
        END IF
c       read in scaling
        scl0 = RDINP(Equal,1)
        IF (Ntr.GT.0) THEN
          DO i = 1, Ntr
            scal(i) = RDINP(NoEqual,1)
          END DO
        END IF
c       print info to the output file
        IF (Ntr.EQ.0) THEN
          CALL getfs(pow,2,0,strpow)
          write(12,'(a38,a5)')
     &      ' Density described by 1/r**k with k =',strpow
          write(12,'(a21,1p,e10.3)')'  Relative thickness:',Yout
        ELSE
          IF (denstyp.EQ.1) THEN
            write(12,*)' Density described by smooth power law'
          ELSE
            write(12,*)' Density described by a broken power law:'
          END IF
          write(12,*)'  power   Ytransition  Scaling'
          write(12,*)'  ----------------------------'
          write(12,*)'              1.0'
          CALL getfs(pow,2,0,strpow)
          CALL getfs(scl0,2,0,strscl)
          write(12,'(a2,a5,15x,a5)')'  ',strpow,strscl
          DO i = 1, Ntr
            write(12,'(a10,1p,e10.3)')'         ',Ytr(i)
            CALL getfs(ptr(i),2,0,strpow)
            CALL getfs(scal(i),3,0,strscl)
            write(12,'(a2,a5,15x,f5.2)')'  ',strpow, scal(i)
          END DO
          write(12,'(a10,1p,e10.3)')'          ',Yout
        END IF
      END IF
c     exponential law
      IF (denstyp.EQ.3) THEN
        EtaOK = 1
        Yout = RDINP(Equal,1)
        IF (Yout.LE.1.0d0) Yout = 1.001d0
        pow = RDINP(Equal,1)
        IF (pow.LE.0.0d0) THEN
          EtaOK = 0
          ELSE
          write(12,*)' Density described by exponential distribution'
          write(12,'(a21,1p,e10.3)')'               Sigma:',pow
          write(12,'(a21,1p,e10.3)')'  Relative thickness:',Yout
        END IF
      END IF
c     default approximation and default numerics for rad. driven winds
      IF (denstyp.EQ.4.OR.denstyp.EQ.5) THEN
        EtaOK = 1
        Yout = RDINP(Equal,1)
        IF (Yout.LE.1.0d0) Yout = 1.001d0
c       ** DEFAULT ** for epsilon = v1/ve = u1/ue:
        pow = 0.2d0
        IF(denstyp.EQ.5) THEN
c         ** DEFAULT ** for Max(GravCor = Fgrav/Frad_press):
          ptr(1) = 0.5d0
c         convergence criterion:
          ptr(2) = 1.0d0
        END IF
        write(12,*)' Density for radiatively driven winds from'
        IF (denstyp.EQ.4) THEN
          write(12,*)' analytic approximation for gray dust.'
        ELSE
          write(12,*)' full dynamic calculation.'
        END IF
        write(12,'(a21,1p,e10.3)')'  Relative thickness:',Yout
      END IF
c     full dynamical calculation for radiatively driven winds
      IF (denstyp.EQ.6) THEN
        EtaOK = 1
c       Yout:
        Yout = RDINP(Equal,1)
        IF (Yout.LE.1.0d0) Yout = 1.001d0
c       u1:
        pow = RDINP(Equal,1)
c       GravCor:
        ptr(1) = RDINP(Equal,1)
c       convergence criterion:
        ptr(2) = 1.0d0
c       default limits
        IF (ptr(1).GT.1.0d0) ptr(1) = 0.9999d0
        IF (ptr(1).LT.0.0d0) ptr(1) = 0.0d0
        write(12,*)' Density for radiatively driven winds:'
        write(12,*)' Full dynamic calculation (denstyp.EQ.6),'
        write(12,'(a6,1p,e10.3,a20,e10.3)')
     &                   '  u1 =',pow,' Gamma^{-1}_{max} =',ptr(1)
      END IF
c     user specified table for ETA
      IF(denstyp.EQ.7) THEN
        EtaOK = 1
        strg = 'dust density distribution:'
        CALL FileMSG(nameETA,strg)
        write(12,*)' Density distribution supplied from file:'
        write(12,'(2x,a70)') nameETA
c       read in the density
        open(31,ERR=997,file=nameETA,STATUS='OLD')
c       three lines in the header:
        DO i = 1, 3
          read(31,*,ERR=997)
        END DO
        istop = 0
        i = 0
        DO WHILE (istop.GE.0)
          read(31,*,END=900,ERR=997,iostat=istop)a, b
          IF (istop.GE.0) THEN
            i = i + 1
            x(i) = a
            e(i) = b
            IF (i.EQ.1) x1 = x(i)
            yEta7(i) = x(i) / x1
          END IF
        END DO
900     close(31)
        Eta7OK = 7
        nYEta7 = i
        IF (nYEta7.LT.2) goto 997
c       if input positions in descending order turn them around
        IF (yEta7(1).GT.yEta7(2)) THEN
          DO i = 1, nYEta7
            aa(i) = yEta7(i)
            bb(i) = e(i)
          END DO
          DO i = 1, nYEta7
            yEta7(i) = aa(nYEta7+1-i)
            e(i) = bb(nYEta7+1-i)
          END DO
        END IF
c       relative thickness
        Yout = yEta7(nYEta7)
        write(12,'(a21,1p,e10.3)')'  Relative thickness:',Yout
        IF (Yout.LE.1.0d0) Yout = 1.001d0
c       integrate and ...
        CALL SIMPSON(Nmax,1,nYEta7,yEta7,e,Ceta)
c       ... renormalize
        DO i = 1, nYEta7
          Eta7(i) = e(i) / Ceta
        END DO
      END IF
c     done with the reading of density distribution
      IF (EtaOK.NE.1) THEN
        CALL MSG(3)
        error = 1
        GOTO 999
      END IF
      write(12,*)' --------------------------------------------'

c     4) OPTICAL DEPTH
c     grid type
      GridType = RDINP(Equal,1)
      IF (GridType.EQ.3) THEN
c     TAU-grid from a file
        strg = 'user supplied TAU-grid:'
        CALL FileMSG(nameTAU,strg)
c       read optical depths
        open(32,ERR=992,file=nameTAU,STATUS='OLD')
c       fiducial wavelength
c       (the second argument of RDINP is the unit)
        lamfid = RDINP(Equal,32)
        i = 0
        DO WHILE (i.LT.Nrec)
          read(32,*,END=902,ERR=992) a
          i = i + 1
          TAUin(i) = a
        END DO
902     close(32)
        Nmodel = i
c       sort the tau-grid
        CALL Sort(TAUin,Nmodel)
        TAU1 = TAUin(1)
        IF (TAU1.LE.0.0d0) TAU1 = 0.0001d0
        TAU2 = TAUin(Nmodel)
      ELSE
c      fiducial wavelength
       lamfid = RDINP(Equal,1)
c      total optical depths at lamfid
       TAU1 = RDINP(Equal,1)
       IF (TAU1.LE.0.0d0) TAU1 = 0.0001d0
       TAU2 = RDINP(Equal,1)
       IF (TAU2.LE.TAU1) THEN
         TAU2 = TAU1
         Nmodel = 1
       END IF
c      read number of models
       Nmodel = RDINP(Equal,1)
       IF (Nmodel.GT.(Nrec-1)) Nmodel = Nrec-1
       IF (Nmodel.LT.1) Nmodel = 1
      END IF
      IF (Nmodel.GT.1) THEN
        write(12,'(a19,1p,e8.1,a8)')' Optical depths at',lamfid,
     &                              'microns'
        write(12,'(a14,1p,e9.2,a3,e9.2)')' ranging from',TAU1,' to',TAU2
        IF (GridType.EQ.1) strg=' models with linear grid    '
        IF (GridType.EQ.2) strg=' models with logarithmic grid'
        IF (GridType.EQ.3) strg=' models with grid from file  '
        write(12,'(a1,i4,a)')' ', Nmodel, strg
        IF (GridType.EQ.3) write(12,'(a4,a70)')'    ',nameTAU
      ELSE
        write(12,'(a18,1p,e9.2,a9,e10.3)')' Optical depth at',lamfid,
     &                                    ' microns:',TAU1
      END IF

c     ************************
c     ** NUMERICAL ACCURACY **
c     ************************
c     some of the parameters were originally left to user to
c     specify them, most of them are now unchangeable defaults
c     max. increase of scaled TAU/TAUtot
c      delTAUsc = RDINP(Equal,1)
c      IF (delTAUsc.LE.0.0) delTAUsc = 0.3
      delTAUsc= 0.3d0
c     max. increase in the ratio of two y
c      facc = RDINP(Equal,1)
c      IF (facc.LE.0.0) facc = 2.0
c     STANDARD VALUE IN DUSTY
      facc= 2.0d0
c     MG 30.01.11 U Cam
      facc= 1.5d0
c     MG 27.08.09 (final value based on 2 points in U Hya density enhancement)
c      facc= 1.2d0
c      do kk=1,ntr
c        if (scal(kk)/scl0 .gt. 3./2. .OR. scal(kk)/scl0 .lt. 2./3.) then
c           facc= 1.2d0
c           goto 123
c        endif
c      enddo
c 123  continue
c     max allowed ratio of Eta for two consecutive pts.
      EtaRat= 4.0d0
c     MG 27.08.09
c     With scaling factors in powerlaws, ratios WILL be large, so escape this
      do kk= 1,ntr
       if (scal(kk)/scl0.gt. 1.5d0 .OR.scal(kk)/scl0.lt. 1.d0/1.5d0)then
           EtaRat= 2000.d0
           EtaRat= 20000.d0
           goto 124
        endif
      enddo
 124  continue
c     # of rays per radial step
c      Nins = RDINP(Equal,1)
c      IF (Nins.LE.0) Nins = 2
      Nins = 2
c     accuracy for numerical integration in ROMBERG
c      accRomb = RDINP(Equal,1)
c      IF (accRomb.LE.0.0) accRomb = 0.0001
c      IF (accRomb.GT.0.005) accRomb = 0.005
      accRomb = 0.0001d0
c     accuracy for flux conservation
      accuracy = RDINP(Equal,1)
      IF (accuracy.LE.0.0d0) accuracy = 0.05d0
c     protect against a very large value for accuracies
      IF (accuracy.GT.0.25d0) accuracy = 0.25d0
c     accuracy for convergence (typical 0.0001)
      accConv = accuracy / 500.d0
      accFbol = 10.d0*accConv
c     dynamical range
c      dynrange = RDINP(Equal,1)
c      IF (dynrange.LE.0.0) dynrange = 1.0e-14
c      IF (dynrange.GT.0.0001) dynrange = 1.0e-4
      dynrange = 1.0d-15
      IF (accuracy.GE.0.1d0) THEN
        CALL getfs(accuracy*100,0,1,strpow)
        write(12,'(a20,a3,a1)')' Required accuracy:',strpow,'%'
      ELSE
        CALL getfs(accuracy*100,0,1,strpow)
        write(12,'(a20,a2,a1)')' Required accuracy:',strpow,'%'
      END IF
      write(12,*)' --------------------------------------------'
c     ******************
c     ** OUTPUT FLAGS **
c     ******************
c     A flag for additional output for us only [MN]:
c     If iInn=1: print err.vs.iter in unt=38 (fname.err) for all models
c     and additionally list scaled fbol(y) and Ubol(y) in m-files.
c     iInn replaces iLTS in 'output.inc'
      iInn = 0
c     these two by default
      iSUM = 1
      iOUT = 1
      iVerb = RDINP(Equal,1)
c     spectral properties
      iSPP = RDINP(Equal,1)
c     spectra
      iA = RDINP(Equal,1)
c     images (intensity) for spherical only
      IF(denstyp.NE.0) THEN
       iC = RDINP(Equal,1)
       IF (iC.NE.0) THEN
        NlambdaOut = RDINP(Equal,1)
        IF (NlambdaOut.GE.1) THEN
          DO i = 1, NlambdaOut
            LambdaOut(i) = RDINP(NoEqual,1)
c           make sure the wavelengths are inside Dusty's range
            IF (LambdaOut(i).LE.0.01d0)   LambdaOut(i) = 0.01d0
            IF (LambdaOut(i).GT.36000.d0) LambdaOut(i) = 36000.d0
          END DO
          ioverflw = 0
          DO i = 1, NlambdaOut
            IF (LambdaOut(i).LT.0.995d0) THEN
              CALL getfs(LambdaOut(i),2,1,LamStr(i))
            ELSE
              IF (LambdaOut(i).LT.9.95d0) THEN
               CALL getfs(LambdaOut(i),1,0,LamStr(i))
              ELSE
                IF (LambdaOut(i).LT.99.5d0) THEN
                 CALL getfs(LambdaOut(i),0,0,LamStr(i))
                ELSE
                 CALL getfs(LambdaOut(i),0,1,LamStr(i))
c                  IDINT truncates the numbers
c                  prn = IDINT(LambdaOut(i))
c                  write (LamStr(i),'(I6)') prn
                END IF
              END IF
            END IF
            IF (LambdaOut(i).GT.9999.5d0) THEN
              ioverflw = 1
              strpow = LamStr(i)
              strpow(4:4) = '*'
              strpow(5:5) = ' '
              LamStr(i) = strpow
            END IF
          END DO
        END IF
        write(12,*)' Images requested for these wavelengths (mic)'
        write(12,'(a1,20a5)')' ',(LamStr(i),i=1,NlambdaOut)
        IF (ioverflw.EQ.1) write(12,*)'  *: in mm'
c       convolved images  (only for our use)
c        write(*,*) 'convolved ', iC
        IF (iC.LT.0) THEN
         iPSF = RDINP(Equal,1)
         IF (iPSF.NE.0) THEN
           Theta1= RDINP(Equal,1)
           write(12,'(a39,1p,e9.3)')
     &           ' Convolved images produced for theta1=',Theta1
           psftype = RDINP(Equal,1)
           write(*,*) 'convolved ', iPSF, psftype, nlambdaout
           IF (psftype.NE.1.AND.psftype.NE.2.AND.psftype.NE.3
     c                                      .AND.psftype.NE.4) goto 994
           IF (psftype.LT.4) THEN
c            Gaussians, read in parameters
c            FWHM for the first component
c            MG: if psftype=3: Bessell function, read in Diameter primary mirror in meter
             FWHM1(1) = RDINP(Equal,1)
             IF (NlambdaOut.GT.1) THEN
               DO i = 2, NlambdaOut
                FWHM1(i) = RDINP(NoEqual,1)
                if  (FWHM1(i) .le. 0.d0) FWHM1(i)= FWHM1(1)
               END DO
             END IF
             IF (psftype.EQ.2) THEN
c             relative strength for the second component
              kPSF(1) = RDINP(Equal,1)
              IF (NlambdaOut.GT.1) THEN
                DO i = 2, NlambdaOut
                  kPSF(i) = RDINP(NoEqual,1)
                END DO
              END IF
c             FWHM for the second component
              FWHM2(1) = RDINP(Equal,1)
              IF (NlambdaOut.GT.1) THEN
                DO i = 2, NlambdaOut
                  FWHM2(i) = RDINP(NoEqual,1)
                END DO
              END IF
             ENDIF
c     MG Bessell function
             IF (psftype.EQ.3) THEN
c              diameter (meter) of 'hole'
              kPSF(1) = RDINP(Equal,1)
              IF (NlambdaOut.GT.1) THEN
                DO i = 2, NlambdaOut
                  kPSF(i) = RDINP(NoEqual,1)
                END DO
              END IF
c     now make sense of it
              DO i = 1, NlambdaOut
c     of relevance here is D1/D0
                   kPSF(i)=  kPSF(i)/FWHM1(i)
c     lambda/D is the relevant quantity later, and luckily it is almost equivalent to the FWHM of the Gaussian
                   FWHM1(i)=  LambdaOut(i)/FWHM1(i) * 206264.8d-6
                   FWHM2(i)=  0.d0
                   write(*,*) i, LambdaOut(i), kpsf(i), fwhm1(i)
              END DO
             END IF
             IF (psftype.LT.3) write(12,*)'The PSFs are Gaussians'
             IF (psftype.EQ.3) write(12,*)'The PSFs are Bessell fie'

           ELSE
c           user supplied PSF
            strg = 'point spread function:'
            CALL FileMSG(namePSF,strg)
            write(12,*)' The point spread function supplied from file'
            write(12,'(2x,a70)')namePSF
            open(31,ERR=995,file=namePSF,STATUS='OLD')
c           three lines in the header:
            DO i = 1, 3
              read(31,*,ERR=995)
            END DO
            istop = 0
            i = 0
            DO WHILE (istop.GE.0)
              read(31,*,END=901,ERR=995,iostat=istop)a, b
              IF (istop.GE.0) THEN
                i = i + 1
                IF (i.EQ.1) THEN
                  psf1 = b
                  IF (a.NE.0.d0) goto 995
                END IF
                xpsf(i) = a
                ypsf(i) = b / psf1
              END IF
            END DO
901         close(31)
            Npsf = i
c           scale to 1 at the center
            CALL ScaleTo1(1000,Npsf,ypsf)
c           find equivalent FWHM
            istop = 0
            i = 1
            DO WHILE (istop.EQ.0)
              i = i + 1
              IF (ypsf(i).LE.0.5d0) istop = 1
            END DO
c           linear interpolation
            FWHM1(1) = (xpsf(i)-xpsf(i-1))/(ypsf(i)-ypsf(i-1))
            FWHM1(1) = (FWHM1(1)*(0.5d0-ypsf(i-1))+xpsf(i-1))*2
            FWHM2(1) = 0.0d0
            write(12,'(a18,1p,e8.1)')' Equivalent FWHM:',FWHM1(1)
           END IF
         END IF
        END IF
c       visibility (only if the intensity is requested)
        iV = RDINP(Equal,1)
        IF(iV.NE.0) iV = iC
c        write(*,*) 'visibilities iV ', iV
        write(12,*)' --------------------------------------------'
       ELSE
        iPSF = 0
        iV = 0
       END IF
      ELSE
       iC = 0
      END IF
      write(12,*)' '
c     radial quantities
      iB = RDINP(Equal,1)
c     run-time messages
      iX = RDINP(Equal,1)
      iINP = 0
c     *** DONE ***
c     if everything is OK, close the input file and finish
999   goto 996
c     or in the case of err reading files...
992   write(12,*)' ***  FATAL ERROR IN DUSTY  *************'
      write(12,*)' File with user supplied TAU-grid:'
      write(12,'(2x,a70)') nameTAU
      write(12,*)' is not properly formatted?!'
      write(12,*)' ****************************************'
      close(12)
      error = 3
      goto 996
994   CALL MSG(12)
      close(12)
      error = 3
      goto 996
995   write(12,*)' ***  FATAL ERROR IN DUSTY  *************'
      write(12,*)' File with the point spread function:'
      write(12,'(a2,a70)')'  ', namePSF
      write(12,*)' is not properly formatted?!'
      write(12,*)' ****************************************'
      close(12)
      error = 3
997   write(12,*)' ***  FATAL ERROR IN DUSTY  *************'
      write(12,*)' File with the dust density distribution:'
      write(12,'(2x,a70)') nameETA
      write(12,*)' is not properly formatted?!'
      write(12,*)' ****************************************'
      close(12)
      error = 3
998   write(12,*)' ***  FATAL ERROR IN DUSTY  ****'
      write(12,*)' Input file:'
      write(12,'(2x,a70)') nameIn
      write(12,*)' is missing?!'
      write(12,*)' *******************************'
      close(12)
      error = 3
c -----------------------------------------------------------------------
996   close(1)
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE OPPEN(model,RootName,length)
c =======================================================================
c This subroutine prints the results out.              [Z.I., Feb. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1,xpsf, ypsf
      CHARACTER ch5*5, RootName*(*), fname*235
      CHARACTER*72 header1, s3, s4
      INTEGER model, length, i
c -----------------------------------------------------------------------
c     set up the status indicators
      iERROR = 0
      iWARNING = 0
      IF (model.EQ.1) iCUMM = 0
c     The following files pertain to ALL models and are open if model.EQ.1
      IF (model.EQ.1) THEN
c      the header to output file *.OUT is moved to PrOut [MN,Sep'99]

c      open file with spectral properties RootName.SPP
       IF (iSPP.NE.0) THEN
        CALL Attach(RootName,length,'.spp',fname)
        open(19,file=fname,STATUS='UNKNOWN')
        IF(denstyp.EQ.0) THEN
          write(19,'(a49)')
     &              '# ==============================================='
          write(19,'(a49)')
     &              '# Properties of Spectra from the slab right side '
          write(19,'(a49)')
     &              '# -----------------------------------------------'
        ELSE
          call line(1,2,19)
          write(19,'(a23)')'#  Spectral Properties '
          call line(1,1,19)
        END IF
         s3='###   tau0      Psi      fV       fK       f12    C21  '
         s4=' C31   C43  b8-13 b14-22 B9.8 B11.4  R9.8-18  '
         write(19,'(a55,a46)')s3,s4
        IF (denstyp.EQ.0.AND.iSPP.EQ.3) THEN
        CALL Attach(RootName,length,'.zpp',fname)
          open(24,file=fname,STATUS='UNKNOWN')
          write(24,'(a49)')
     &              '# ==============================================='
          write(24,'(a49)')
     &              '# Properties of Spectra from the slab left side  '
          write(24,'(a49)')
     &              '# -----------------------------------------------'
         s3='###   tau0      Psi      fV       fK       f12    C21  '
         s4=' C31   C43  b8-13 b14-22 B9.8 B11.4  R9.8-18  '
           write(24,'(a55,a46)')s3,s4
        END IF
       END IF
c       open file for point spread function
        IF (iPSF.NE.0.AND.psftype.LT.4) THEN
c         wavelength dependent PSF are also printed out
          CALL Attach(RootName,length,'.psf',fname)
          open(23,file=fname,STATUS='UNKNOWN')
          header1 = '    Offset'
          write(23,'(a10,20f10.2)')header1,(lambdaOut(i),i=1,NlambdaOut)
        END IF
c       Spectra for all models in one file '*.stb' if flag=1
        IF(iA.eq.1) THEN
         CALL Attach(RootName,length,'.stb',fname)
         open(15,file=fname,STATUS='UNKNOWN')
        END IF
c       All radial profiles in one file '*.rtb' if flag=1
        IF(iB.eq.1) THEN
         CALL Attach(RootName,length,'.rtb',fname)
         open(16,file=fname,STATUS='UNKNOWN')
        END IF
c       All imaging files in  '*.itb' if flag=1
        IF (abs(iC).eq.1) THEN
         CALL Attach(RootName,length,'.itb',fname)
         open(17,file=fname,STATUS='UNKNOWN')
        END IF
        IF(iX.eq.1) THEN
         CALL Attach(RootName,length,'.mtb',fname)
         open(18,file=fname,STATUS='UNKNOWN')
        END IF
        IF(iInn.eq.1) THEN
         CALL Attach(RootName,length,'.err',fname)
         open(38,file=fname,STATUS='UNKNOWN')
        END IF
c     end if for model=1
      END IF
c -------------------------------------------------------------
c     the following files are open for EVERY model

c     (the headers for .s## and .r## files are moved to PrOut, MN)
c     open the spectrum file RootName.s##  (## = model number)
      IF(iA.GT.1) THEN
       write(ch5,'(a2,I3.3)') '.s', model
       CALL Attach(RootName,length,ch5,fname)
       open(15,file=fname,STATUS='UNKNOWN')
       IF(denstyp.EQ.0) THEN
         IF(iA.eq.3) THEN
           write(ch5,'(a2,I3.3)') '.z', model
           CALL Attach(RootName,length,ch5,fname)
           open(25,file=fname,STATUS='UNKNOWN')
         END IF
       END IF
      END IF
c     open the file RootName.r## (y-dependent quantities)
      IF(iB.GT.1) THEN
        write(ch5,'(a2,I3.3)') '.r', model
        CALL Attach(RootName,length,ch5,fname)
        open(16,file=fname,STATUS='UNKNOWN')
      END IF
c     open the file RootName.i## (surface brightness)
      IF(abs(iC).GT.1) THEN
        write(ch5,'(a2,I3.3)') '.i', model
        CALL Attach(RootName,length,ch5,fname)
        open(17,file=fname,STATUS='UNKNOWN')
      END IF
c     open the file RootName.c## (convolved images) for flag iC<0
c      if iC=-3 - in a separate file fname.c##
      IF(iC.EQ.-3.AND.iPSF.GT.0) THEN
        write(ch5,'(a2,I3.3)') '.c', model
        CALL Attach(RootName,length,ch5,fname)
        open(21,file=fname,STATUS='UNKNOWN')
      END IF
c     open the file RootName.v## (visibility curves)
      IF((abs(iC).EQ.3).AND.(iV.GT.0)) THEN
        write(ch5,'(a2,I3.3)') '.v', model
        CALL Attach(RootName,length,ch5,fname)
        open(22,file=fname,STATUS='UNKNOWN')
      END IF
c     open the output file RootName.m##
      IF (iX.GT.1) THEN
        write(ch5,'(a2,I3.3)') '.m', model
        CALL Attach(RootName,length,ch5,fname)
        open(18,file=fname,STATUS='UNKNOWN')
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE PROUT(model)
c =======================================================================
c This subroutine prints the results out.        [ZI,Feb'96; MN,Mar'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION ugas(npY), qF(npY), vrat(npG,npY), Gamma(npY),
     &       I1, I2, I3, CMdot, Cve, CM, Cr1
      COMMON /dyn/ ugas, qF, vrat, Gamma, I1, I2, I3, CMdot, Cve, CM,
     &       Cr1
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      CHARACTER*72 SC21,SC31,SC43,SB98,SB11,Sbet1,Sbet2,STemp,Serr,
     &             hdint, hdcon, hdvis, s1, su1, s2, su2, Tstr*10
      CHARACTER*132 hdsp1,hdsp2,hdrslb1,hdrslb2,hdrsph1,hdrsph2,hdrdyn
      INTEGER iY, iL, i, model, j, unt
      DOUBLE PRECISION PSFN, PSFfunc(20,1000), Elems(25,1000),  ETA,
     &        faux(npL), fsRbol(npY), tht1, xs, xds, xde, g, res, fnorm
c ----------------------------------------------------------------------
c     SmC(1..5, model) are found in ANALYSIS
      SmC(6,model) = Td(1,nY)
c     SmC(7,model) and SmC(8,model) are Teff(L) and Teff(R), respectively,
c     the Teff of the slab illumination sources, found from F1 in Analysis
      tht1 = 412.6d0/(dsqrt(F1))
c     colors
      CALL getFS(SpecChar(9,model),2,0,SC21)
      CALL getFS(SpecChar(10,model),2,0,SC31)
      CALL getFS(SpecChar(11,model),2,0,SC43)
c     error in %
      IF (SmC(5,model).LT.0.1d0) THEN
        CALL getFS(SmC(5,model)*100,0,0,Serr)
      ELSE IF (SmC(5,model).LT.1.0d0) THEN
        CALL getFS(SmC(5,model)*100,0,1,Serr)
      ELSE
        CALL getFS(SmC(5,model)*100,0,2,Serr)
      END IF
c     dust temperature at y=Y
      IF (SmC(6,model).LT.99.5d0) THEN
        CALL getFS(SmC(6,model),0,0,STemp)
      ELSE
        CALL getFS(SmC(6,model),0,1,STemp)
      END IF

c --------------  overall parameters to *.OUT file -----------------------
c     write header to output file *.OUT
      IF (model.EQ.1) THEN
       write(12,*)'         '
       write(12,*)' RESULTS:'
       write(12,*)' --------'
       IF (denstyp.EQ.0) THEN
c     ---------- slab output ----------------
        s1=' ###   tau0    Fe1(W/m2)   f1     r1(cm)  Td(K)  Te(L)'
       su1=' ###     1        2         3       4       5      6  '
        IF(ksi.GT.0) THEN
          s2='   Te(R)   err'
         su2='     7      8 '
         write(12,'(a54,a14)')s1,s2
         write(12,'(a54,a14)')su1,su2
         su1=' ====================================================='
         su2='=============='
         write(12,'(a54,a14)')su1,su2
        ELSE
          s2='  err '
         su2='   7  '
         write(12,'(a54,a6)')s1,s2
         write(12,'(a54,a6)')su1,su2
         su1=' ====================================================='
         su2='====='
         write(12,'(a54,a6)')su1,su2
        END IF
       ELSE
c     ------------- output for sphere -----------------------------
        s1=' ###   tau0   F1(W/m2)  r1(cm)    r1/rc   theta1  Td(Y) err'
       su1=' ###     1        2        3        4        5      6    7 '
        IF(denstyp.eq.4.OR.RDW) THEN
        s2='   Mdot      Ve       M> '
       su2='     8        9       10 '
         write(12,'(a59,a25)')s1,s2
         write(12,'(a59,a25)')su1,su2
       su1=' =========================================================='
       su2='============================'
         write(12,'(a59,a28)')su1,su2
        ELSE
         write(12,'(a59)')s1
         write(12,'(a59)')su1
       su1=' =========================================================='
         write(12,'(a59)')su1
        END IF
       END IF
      END IF
c     print output tables
c     for slab:
      IF(denstyp.EQ.0) THEN
      IF (fmed.LE.accFbol) fmed = 0.d0
        IF(ksi.NE.0.d0) THEN
          CALL Bolom(fsR,fsRbol)
          g = ksi*fsRbol(1) + fmbol(1)
        ELSE
          g = fmbol(1)
        END IF
        IF (ksi.GT.0) THEN
         IF (SmC(6,model).GE.999.5d0) THEN
          write(12,'(i4,1p,2E9.2,E10.2,E9.2,a5,1p,2E9.2,a4)')
     &    model, TAUfid, F1, fmed, Cr1, STemp, SmC(7,model),
     &                                         SmC(8,model), Serr
         ELSE
          write(12,'(i4,1p,2E9.2,E10.2,E9.2,a1,a4,1p,2E9.2,a4)')
     &    model, TAUfid, F1, fmed, Cr1, ' ',STemp, SmC(7,model),
     &                                             SmC(8,model), Serr
         END IF
        ELSE
         IF (SmC(6,model).GE.999.5d0) THEN
          write(12,'(i4,1p,2E9.2,E10.2,E9.2,a5,1p,E9.2,a3)')
     &    model, TAUfid, F1, fmed, Cr1, STemp, SmC(7,model), Serr
         ELSE
          write(12,'(i4,1p,2E9.2,E10.2,E9.2,a1,a4,1p,E9.2,a3)')
     &    model, TAUfid, F1, fmed, Cr1,' ', STemp, SmC(7,model), Serr
         END IF
        END IF

      ELSE
c     for spherical shell
        IF (SmC(6,model).LT.9.5d0) THEN
          IF (denstyp.eq.4.OR.RDW) THEN
           write(12,'(i4,1p,5E9.2,a2,a3,a1,a3,1p,3E9.2)')
     &     model, TAUfid, F1, Cr1, r1rs, tht1,'  ', STemp,' ',Serr,
     &                                    CMdot, CVe, CM
          ELSE
           write(12,'(i4,1p,5E9.2,a2,a4,a3)')
     &     model, TAUfid, F1, Cr1, r1rs, tht1,'  ', STemp, Serr
          END IF
        ELSE
         IF (denstyp.eq.4.OR.RDW) THEN
          write(12,'(i4,1p,5E9.2,2(a1,a4),1p,3E9.2)')
     &    model, TAUfid, F1, Cr1, r1rs, tht1,' ',STemp,' ', Serr,
     &                                    CMdot, CVe, CM
         ELSE
          write(12,'(i4,1p,5E9.2,2(a1,a4))')
     &    model, TAUfid, F1, Cr1, r1rs, tht1,' ',STemp,' ', Serr
         END IF
        END IF

       IF (startyp(1).EQ.1.OR.startyp(1).EQ.2) THEN
        IF(Tstar.LT.Te_min) THEN
          CALL GetFS(Tstar,0,1,Tstr)
          write(12,'(a50,a5,a5)')
     &' ** WARNING: the input spectrum is a black-body at ',Tstr,' K **'
          CALL GetFS(Te_min,0,1,Tstr)
          write(12,'(a50,a5,a5)')
     &' *The point-source assumption requires min Teff of ',Tstr,' K **'
        END IF
       END IF
c     end if for geometry
      END IF

      CALL getFS(SpecChar(1,model),2,0,SB98)
      CALL getFS(SpecChar(2,model),2,0,SB11)
      CALL getFS(SpecChar(4,model),2,0,Sbet1)
      CALL getFS(SpecChar(5,model),2,0,Sbet2)
c --------------     spectral properties to *.SPP file   -----------------------
      IF (iSPP.NE.0) THEN
       write(19,'(i3,1p,5E9.2,7a6,E9.2)') model, TAUfid, SmC(1,model),
     &      (SpecChar(i,model),i=6,8), SC21, SC31, SC43, Sbet1, Sbet2,
     &       SB98, SB11, SpecChar(3,model)
      END IF

c --------------   spectrum to *.s## (old *.Axx) file   ------------------------
      IF (iA.NE.0) THEN
       IF(denstyp.EQ.0) THEN
        hdsp1 = '#  lambda     fRight       xAtt       xDs   '
       ELSE
        hdsp1 = '#  lambda      fTot        xAtt       xDs   '
       END IF
        hdsp2 = '     xDe       fInp       tauT      albedo  '
        unt = 15
        call line(1,2,unt)
        IF(denstyp.EQ.0) THEN
          write(unt,'(a8,i4,a36)')
     &         '#  model',model,'   SPECTRUM from the right slab side '
        ELSE
          write(unt,'(a8,i4,a12)') '#  model',model,'   SPECTRUM '
        END IF
        call line(1,1,unt)
        DO iL = 1, nL
c         The right-side spectra are: ftot + ksi*fsR = fsL + fds + fde
          ftot(iL,nYok) = ftot(iL,nYok) + ksi*fsR(iL,nYok)
          faux(iL) = ftot(iL,nYok)/lambda(iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,faux,res)
c       Normalization factor for slab s-spectra
        fnorm = res
        DO iL = 1, nL
           IF (ftot(iL,nYok).NE.0.d0) THEN
             xs = fsL(iL,nYok)/ftot(iL,nYok)
             xds = fds(iL,nYok)/ftot(iL,nYok)
             xde = fde(iL,nYok)/ftot(iL,nYok)
           ELSE
             xs = 0.0d0
             xds = 0.0d0
             xde = 0.0d0
           END IF
c          change introduced for version 11a - no need to print negligible value
           IF (ftot(iL,nYok).LT.1.0d-20) ftot(iL,nYok) = 0.d0
           IF (xs.LT.1.0d-20) xs = 0.0d0
           IF (xds.LT.1.0d-20) xds = 0.0d0
           IF (xde.LT.1.0d-20) xde = 0.0d0
           IF (fsL(iL,1).LT.1.0d-20) fsL(iL,1) = 0.0d0
c          for slab rescale fTot with the bolom flux
           IF (denstyp.eq.0) ftot(iL,nYok) = ftot(iL,nYok)/fnorm
           Elems(1,iL) = lambda(iL)
           Elems(2,iL) = fTot(iL,nYok)
           Elems(3,iL) = xs
           Elems(4,iL) = xds
           Elems(5,iL) = xde
           Elems(6,iL) = fsL(iL,1)
           Elems(7,iL) = TAUtot(iL)
           Elems(8,iL) = omega(iL,1)
        END DO
c     ------ Tabulate the spectra in the desired form ----------
        write(unt,'(2(a45))') hdsp1,hdsp2
        CALL MakeTable(Elems,nL,8,unt)
c       spectra from the illuminated slab side (file *.z##)
        IF (denstyp.EQ.0) THEN
           DO iL = 1, nL
c           The left-side spectra are: |R*fsR + fm|=|fsL-ftot|
            ftot(iL,1) = dabs(fsL(iL,1) - ftot(iL,1))
c           normalization of z-spectra for slab
            faux(iL) = ftot(iL,1)/lambda(iL)
           END DO
           CALL Simpson(npL,1,nL,lambda,faux,res)
           fnorm = res	
           DO iL = 1, nL
             IF (ftot(iL,1).NE.0.0d0) THEN
                xs =  ksi*fsR(iL,1)/ftot(iL,1)
                xds = dabs(fds(iL,1)/ftot(iL,1))
                xde = dabs(fde(iL,1)/ftot(iL,1))
             ELSE
                xs = 0.0d0
                xds = 0.0d0
                xde = 0.0d0
             END IF
             IF (xs.LT.1.0d-20) xs =0.0d0
             IF (xds.LT.1.0d-20) xds =0.0d0
             IF (xde.LT.1.0d-20) xde =0.0d0
             IF(fsR(iL,nYok).LT.1.0d-20) fsR(iL,nYok) = 0.0d0
             IF(ftot(iL,1).LT.1.0d-20) ftot(iL,1) = 0.0d0
c            rescale fTot with the bolom flux for z-spectra
             ftot(iL,1) = ftot(iL,1)/fnorm
             Elems(1,iL) = lambda(iL)
             Elems(2,iL) = fTot(iL,1)
             Elems(3,iL) = xs
             Elems(4,iL) = xds
             Elems(5,iL) = xde
             Elems(6,iL) = ksi*fsR(iL,nYok)
             Elems(7,iL) = TAUtot(iL)
             Elems(8,iL) = omega(iL,1)
           END DO
           IF (iA.EQ.3) unt=25
c          append to the .s## file or write in a separate .z## file (if iA=3)
           call line(1,1,unt)
           write(unt,'(a8,i4,a36)')
     &         '#  model',model,'   SPECTRUM from the left slab side'
           call line(1,1,unt)
           hdsp1 = '#  lambda      fLeft       xAtt       xDs   '
           write(unt,'(2(a45))') hdsp1,hdsp2
           CALL MakeTable(Elems,nL,8,unt)
        END IF
      END IF

c     spectral properties for *.ZPP file in slab case
      IF (denstyp.eq.0.AND.iSPP.NE.0) THEN
        CALL getFS(SpecChar(12,model),2,0,SB98)
        CALL getFS(SpecChar(13,model),2,0,SB11)
        CALL getFS(SpecChar(15,model),2,0,Sbet1)
        CALL getFS(SpecChar(16,model),2,0,Sbet2)
        CALL getFS(SpecChar(20,model),2,0,SC21)
        CALL getFS(SpecChar(21,model),2,0,SC31)
        CALL getFS(SpecChar(22,model),2,0,SC43)
c       write spectral properties to *.ZPP file
         IF (iSPP.EQ.3) THEN
            write(24,'(i3,1p,5E9.2,7a6,E9.2)')
     &      model, TAUfid, SmC(1,model), (SpecChar(i,model),i=17,19),
     &      SC21,SC31,SC43, Sbet1,Sbet2, SB98,SB11,SpecChar(14,model)
         ELSE
            write(zline(model),'(i3,1p,5E9.2,7a6,E9.2)')
     &      model, TAUfid, SmC(1,model), (SpecChar(i,model),i=17,19),
     &      SC21,SC31,SC43, Sbet1,Sbet2,SB98,SB11,SpecChar(14,model)
         END IF
      END IF

c -----------  y-dependent quantities to *.r## (old *.Bxx) file -------------
      IF (iB.NE.0) THEN
       hdrslb1= '#     t        tauF      epsilon       Td '
       hdrslb2= '      febol      fRbol      fLbol '
       hdrsph1= '#     y         eta         t         tauF '
       hdrsph2= '     epsilon      Td         rg '
        hdrdyn= '         u        drift'
       unt = 16
       call line(1,2,unt)
       IF(denstyp.EQ.0) THEN
          write(unt,'(a8,i4,a18)') '#  model',model,'  SPATIAL PROFILES'
       ELSE
          write(unt,'(a8,i4,a18)') '#  model',model,'  RADIAL PROFILES '
       END IF
       call line(1,1,unt)
c    --------- for slab ---------
       IF (denstyp.EQ.0) THEN
         DO iY = 1, nYok
           Elems(1,iY) = tr(iY)
           Elems(2,iY) = tauF(iY)
           Elems(3,iY) = Eps(iY)
           Elems(4,iY) = Td(1,iY)
           Elems(5,iY) = fsbol(iY)
           Elems(6,iY) = fpbol(iY)
           Elems(7,iY) = fmbol(iY)
         END DO
c      check for nonsense values:
         DO i = 1, 8
          DO iY = 1, nYok
           IF (Elems(i,iY).NE.Elems(i,iY)) THEN
              Elems(i,iY) = 0.0d0
           END IF
          END DO
         END DO
         write(unt,'(a42,a34)') hdrslb1,hdrslb2
         CALL MakeTable(Elems,nYok,7,unt)
       ELSE
c     ------  for spherical shell --------
        DO iY = 1, nYok
          Elems(1,iY) = Yok(iY)
          Elems(2,iY) = ETA(Y(iY))
          Elems(3,iY) = tr(iY)
          Elems(4,iY) = tauF(iY)
          Elems(5,iY) = Eps(iY)
          Elems(6,iY) = Td(1,iY)
          Elems(7,iY) = rg(1,iY)
        END DO
c       check for nonsense values:
        DO i = 1, 7
         DO iY = 1, nYok
          IF(Elems(i,iY).NE.Elems(i,iY).OR.Elems(i,iY).LT.1.d-20) THEN
            Elems(i,iY) = 0.0d0
          END IF
         END DO
        END DO
c       with dynamics
        IF (RDW) THEN
         DO iY = 1, nYok
           Elems(8,iY) = ugas(iY)/ugas(nYok)
           Elems(9,iY) = vrat(1,iY)
         END DO
c        check values:
         DO i = 8, 9
          DO iY = 1, nYok
           IF(Elems(i,iY).NE.Elems(i,iY).OR.Elems(i,iY).LT.1.d-20) THEN
             Elems(i,iY) = 0.0d0
           END IF
          END DO
         END DO
         write(unt,'(a42,a32,a23)') hdrsph1,hdrsph2,hdrdyn
         CALL MakeTable(Elems,nYok,9,unt)
        ELSE
         write(unt,'(a42,a32)') hdrsph1,hdrsph2
         CALL MakeTable(Elems,nYok,7,unt)
        END IF
c      end if for geometry
       END IF
c     end if for the iB (radial) flag
      END IF

c --------------   intensities to *.inn (old *.Cxx) file  --------------
      IF (abs(iC).NE.0) THEN
        hdint = '#     b          t(b)'
        hdcon = '#   Offset '
        hdvis = '#     q    '
        unt = 17
        CALL LINE(1,2,unt)
        write(unt,'(a8,i4,a14)') '#  model',model,'   RAW IMAGE  '
        CALL LINE(1,1,unt)
        DO i = 1, nPok+2
          Elems(1,i) = bOut(i)
          Elems(2,i) = tauZout(i)
          DO j = 1, NLambdaOut
c           check values:
            IF(IntOut(j,i).NE.IntOut(j,i).OR.IntOut(j,i).LT.1.d-20) THEN
               IntOut(j,i) = 0.0d0
            END IF
            Elems(j+2,i) = IntOut(j,i)
c           we want intensity in Jy/arcsec2
            Elems(j+2,i) = 7.83d0 * lambdaOut(j) * F1 * Elems(j+2,i)
          END DO
        END DO
        write(unt,'(a21,20f11.2)')hdint,(lambdaOut(j),j=1,NlambdaOut)
        CALL MakeTable(Elems,nPok+2,NlambdaOut+2,unt)
      END IF
      IF (iC.LT.0) THEN
c ---------  convolved images either add to .i## file or write in *.c## file --
        IF(iC.EQ.-3) unt = 21
        call line(1,2,unt)
        write(unt,'(a8,i4,a20)') '#  model',model,'   CONVOLVED IMAGE  '
        call line(1,1,unt)
        DO i = 1, Nconv
         Elems(1,i) = Offset(i)
         DO j = 1, NLambdaOut
c        check values:
         IF(ConvInt(j,i).NE.ConvInt(j,i).OR.ConvInt(j,i).LT.1.d-20) THEN
            ConvInt(j,i) = 0.d0
         END IF
         Elems(j+1,i) = ConvInt(j,i)
         END DO
        END DO
        write(unt,'(a11,20f11.2)')hdcon,(lambdaOut(i),i=1,NlambdaOut)
        CALL MakeTable(Elems,Nconv,NLambdaOut+1,unt)
        IF (psftype.LT.4.AND.model.EQ.1) THEN
c         Wavelength dependent PSFs, print them separately in *.psf
c         first generate wavelength dependent PSFs
          DO j = 1, NlambdaOut
            iLambda = j
            DO i = 1, Nconv
              PSFfunc(j,i) = PSFN(Offset(i))
c             check dynamic range
              CALL CHKRANGE(dynrange,PSFfunc(j,i))
            END DO
          END DO
c         print them out
          DO i = 1, Nconv
           write(23,'(1p,e12.5,20e10.3)')Offset(i),
     &                                   (PSFfunc(j,i),j=1,NlambdaOut)
          END DO
        END IF
      END IF
c --------------     visibility curves to *.vnn file    ------------------------
      IF (iV.NE.0) THEN
        IF(abs(iC).EQ.3) unt = 22
        call line(1,2,unt)
        write(unt,'(a8,i4,a14)') '#  model',model,'  VISIBILITY  '
        call line(1,1,unt)
        DO i = 1, Nvisi
c     MG 05.10.09  /theta1 to get correct scale
          Elems(1,i) = qtheta1(i) /theta1
          DO j = 1, NLambdaOut
c          check for nonsense values:
           IF(Visib(j,i).NE.Visib(j,i).OR.Visib(j,i).LT.1.d-20) THEN
              Visib(j,i) = 0.d0
           END IF
           Elems(j+1,i) = Visib(j,i)
          END DO
        END DO
        write(unt,'(a11,20f11.2)')hdvis,(lambdaOut(i),i=1,NlambdaOut)
        CALL MakeTable(Elems,Nvisi,NLambdaOut+1,unt)
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
c This function is taken from Moshe Elitzur.           [Z.I., Nov. 1995]
c =======================================================================
      DOUBLE PRECISION FUNCTION RDINP(Equal,IUNIT)
c =======================================================================
C     Read lines, up to 232 long, from pre-opened unit IUNIT and extract
C     all input numbers from them. When EQUAL is set, numeric input data
C     must be preceded by an equal sign.All non-numeric data and numbers
C     not preceded by = when EQUAL is on are ignored.RDINP = next number
C     encountered (after equal sign) and terminated by a nun-numeric
C     symbol (termination with blank is best). Commas and exponential
C     notation are allowed.  All text after % is ignored, as in TeX.
C     Lines with * in the first column are echoed to the output device.
C     The number is comprised of an actual VALUE, decimal part FRAC and
C     (integer) exponent PWR.  It has a SIGN, and the exponential power
C     has sign SIGNEX. Logical flag to the decimal part is set in
C     DECIMAL. The search is conducted between FIRST, which is
C     continuously increased, and LAST.  A new line is read when FIRST
C     exceeds LAST, and can be forced by calling with -IUNIT.  Actual
C     extraction of numerical value is done in separate FUNCTION VAL.
c =======================================================================
      IMPLICIT None
      Integer IUnit,Ind,First, Last
      DOUBLE PRECISION Value,Val,Frac,Pwr,Sign,Signex
      CHARACTER Card*(232),CR,prev,Term,Next
      Logical Equal,digit,minus,sgn,dot,E,decimal
      Save Card,First,Last
      DATA First/1/, Last/0/
c -----------------------------------------------------------------------
C FUNCTION STATEMENTS
      digit(CR) = CR.GE.'0' .AND. CR.LE.'9'
      minus(CR) = CR.EQ.'-'
      sgn(CR)   = CR.EQ.'+' .OR. CR.EQ.'-'
      dot(CR)   = CR.EQ.'.'
      E(CR)     = CR.EQ.'E' .OR. CR.EQ.'e'
C
      IF (IUnit.lt.0) Then
         First = Last + 1
         IUnit = -IUnit
      END IF
c     Start the search for the next number:
  1   RDINP  = 0.
      VALUE  = 0.
      FRAC   = 0.
      PWR    = 0.
      SIGN   = 1.
      SIGNEX = 1.
      Decimal = .False.
      If (first.gt.last) then
c     Time to get a new line
         READ (IUNIT, '(A)' , END = 99) Card
         first = 1
         last = len(Card)
c        Find start of trailing junk:
         DO WHILE (Card(last:last).LE.' ')
          last = last - 1
          if (last.lt.first) goto 1
         END DO
         IF (Card(first:first).EQ.'*') WRITE (12,'(A)') Card(1:last)
         ind = Index(Card,'%')
         if (ind.gt.0) last = ind - 1
      End If

c     Get past the next '=' when the EQUAL flag is set
      If (Equal) then
        DO WHILE (Card(first:first).NE.'=')
          first = first + 1
          IF (first.GT.last) goto 1
        END DO
      End If
c     OK, start searching for the next digit:
      Do While (.not.digit(Card(first:first)))
	    first = first + 1
		if (first.gt.last) goto 1
	End Do
c     Check if it is a negative or decimal number
      If (first.gt.1) then
         prev = Card(first-1:first-1)
         if (minus(prev)) sign = -1.
         if (dot(prev)) then
           decimal = .True.
           if (first.gt.2 .and. minus(Card(first-2:first-2))) sign = -1.
         end if
      End If
c     Extract the numerical value
      IF (.not.Decimal) Then
         Value = VAL(Card,first,last,decimal,Term)
c        Check for a possible decimal part.  Termination with '.E' or
c        '.e' is equivalent to the same ending without '.'
         if (first.lt.last.and.dot(Term)) then
            first = first + 1
            next = Card(first:first)
            if (digit(next)) decimal = .true.
            if (E(next)) Term = 'E'
         end if
      END IF
c     Extract the decimal fraction, when it exists
      IF (Decimal) Frac = VAL(Card,first,last,decimal,Term)
c     An exponential may exist if any part terminated with 'E' or 'e'
      IF (first.lt.last.and.E(term)) then
         first = first + 1
         next = Card(first:first)
         if (first.lt.last.and.sgn(next))then
            first = first + 1
            if (minus(next)) Signex = -1.
         end if
         decimal = .False.
         PWR = VAL(Card,first,last,decimal,Term)
      END IF
c     Finally, put the number together
      RDINP = Sign*(Value + Frac)*10**(Signex*PWR)
      Return

99    WRITE (12,'(3(1x,a,/))')
     *' ****TERMINATED. EOF reached by RDINP while looking for input. ',
     *' *** Last line read:',Card
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c ***********************************************************************
c This function is taken from Moshe Elitzur            [Z.I., Nov. 1995]
c =======================================================================
      DOUBLE PRECISION FUNCTION VAL(Card,first,last,decimal,Term)
c     Extract numerical value from CARD, begining at position FIRST up
c     to the first non-digit encountered.  The terminating character is
c     returned in TERM, its position in FIRST. Commas are treated as
c     simple separators.
c =======================================================================
      IMPLICIT None
      Character Card*(*), Term, CH
      Logical Decimal, digit
      Integer IVAL, first, last, first0
      Real pwr
c -----------------------------------------------------------------------
C     FUNCTION STATEMENTS
      IVAL(CH) = ICHAR(CH) - ICHAR('0')
      digit(CH) = CH.GE.'0' .AND. CH.LE.'9'
c
      VAL = 0.d0
      pwr = 1.
      first0 = first
      DO 10 first = first0, last
         Term = Card(first:first)
         if (Term.eq.',') goto 10
         if (.not.digit(Term)) Return
         If (decimal) then
            pwr = pwr*0.1
            Val = Val + pwr*IVAL(Term)
         Else
            Val = 10.d0*Val + IVAL(Term)
         End If
  10  CONTINUE
      Term = ' '
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************
c =========================================================================
c     This is are the core subroutines for radiative transfer calculation.
c                                                             [MN, Mar'99]
c =========================================================================
C     Table of Contents
C
C     EMISSION
C     GFUN
C     FINDTEMP
C     GRAYBODY
C     INITTEMP
C     INSERT
C     INTETA
C     INVERT
C     KINT4
C     MATRIX
C     NORDLUND
C     OCCLTMSG
C     PGRID
C     PLANCK
C     RADTRANSF
C     SETGRIDS
C     SOLVE
C     STAR
C     TRAPZD2
C     TWOFUN
C     WEIGHTS
C     YGRID
c =========================================================================

c ***********************************************************************
      SUBROUTINE Emission(flag,nG,Td,alpha,abund,Uin,Emiss)
c =======================================================================
c This subroutine calculates emission term from the temperature, abund
c and alpha arrays for flag=0, and adds U to it for flag=1.
c                                                      [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iG, iY, iL, nG, flag
      DOUBLE PRECISION Uin(npL,npY), Td(npG,npY), alpha(npG,npY),
     &       Emiss(npL,npY), abund(npG,npY), EmiG, xP, Planck
c -----------------------------------------------------------------------
c     first initialize Emiss
c     loop over wavelengths
      DO iL = 1, nL
c       loop over radial coordinate
        DO iY = 1, nY
          Emiss(iL,iY) = 0.0d0
        END DO
      END DO
c     calculate emission term for each component and add it to Emiss
c     loop over wavelengths
      DO iL = 1, nL
c       loop over radial coordinate
        DO iY = 1, nY
c         loop over grains
          DO iG = 1, nG
            xP = 14400.d0 / lambda(iL) / Td(iG,iY)
            EmiG = abund(iG,iY) * alpha(iG,iY) * Planck(xP)
c           add contribution for current grains
            Emiss(iL,iY) = Emiss(iL,iY) + EmiG
          END DO
c         if needed add Uin
          IF (flag.EQ.1) THEN
            Emiss(iL,iY) = Emiss(iL,iY) + Uin(iL,iY)
          END IF
          IF (Emiss(iL,iY).LT.dynrange*dynrange) Emiss(iL,iY) = 0.0d0
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION Gfun(Tt)
c =======================================================================
c This is an auxiliary function used in determining the dust temperature
c                                                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iW, nW
      DOUBLE PRECISION Tt, wav(npL), Eff(npL), ff(npL), xP, gg, f1, f2,
     &       Planck
      COMMON /gfunction/ wav, Eff, f1, f2, nW
c -----------------------------------------------------------------------
      DO iW = 1, nW
        xP = 14400.d0 / wav(iW) / Tt
        ff(iW) = Eff(iW) * Planck(xP) / wav(iW)
      END DO
      CALL Simpson(npL,1,nW,wav,ff,gg)
      Gfun = f1 - f2 * gg * Tt**4.d0
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE FindTemp(geom,Utot,nG,Td,alpha)
c =======================================================================
c This subroutine finds new temperature and alpha arrays from Utot.
c Temperature is obtained by solving:
c   f1(y) - f2(y)*g(T) = 0
c where
c   f1(y) = Int(Qabs*Utot*dlambda)
c   f2(y) = alpha(y=1)*y**2/Tsub**4
c    g(T) = Td**4*Int(Qabs*Planck(Td)*dlambda)
c alpha(y)= Int(Qabs*Utot*dlambda)/Int(Qabs*Planck(Td)*dlambda)
c The equation is solved by Ridder's method (subroutine from Num.Rec)
c                                                      [Z.I., Oct. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG, nfit
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nfit=4)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER iG, iY, iL,nG, nW, succes, geom
      DOUBLE PRECISION Utot(npL,npY), Td(npG,npY), alpha(npG,npY),
     &       fnum(npL), fdenum(npL), num, denum, xP, Tin, aa, Planck,
     &       wav(npL), f1, f2, gfun, x1, x2,  Eff(npL), Zriddr
      EXTERNAL gfun
      COMMON /gfunction/ wav, Eff, f1, f2, nW
      double precision a(nfit)
      integer ia(nfit)
      common/params/a,ia
c -----------------------------------------------------------------------
      nW = nL
c     loop over grains
      DO iG = 1, nG
c       evaluate alpha(1)
        DO iL = 1, nL
          fnum(iL) = SigmaA(iG,iL) * Utot(iL,1) / lambda(iL)
          xP = 14400.d0 / lambda(iL) / Tsub(iG)
          fdenum(iL) = SigmaA(iG,iL) * Planck(xP) / lambda(iL)
          wav(iL) = lambda(iL)
          Eff(iL) = SigmaA(iG,iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,fnum,num)
        CALL Simpson(npL,1,nL,lambda,fdenum,denum)
        alpha(iG,1) = num /  denum
        aa = alpha(iG,1) / Tsub(iG)**4.d0
        Td(iG,1) = Tsub(iG)
c       loop over radial positions (solving f1-f2*g(T)=0)
        DO iY = 2, nY
c         calculate f1 and f2
          DO iL = 1, nL
            fnum(iL) = SigmaA(iG,iL) * Utot(iL,iY) / lambda(iL)
          END DO
          CALL Simpson(npL,1,nL,lambda,fnum,f1)
          IF (geom.EQ.0) THEN
c           This is for slab geometry ...
            f2 = aa
          ELSE
c          ... and for spherical
             f2 = aa * Y(iY)**2.d0
          END IF
c         estimate range for temperature
          x1 = Td(iG,iY)
          x2 = 1.01d0*Td(iG,iY)
c         make sure that correct solution is bracketted
          CALL Zbrac(gfun,x1,x2,100,succes)
          IF (succes.NE.1) THEN
            CALL Msg(4)
            ELSE
c           save the old value of Td
            Tin = Td(iG,iY)
c           get new temperature
            Td(iG,iY) = Zriddr(gfun,x1,x2,500,accConv)
c           calculate alpha
            DO iL = 1, nL
              xP = 14400.d0 / lambda(iL) / Td(iG,iY)
              fdenum(iL) = SigmaA(iG,iL) * Planck(xP) / lambda(iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,fdenum,denum)
            alpha(iG,iY) = f1 /  denum
          END IF
c     OVERWRITE Tdust MG 12.02.11
c          if (Y(iy) .ge. 10**a(5) .and. Y(iy) .lt. 10**a(5)+10**a(6)) 
c     c              Td(iG,iY) = 120. * (Y(iy) / 10**a(5))**(-0.4)
c          if (Y(iy) .ge. 10**a(5)+10**a(6))   Td(iG,iY) = 20. 
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE GrayBody(albedo,TAUgbTot,Ugb,fgb)
c =======================================================================
c This subroutine solves the gray body problem for albedo=1 (or
c equivalently pure scattering) and scattering with absorption (but no
c emission) for albedo<1, in a spherically symmetric envelope. Total
c optical depth is TAUtot, and density law is specified elsewhere.
c This subroutine was designed to be a part of Dusty and to use already
c existing subroutines as much as possible, so some parts might seem to
c be a little awkward.                           [ZI,Jul'96;MN,Sep'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iPGB, iY, nLstore, error
      DOUBLE PRECISION ETAzp(npP,npY), mat0(npL,npY,npY),
     &       mat1(npL,npY,npY), Em(npL,npY), Ugb(npY), fgb(npY),
     &       Dummy1(npL,npP,npY), Dummy2(npL,npP,npY), Dummy3(npL,npY),
     &       albedo, pGB, TAUgbTot, TAUstore
c ----------------------------------------------------------------------
c     Values needed in this subroutine only
      pGB = 0.d0
      iPGB = 0
      nLstore = nL
      nL = 1
      TAUstore = TAUtot(1)
      TAUtot(1) = TAUgbTot
c     generate spline coefficients for ETA
      CALL setupETA
c     evaluate ETAzp
      CALL getETAzp(ETAzp)
c     generate some temporary arrays
      DO iY = 1, nY
        Us(1,iY) = dexp(-ETAzp(1,iY)*TAUgbTot)
        fs(1,iY) = Us(1,iY)
        Em(1,iY) = 0.d0
        fde(1,iY) = 0.d0
        omega(1,iY) = albedo
      END DO
c     find radiative transfer matrices
      CALL Matrix(ETAzp,pGB,iPGB,mat0,mat1,Dummy1,Dummy2)
c     solve for Utot
      CALL Invert(nY,nL,mat0,Us,Em,omega,Utot,Dummy3,error)
c     calculate flux, ftot
      CALL Multiply(1,npY,nY,npL,nL,mat1,Utot,omega,1,fs,ftot)
c     store to the output arrays
      DO iY = 1, nY
        Ugb(iY) = Utot(1,iY)
        fgb(iY) = ftot(1,iY)
      END DO
      nL = nLstore
      TAUtot(1) = TAUstore
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE InitTemp(ETAzp,nG,alpha)
c =======================================================================
c This subroutine initializes the first approximations for temperature
c and alpha arrays. It uses approximations given by eqs. B5 and B7 from
c IE96. Alpha(y) is defined as the ratio of Qabs averaged with the total
c energy density at y and Qabs Planck averaged with T(y). That is, Psi
c is alpha(y=1) and (T/Tsub)^4 = alpha(y) / alpha(1).  [Z.I., Jul. 1996]
c
c *** This version works for single grains ONLY ***
c
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav, nitt
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER iL, iY, iG, nG, istop, iW
      DOUBLE PRECISION ETAzp(npP,npY), xP, Planck, resaux, aux(npY),
     &       faux(npL), fstar(npY), Qfstar(npY),  fstarQ(npY),
     &       alpha(npG,npY), oldalpha(npY), Sigext(npL), QP(npY),
     &       QF(npY),EtaQF, ETA, delta, QaP(npY)
c -----------------------------------------------------------------------
      nitt=0
c     Lambda integral of fs=f_e*exp(-TAU) -> fstar
      DO iY = 1, nY
c       generate auxiliary function for lambda integration:
        DO iL = 1, nL
          faux(iL) = fs(iL,iY) / lambda (iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,faux,resaux)
        fstar(iY) = resaux
c      if (iy.ge.15.and.iy.le.17)write(*,*)'fstar ini',iy,fstar(iy),Y(iY)
      END DO
c     loop over grains
      DO iG = 1, nG
c       first approximation for temperature
        DO iY = 1, nY
          Td(iG,iY) = Tsub(iG) / Y(iY)**0.4d0
          alpha(iG,iY) = 1.d0
c        if (iy.ge.15.and.iy.le.17)write(*,*)'ini',Td(iG,iY),alpha(iG,iY)
        END DO
c       generate the extinction cross-section Sigext
        DO iL = 1, nL
          Sigext(iL) = SigmaA(iG,iL)+SigmaS(iG,iL)
        END DO
c       Lambda integral of Sigext*fs -> Qfstar in IE97
        DO iY = 1, nY
c         generate auxiliary function for lambda integration:
          DO iL = 1, nL
            faux(iL) = Sigext(iL) * fs(iL,iY) / lambda (iL)
          END DO
          CALL Simpson(npL,1,nL,lambda,faux,resaux)
          Qfstar(iY) = resaux
c        if (iy.ge.15 .and.iy.le.17)write(*,*)'Qfstar ini ',iy,Qfstar(iy)
        END DO
c       iterate until Td and Psi converge (i.e. until alpha does)
        istop = 0
        DO WHILE (istop.NE.1)
          nitt=nitt+1
          istop = 1
c         find Planck average of Sigext and calculate QF (eq. B5)
          DO iY = 1, nY
c           generate auxiliary function for lambda integration:
            DO iL = 1, nL
              xP = 14400.d0 / Td(iG,iY) / lambda(iL)
              faux(iL) = Sigext(iL) * Planck(xP) / lambda (iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,faux,resaux)
c           Planck average of Sigext
            QP(iY) = resaux
c           calculate integral next to 1/y2 in eq. B7 -> fstarQ
            DO iL = 1, nL
              xP = 14400.d0 / Td(iG,iY) / lambda(iL)
              faux(iL) = SigmaA(iG,iL) * Planck(xP) / lambda (iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,faux,resaux)
c           Planck average of SigmaAbs
            QaP(iY) = resaux
c            if (iy.ge.15 .and. iy.le.17) write(*,*)'QaP ', iy, QaP(iy)
c           calculate intetgral next to 1/y2 in eq. B7 -> fstarQ
            DO iL = 1, nL
              faux(iL)= fs(iL,iY)*(1.d0-SigmaA(iG,iL)/QP(iY))/lambda(iL)
c     MG 06.11
c              faux(iL)=fs(iL,iY)*(1.d0-SigmaA(iG,iL)/QaP(iY))/lambda(iL)
c              faux(iL)=fs(iL,iY)*(1.d0-Sigext(iL)/QaP(iY))/lambda(iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,faux,resaux)
            fstarQ(iY) = resaux
c            if (iy.ge.15 .and. iy.le.17)write(*,*)'fstarq',iy,fstarq(iy)
c           calculate QF (eq. B5)
            QF(iY) = Qfstar(iY) + QP(iY) * (1.d0-fstar(iY))
c            QF(iY) = Qfstar(iY) + QaP(iY) * (1.d0-fstar(iY))
c            if (iy.ge.15 .and. iy.le.17) write(*,*)'QF ', iy, QF(iy)
c           store current alpha
            oldalpha(iY) = alpha(iG,iY)
          END DO
c         for each y calculate new alpha from eq. B7
c         two y loops are needed because of integral QF*ETA
          DO iY = 1, nY
c           first evaluate integral of QF with ETA...
            DO iW = iY, nY
              aux(iW) = QF(iW) * ETA(Y(iW)) / Y(iW)**2.0
            END DO
            CALL Simpson(npY,iY,nY,Y,aux,EtaQF)
c           ... and alpha
            alpha(iG,iY) = 3.d0*TAUfid*EtaQF + (1-fstarQ(iY))
c           calculate temperature
            Td(iG,iY) = Tsub(iG) * (alpha(iG,iY)/alpha(iG,1))**0.25d0
            Td(iG,iY) = Td(iG,iY) / dsqrt(Y(iY))
            delta = DABS((alpha(iG,iY)-oldalpha(iY))/alpha(iG,iY))
            IF (delta.GT. accConv) istop = 0
c            write(*,*) nitt, iY, delta, accconv, Td(iG,iY)
          END DO

c          if (nitt.eq.3)stop
        END DO
c       end of iterations
      END DO
c     end of loop over grains (iG)
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE INSERT(pstar,iP,iPstar)
c =======================================================================
c This subroutine inserts two rays if the stellar disk is finite. The
c first ray, corresponding to the disk edge, has index iPstar, and the
c following ray with 1.0001 greater impact parameter has index iPstar+1.
c The only exception is if pstar>0.9999 when only a single ray is
c inserted.                                            [Z.I., Feb. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iP, iPstar
      DOUBLE PRECISION pstar
c -----------------------------------------------------------------------
      IF (pstar.GE.0.999999d0) THEN
        pstar = 0.999999d0
        iP = nPcav + 1
        iPstar = nPcav + 1
        P(iP) = pstar
        ELSE
        IF (pstar.GE.P(nPcav)) THEN
          IF (pstar.EQ.P(nPcav)) pstar = 1.00001d0*P(nPcav)
          P(nPcav+1) = pstar
          iPstar = nPcav + 1
          P(nPcav+2) = 1.00001d0*pstar
          iP = nPcav + 2
        ELSE
          iPstar = 0
          iP = 0
          DO WHILE (iPstar.EQ.0)
            iP = iP + 1
            IF (P(iP).GT.pstar.AND.iPstar.EQ.0) iPstar = iP
          END DO
          DO iP = 1, nPcav-iPstar+1
            P(nPcav+3-iP) = P(nPcav+1-iP)
          END DO
          IF (pstar.EQ.P(iPstar-1)) pstar = 1.00001d0*P(iPstar-1)
          P(iPstar) = pstar
          P(iPstar+1) = 1.00001d0*pstar
          iP = nPcav + 1
        END IF
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION IntETA(p,iW1,w1,w)
c =======================================================================
c This function calculates the integral over the normalized dens. prof.
c along the line of sight with impact parameter p and between the points
c corresponding to y=w1 and y=w. The method used is spline approximation
c for normalized density distribution ETA and subsequent integration
c performed analytically by MAPLE (these results are given through
c soubroutine Maple3).                         [ZI,Feb'96,MN,Aug'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iW1, iC
      DOUBLE PRECISION  p, w1, w, aux(4), z, z1, aux1(4)
c -----------------------------------------------------------------------
      z =  dsqrt(max(w*w-p*p, 0.d0))
      z1 = dsqrt(max(w1*w1-p*p, 0.d0))
c     integrals calculated by MAPLE
      CALL Maple3(w,z,p,aux)
      CALL Maple3(w1,z1,p,aux1)
      DO iC = 1, 4
        aux(iC) = aux(iC) - aux1(iC)
      END DO
      IntETA = 0.d0
      DO iC = 1, 4
        IntETA = IntETA + ETAcoef(iW1,iC) * aux(iC)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE INVERT(nY,nL,mat,Us,Em,omega,Utot,Uold,error)
c =======================================================================
c This subroutine solves the linear system
c [Utot] = [Us+Em] + [mat0]*[omega*Utot] by calling LINSYS subroutine.
c                                                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER nY, iL,nL,iY, iYaux, Kronecker, error
      DOUBLE PRECISION mat(npL,npY,npY), Us(npL,npY), Em(npL,npY),
     &       Utot(npL,npY), Uold(npL,npY),B(npY), A(npY,npY), X(npY),
     &       omega(npL,npY)
c -----------------------------------------------------------------------
      error = 0
c     first copy Utot to Uold
      DO iL = 1, nL
        DO iY = 1, nY
          Uold(iL,iY) = Utot(iL,iY)
        END DO
      END DO
c     calculate new energy density
c     loop over wavelengths
      DO iL = 1, nL
c       generate the vector of free coefficients, B, and matrix A
        DO iY = 1, nY
          B(iY) = Us(iL,iY)
          DO iYaux = 1, nY
            Kronecker = 0
            IF (iY.EQ.iYaux) Kronecker = 1
            B(iY) = B(iY) +
     &              (1.d0-omega(iL,iYaux))*Em(iL,iYaux)*mat(iL,iY,iYaux)
            A(iY,iYaux) = Kronecker - omega(iL,iYaux) * mat(iL,iY,iYaux)
          END DO
        END DO

c       solve the system
        CALL LINSYS(nY,A,B,X,error)
        IF(error.NE.0) THEN
         CALL MSG(20)
         iERROR = iERROR + 1
         RETURN
        END IF
c       store the result
        DO iY = 1, nY
          IF (X(iY).GE.dynrange*dynrange) THEN
            Utot(iL,iY) = X(iY)
          ELSE
            Utot(iL,iY) = 0.d0
          END IF
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Kint4(TAUaux,iP,iL,nZ,K1p,K2p,K3p,K4p,K1m,K2m,K3m,K4m)
c =======================================================================
c For given wavelength (iL) and impact parameter (iP), this subroutine
c calculates integrals Knp and Knm defined as:
c               Knp(iZ)=INT[PHIn(tz)*exp(tz)*dtz]
c from tz1=TAUaux(iL,iP,iZ) to tz2=TAUaux(iL,iP,iZ+1) and analogously for
c Km with exp(tz) replaced by exp(-tz). Function PHIn is defined as
c x**(n-1)/Yloc^2, where Yloc is the local radius corresponding to tz,
c and x measures relative radial tau: x = (rt - tL)/(tR-tL). Here rt is
c the radial optical depth corresponding to tz and tL and tR are radial
c optical depths at the boundaries of the integration interval:
c tL = TAUaux(iL,1,iZ) = rt(iZ) and tR = TAUaux(iL,1,iZ+1) = rt(iZ+1).
c Integration is performed in z space by Romberg integration implemented
c in subroutine ROMBERG2 (slightly changed version of 'qromb' from Num.
c Recipes).                                     [ZI,Feb'96;MN,Sep'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iP, iL, nZ, iZ, iW1, iLaux, iC
      DOUBLE PRECISION TAUaux(npL,npP,npY), K1p(npY),K2p(npY),K3p(npY),
     &    K4p(npY), K1m(npY), K2m(npY), K3m(npY), K4m(npY), result(8),
     &    Kaux(8), deltrton(4),tRL,paux, w1,w2,wL, delTAUzp, z1, z2
      COMMON /phi2/ paux, w1, wL, delTAUzp, iLaux, iW1
c -----------------------------------------------------------------------
      paux = P(iP)
      iLaux = iL
c     iLaux is needed to avoid compiler errors since it is in COMMON
c     /phi2/ (here and in 'TWOfun'), while iL is transferred as a
c     argument loop over positions on the line of sight
      DO iZ = 1, nZ-1
c       index for the local radial position (left boundary)
        iW1 = iYfirst(iP) + iZ - 1
c       radii at the boundaries
        wL = Y(iW1)
        IF (iZ.EQ.1) THEN
          if (paux.GT.1.d0) then
            w1 = paux
            else
            w1 = 1.d0
          end if
          ELSE
          w1 = Y(iW1)
        END IF
        w2 = Y(iW1+1)
        z1 = dsqrt(DABS( max(w1*w1 - paux*paux, 0.d0)))
        z2 = dsqrt(      max(w2*w2 - paux*paux, 0.d0) )
c       radial tau-difference at the bound., scaled to tot. opt. depth
        tRL = TAUaux(iL,1,iW1+1)-TAUaux(iL,1,iW1)
c       auxiliary quantity aux/tRL**(n-1)
        deltrton(1) = TAUtot(iL)
        DO iC = 1, 3
          deltrton(iC+1) = deltrton(iC)/tRL
        END DO
c       delTAUzp is needed in PHIn fun's
        delTAUzp = TAUaux(iL,iP,iZ+1)-TAUaux(iL,iP,iZ)
c       integrate this step for all 8 cases
        CALL ROMBERG2(z1,z2,result)
c       generate output values
        DO iC = 1, 4
           Kaux(iC) = result(iC) * deltrton(iC)
           Kaux(iC+4) = result(iC+4) * deltrton(iC)
        END DO
        K1m(iZ) = Kaux(1)
        K2m(iZ) = Kaux(2)
        K3m(iZ) = Kaux(3)
        K4m(iZ) = Kaux(4)
        K1p(iZ+1) = Kaux(5)
        K2p(iZ+1) = Kaux(6)
        K3p(iZ+1) = Kaux(7)
        K4p(iZ+1) = Kaux(8)
      END DO
c     set undefined elements to 0
      K1m(nZ) = 0.d0
      K2m(nZ) = 0.d0
      K3m(nZ) = 0.d0
      K4m(nZ) = 0.d0
      K1p(1) = 0.d0
      K2p(1) = 0.d0
      K3p(1) = 0.d0
      K4p(1) = 0.d0
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE matrix(ETAzp,pstar,iPstar,m0,m1,mifront,miback)
c =======================================================================
c This subroutine evaluates radiative transfer matrix for spherically
c symmetric envelope. Here m is the order of moment (0 for energy dens.,
c 1 for flux, 2 for pressure etc.), ETAzp is array of optical depths
c along the line of sight and mat is radiative transfer matrix.
c =======================================================================
      IMPLICIT none
      INTEGER m
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iP, iL, nZ(npP), iZ, iW,  iY, flag, im, iPstar, jZ, error
      DOUBLE PRECISION ETAzp(npP,npY),TAUaux(npL,npP,npY), haux(npP),H,
     &       m0(npL,npY,npY), m1(npL,npY,npY), pstar, addplus,addminus,
     &       Tplus(npP,npY,npY),Tminus(npP,npY,npY), xN(npP),yN(npP),
     &       result1,result2,resaux,TAUr(npY), wm(npY),wmT(npY),wp(npY),
     &       alpha(npY,npY),beta(npY,npY),gamma(npY,npY),delta(npY,npY),
     &       wgmatp(npY,npY), wgmatm(npY,npY), mifront(npL,npP,npY),
     &       miback(npL,npP,npY), fact, faux
c -----------------------------------------------------------------------
      error = 0
c     generate auxiliary arrays haux & nZ
      DO iP = 1, nP
c       parameter alowing for a line of sight terminating on the star
c       H(x1,x2) is the step function.
        haux(iP) = H(P(iP),pstar)
c       upper limit for the counter of z position
        nZ(iP) = nY + 1 - iYfirst(iP)
      END DO
c     Using the local array TAUaux to avoid multiple calculations of the
c     product
      DO iL = 1, nL
       DO iP = 1, nP
        DO iY = 1, nY
           TAUaux(iL,iP,iY) = ETAzp(iP,iY)*TAUtot(iL)
        END DO
       END DO
      END DO
c     -- evaluate matrix elements --
c     loop over wavelengths
      DO iL = 1, nL
c       radial optical depths
        DO iY = 1, nY
          TAUr(iY) = ETAzp(1,iY)*TAUtot(iL)
        END DO
c       auxiliary arrays for given TAUr
        CALL MYSPLINE(TAUr,nY,alpha,beta,gamma,delta)
c       loop over impact parameters
        DO iP = 1, nP-1
c         set T-s to 0
          DO iY = 1, nY
            DO iW = 1, nY
              Tplus(iP,iY,iW) = 0.d0
              Tminus(iP,iY,iW) = 0.d0
            END DO
          END DO
c         generate weights matrices
          CALL WEIGHTS(TAUaux,iP,iL,nZ(iP),nY,alpha,beta,gamma,delta,
     &                 wgmatp,wgmatm)
c         first position on the line of sight
          IF (YPequal(iP).EQ.1) THEN
            iY = iYfirst(iP)
            DO iW = 1, nY
c             cummulative weights for parts II & III
              wmT(iW) = 0.d0
              DO jZ = 1, nZ(iP)-1
                fact = dexp(-TAUaux(iL,iP,jZ))
                wmT(iW) = wmT(iW) + fact * wgmatm(jZ,iW)
              END DO
              Tplus(iP,iY,iW) = Tplus(iP,iY,iW) + haux(iP)*wmT(iW)
              Tminus(iP,iY,iW) = Tminus(iP,iY,iW) + wmT(iW)
            END DO
          END IF
c         loop over positions on the line of sight
          DO iZ = 2, nZ(iP)
c           increase index for radial position
            iY = iYfirst(iP) + iZ - 1
c           generate weights for this position
            DO iW = 1, nY
              wp(iW) = 0.d0
              wm(iW) = 0.d0
              wmT(iW) = 0.d0
c             part I
              DO jZ = 2, iZ
                fact = dexp(TAUaux(iL,iP,jZ)-TAUaux(iL,iP,iZ))
                wp(iW) = wp(iW) + fact * wgmatp(jZ,iW)
              END DO
c             part II & III
              DO jZ = 1, nZ(iP)-1
                fact = dexp(-(TAUaux(iL,iP,iZ)+TAUaux(iL,iP,jZ)))
                wmT(iW) = wmT(iW) + fact * wgmatm(jZ,iW)
              END DO
c             part IV
              IF (iZ.LT.nZ(iP)) THEN
                DO jZ = iZ, nZ(iP)-1
                  fact = dexp(-(TAUaux(iL,iP,jZ)-TAUaux(iL,iP,iZ)))
                  wm(iW) = wm(iW) + fact * wgmatm(jZ,iW)
                END DO
              ELSE
                wm(iW) = 0.d0
              END IF
c             add contribution from this step
              addplus = wp(iW) + haux(iP)*wmT(iW)
              Tplus(iP,iY,iW) = Tplus(iP,iY,iW) + addplus
              addminus = wm(iW)
              Tminus(iP,iY,iW) = Tminus(iP,iY,iW) + addminus
            END DO
c         end of loop over iZ
          END DO
c       end of the impact parameter loop, iP
        END DO
c       add points on the edge
        DO iW = 1, nY
          Tplus(nP,nY,iW) = 0.d0
          Tminus(nP,nY,iW) = 0.d0
        END DO
c     ============================
c       find mat(iL,iY,iW) -> angular (mu) integration
c       loop over moments (without calculation of rad.pressure)
        DO im = 1, 2
          m = im - 1
c         loop over radial positions
          DO iY = 1, nY
c           generate mu arrray
            DO iP = 1, Plast(iY)
              xN(iP) = dsqrt( max(1.d0-(P(iP)/Y(iY)*P(iP)/Y(iY)),0.d0))
            END DO
c           loop over local (radial) positions
            DO iW = 1, nY
c             generate intensity array for NORDLUND
              DO iP = 1, Plast(iY)
c               'faux' is a representation of (-1)**m
                 faux = 1.d0 - 2.d0*MOD(m,2)
                 yN(iP) = Tplus(iP,iY,iW) + faux*Tminus(iP,iY,iW)
c               store matrix elements to evaluate intensity (*1/4Pi)
                IF (im.EQ.1.AND.iY.EQ.nY) THEN
                  mifront(iL,iP,iW) = 0.0795775 * Tplus(iP,iY,iW)
                  miback(iL,iP,iW)  = 0.0795775 * Tminus(iP,iY,iW)
                END IF
              END DO
c             angular integration inside cavity
              IF (pstar.GT.0.0) THEN
                CALL NORDLUND(0,xN,yN,1,iPstar,m,resaux,error)
                IF (error.NE.0) GOTO 999
                IF (nPcav.GT.iPstar)
     &          CALL NORDLUND(0,xN,yN,iPstar+1,nPcav+1,m,result1,error)
                IF (error.NE.0) GOTO 999
                result1 = result1 + resaux
              ELSE
                CALL NORDLUND(0,xN,yN,1,nPcav+1,m,result1,error)
                IF (error.NE.0) GOTO 999
              END IF
c             flag for analytic integration outside cavity
              IF (iY.GT.6) THEN
                flag = 1
              ELSE
                flag = 0
              ENDIF
c             angular integration outside cavity
              IF (iY.GT.1) THEN
                CALL NORDLUND(flag,xN,yN,nPcav+1,Plast(iY),
     &                                      m,result2,error)
                IF (error.NE.0) GOTO 999
              ELSE
                result2 = 0.d0
              END IF
c             store current matrix element
              IF (m.EQ.0)
     &        m0(iL,iY,iW) = 0.5d0*Y(iY)*Y(iY)*(result1 + result2)
              IF (m.EQ.1)
     &        m1(iL,iY,iW) = 0.5d0*Y(iY)*Y(iY)*(result1 + result2)
            END DO
          END DO
        END DO
c     =============================
c     end of loop over wavelengths
      END DO
c     save Y and P grids to Yok and Pok, they are needed for analysis
c     in cases when requirement for finer grids cannot be satisfied and
c     previous solution is used for output
      nYok = nY
      DO iY = 1, nY
        Yok(iY) = Y(iY)
      END DO
      nPok = nP
      DO iP = 1, nP
        Pok(iP) = P(iP)
      END DO
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE NORDLUND(flag,x,y,N1,N2,m,intydx,error)
c =======================================================================
c This subroutine calculates integral I(x**m*y(x)*dx). Both y and x are
c 1D arrays, y(i), x(i) with i=1,nM (nM comes from 'paramslb.inc'). Lower
c and upper integration limits are x(N1) and x(N2), respectively. The
c method used is approximation of y(x) by a piecewise cubic spline (see
c Nordlund: Spherical Transfer with Single-Ray Approximation, in
c 'Methods in radiative transfer', ed. W. Kalkofen, Cambridge University
c Press, 1984). The resulting integral is sum of y(i)*w(i), i=N1,N2.
c Weights w(i) are determined from the array x(i). Here w(i) = wSimp(i)
c + wCorr(i). To improve accuracy of angular integration in radiative
c transfer, if flag=1 the contribution of the last Nanal (specified
c below) points is calculated in subroutine ANALINT which fits a
c function of the form: y = P(x) + d/sqrt(1-x*x), where P(x) is the
c polynomial of order Nanal-1, to these points and evaluates integral
c analytically.                                        [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER i, flag, N1, N2, N2n, Nanal, m, first, error
      DOUBLE PRECISION x(npP), y(npP), wSimp(npP), wCorr(npP), wC1, wC2,
     &        am, intydx, xaux(4), yaux(4), aux
c -----------------------------------------------------------------------
      error = 0
c parameter 'first' selects choice for derivatives at boundary points.
c For first.EQ.0 derivatives are 0 and first*(y2-y1)/(x2-x1) otherwise.
c first=1 works much better for functions encountered here.
      first = 1
c number of points for analytic integration
      Nanal = 4
c do not include points for analytic integration
      IF (flag.EQ.1.AND.N2.GT.N1+Nanal) THEN
        N2n = N2 - Nanal + 1
      ELSE
        N2n = N2
      END IF
c set integral to 0 and accumulate result in the loop
      intydx = 0.d0
c generate weighting factors, w(i), and integrate in the same loop
      DO i = N1, N2n
c first usual Simpson factors (Nordlund, eq. III-14, first term)...
        IF (i.NE.N1.AND.i.NE.N2n) THEN
          wSimp(i) = 0.5d0 * (x(i+1)-x(i-1))
        ELSE
          IF (i.eq.N1) wSimp(i) = 0.5d0 * (x(N1+1)-x(N1))
          IF (i.eq.N2n) wSimp(i) = 0.5d0 * (x(N2n)-x(N2n-1))
        END IF
c ... and then correction term for cubic spline (Nordlund, eq. III-14,
c second term and eq. III-16) (wC1 and wC2 are auxiliary quantities)
        IF (i.GT.N1+1) THEN
          wC1 = x(i) - 2.d0*x(i-1) + x(i-2)
        ELSE
          IF (i.EQ.N1) wC1 =  first * (x(N1+1) - x(N1))
          IF (i.EQ.N1+1) wC1 = first * (x(N1) - x(N1+1))
        ENDIF
        IF (i.LE.(N2n-2)) THEN
          wC2 = x(i+2) - 2.d0*x(i+1) + x(i)
        ELSE
          IF (i.EQ.(N2n-1)) wC2 = first * (x(N2n-1) - x(N2n))
          IF (i.EQ.N2n) wC2 = first * (x(N2n) - x(N2n-1))
        ENDIF
        wCorr(i) = (wC1 - wC2) / 12.
c       add contribution to the integral
        IF (m.EQ.0) THEN
          intydx = intydx + y(i) * (wSimp(i) + wCorr(i))
         ELSE IF(m.EQ.1) THEN
            intydx = intydx + x(i)*y(i)*(wSimp(i) + wCorr(i))
         ELSE IF(m.EQ.2) THEN
            intydx = intydx + x(i)*x(i)*y(i)*(wSimp(i) + wCorr(i))
        END IF
      END DO
c     change the sign (x [i.e. mu] array is in descending order!!!)
      intydx = -intydx
c     if flag=1 use analytic approximation for the last Nanal points
      IF (flag.EQ.1.AND.N2n.GT.N1+Nanal) THEN
c       generate auxiliary arrays for ANALINT
        DO i=1,Nanal
          xaux(i) = x(N2n+Nanal-i)
          yaux(i) = y(N2n+Nanal-i)
        END DO
c     calculate the contribution of the last Nanal points
c       produce REAL copy of m
        am = 1.0*(m)
        CALL ANALINT(Nanal,xaux,yaux,am,aux,error)
        IF(error.NE.0) RETURN
c       add the contribution of the last Nanal points
        intydx = intydx + aux
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE OccltMSG
c =======================================================================
c     Prints a message informing the user about the min Teff required to
c     neglect occultation by the central source.
c =======================================================================
      IMPLICIT NONE
      CHARACTER*10 Tstrg
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iL
      DOUBLE PRECISION qaux(npL), qaux2(npL), res1, res2, Te_min,
     &        mx, Psitn, Planck, xP
c -----------------------------------------------------------------------
c     Estimate min Teff required to neglect occultation (eq.(5) in Manual):
      DO iL = 1, nL
        qaux(iL) = SigmaA(1,iL) * Us(iL,1) / lambda(iL)
        xP = 14400.d0 / Tsub(1) / lambda(iL)
        qaux2(iL) = SigmaA(1,iL) * Planck(xP) / lambda (iL)
      END DO
      CALL Simpson(npL,1,nL,lambda,qaux,res1)
      CALL Simpson(npL,1,nL,lambda,qaux2,res2)
c     Approximate Psi for opt.thin case:
      Psitn = res1/res2
      mx = Tsub(1)*sqrt(sqrt(4.d0/Psitn))
      IF(Tsub(1).LT.mx) THEN
       Te_min = 2.d0 * mx
      ELSE
       Te_min = 2.d0 * Tsub(1)
      END IF
      CALL GetFS(Te_min,0,1,Tstrg)
      write(12,*)
     & ' ====================================================  '
      write(12,*)
     & ' For compliance with the point-source assumption, the'
      write(12,*)
     & ' following results should only be applied to sources '
      write(12,'(a37,a5,a3)')
     & '  whose effective temperature exceeds ',Tstrg, ' K.'
      write(12,*)
     & ' ===================================================='
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Pgrid(pstar,iPstar,error)
c =======================================================================
c     After having the Y grid, generate the P grid (impact parameters)
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG, nfit
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nfit= 4)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER i, iP, j, error, Naux, iPstar, NinsLoc
      DOUBLE PRECISION pstar, delP
      common/params/a,ia
      double precision expn, a(nfit)
      integer ia(nfit)
c -----------------------------------------------------------------------
      error = 0
      P(1) = 0.d0
      Naux = 1
      iYfirst(Naux) = 1
      YPequal(Naux) = 1
c     grid within the cavity (points concentrated towards p=1, SQRT!)
      nPcav = Ncav + Naux
c     MG 08.10
      expn= 0.5d0
c      if (10**a(3) .lt. 100.) expn= 0.7d0
      DO iP = Naux+1, nPcav
        P(iP) = P(Naux) + (1.d0-P(Naux))* ((iP-Naux)/(Ncav+1.d0))**expn
        iYfirst(iP) = 1
        YPequal(iP) = 1
      END DO
c     insert two rays if the stellar disk size is finite
      IF (pstar.GT.0.0) THEN
        CALL INSERT(pstar,iP,iPstar)
        DO i = nPcav+1, iP
          iYfirst(i) = 1
          YPequal(i) = 1
        END DO
        nPcav = iP
        ELSE
        iP = nPcav
        iPstar = 0
      ENDIF
c     impact parameters for the envelope (tangential to the radial grid)
      DO i =1, nY-1
        Plast(i) = iP + 1
c       points close to the inner cavity should have more impact param.
        NinsLoc = Nins
c       if tau is large add a few more points to the impact param. grid
        IF (TAUmax.GT.10) THEN
          IF (i.LE.5) NinsLoc = Nins + 1
        END IF
        IF (TAUmax.GT.100) THEN
          IF (i.LE.10) NinsLoc = Nins + 1
          IF (i.LE.5)  NinsLoc = Nins + 2
        END IF
c       increment in P
        delP = (Y(i+1) - Y(i)) / (NinsLoc+1.0)
        DO j = 1, NinsLoc+1
          iP = iP + 1
          iYfirst(iP) = i
          IF (j.eq.1) THEN
            YPequal(iP) = 1
            ELSE
            YPequal(iP) = 0
          END IF
          P(iP) = Y(i) + (j-1)*delP
        END DO
      END DO
c     number of points for the P grid
      nP = iP + 1
      P(nP) = Y(nY)
      iYfirst(nP) = nY
      YPequal(nP) = 1
      Plast(nY) = nP
c     check that the P grid is not too large
      IF (nP.GT.npP) THEN
        error = 2
        CALL LINE(0,2,12)
        write(12,'(a)')' This model terminated because needed accuracy'
        write(12,'(a,i6)')' results in too many points in P grid:',
     &                    nP
        write(12,'(a,i4,a)')'          (See PARAMET.inc, npP =',npP,')'
        CALL LINE(0,2,12)
        iERROR = iERROR + 1
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION Planck(x)
c =======================================================================
c This function evaluates the Planck function multiplied by wavelength
c and normalized by sigma*T^4/Pi.                      [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      DOUBLE PRECISION x
c -----------------------------------------------------------------------
      IF (x.GT.100) THEN
        Planck = 0.d0
        ELSE
        IF (x.LT.0.00001d0) THEN
          Planck = 0.154d0 * x**3.0
          ELSE
          Planck = 0.154d0 * x**4.0 / (dexp(x) - 1)
        END IF
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE RADTRANSF(pstar,iPstar,TAUlim,nG,ETAzp,FbolOK,deviat,
     &                     error,iterFbol,model)
c =======================================================================
c This subroutine solves the continuum radiative transfer problem for a
c spherically symmetric envelope.                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER error, iPstar, nG, Conv, iter, FbolOK, iterFbol, iaux, iY,
     &        Fconv, Uconv, BolConv, model, itnum, itlim
      DOUBLE PRECISION pstar, ETAzp(npP,npY),mat0(npL,npY,npY), maxFerr,
     &       mat1(npL,npY,npY), Em(npL,npY),  alpha(npG,npY), deviat,
     &       Uold(npL,npY), fbolold(npY), mifront(npL,npP,npY), dmaxU,
     &       miback(npL,npP,npY), fsbol(npY), fdbol(npY), TAUlim, dmaxF
c -----------------------------------------------------------------------
c     generate, or improve, or do not touch the Y and P grids
      IF (iterETA.EQ.1.OR.iterFbol.GT.1) THEN
        IF (iterFbol.EQ.1) THEN
c         first time generate grids
          CALL SetGrids(pstar,iPstar,error,TAUlim)
          IF (error.NE.0) goto 999
          IF (iVerb.EQ.2) write(*,*) 'Done with SetGrids'
        ELSE
c         or improve the grid from previous iteration
          CALL ChkFlux(fBol,accuracy,iaux,error,ETAzp)
          IF (error.NE.0) goto 999
c         generate new impact parameter grid
c         increase the number of rays through the cavity
          IF (Ncav.LT.80) THEN
            Ncav = 2 * Ncav
            IF (iX.NE.0) write(18,'(a20,i3)')' Ncav increased to:',Ncav
          END IF
c         increase the number of rays per y-grid interval
          IF (iterFbol.EQ.3.AND.Nins.EQ.2) THEN
            Nins = Nins + 1
            IF (iX.NE.0) write(18,'(a20,i3)')' Nins increased to:',Nins
          END IF
          CALL Pgrid(pstar,iPstar,error)
c         if P grid is not OK end this model
          IF (error.NE.0) goto 999
          IF (iX.NE.0) THEN
            write(18,'(a23,i3)')' Y grid improved, nY =',nY
            write(18,'(a23,i3)')'                  nP =',nP
            write(18,'(a23,i3)')'                Nins =',Nins
            write(18,'(a23,i3)')'                Ncav =',Ncav
          END IF
        END IF
      ELSE
        IF (iX.NE.0) write(18,*)' Using same Y and P grids'
      END IF
c     generate spline coefficients for ETA
      CALL setupETA
c     evaluate ETAzp
      CALL getETAzp(ETAzp)
c     generate albedo through the envelope
      CALL getOmega(nG)
c     generate stellar moments
      CALL Star(pstar,ETAzp,error)
      IF (iVerb.EQ.2) write(*,*) 'Done with Star'
c     issue a message in fname.out about the condition for neglecting
c     occultation:
      IF(model.eq.1.AND.iterFbol.eq.1.AND.iterEta.eq.1) CALL OccltMSG
c     generate the first approximations for Td and alpha
      CALL InitTemp(ETAzp,nG,alpha)
      IF (iVerb.EQ.2) write(*,*) 'Done with InitTemp'
c     find radiative transfer matrices
      IF (iX.NE.0) write(18,*)' Calculating weight matrices'
      IF (iVerb.EQ.2) write(*,*) 'Calculating weight matrices'
      CALL Matrix(ETAzp,pstar,iPstar,mat0,mat1,mifront,miback)
      Conv = 0
      iter = 0
c     itlim is an upper limit on number iterations
      itlim = 10000
      IF (iX.NE.0) write(18,*)' Weight matrices OK, calculating Tdust'
      IF (iVerb.EQ.2) write(*,*)' Weight matrices OK, calculating Tdust'
      IF (iInn.eq.1) THEN
        write(38,'(a8,i5)') '    nY= ',nY
        write(38,*) '    iter   maxFerr     dmaxU       dmaxF'
      END IF
c     === Iterations over dust temperature =========
      DO WHILE (Conv.EQ.0.AND.iter.LE.itlim)
        iter = iter + 1
c       find emission term
        CALL Emission(0,nG,Td,alpha,abund,Us,Em)
c       solve for Utot
        CALL Invert(nY,nL,mat0,Us,Em,omega,Utot,Uold,error)
        IF(error.NE.0) goto 999
c       find new Td and alpha, and check convergence
        CALL FindTemp(1,Utot,nG,Td,alpha)
c       --------------------------------------
c       every itnum-th iteration check convergence:
          IF (iter.GT.80) THEN
             itnum = 10
            ELSE
             itnum = 6
          END IF
c       first find 'old' flux (i.e. in the previous iteration)
        IF (MOD(iter+1,itnum).EQ.0) THEN
          CALL Multiply(1,npY,nY,npL,nL,mat1,Utot,omega,0,fs,fds)
          CALL Multiply(0,npY,nY,npL,nL,mat1,Em,omega,0,fs,fde)
          CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
c         find bolometric flux
          CALL Bolom(ftot,fbolold)
        END IF
        IF (MOD(iter,itnum).EQ.0) THEN
c         first calculate total flux
          CALL Multiply(1,npY,nY,npL,nL,mat1,Utot,omega,0,fs,fds)
          CALL Multiply(0,npY,nY,npL,nL,mat1,Em,omega,0,fs,fde)
          CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
c         find bolometric flux
          CALL Bolom(ftot,fbol)
c         check convergence of bolometric flux
          CALL Converg1(nY,accFbol,dynrange,fbolold,fbol,Fconv,dmaxF)
c         check convergence of energy density
          CALL Converg2(nY,nL,accConv,dynrange,Uold,Utot,Uconv,dmaxU)
c         find maximal fbol error
          CALL FindErr(fbol,maxFerr,nY)
c ------  printout of errors and convergence with iter.(inner flag): -------
          IF(iInn.EQ.1) THEN
            write(38,'(i7,1p,3e12.4)') iter,maxFerr,dmaxU,dmaxF
          END IF
c --------------------------------------------------------------
          IF (maxFerr.LE.accuracy) THEN
            BolConv = 1
          ELSE
            BolConv = 0
          END IF
c         total criterion for convergence: Utot must converge, and ftot
c         must either converge or have the required accuracy
          IF (Uconv*(Fconv+BolConv).GT.0) Conv = 1
        END IF
c       --------------------------------------
      END DO
c     === The End of Iterations over Td ===
      IF (iX.NE.0) THEN
        IF (iter.LT.itlim) write(18,*)
     &     ' Convergence achieved, number of'
        write(18,'(a34,i4)')
     &     ' iterations over energy density: ',iter
        write(18,'(a30,1p,e8.1)')
     &     ' Flux conservation OK within:',maxFerr
        IF (iter.GE.itlim) THEN
          CALL MSG(2)
          iWARNING = iWARNING + 1
        END IF
      END IF
c     calculate the emission term for the converged Td
      CALL Emission(0,nG,Td,alpha,abund,Us,Em)
c     calculate flux
      CALL Multiply(1,npY,nY,npL,nL,mat1,Utot,omega,0,fs,fds)
      CALL Multiply(0,npY,nY,npL,nL,mat1,Em,omega,0,fs,fde)
      CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
      CALL Bolom(ftot,fbol)
c     check whether, and how well, is bolometric flux conserved
      CALL ChkBolom(fbol,accuracy,deviat,FbolOK)
c     calculate additional output quantities
c     1) energy densities
      CALL Multiply(1,npY,nY,npL,nL,mat0,Utot,omega,0,Us,Uds)
      CALL Multiply(0,npY,nY,npL,nL,mat0,Em,omega,0,Us,Ude)
      CALL Add(npY,nY,npL,nL,Us,Uds,Ude,Uchck)
      CALL Bolom(Utot,Ubol)
      CALL Bolom(Uchck,UbolChck)
c     2) scaled radial optical depth, tr
      DO iY = 1, nY
        tr(iY) = ETAzp(1,iY) / ETAzp(1,nY)
      END DO
c     3) calculate intensity (at the outer edge) if required
      IF(iC.NE.0) THEN
       CALL FindInt(nG,alpha,ETAzp)
       IF (iVerb.EQ.2) write(*,*) 'Done with FindInt'
      END IF

c     MG 30.09.09 not here but later
c     if needed convolve intensity with the PSF
c      IF (iPSF.NE.0) THEN
c        CALL Convolve(IntOut)
c        IF (iVerb.EQ.2) write(*,*) 'Done with Convolve'
c      END IF
c     if needed find the visibility function
c      IF (iV.NE.0) THEN
c        CALL Visibili(IntOut)
c        IF (iVerb.EQ.2) write(*,*) 'Done with Visibili'
c      END IF
c ============ if the inner flag iInn=1:  =========
      IF(iX.GE.1 .AND. iInn.EQ.1) THEN
        CALL Bolom(fs,fsbol)
        CALL ADD2(fds,fde,fdbol,nY)
        write(18,'(a11,1p,E11.3)')'   TAUfid =',TAUfid
        write(18,'(a11,1p,E11.3)')'  MaxFerr =',maxFerr
        write(18,*)
     &'     tr      fbol       fsbol      fdbol       Ubol  '
       DO iY = 1, nY
        write(18,'(1p,5E11.3)') tr(iY), fbol(iY), fsbol(iY),
     &                          fdbol(iY), Ubol(iY)
       END DO
      END IF
c =====================
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************

      SUBROUTINE SetGrids(pstar,iPstar,error,TAU)
c =======================================================================
c Sets the Y and P grids based on GrayBody flux conservation.
c                                                     [MN & ZI, July'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER error, iPstar, dummy
      DOUBLE PRECISION pstar, Ugb(npY), fgb(npY), ETAzp(npP,npY),albedo,
     &       aux, faccs, TAU, accur, delTAUin
c -----------------------------------------------------------------------
c     store the default value for delTAUsc and facc
      faccs = facc
      delTAUin = delTAUsc
c     change the delTAUsc seed for the initial Y grid if TAU is large
      IF (TAU.LT.1.0) delTAUsc = delTAUin * 2.d0
      IF (TAU.GE.1.0.and.TAU.LT.5.0) delTAUsc = delTAUin * 1.5d0
      IF (TAU.EQ.5.0) delTAUsc = delTAUin
      IF (TAU.GT.5.0.and.TAU.LT.10.0) delTAUsc = delTAUin / 1.2d0
      IF (TAU.GE.10.0.and.TAU.LT.20.0) delTAUsc = delTAUin / 1.3d0
c      The grid is set with TAU=min{TAUlim,TAUmax}, so the lines below are obsol
c      IF (TAU.GE.20.0.and.TAU.LT.30.0) delTAUsc = delTAUin / 1.4
c      IF (TAU.GE.30.0.and.TAU.LT.50.0) delTAUsc = delTAUin / 1.5
c      IF (TAU.GE.50.0) delTAUsc = delTAUin / 2.0
c     for steep density distributions (RDW, including analyt.approximation):
      IF (denstyp.EQ.4.OR.RDW) delTAUsc = delTAUin / 1.2d0
c     change the facc seed for the initial Y grid if Yout is very small
      IF (Yout.LT.1000.0) facc = dsqrt(faccs)
      IF (Yout.LT.100.0) facc = dsqrt(facc)
      IF (Yout.LT.10.0) facc = dsqrt(facc)
      IF (Yout.LT.2.0) facc = dsqrt(facc)
      IF (Yout.LT.1.2) facc = dsqrt(facc)
      IF (Yout.LT.1.05) facc = dsqrt(facc)

      albedo = 1.d0
      aux = 1.d0
c     generate initial grids
      CALL Ygrid(pstar,iPstar,error)
      IF (error.NE.0) goto 101
      CALL Pgrid(pstar,iPstar,error)
      IF (error.NE.0) goto 101
      IF (iX.GE.1) THEN
         write(18,'(a24,i3)')' Y grid generated, nY =',nY
         write(18,'(a24,i3)')'                   nP =',nP
         write(18,'(a24,i3)')'                 Nins =',Nins
         write(18,'(a24,i3)')'                 Ncav =',Ncav
      END IF
c     solve for gray body (i.e. pure scattering)
      CALL GrayBody(albedo,TAU,Ugb,fgb)
      IF (iVerb.EQ.2) write(*,*) 'Done with GrayBody'
c     find the max deviation of fgb (FindRMS called with flag 1)
      CALL FindRMS(1,fgb,aux,accur,nY)
      IF (iX.GE.1) THEN
        IF (accur.GT.accuracy) THEN
          write(18,'(a25)')' Grids need improvement:'
          write(18,'(a29,1p,e10.3)')
     &                          '                   fTot(nY):',fgb(nY)
          write(18,'(a29,1p,e10.3)')'      Single wavelength TAU:',TAU
          write(18,'(a29,1p,e10.3)')
     &                         '          Required accuracy:',accuracy
        END IF
        write(18,'(a29,1p,e10.3)')' Single wavelength accuracy:',accur
      END IF
      IF(accur.GT.accuracy) THEN
c       ChkFlux checks the bolometric flux conservation for the given
c       grid and decreases the step if conservation is not satisfactory
        dummy = 5
        CALL ChkFlux(fgb,accuracy,dummy,error,ETAzp)
        IF (error.NE.0) goto 101
c       dummy=5 means everything was fine in ChkFlux
        IF (dummy.EQ.5) THEN
          IF (iX.GE.1) write(18,'(a23,i3)')' Y grid improved, nY =',nY
c         generate new impact parameter grid
          CALL Pgrid(pstar,iPstar,error)
c         if P grid is not OK end this model
          IF (error.NE.0) goto 101
        ELSE
          IF (iX.GE.1) THEN
            write(18,'(a59,i3)')
     &      ' Although single wavelength accuracy was not satisfactory,'
            write(18,'(a56,i3)')
     &      ' Y grid could not be improved because npY is too small.'
            write(18,'(a58,i3)')
     &      ' Continuing calculation with a hope that it will be fine.'
          END IF
        END IF
      END IF
c     return the default value for facc
101    facc = faccs
       delTAUsc = delTAUin
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

      SUBROUTINE solve(model,nG,error,ETAzp)
c =======================================================================
c This subroutine solves the continuum radiative transfer problem for a
c spherically symmetric envelope.                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER model,error, iPstar, iterFbol, nG, FbolOK, EtaOK, iY
      DOUBLE PRECISION pstar, ETAzp(npP,npY), TAUlim, deviat
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      integer kk
c -----------------------------------------------------------------------
      IF(iInn.eq.1) THEN
        write(38,*)'============================================='
        write(38,'(a7,i5)') ' model= ',model
        write(38,*)'============================================='
      END IF
      IF (iX.NE.0) THEN
       CALL LINE(0,2,18)
       write(18,'(a7,i3,a20)') ' model ',model,'  RUN-TIME MESSAGES '
       CALL LINE(0,1,18)
       write(18,*)'===========  STARTING SOLVE  ==========='
      END IF
      error = 0
      IF(denstyp.NE.0) THEN
c     Solve for spherical envelope:
c      temporarily the star is approximated by a point source
       pstar = 0.d0
       iPstar = 1
c      select optical depth for the grid calculation
c      based on dynamical range
       TAUlim = 0.5d0*log(1.d0/dynrange)
c      if actual maximal tau is smaller use that value
       IF (TAUmax.LT.TAUlim) TAUlim = TAUmax
c      counter over ETA (for radiatively driven winds only)
       iterETA = 0
       EtaOK = 0
c      iterations over ETA
       DO WHILE (EtaOK.EQ.0)
         iterETA = iterETA + 1
         IF (iX.NE.0.AND.RDW) THEN
           write(18,*)'----------------------------------------'
           write(18,*)' ',iterETA,'. iteration over ETA'
         END IF
         IF (iVerb.EQ.2.AND.RDW)
     &          write(*,*) ' ',iterETA,'. iteration over ETA'
c        counter for iterations over bolometric flux conservation
         iterFbol = 0
         FbolOK = 0
         DO WHILE (FbolOK.EQ.0)
           iterFbol = iterFbol + 1
           IF (iX.NE.0) THEN
            write(18,*)'  ',iterFbol,'. iteration over Fbol'
           END IF
           IF (iVerb.EQ.2) write(*,*) iterFbol,'. iteration over Fbol'
c          solve the radiative transfer problem
c           write(80,*) 'thetav 1', theta1
           CALL RADTRANSF(pstar,iPstar,TAUlim,nG,ETAzp,FbolOK,deviat,
     &                   error,iterFbol,model)
c           write(80,*) 'thetav 2', theta1
           IF (iVerb.EQ.2) write(*,*) 'Done with RadTransf'
c          error.EQ.3 : file with stellar spectrum not available
           IF (error.EQ.3) goto 999
c          error.EQ.5 : Singular matrix
           IF (error.EQ.5) goto 999
c          error.EQ.6 : Eta exceeds limitations
           IF (error.EQ.6) goto 999
c          error.EQ.2 : P grid was not produced
           IF (error.EQ.2.AND.iterFbol.EQ.1.AND.iterETA.EQ.1) THEN
c           if this is the first calculation end this model
            iERROR = iERROR + 1
            goto 999
           ELSE
c           if this is a higher iteration use previous solution
            IF (error.EQ.2) THEN
              IF (iX.NE.0.AND.iterFbol.GT.1) THEN
              write(18,*)' ======= IMPORTANT WARNING ======== '
              write(18,*)' In trying to conserve Fbol reached'
              write(18,*)' the limit for grid sizes. Flux is '
              write(18,'(a,1p,e9.3)')'  conserved to within ', deviat
              write(18,*)' Treat all results with caution!'
              END IF
              IF (iX.NE.0.AND.iterFbol.EQ.1) THEN
              write(18,*)' ======== IMPORTANT  WARNING ======== '
              write(18,*)' In trying to converge on ETA reached'
              write(18,*)' the limit for grid sizes. Flux is '
              write(18,'(a,1p,e9.3)')'  conserved to within ', deviat
              write(18,*)' Treat all results with caution!'
              END IF
              error = 0
              FbolOK = 2
              iWARNING = iWARNING + 1
            END IF
           END IF
c          just in case...
           IF (error.EQ.1) THEN
            IF (iX.NE.0) THEN
              write(18,*)' *********  FATAL ERROR  *********'
              write(18,*)' * Something was seriously wrong *'
              write(18,*)' * Contact Z. Ivezic, M. Elitzur *'
              write(18,*)' *********************************'
            END IF
            iERROR = iERROR + 1
            goto 999
           END IF
c          if Fbol not conserved try again with a finer grid
           IF (FbolOK.EQ.0.AND.iterFbol.LT.10.AND.iX.NE.0) THEN
            write(18,*)'  ******** MESSAGE from SOLVE ********'
            write(18,*)'  Full solution does not conserve Fbol'
            write(18,*)'       Y       TAU/TAUtot        fbol'
            DO iY =1, nY
              write(18,'(1p,3e13.4)')Y(iY),
     &                  ETAzp(1,iY)/ETAzp(1,nY),fbol(iY)
            END DO
            write(18,*)'  Trying again with finer grids'
           END IF
c          if could not conserve Fbol in 10 trials give it up
           IF (FbolOK.EQ.0.AND.iterFbol.GE.10) THEN
            IF (RDW) THEN
            IF (iX.NE.0) THEN
            write(18,*)' **********  WARNING from SOLVE  **********'
            write(18,*)' Could not obtain required accuracy in Fbol'
            write(18,'(a26,1p,e10.3)')'  The achieved accuracy is:',
     &                                 deviat
            write(18,*)' Will try to converge on the dynamics, but '
            write(18,*)' treat all results with caution !!         '
            write(18,*)' If accuracy<=0.01, or TAUmax>1000, this   '
            write(18,*)' code probably cannot do it. Otherwise,    '
            write(18,*)' please contact Z. Ivezic or M. Elitzur    '
            write(18,*)' ******************************************'
            END IF
            iWARNING = iWARNING + 1
            FbolOK = 1
            ELSE
            IF (iX.NE.0) THEN
            write(18,*)' **********  WARNING from SOLVE  **********'
            write(18,*)' Could not obtain required accuracy in Fbol'
            write(18,'(a26,1p,e10.3)')'  The achieved accuracy is:',
     &                                 deviat
            write(18,*)' !!!!  Treat all results with caution  !!!!'
            write(18,*)' If accuracy<=0.01, or TAUmax>1000, this   '
            write(18,*)' code probably cannot do it. Otherwise,    '
            write(18,*)' please contact Z. Ivezic or M. Elitzur    '
            write(18,*)' ******************************************'
            END IF
            iWARNING = iWARNING + 1
            FbolOK = 2
            END IF
           END IF
c        end of loop over flux conservation
         END DO
c        for winds check if ETA has converged...
         IF ((RDW).AND.FbolOK.NE.2) THEN
c         ptr(2) is specified in INPUT and controls converg. crit.
          IF (ptr(2).LT.1.0d-6.AND.iterETA.GT.2)THEN
            EtaOK = 1
          ELSE
            CALL WINDS(nG,EtaOK,ETAzp,ftot)
          END IF
          IF (iterETA.GT.10.AND.EtaOK.EQ.0) THEN
            EtaOK = 2
            iWARNING = iWARNING + 1
            IF (iX.NE.0) THEN
              write(18,*)' *********  WARNING  *********'
              write(18,*)' Could not converge on ETA in '
              write(18,*)' 10 iterations.'
              write(18,*)' *********************************'
            END IF
          END IF
c         ...or otherwise finish right away
         ELSE
          EtaOK = 1
         END IF
c      end of loop over ETA
       END DO
      ELSE
c      solve for slab case
       CALL SLBsolve(model,nG,error)
c      error=4 means npY not large enough for oblique illumination grid
       IF (error.eq.4) THEN
        CALL MSG(15)
        iWARNING = iWARNING + 1
        goto 999
       END IF
      END IF
c     analyze the solution and calculate some auxiliary quantities
c      write(80,*) 'thetav 3', theta1
      CALL Analysis(model,ETAzp,error)
c      write(80,*) 'thetav 4', theta1
      IF (iVerb.EQ.2) write(*,*) 'Done with Analysis'

c     MG 30.09.09 moved here
c     if needed convolve intensity with the PSF
      IF (iPSF.NE.0) THEN
         write(80,*) 'convolve'
         do kk= 1,np+2
            write(80,*) kk,intout(1,kk)
         enddo
        CALL Convolve(IntOut)
        IF (iVerb.EQ.2) write(*,*) 'Done with Convolve'
      END IF
c     if needed find the visibility function
      IF (iV.NE.0) THEN
        CALL Visibili(IntOut)
        IF (iVerb.EQ.2) write(*,*) 'Done with Visibili'
      END IF


      IF (iX.NE.0) THEN
        write(18,*)' ==== SOLVE successfully completed ====='
        write(18,*)' ======================================='
      END IF
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE STAR(pstar,ETAzp,error)
c =======================================================================
c This subroutine generates the stellar moments   [ZI, Nov'95; MN,Mar'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      CHARACTER*235 line
      INTEGER iY, iL, ios1, iLs, nLs, k, kstop, i, error, Nlambdam
c     Nlambdam is the max number entries for a user supplied stellar spectrum
      PARAMETER (Nlambdam = 10000)
      DOUBLE PRECISION pstar, ETAzp(npP,npY), zeta, Bb, x, Planck, a, b,
     &        lambdaS(Nlambdam), Llamstar(Nlambdam), Stellar(Nlambdam),
     &        Lstar, fL(100), fpl(npL), llS(Nlambdam), lS(Nlambdam),
     &        expow, dyn2, EMfunc
c -----------------------------------------------------------------------
c     for  startyp.GE.4 stellar spectrum is read from the file 'nameStar'
c     it is unit=3 (1 is the input file)
      IF ((startyp(1).GE.4).AND.(startyp(1).LE.6)) THEN
        open(3,ERR=998,file=nameStar(1),STATUS='OLD')
        rewind(3)
        read(3,'(a235)',ERR=998) line
        read(3,'(a235)',ERR=998) line
        read(3,'(a235)',ERR=998) line
        ios1 = 0
        iLs = 0
        DO WHILE (ios1.ge.0)
          read(3,*,END=900,ERR=998,iostat=ios1)a,b
          IF (ios1.ge.0) THEN
            iLs = iLs + 1
            lambdaS(iLs) = a
            IF (a.LE.0.0) goto 998
c           it is assumed that Llamstar is L_Lambda, but...
c           if startyp.EQ.4 then file gives lambda*L_lambda
            IF (startyp(1).EQ.4) Llamstar(iLs) = b / a
c           if startyp.EQ.5 then file gives L_lambda
            IF (startyp(1).EQ.5) Llamstar(iLs) = b
c           if startyp.EQ.6 then file gives Lnu=lambda**2*L_lambda
            IF (startyp(1).EQ.6) Llamstar(iLs) = b / a / a
           END IF
        END DO
900     close(3)
        IF (iLs.LT.2) goto 998
        nLs = iLs
c       if input wavelengths in descending order turn them around
        IF (lambdaS(1).GT.lambdaS(2)) THEN
          DO iLs = 1, nLs
            llS(iLs) = lambdaS(iLs)
            lS(iLs) = Llamstar(iLs)
          END DO
          DO iLs = 1, nLs
            lambdaS(iLs) = llS(nLs+1-iLs)
            Llamstar(iLs) = lS(nLs+1-iLs)
          END DO
        END IF
c       normalize stellar spectrum
        CALL Simpson(Nlambdam,1,nLs,lambdaS,Llamstar,Lstar)
c       generate dimensionless stellar spectrum
        DO iLs = 1, nLs
          Stellar(iLs) = lambdaS(iLs) * Llamstar(iLs) / Lstar
        END DO
        ELSE
c       if startyp.EQ.3 generate power-law spectrum
        IF (startyp(1).EQ.3) THEN
          fL(1) = 1.d0
          IF (Nlamtr(1).GT.1) THEN
            DO i = 2, Nlamtr(1)
              fL(i) = fL(i-1) * (lamtr(1,i-1)/lamtr(1,i))**klam(1,i-1)
            END DO
          END IF
          DO iL = 1, nL
            IF ((lambda(iL)-lamtr(1,1))*(lambda(iL)-
     &                              lamtr(1,Nlamtr(1)+1)).LE.0.0) THEN
              kstop = 0
              k = 0
              DO WHILE (kstop.EQ.0)
                k = k + 1
                IF (lambda(iL).GE.lamtr(1,k)) THEN
                  kstop = 1
                  fpl(iL) = fL(k) * (lamtr(1,k)/lambda(iL))**klam(1,k)
                END IF
              END DO
            ELSE
              fpl(iL) = 0.d0
            END IF
          END DO
        END IF
      END IF
      DO iY = 1, nY
c       effect of the star's finite size
        IF (pstar.GT.0.d0) THEN
         zeta= 2.d0*(1.d0-sqrt(1.d0-(pstar/Y(iY))**2.))
     c                             *(Y(iY)/pstar)**2.
        ELSE
         zeta= 1.d0
        END IF
c       loop over wavelengths
        DO iL = 1, nL
          IF (startyp(1).EQ.1) THEN
            Bb = 0.0
            DO k = 1, nBB(1)
              x = 14400.d0 / lambda(iL) / Tbb(1,k)
              Bb = Bb + rellum(1,k)*Planck(x)
            END DO
          ELSE IF (startyp(1).EQ.2) THEN
              Bb = EMfunc(lambda(iL),Tbb(1,1),xSiO)
          ELSE IF (startyp(1).EQ.3) THEN
              Bb = fpl(iL)
          ELSE IF (lambda(iL).GT.lambdaS(nLs)) THEN
c             for lambda longer than the longest entry in nameStar
c             assume Rayleigh-Jeans tail
              Bb = Stellar(nLs) * (lambdaS(nLs)/lambda(iL))**3.
          ELSE IF (lambda(iL).LT.lambdaS(1)) THEN
c             if shorter than the shortest assume 0
              Bb = 0.d0
          ELSE
c             if within limits interpolate
              CALL LinInter(Nlambdam,nLs,lambdaS,Stellar,
     &                                             lambda(iL),iLs,Bb)
          END IF
c   ----------  done with stellar spectrum ---------------
c         stellar part of en.density and flux
          expow = ETAzp(1,iY)*TAUtot(iL)
          Us(iL,iY) = Bb * zeta * dexp(-expow)
c         flux
          fs(iL,iY) = Bb * dexp(-expow)
c         need to carry fsL to be compatible with the slab case
          fsL(iL,iY) = fs(iL,iY)
          fsR(iL,iY) = 0.d0
          dyn2 = dynrange*dynrange
          IF (Us(iL,iY).LT.dyn2) Us(iL,iY) = 0.d0
          IF (fs(iL,iY).LT.dyn2.AND.denstyp.NE.0) fs(iL,iY) = 0.d0
        END DO
      END DO
c     normalize stellar quantities with the stellar bolometric flux
      CALL Bolom(fsL,fsbol)
      DO iY = 1, nY
        DO iL = 1, nL
           Us(iL,iY) = Us(iL,iY) / fsbol(1)
           fs(iL,iY) = fs(iL,iY) / fsbol(1)
           fsL(iL,iY) = fsL(iL,iY) / fsbol(1)
        END DO
      END DO
      error = 0
      goto 999
998   write(12,*)' *** FATAL ERROR IN DUSTY! *************************'
      write(12,*)' File with the spectral shape of external radiation:'
      write(12,'(a2,a70)')'  ',nameStar(1)
      write(12,*)' is missing or not properly formatted?!'
      write(12,*)' ***************************************************'
      error = 3
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE trapzd2(a,b,s,n)
c =======================================================================
c This function integrates prescribed 8 functions from z=a to z=b with n
c divisions and stores the results to s(1..8). It is a heavily modified
c version of subroutine 'trapzd' (Num.Rec.'92).        [MN & ZI, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER it,iC,i,n,j
      DOUBLE PRECISION s(8),a,b,funcx(8),funca(8),funcb(8),del,sum(8),
     &       tnm, x, ff, gp, gm
c -----------------------------------------------------------------------
      IF (n.eq.1) then
c       calculate auxiliary functions at a and at b
        CALL TWOFUN(a,ff,gp,gm)
        funca(1) =  gm
        funca(5) =  gp
        DO iC = 2, 4
            funca(iC) = funca(iC-1) * ff
            funca(4+iC) = funca(3+iC) * ff
        END DO
        CALL TWOFUN(b,ff,gp,gm)
        funcb(1) =  gm
        funcb(5) =  gp
        DO iC = 2, 4
          funcb(iC) = funcb(iC-1) * ff
          funcb(4+iC) = funcb(3+iC) * ff
        END DO
c       calculate integrals for all 8 functions
        DO i = 1, 8
          s(i) = 0.5d0*(b-a)*(funca(i)+funcb(i))
        END DO
      ELSE
        it=2**(n-2)
        tnm=1.0*(it)
        del=(b-a)/tnm
        x=a+0.5d0*del
        DO i=1,8
          sum(i)=0.d0
        END DO
c       calculate contributions of all 'it' divisions
        DO j = 1, it
c         auxiliary functions at x
          CALL TWOFUN(x,ff,gp,gm)
c         generate (8) integrated functions at x
          funcx(1) = gm
          funcx(5) = gp
          DO iC = 2, 4
            funcx(iC) = funcx(iC-1) * ff
            funcx(4+iC) = funcx(3+iC) * ff
          END DO
          DO i=1,8
            sum(i)=sum(i)+funcx(i)
          END DO
c         next x
          x=x+del
        END DO
c       evaluate new value of the integral for all 8 cases
        DO i=1,8
          s(i)=0.5d0*(s(i)+(b-a)*sum(i)/tnm)
        END DO
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE TWOFUN(z,ff,gp,gm)
c =======================================================================
c This function evaluates auxiliary functions needed in trapzd2.
c                                           [MN & ZI,Aug'96; MN,Sep'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iLaux, iW1, iC
      DOUBLE PRECISION paux, w1,wL,etaloc, w, IntETA, pp, delTAUzp, z,
     &        auxw, ff, gp, gm, gp1,gm1
      COMMON /phi2/ paux, w1, wL, delTAUzp, iLaux, iW1
c -----------------------------------------------------------------------
c     local radius
      w = dsqrt(paux*paux + z*z)
      IF (w.LT.w1) w = w1
c     find local value for ETA function
      etaloc = 0.d0
      auxw = 1.d0
      DO iC = 1, 4
        etaloc = etaloc + ETAcoef(iW1,iC)*auxw
        auxw = auxw/w
      END DO
c     ff, i.e. radial optical depth:
      pp = 0.d0
      ff = IntETA(pp,iW1,wL,w)*TAUtot(iLaux)
c     g functions:
      gp1 = dexp(IntETA(paux,iW1,w1,w)*TAUtot(iLaux)-delTAUzp)
      gm1 = dexp(-IntETA(paux,iW1,w1,w)*TAUtot(iLaux))
      gp = etaloc/w/w * gp1
      gm = etaloc/w/w * gm1
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE WEIGHTS(TAUaux,iP,iL,nZ,nY,alpha,beta,gamma,delta,
     &                   wgp,wgm)
c =======================================================================
c This subroutine calculates weights wgp(iZ,iY) and wgm(iZ,iY) for
c integrations:
c INT(S(w)*exp(sign*ETAzp(iP,iZ')/w^2)dETAzp(iP,iZ')]
c from ETAzp(iP,iZ) to ETAzp(iP,iZ+1), where w is local radius
c corresponding to TAU(iP,iZ'), and sign=1 for wgp and -1 for wgm.
c Integrals are evaluated as:
c INT = wg(iZ,1)*S(1) + wg(iZ,2)*S(2) + ... + wg(iZ,nY)*S(nY) with
c iZ=1..nZ-1. The method is based on approximation of S by cubic spline
c in radial optical depth given through matrices alpha, beta, gamma and
c delta (see MYSPLINE).                         [ZI,Dec'95;MN,Sep'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iP, iL, nZ, nY, iW, iZ, j
      DOUBLE PRECISION alpha(npY,npY), beta(npY,npY), gamma(npY,npY),
     &        delta(npY,npY), TAUaux(npL,npP,npY), K1p(npY),K2p(npY),
     &        K3p(npY),K4p(npY), K1m(npY),K2m(npY),K3m(npY),K4m(npY),
     &        wgp(npY,npY), wgm(npY,npY), waux
c -----------------------------------------------------------------------
c     generate integrals of 'TAUr**n'
      CALL Kint4(TAUaux,iP,iL,nZ,K1p,K2p,K3p,K4p,K1m,K2m,K3m,K4m)
c     loop over position on the line of sight
      DO iZ = 1, nZ
        iW = iYfirst(iP) + iZ - 1
c       loop over radial position
        DO j = 1, nY
         IF (iZ.GT.1) THEN
          waux = alpha(iW-1,j)*K1p(iZ) + beta(iW-1,j)*K2p(iZ)
          wgp(iZ,j)=waux + gamma(iW-1,j)*K3p(iZ)+delta(iW-1,j)*K4p(iZ)
         ELSE
          wgp(1,j) = 0.d0
         END IF
         IF (iZ.LT.nZ) THEN
          wgm(iZ,j) = alpha(iW,j)*K1m(iZ) + beta(iW,j)*K2m(iZ)
          wgm(iZ,j) = wgm(iZ,j)+gamma(iW,j)*K3m(iZ)+delta(iW,j)*K4m(iZ)
         ELSE
          wgm(nZ,j) = 0.d0
         END IF
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Ygrid(pstar,iPstar,error)
c =======================================================================
c This subroutine generates the radial (Y) grid.
c Ncav is desired number of rays through the inner cavity (<=20), denstype
c is type of density law (see input file). Yout is the relative thickness,
c Yout=rout/r1. delTausc is maximum increase of the scaled optical depth
c tau/tauTot between two successive radial grid points and facc is the
c maximum ratio of their y coordinates. EtaRat is initialized in SUB Input
c and limits the ratio of two successive Eta(iY), in order to prevent
c nonphysical results in case of steep density distribution (pow>2). pstar is
c the impact parameter for star (0<=p<=1). First few points are prescribed
c arbitrarily. error is set to 1 if desired delTausc and facc result in too
c many points (> npY from userpar.inc). This subroutine calls function ETA
c which evaluates the normalized density profile.    [ZI, Nov'95; MN,Sep'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG, nfit
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nfit=4)

      INTEGER nY, nYprev, nP, nL, nPcav, idx(npP)
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2), dum(npY)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      common/params/a,iadum
      integer iadum(nfit)
      double precision a(nfit)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER i, istop,error,iPstar, iter, iYdummy, iY, itr, j, ir, jY,
     &        irmax
      DOUBLE PRECISION pstar, dyR, dyT, ETA, aux, tausc, EtaTemp(npY),
     &       ee, Yloc, nh, fac, dyF, yold, ynew, y1, delY1, Ymid,
     &       TAUloc, rat, dY, Etamin, Etamax
c -----------------------------------------------------------------------
c     max number iter. over improving ratio of two Eta's
      irmax = 20
c     save old grid and values of Eta (important for denstyp = 5 or 6)
      IF (nY.GT.0.AND.(RDW)) THEN
        DO iY = 1, nY
          Yprev(iY) = Y(iY)
          EtaTemp(iY) = ETAdiscr(iY)
        END DO
        nYprev = nY
      END IF
      pstar = pstar
      iPstar = iPstar
      y1 = 1.d0
      iter = 0
101   error = 0
      iter = iter + 1
c     resolve inner boundary in tau space
c     from requiring TAU(2) = TAUmax*ETA(1)*(Y(2)-1) =~ 1
      Y(1) = y1
      IF (TAUmax*ETA(y1).GT.2000.d0) THEN
        delY1 = 2.d0 / TAUmax / ETA(y1)
      ELSE
        delY1 = 1.d0 / TAUmax / ETA(y1)
      END IF
c     if very thin generate at least about 10-15 pts.
      IF (delY1.GT.0.01d0/ETA(y1)) delY1 = 0.01d0/ETA(y1)
c     do not push it over the limit of spline stability
      IF (delY1.LT.0.00005d0) delY1 = 0.00005d0
      i = 1
      istop = 0
      DO WHILE (istop.NE.1)
        i = i + 1
        Y(i) = Y(i-1) + delY1
        IF (Y(i).GT.facc*Y(i-1)) THEN
          Y(i) = facc * Y(i-1)
        ELSE
          delY1 = 2.d0 * delY1
        END IF
        Ymid = dsqrt(Y(i)*Y(i-1))
        TAUloc = TAUmax * (Y(i)-1.0) * ETA(Ymid)
        IF (Y(i).GE.1.01.OR.TAUloc.GT.10.0) istop = 1
c       in case of shell thinner than 1.01 comment the above line and
c       uncomment the next line, unless it is a case of RDW at high TauV.
c       These require more points near the origin and 1.01 is a better limit.
c       IF (Y(i).GE.1.0001.OR.TAUloc.GT.10.0) istop = 1
      END DO
      Ynew = Y(i)
c     some rule of thumb estimates for factor nh
      IF (TAUmax.GT.10000.0) THEN
c       extreme taus
        nh = 15.0
        Ncav = 80
      ELSE IF (TAUmax.GT.2000.0) THEN
c         huge taus
          nh = 10.0
          Ncav = 40
      ELSE IF (TAUmax.GT.400.0) THEN
c         large taus
          nh = 8.0
          Ncav = 20
      ELSE
c         normal' taus
          nh = 5.0
          Ncav = 10
      END IF

c     MG 08.10  increase Ncav for low  inner radius dust temperatures
c      if (10**a(3) .lt. 100.) Ncav = 40

c     very small taus
      IF (TAUmax.LT.10.0) nh = nh / 2.0
      IF (TAUmax.LT.1.0) nh = nh / 2.0
c     MG 08.10
      IF (TAUmax.LT.0.1) nh = nh / 2.0

c     MG 30.01.11  hardcode for U Cam to increase grids
c      nh = 5.0
c      Ncav = 10

c     empirically: ~1/r needs more points for small y:
      IF ((pow-1.4)*(pow-0.6).LE.0.0) nh = nh * 1.5
c     same for for steep density distributions:
      IF (denstyp.eq.4.OR.RDW) nh = nh * 1.5
      tausc = ETA(Y(i))+ETA(Y(i-1))
      tausc = (Y(i)-Y(i-1)) * 0.5 * tausc
      fac = dexp( -dlog(tausc) / nh)
      istop = 0
c     for broken power-laws
      itr = 0
      IF (Ntr.GE.1) THEN
        itr = 1
        DO j = 1, i
          IF (Y(j).GE.Ytr(itr)) itr = itr + 1
        END DO
      END IF
c     generate the rest of Y grid points
      DO WHILE (istop.NE.1)
        i = i + 1
        Yold = Ynew
c       find maximal increase in Y allowed by the ratio facc
        dyR = Yold * (facc -1.)
c       find maximal increase in Y allowed by delTausc
        dyT = delTausc / ETA(Yold)
c       find maximal increase in Y allowed by the ratio of tausc
        dyF = tausc*(fac -1.) / ETA(Yold)
c       find new Y
c        Ynew = Yold + MIN(dyR,dyT,dyF)
        dY = MIN(dyR,dyT,dyF)
        write(80,*) "build Ygrid", i, dyR,dyT,dyF, Y(I-1), facc,fac,nh
c        write(*,*) dyR,dyT,dyF, Y(I-1),i, facc
c       Check if the max ratio btw. two Eta values is less than EtaRat
c       and insert additional y-pts. where necessary. This prevents sharp
c       drops in Utot(npL,npY) in case of steep Eta's [MN'99].
        DO ir = 1 , irmax
          Ynew = Yold + dY
          rat = ETA(Yold)/ETA(Ynew)
c          write(*,*) ir, Yold, Ynew, ETA(Yold), rat
          IF(rat.GE.1./EtaRat .AND. rat.LE.EtaRat) goto 10
          dY = 0.5*dY
        END DO
        write(*,*) 'probably increase EtaRat', rat
        STOP
        CALL MSG(16)
10      continue
        Y(i) = Ynew
c       make sure that all transition points are included in the grid
c      MG 27.08.09 With scaled broken powerlaws,
c                  one needs points just below and above transition to resolve it
        IF (Ntr.GE.1) THEN
         IF (Y(i).GE.Ytr(itr)) THEN
           Y(i) = Ytr(itr)*0.999
           i = i+1
           Y(i) = Ytr(itr)*1.001

           Ynew = Y(i)
           itr = itr + 1
         END IF
        END IF
        aux = ETA(Ynew)+ETA(Yold)
        aux = (Ynew-Yold) * 0.5 * aux
        tausc = tausc + aux
c       finish when Yout is reached
        IF (Ynew.GE.Yout) istop = 1
      END DO
      Y(i) = Yout
      nY = i
c     insert additional penultimate point to avoid spline oscillations
      Y(nY+1) = Yout
      Y(nY) = dsqrt(Y(nY)*Y(nY-1))
      nY = nY + 1

c      do i= 1,ny
c         write(80,*) i, y(i)
c      enddo

c     MG 27.08.09 specifically add points to better resolve transition regions
      IF (Ntr.GE.1) THEN
         Yold= 1.0d0
         do i= 1, ntr+1
c             nY = nY + 1
c             Y(nY) = (Ytr(i)-Yold)* 1./5. +Yold
c             nY = nY + 1
c             Y(nY) = (Ytr(i)-Yold)* 2./5. +Yold
c             nY = nY + 1
c             Y(nY) = (Ytr(i)-Yold)* 3./5. +Yold
c             nY = nY + 1
c             Y(nY) = (Ytr(i)-Yold)* 4./5. +Yold

             nY = nY + 1
             Y(nY) = Yold* 10**( (log10(Ytr(i))-log10(Yold))* 1./4.)
             nY = nY + 1
             Y(nY) = Yold* 10**( (log10(Ytr(i))-log10(Yold))* 2./4.)
             nY = nY + 1
             Y(nY) = Yold* 10**( (log10(Ytr(i))-log10(Yold))* 3./4.)
c             nY = nY + 1
c             Y(nY) = Yold* 10**( (log10(Ytr(i))-log10(Yold))* 4./5.)

             yold= Ytr(i)
         enddo
c     sort Y-array
         call indexx(nY, Y, idx)
         do i= 1,ny
            dum(i)= Y(idx(i))
         enddo
         do i= 1,ny
            Y(i)= dum(i)
c            write(*,*) 'Y-array', i, y(i)
         enddo
      END IF
c     MG 27.08.09 end


c     check that outer edge is well resolved in tau space
c     (important for flat ETAs)
      istop = 0
      DO WHILE (istop.NE.1)
        IF ((Yout-Y(nY-1))*TAUmax*ETA(Yout).GT.1.0) THEN
          Y(nY+1) = Yout
          Y(nY) = dsqrt(Y(nY)*Y(nY-1))
          nY = nY + 1
        ELSE
          istop = 1
        END IF
      END DO
c     check dynamical range of Eta to avoid nonphysical results or code errors [
      Etamax = 0.
      Etamin = 1.d+20
      DO iY = 1, nY
       IF(ETA(Y(iY)).lt.Etamin) Etamin = ETA(Y(iY))
       IF(ETA(Y(iY)).gt.Etamax) Etamax = ETA(Y(iY))
       IF (ETA(Y(iY)).LT.1.d-12) THEN
        IF (iX.GT.0) THEN
         write(18,*)'      Y          ETA  '
         DO jY = 1, nY
           write(18,'(1p,2e12.3)') Y(jY),ETA(Y(jY))
         END DO
        END IF
        CALL MSG(17)
        error = 6
        iERROR = iERROR + 1
        goto 102
       END IF
      END DO
      IF ((Etamin/Etamax).LT.1.d-12) THEN
       CALL MSG(18)
       error = 6
       iERROR = iERROR + 1
       goto 102
      END IF
c     check that the Y grid is not too large
      IF (nY.GT.npY) THEN
        delTAUsc = delTAUsc * 1.5
        iWARNING = iWARNING + 1
        IF (iX.NE.0) THEN
        IF (iter.EQ.1) call line(0,2,18)
        write(18,'(a)')
     &  ' ****************   WARNING   *******************'
        write(18,'(a46,i3)')
     &             ' Initial delTAUsc resulted in too many points:',nY
        write(18,'(a,i3,a)')' You need to increase npY in userpar.inc'
        write(18,*)'Multiplying delTAUsc by 1.5 and trying again'
        write(18,'(a14,1p,e10.3)')' New delTAUsc:',delTAUsc
        END IF
        IF (iter.LT.5) THEN
          goto 101
        ELSE
          IF (iX.NE.0) THEN
            write(18,'(a)')
     &            ' ****************  GIVING UP  *******************'
            call line(0,2,18)
          END IF
          error = 2
          goto 102
        END IF
      END IF
c     intepolate ETAdiscr to new Y grid (for RDW (denstyp=5 or 6))
c      write(18,*)' ***** From Ygrid *****'
c      write(18,*)'      Y      ETAdiscr      '
      DO iY = 1, nY
        Yloc = Y(iY)
        IF (iterETA.GT.1) THEN
          CALL LinInter(npY,nYprev,Yprev,EtaTemp,Yloc,iYdummy,ee)
          ETAdiscr(iY) = ee
        ELSE
          ETAdiscr(iY) = ETA(Yloc)
        END IF
c        write(18,'(1p,2e12.4)')Y(iY), ETAdiscr(iY)
      END DO
c      write(18,*)' *************************'
c -----------------------------------------------------------------------
102   RETURN
      END
c ***********************************************************************


c =======================================================================
c     These are the subroutines for a full dynamical calculation of
c     radiatively driven winds.                              [MN, Mar'99]
c =======================================================================
C     Table of Contents
C
C     CALCETA
C     DYNAMICS
C     EMFUNC
C     GAMMAFUN
C     UFUN
C     VRATFUN
C     WINDS
c =======================================================================

c ***********************************************************************
      SUBROUTINE CalcETA(Y,qF,u,vrat,Eta,tauF,nY)
c =======================================================================
c Calculates the dimensionless density profile ETA(y) and tauF(y) when
c taking the drift into account                         [ZI & MN, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iY, nY
      DOUBLE PRECISION qF(npY), Y(npY), u(npY), Eta(npY), tauF(npY),
     &       F1(npY), F2(npY), vrat(npY), EtaINT, INT
c -----------------------------------------------------------------------
c     generate ETA and its integral (normalization constant)
      DO iY = 1, nY
        F1(iY) = vrat(iY)/u(iY)/Y(iY)/Y(iY)
      END DO
      CALL SIMPSON(npY,1,nY,Y,F1,EtaINT)
c     find tauF
      DO iY = 1, nY
        Eta(iY) = F1(iY)/EtaINT
        F2(iY) = qF(iY)*ETA(iY)
        CALL SIMPSON(npY,1,iY,Y,F2,INT)
        tauF(iY) = TAUfid*INT
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE DYNAMICS(nG,ETAzp,ftot)
c =======================================================================
c This subroutine finds the velocity structure of a radiatively driven
c wind.
c *** This version works for single size grains only ***
c                                                       [ZI & MN, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION ugas(npY), qF(npY), vrat(npG,npY), Gamma(npY),
     &       I1, I2, I3, CMdot, Cve, CM, Cr1
      COMMON /dyn/ ugas, qF, vrat, Gamma, I1, I2, I3, CMdot, Cve, CM,
     &       Cr1
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER nG, iL, iY, iconv, itr, ETAconv, uconv
      DOUBLE PRECISION ETAold(npY), u(npY), uold(npY), resaux,tauF(npY),
     &       Faux(npL), u1, eps, uacc, GammaMax, ETAzp(npP,npY),
     &       ftot(npL,npY),Sigaux
c -----------------------------------------------------------------------
c     Temporary local rescaling (to reconcile with Zeljko's f-lae which
c     were for <sigma>/<V>) [MN]
      Sigaux = SigExfid/aveV
      IF (iX.GE.1) THEN
         write(18,*)' Doing Dynamics'
      END IF
      IF(iVerb.EQ.2) write(*,*)' Doing Dynamics'
c     so far it works for nG=1 only:
      IF (nG.GT.1) THEN
        write(12,*)' **************************** '
        write(12,*)' Change dynamics sub to nG>1! '
        write(12,*)'       PROGRAM STOPPED        '
        write(12,*)' **************************** '
        stop
      END IF
c     accuracy for velocity convergence same as for Utot:
      uacc = accConv
c     find the flux averaged extinction efficiency, qF(y), and flux
c     averaged optical depth, tauF(y) (with old ETA, i.e. it can be
c     determined by using ETAzp, see below)
      DO iY = 1, nY
c       generate auxiliary function for lambda integration:
        DO iL = 1, nL
          Faux(iL) = (SigmaA(1,iL)+SigmaS(1,iL))*ftot(iL,iY)/lambda(iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,Faux,resaux)
c       qF scaled with Qext at lamfid
        qF(iY) = resaux / SigExfid
c       tauF
        IF (iY.EQ.1) THEN
          tauF(iY) = 0.0
        ELSE
          DO iL = 1, nL
           Faux(iL)=ETAzp(1,iY)*TAUtot(iL)*ftot(iL,iY)/lambda(iL)
          END DO
          CALL Simpson(npL,1,nL,lambda,Faux,resaux)
          tauF(iY) = resaux
        END IF
      END DO
c     assign input parameters to local variables
      GammaMax = ptr(1)
      IF (denstyp.EQ.5) THEN
        eps = pow
        u1 =  tauF(nY)*eps*(1.d0-0.5d0*GammaMax)/(1.d0-eps)
        ELSE
        u1 = pow
      END IF
c     Initial approximation for u(y)
      DO iY = 1, nY
        uold(iY) = u1 + tauF(iY)*(1.d0-0.5d0*GammaMax)
      END DO
c     Initial approximation for v/vd
      CALL vratFun(Sigaux,qF,uold,vrat,nY)
c     Initial approximation for Gamma
      CALL GammaFun(GammaMax,qF,uold,vrat,Y,Gamma,nY,I1,I2,I3)
      iconv = 0
      itr = 0
c     ITERATIONS until u and eta converge within uacc
      DO WHILE(iconv.NE.1)
        itr = itr + 1
c       Find the new value of u(y)
        IF (denstyp.EQ.5)
     &      u1 = tauF(nY)*eps*(1.d0-Gamma(nY))/(1.d0-eps)
        CALL uFun(u1,tauF,Gamma,u,nY)
c       Find the new ETAdiscr(y) and tauF(y)
        CALL CalcETA(Y,qF,u,vrat,ETAdiscr,tauF,nY)
c       generate new v/vd
        CALL vratFun(Sigaux,qF,u,vrat,nY)
c       generate new Gamma
        CALL GammaFun(GammaMax,qF,u,vrat,Y,Gamma,nY,I1,I2,I3)
c       check convergence of u and Eta
        IF (itr.GT.1) THEN
          CALL ChkConv(nY,uacc,uold,u,uconv)
          CALL ChkConv(nY,uacc,ETAold,ETAdiscr,ETAconv)
c         convergence required for both u(y) and ETA(y)
          iconv = ETAconv * uconv
        END IF
        IF (iconv.NE.1) THEN
          DO iY =1, nY
            uold(iY) = u(iY)
            ETAold(iY) = ETAdiscr(iY)
          END DO
          IF (itr.GE.100) iconv = 1
        ELSE
          DO iY = 1, nY
            ugas(iY) = u(iY)
          END DO
        END IF
      END DO
      IF (iX.GE.1)
     &  write(18,'(a35,i3)')' Number of iterations to converge:',itr
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      DOUBLE PRECISION FUNCTION EMfunc(lambda,Teff,xSiO)
c This is modeled after subroutine engelke by M. Marengo. Here are his
c original comments:
c     =================================================================
c     This subroutine computes a modified black body spectrum using an
c     "Engelke" function (see Engelke 1992, AJ 104, 1248):
c     Bnu = Bnu(Tb) with Tb = 0.738*Teff*(1+79450/(lambda*Teff))**0.182
c
c     Molecular SiO absorption is modelled from the alpha Tau spectrum
c     of Cohen et al. 1992, AJ 104,2030 with a 5th order polinomial,
c     and added to the modified bb.
c
c     M. Marengo - mmarengo@cfa.harvard.edu - Sep 1998
c     =================================================================
c
c
c This version makes use of the scaled quantities and Dusty's function
c Planck(x)                                                  [ZI, Feb 99]
c =======================================================================
      IMPLICIT none
      INTEGER j
      DOUBLE PRECISION lambda, Teff, xSiO, x, Planck, Teng, SiOc(6),
     &                 lambda1, lambda2, SiO8m, SiOf
c -----------------------------------------------------------------------
c  SiO fit data from Massimo:
c     Polinomial coeff for SiO absorption model (5th order),
c     wavelength interval in which to apply the absorption
c     and given absorption at 8 micron (to rescale for SiO)
      lambda1 =  7.8636d0
      lambda2 = 11.4280d0
      SiO8m = 1.0701447d0
      SiOc(1) = -300.43916d0
      SiOc(2) =  149.32134d0
      SiOc(3) =  -29.493280d0
      SiOc(4) =    2.9067144d0
      SiOc(5) =   -0.14304663d0
      SiOc(6) =    0.0028134070d0
c -----------------------------------------------------------------------
c     Engelke's effective temperature
      Teng = 0.738d0 * Teff * (1.d0 + 79450.d0/(lambda*Teff))**0.182d0
      x = 14400.d0 / lambda / Teng
      EMfunc = (Teng/Teff)**4 * Planck(x)
c     If lambda is in SiO region, compute and apply the SiO absorption
      IF ((lambda-lambda1)*(lambda-lambda2).LT.0) THEN
          SiOf = 0.d0
          DO j = 1, 6
             SiOf = SiOf + SiOc(j) * lambda**(1.0*j-1)
          END DO
          EMfunc = EMfunc / (1.0 + (SiOf-1)/(SiO8m-1)*xSiO*0.01)
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE  GammaFun(GammaMax,qF,u,vrat,Y,Gamma,nY,Int1,Int2,Int3)
c =======================================================================
c This subroutine finds the ratio of the gravitaional to the radiative
c force for the whole envelope Gamma^(-1). Note that this quantity is
c called Gamma in the code.                                  [MN, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER jY, nY
      DOUBLE PRECISION qF(npY), u(npY), vrat(npY), Gamma(npY), Y(npY),
     &       Int2, Int3, Faux1(npY), Faux2(npY), Faux3(npY), GammaMax,
     &       C, Int1
c -----------------------------------------------------------------------
c     generate integrals
      DO jY = 1, nY
        Faux1(jY) = 1.d0/u(jY)/Y(jY)/Y(jY)
        Faux2(jY) = vrat(jY)*Faux1(jY)
        Faux3(jY) = qF(jY)*Faux2(jY)
        CALL SIMPSON(npY,1,jY,Y,Faux1,Int1)
        CALL SIMPSON(npY,1,jY,Y,Faux2,Int2)
        CALL SIMPSON(npY,1,jY,Y,Faux3,Int3)
        IF (jY.GT.1) THEN
          Gamma(jY) = Int1 / Int3
          ELSE
          Gamma(jY) = 1.d0 / vrat(1) / qF(1)
        END IF
      END DO
c     find normalization constants
      CALL FindMax(npY,1,nY,Gamma,C)
      C = GammaMax / C
c     normalize Gamma
      DO jY = 1, nY
        Gamma(jY) = C * Gamma(jY)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE uFun(u1,tauF,Gamma,u,nY)
c =======================================================================
c Calculates the scaled gas velocity u(y) with given u1=u(1), tauF(y),
c and gravitational correction term Gamma^(-1) (named Gamma in the code).
c                                                            [MN, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY,iY
      DOUBLE PRECISION u(npY), Gamma(npY), tauF(npY), u1
c -----------------------------------------------------------------------
      DO iY = 1, nY
         u(iY) = u1 + tauF(iY) * (1.d0-Gamma(iY))
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE vratFun(Qfid,qF,u,vrat,nY)
c =======================================================================
c Calculates the drift correction v(y)/vd(y).                [MN, Aug'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, iY
      DOUBLE PRECISION Qfid, qF(npY), u(npY), vrat(npG,npY)
c -----------------------------------------------------------------------
      DO iY = 1, nY
         vrat(1,iY) = 1.0d0 / (1.0d0 + dsqrt(Qfid*qF(iY)/u(iY)))
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE WINDS(nG,EtaOK,ETAzp,ftot)
c =======================================================================
c This subroutine takes care of the interface between radiatively driven
c winds and radiative transfer.                              [ZI, Aug'95]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER nG, EtaOK, iY
      DOUBLE PRECISION ETAold(npY), ETAzp(npP,npY), ftot(npL,npY),
     &       accETA
c -----------------------------------------------------------------------
      DO iY = 1, nY
        ETAold(iY) = ETAdiscr(iY)
      END DO
c     find new ETA (ETAdiscr in density.inc) based on current flux ftot
      CALL DYNAMICS(nG,ETAzp,ftot)
c     check convergence (ptr(2) is specified in INPUT)
      accETA = ptr(2) * accuracy
      CALL ChkConv(nY,accETA,ETAold,ETAdiscr,EtaOK)
      IF (iX.GE.1) THEN
        write(18,*)'     Y         ETAold      ETAnew      ratio'
        DO iY = 1, nY
          accETA = ETAold(iY) / ETAdiscr(iY)
          write(18,'(1p,4e12.5)')Y(iY),ETAold(iY),ETAdiscr(iY),accETA
        END DO
        IF (EtaOK.EQ.1) THEN
          write(18,*)' Convergence on Eta achieved'
        ELSE
          write(18,*)' Convergence on Eta not achieved.'
          write(18,*)' Going to the next iteration.'
        END IF
      END IF
c     save Y to Yprev and nY to nYprev
      DO iY = 1, nY
         Yprev(iY) = Y(iY)
      END DO
      nYprev = nY
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c =========================================================================
c          Below are the subroutines for calculation in slab geometry
c                     arranged in alphabetical order
c =========================================================================
C     Table of Contents
C
C     SLBANALYT
C     SLBDIFF
C     EINT1
C     EINT2
C     EINT3
C     EINT4
C     EINT5
C     SLBACC
C     SLBGRAY
C     SLBINIT
C     SLBMAT
C     SLBMISC
C     SLBRADT
C     SLBSOLVE
C     SLBSTAR
C     SLBTAU
C     SLBTRACE
C     SLBY
c =========================================================================

c *************************************************************************
      SUBROUTINE SLBAnalyt(TAU,L1,L2,L3,L4,N,NN)
c =========================================================================
c     Finds the integrals of the moments of the first exponential function E1
c     Lk(Tau)=Int{t^(k-1) E1|t-Tau|}, k=1..4. The analytical expressions used
c     are obtained integrating Lk by parts.                     [MN,Nov'98]
c =========================================================================
      IMPLICIT NONE
      INTEGER i, j, N, NN
      DOUBLE PRECISION L1(NN,NN), L2(NN,NN), L3(NN,NN), L4(NN,NN), del,
     &          TAU(NN), arg, arg1, Eint2, Eint3, Eint4, Eint5, Lt1,
     &          Lt2, Lt3, Lt4, E2a1, E3a1, E4a1
c ----------------------------------------------------------------------
      DO i = 1, N
       DO j = 1, N
        L1(i,j) = 0.d0
        L2(i,j) = 0.d0
        L3(i,j) = 0.d0
        L4(i,j) = 0.d0
       END DO
      END DO
c     Calculate Lk(i)=Int_t^t1 {x**(k-1)E1|x-TAU(i)| dx}
      DO j = 1, N
        DO i = 1, N-1
          del = TAU(i+1)-TAU(i)
          arg1 = dabs(TAU(j)-TAU(i+1))
          arg = dabs(TAU(j)-TAU(i))

          E2a1 = Eint2(arg1)
          E3a1 = Eint3(arg1)
          E4a1 = Eint4(arg1)
          Lt1 = E2a1-Eint2(arg)
          Lt2 =-(E3a1-Eint3(arg))/del
          Lt3 = E2a1 + 2.d0/del/del*(E4a1-Eint4(arg))
          Lt4 =-3.d0/del*E3a1 -6.d0/del/del/del*
     *                     (Eint5(arg1)-Eint5(arg))
          IF(i.LT.j) THEN
             L1(i,j) = 0.5d0*Lt1
             L2(i,j) = 0.5d0*(Lt2 + E2a1)
             L3(i,j) = 0.5d0*(Lt3 - 2./del*E3a1)
             L4(i,j) = 0.5d0*(Lt4 + E2a1 + 6.d0/del/del*E4a1)
           ELSE
            L1(i,j) = -0.5d0*Lt1
            L2(i,j) = 0.5d0*(Lt2 - E2a1)
            L3(i,j) = 0.5d0*(-Lt3 - 2.d0/del*E3a1 )
            L4(i,j) = 0.5d0*(Lt4 - E2a1 - 6.d0/del/del*E4a1)
          END IF
        END DO
      END DO

      DO i =1 , N
        DO j = 1, N
          IF(L1(i,j).LT.1.d-20) L1(i,j) = 0.d0
          IF(L2(i,j).LT.1.d-20) L2(i,j) = 0.d0
          IF(L3(i,j).LT.1.d-20) L3(i,j) = 0.d0
          IF(L4(i,j).LT.1.d-20) L4(i,j) = 0.d0
        END DO
      END DO
c ---------------------------------------------------------------------
      RETURN
      END
c *********************************************************************


c *********************************************************************
      SUBROUTINE SLBdifF(flag,om,grid,mat1,nL,nY,mat2,fp,fm)
c =========================================================================
c     Integration of U(lam,t)*E2|Tau-t| to get the diffuse flux.
c     flag=1 is for scattered and flag=0 for emitted flux. [MN, Apr'98]
c =========================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iL, iY, j, nL, nY, flag
      DOUBLE PRECISION mat1(npL,npY), mat2(npL,npY), grid(npL,npY),
     &             om(npL,npY), fp(npL,npY), fm(npL,npY), TAU(npY),
     &             faux(npY), Efact, fave, SUM, Eint3
c --------------------------------------------------------------------
      DO iL = 1, nL
        DO iY = 1, nY
          TAU(iY) = grid(iL,iY)
          IF (flag.EQ.1) THEN
             faux(iY) = om(iL,iY)*mat1(iL,iY)
          ELSE
             faux(iY) = (1.d0-om(iL,iY))*mat1(iL,iY)
          END IF
        END DO

c       Find f(+) (in arg Tau>t)
        DO iY = 1, nY
          SUM = 0.d0
          DO j = 1, iY-1
           Efact = dabs(Eint3(TAU(iY)-TAU(j))-Eint3(TAU(iY)-TAU(j+1)))
           fave = 0.5d0*(faux(j)+faux(j+1))
           SUM = SUM + fave*Efact
          END DO
          fp(iL,iY) = 0.5d0*SUM
c       and f(-) (in arg Tau>t)
          SUM = 0.
          DO j = iY, nY-1
           Efact = dabs(Eint3(TAU(iY)-TAU(j))-Eint3(TAU(iY)-TAU(j+1)))
           fave = 0.5d0*(faux(j)+faux(j+1))
           SUM = SUM + fave*Efact
          END DO
          fm(iL,iY) = 0.5d0*SUM
        END DO

        DO iY = 1, nY
           mat2(iL,iY) = fp(iL,iY) - fm(iL,iY)
        END DO
c     End of loop over iL
      END DO
c --------------------------------------------------------------------
      RETURN
      END
c *********************************************************************


c **********************************************************************
      DOUBLE PRECISION FUNCTION Eint1(x)
c ======================================================================
c Needed for the slab geometry. It calculates the first exponential
c integral E1(x) by analytical f-la (13.13) from Abramovitz & Stegun(1994)
c                                                         [MN,Dec'97]
c ======================================================================
      IMPLICIT none
      INTEGER i
      DOUBLE PRECISION AC(4),BC(4), CC(6), x, aux, poly, denom
      DATA AC/8.5733287401,18.0590169730,8.6347608925,0.2677737343/
      DATA BC/9.5733223454,25.6329561486,21.0996530827,3.9584969228/
      DATA CC/-0.57721566,0.99999193,-0.24991055,0.05519968,-0.00976004,
     &        0.00107857/
c ----------------------------------------------------------------------
c  For x=1E-15, E1~30 (used below to limit the value at x=0);for x>1, E1<1e-8
c  Two approximations are used, for x>1 and x<1, respectively
      IF (x.GT.1.d0) THEN
         poly = 0.d0
         denom = 0.d0
         aux = 1.d0
         DO i = 1, 4
           poly = poly + AC(5-i)*aux
           denom = denom + BC(5-i)*aux
           aux = aux * x
         END DO
           poly = poly + aux
           denom = denom + aux
         Eint1 = poly/denom/x*dexp(-x)
      ELSE
         IF (x.LE.1.d-15) x=1.0d-15
         poly = 0.d0
         aux = 1.0d0
         DO i = 1, 6
           poly = poly + CC(i)*aux
           aux = aux * x
         END DO
         Eint1 = poly - dlog(x)
      END IF
c ----------------------------------------------------------------------
      RETURN
      END
c **********************************************************************

c **********************************************************************
      DOUBLE PRECISION FUNCTION Eint2(x)
c ======================================================================
c Needed for the slab geometry. It calculates the second exponential
c integral E2(x) by the recurrence f-la. (see Abramovitz & Stegun,1994)
c                                                         [MN,Dec'97]
c ======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, Eint1
c -------------------------------------------------------------------------
       IF(x.LT.0.d0) x=dabs(x)
       IF (x.LT.1.0D-15) THEN
         Eint2 = 1.0d0
        ELSE
         Eint2 = dexp(-x) - x*Eint1(x)
       END IF
c -------------------------------------------------------------------------
      RETURN
      END
c **********************************************************************

c **********************************************************************
      DOUBLE PRECISION FUNCTION Eint3(x)
c ======================================================================
c Needed for the slab geometry. It calculates the third exponential
c integral E3(x) by the recurrence f-la. (see Abramovitz & Stegun,1994)
c                                                        [MN,Dec'97]
c ======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, Eint1
c -------------------------------------------------------------------------
       IF(x.LT.0.d0) x=dabs(x)
       IF (x.LT.1.0D-15) THEN
         Eint3 = 0.5d0
        ELSE
         Eint3 = 0.5d0*((1.d0-x)*dexp(-x)+x*x*Eint1(x))
       END IF
c -------------------------------------------------------------------------
      RETURN
      END
c **********************************************************************


c **********************************************************************
      DOUBLE PRECISION FUNCTION Eint4(x)
c ======================================================================
c Needed for the slab geometry. It calculates the fourth exponential
c integral E4(x) by the recurrence f-la. (see Abramovitz & Stegun,1994)
c                                                         [MN,Jan'97]
c ======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, Eint3
c -------------------------------------------------------------------------
       IF(x.LT.0.d0) x=dabs(x)
       IF (x.LT.1.0D-15) THEN
         Eint4 = 1.0d0/3.0d0
        ELSE
         Eint4 = (dexp(-x)-x*Eint3(x))/3.0d00
       END IF
c -------------------------------------------------------------------------
      RETURN
      END
c **********************************************************************


c **********************************************************************
      DOUBLE PRECISION FUNCTION Eint5(x)
c ======================================================================
c Needed for the slab geometry. It calculates the fifth exponential
c integral E5(x) by the recurrence f-la. (see Abramovitz & Stegun,1994)
c                                                         [MN,Jan'97]
c ======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, Eint4
c -------------------------------------------------------------------------
        IF(x.LT.0.d0) x=dabs(x)
       IF (x.LT.1.0d-15) THEN
         Eint5 = 0.25d0
        ELSE
         Eint5 = 0.25d0*(dexp(-x)-x*Eint4(x))
       END IF
c -------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE SLBacc(flux,accuracy,devmax,FbolOK,error)
c =======================================================================
c This is SUB ChkFlux modified to be used for slab calculation.
c Checks the bolometric flux conservation at any point of the slab grid.
c In case of nonconservation inserts a number of points at certain
c places.                                             [MN,99; ZI'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER iYins(npY), k, kins, iY, flag, error, istop, FbolOK
      DOUBLE PRECISION Yins(npY), flux(npY), delTAUmax, devmax, ratio,
     &        accuracy, devfac, ff, ffold
c --------------------------------------------------------------------------
      error = 0
      kins = 0
      devmax = 0.d0
c     maximal delTAU is no more than 2 times the average value
      delTAUmax = 2.d0*TAUtot(1)/nY
c     find maximal relative deviation of fbol:
      DO iY = 2, nY
        ratio = (dabs(flux(iY))-dabs(fmed))/dabs(fmed)
        IF (dabs(ratio).GT.devmax) devmax = dabs(ratio)
      END DO
      ff = 0.d0
      istop = 0
      devfac = 0.1
c     search for places to improve the grid
      DO WHILE (istop.NE.1)
        DO iY = 2, nY
          ratio = (dabs(flux(iY))-dabs(fmed))/dabs(fmed)
          ffold = abs(flux(iY-1)/fmed-1.d0)
          ff = abs(flux(iY)/fmed-1.d0)
          flag = 0
c         if any of these criteria is satisfied insert a point:
          IF(ff.GT.accuracy) flag=1
c         1) if error is increasing too fast
          IF (abs(ff-ffold).GT.devfac*devmax) flag = 1
c         2) if delTAU is too large at the left edge:
          IF(TAUslb(1,iY).LT.5.) THEN
           IF ((TAUslb(1,iY)-TAUslb(1,iY-1)).GT.
     &                             delTAUmax) flag = 1
          END IF
          IF(flag.EQ.1.AND.devmax.GE.accuracy) THEN
            kins = kins + 1
            Yins(kins) = Y(iY-1)+0.5*(Y(iY)-Y(iY-1))
            iYins(kins) = iY-1
          END IF
        END DO
        IF (devmax.LT.accuracy.OR.devfac.LT.0.01d0) THEN
          istop = 1
        ELSE
          IF (kins.GT.0) istop = 1
        END IF
        devfac = devfac / 2.d0
      END DO

      IF (kins.EQ.0) THEN
         FbolOK = 1
        ELSE
c       Add all new points to Y(nY). This gives the new Y(nY+kins).
c       However, check if npY is large enough to insert all points:
        IF ((nY+kins).GT.npY) THEN
         IF (iX.GE.1) THEN
         write(18,*)' ****************     WARNING   ******************'
         write(18,*)'  The new Y grid can not accomodate more points!'
         write(18,'(a,i5)')'   Specified accuracy would require',nY+kins
         write(18,'(a,i5,a)')'   points, while npY =',npY,'.'
         write(18,*)'  For the required accuracy npY must be increased,'
         write(18,*)'  (see the manual S3.5 Numerical Accuracy).'
         write(18,*)' *************************************************'
         END IF
         kins = npY - nY
         iWARNING = iWARNING + 1
         error = 2
        END IF
        DO k = 1, kins
          CALL SHIFT(Y,npY,nY+k-1,Yins(k),iYins(k)+k-1)
        END DO
      END IF
c     new size of the Y grid
      nY = nY + kins
c --------------------------------------------------------------------------
      RETURN
      END
c *********************************************************************

c *********************************************************************
      SUBROUTINE SLBmisc(fbol,fmax,fmed,AveDev,RMS,nY)
c =======================================================================
c     Finds some additional quantities: fave-the average and fmed- the
c     median value of fbol in the slab, average and RMS deviations of
c     fbol from fmed.                                     [MN,Aug'98]
c =======================================================================
      IMPLICIT NONE
      INTEGER iY, nY, imid, iup, idn
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION fbol(npY), fsort(npY), fave, fmed, AveDev,
     &                 err, RMS, rnY, fmax, aux
c     Find the median of fbol values distribution
      DO iY = 1, nY
        aux = DMAX1(dabs(fbol(iY)), accFbol)
        fbol(iY) = aux
      END DO
      DO iY = 1, nY
        fsort(iY) = fbol(iY)
      END DO
      CALL sort(fsort,nY)
      IF (MOD(nY,2).NE.0) THEN
c       if nY odd:
        imid = (nY+1)/2
        fmed = fsort(imid)
      ELSE
c       if nY even:
        iup = nY/2 + 1
        idn = nY/2
        fmed = 0.5*(fsort(iup) + fsort(idn))
      END IF
c     In sub PrOut: if(fmed.LE.accFbol) fmed =0
      rnY = 1.0*nY
      fave = 0.
      fmax = 0.
c     find the max |fbol| (carried in slab.inc, needed in SLBacc)
      DO iY = 1, nY
        fave = fave + fbol(iY)
        aux = dabs(fbol(iY))
        IF(aux.GT.fmax) fmax = aux
      END DO
      fave = fave / rnY
c     AveDev is the average relative deviation from the median
      AveDev = 0.
      RMS = 0.0
      DO iY = 1, nY
        aux = dabs(fbol(iY))
c        err = dabs(fmed-aux) /fmax
        err = dabs(fmed-aux) /fmed
        AveDev = AveDev + err
        RMS = RMS + err*err
      END DO
      RMS = sqrt(RMS/rnY/(rnY-1.))
      AveDev = AveDev/rnY
c --------------------------------------------------------------------
      RETURN
      END
c ********************************************************************

c ********************************************************************
      SUBROUTINE SLBgray(model,nG,error)
c =======================================================================
c     Solves the gray slab problem. For single lambda calculation
c     comment the call to Spectral in main.for and the calls to FindErr
c     in Analysis.for                                      [MN, May'98]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER iY, nG
      INTEGER error, nLst, model
      character tt*58
      DOUBLE PRECISION mat0(npL,npY,npY), Em(npL,npY), Uold(npL,npY),
     &         fdsp(npL,npY),fdsm(npL,npY), fdep(npL,npY),fdem(npL,npY),
     &         fp(npY), fm(npY), fd(npY)
c --------------------------------------------------------------------------
      nLst = nL
      nL = 1
c     generate some temporary arrays
      DO iY = 1, nY
c       to prevent exp underflow:
        IF(TAUslb(1,iY).GE.50.) THEN
          Us(1,iY) = 0.
        ELSE
          Us(1,iY) = dexp(-TAUslb(1,iY))
        END IF
        fs(1,iY) = Us(1,iY)
        Em(1,iY) = 0.
        omega(1,iY) = 1.
      END DO
c     find radiative transfer matrices
      IF (iX.GE.1) write(18,*)' Calculating matrix, pure scatt, iL=1'
      CALL SLBMat(TAUslb,mat0)
c     solve for Utot
      CALL INVERT(nY,nL,mat0,Us,Em,omega,Utot,Uold,error)
c      find new Td
       DO iY = 1, nY
c       For a single lambda run:
        Td(1,iY) = Tsub(1)*dsqrt(dsqrt(Utot(1,iY)/Utot(1,1)))
       END DO
c      Find the diffuse scattered flux(fl=1 for scatt. and fl=0 is for emission)
       CALL SLBdifF(1,omega,TAUslb,Utot,nL,nY,fds,fdsp,fdsm)
c      Find the diffuse emitted flux
       CALL SLBdifF(0,omega,TAUslb,Utot,nL,nY,fde,fdep,fdem)
       CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
c      overall conservation of flux - min/max err
       DO iY = 1, nY
        fbol(iY) = fTot(1,iY)
        fsbol(iY) = fs(1,iY)
        fp(iY) = fdsp(1,iY)+fdep(1,iY)
        fm(iY) = fdsm(1,iY)+fdem(1,iY)
        fd(iY) = fp(iY)-fm(iY)
       END DO
c     FindErr calculates the err acc. to min/max values of fbol
      CALL FindErr(fbol,maxFerr,nY)
      CALL SLBmisc(fbol,fmax,fmed,AveDev,RMS,nY)
c --------------------------------------------------------------
c     The slab Tau-profile at the fiducious lambda (needed in PrOut)
      DO iY = 1, nY
        tr(iY) = TAUslb(1,iY)
      END DO
      IF(iInn.EQ.1) THEN
       write(18,*) '----- Single Lambda Case (iL=1) -----'
       write(18,'(a10,1p,E11.3)')'    tauT =', TAUslb(1,nY)
        write(18,'(a11,1p,E11.3)')'     fmed =',fmed
        write(18,'(a11,1p,E11.3)')'  RMS err =',RMS
        write(18,'(a11,1p,E11.3)')'  MAX err =',maxFerr

       tt = '     tr       fTot(i)      fs(i)      fd(i)     fp(i)   '
       write(18,'(a58,a30)') tt , '  fm(i)     Utot(i)      Td(i)'
       DO iY = 1, nY
        write(18,'(1p,8E11.3)') tr(iY), fbol(iY), fsbol(iY), fd(iY),
     &                          fp(iY), fm(iY), Utot(1,iY), Td(1,iY)
       END DO
      END IF
c     this is for running many models with single lambda case
      SmC(5,model) = maxFerr
      nL = nLst
c --------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SLBIniT(nG,alpha)
c =======================================================================
c This subroutine calculates the initial approximation for the temperature
c profile and alpha array. It is based on the analogous subroutine InitTemp
c for spherical shell written by ZI, Jul'96.                [MN, Dec'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER iL, iY, iG, nG, istop, iW
      DOUBLE PRECISION Sigext(npL), aux(npY), faux(npL), fstar(npY),
     &       Qfstar(npY), fstarQ(npY), QP(npY), QF(npY), oldalpha(npY),
     &       alpha(npG,npY), IntQF, xP, Planck, resaux, delta, FovrF1,
     &       TAU(npY)
c --------------------------------------------------------------------------
c     Lambda integral of fs=f_e*exp(-TAU) -> fstar
      CALL Bolom(fs,fstar)
c     loop over grains
      DO iG = 1, nG
c       first approximation for temperature
        DO iY = 1, nY
          Td(iG,iY) = Tsub(iG)
          alpha(iG,iY) = 1.0
        END DO
c       generate the extinction cross-section Sigext
        DO iL = 1, nL
          Sigext(iL) = SigmaA(iG,iL)+SigmaS(iG,iL)
        END DO
c       Lambda integral of Sigext*fs -> Qfstar in IE97
        DO iY = 1, nY
c         generate auxiliary function for lambda integration:
          DO iL = 1, nL
            faux(iL) = Sigext(iL) *fs(iL,iY)/lambda (iL)
          END DO
          CALL Simpson(npL,1,nL,lambda,faux,resaux)
          Qfstar(iY) = resaux
        END DO
c      The slab geom. needs initial approximation for F/F1; Psi is alpha(nG,1)
c      (The solution is not sensitive to this approximation, MN)
        IF(TAUmax.LT.500.) THEN
           FovrF1 = 1.0
         ELSE
           FovrF1 = 1. - 0.25*alpha(1,1)
        END IF
c       iterate until Td and Psi converge (i.e. until alpha does)
        istop = 0
        DO WHILE (istop.NE.1)
          istop = 1
          DO iY = 1, nY
c           generate auxiliary function for lambda integration:
            DO iL = 1, nL
              xP = 14400.d0 / Td(iG,iY) / lambda(iL)
              faux(iL) = Sigext(iL) * Planck(xP) / lambda (iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,faux,resaux)
c           Planck average of Sigext
            QP(iY) = resaux
c           calculate QF for slab (IV in the notes, the equivalent of eq.B5)
            QF(iY) = Qfstar(iY)/FovrF1+QP(iY)*(1.0-fstar(iY)/FovrF1)
c           Find the second term in III (in the notes)
            DO iL = 1, nL
              faux(iL) = fs(iL,iY)*(1-SigmaA(iG,iL)/QP(iY))/lambda(iL)
            END DO
            CALL Simpson(npL,1,nL,lambda,faux,resaux)
            fstarQ(iY) = resaux
c           store current alpha
            oldalpha(iY) = alpha(iG,iY)
          END DO
c         for each y calculate new alpha from III (the equivalent of eq.B7)
          DO iY = 1, nY
            TAU(iY) = TAUslb(iLfid,iY)
          END DO
          DO iY = 1, nY
            DO iW = iY, nY
              aux(iW) = FovrF1*QF(iY)
            END DO
            CALL Simpson(npY,iY,nY,TAU,aux,IntQF)
            alpha(iG,iY) = 3.*IntQF - fstarQ(iY)
            alpha(iG,iY) = oldalpha(iY)
c           calculate temperature
            Td(iG,iY) = Tsub(iG) * (alpha(iG,iY)/alpha(iG,1))**0.25d0
            delta = DABS((alpha(iG,iY)-oldalpha(iY))/alpha(iG,iY))
            IF (delta.GT.accConv) istop = 0
          END DO
c       end of iterations
        END DO
c     end of loop over grains (iG)
      END DO
c --------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c **********************************************************************
      SUBROUTINE SLBmat(TAUslb,mat0)
c ======================================================================
c This subroutine evaluates the radiative transfer matrix for slab geometry.
c TAUslb is the array of optical depths along the line of sight. [MN, Dec'97]
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iL, iY, i, j, k
      DOUBLE PRECISION TAUslb(npL,npY), TAUr(npY), mat0(npL,npY,npY),
     &         L1(npY,npY),L2(npY,npY),L3(npY,npY),L4(npY,npY),
     &         alpha(npY,npY), beta(npY,npY), gamma(npY,npY),
     &         delta(npY,npY), SUM
c -------------------------------------------------------------------------
      DO iL = 1, nL
       DO j = 1, nY
        DO k = 1, nY
          mat0(iL,j,k) = 0.0
        END DO
       END DO
      END DO
c     -- evaluate matrix elements --
c     loop over wavelengths
      DO iL = 1, nL
c      'Myspline' needs a 1D array
        DO iY = 1, nY
          TAUr(iY) = TAUslb(iL,iY)
        END DO
c       Get the spline coefficients of the source function
        CALL MYSPLINE(TAUr,nY,alpha,beta,gamma,delta)
        CALL SLBAnalyt(TAUr,L1,L2,L3,L4,nY,npY)
c       Matrix element for U:
        DO k = 1, nY
          DO j = 1, nY
            SUM = 0.
            DO i = 1, nY
             SUM = SUM + L1(i,k)*alpha(i,j)+L2(i,k)*beta(i,j)
     &                 + L3(i,k)*gamma(i,j)+L4(i,k)*delta(i,j)
            END DO
            mat0(iL,k,j) = SUM
          END DO
        END DO
c     end of loop over wavelengths
      END DO
c     save Y to Yok; needed for analysis in cases when requirement for
c     finer grids cannot be satisfied and previous solution is used for
c     output
      nYok = nY
      DO iY = 1, nY
        Yok(iY) = Y(iY)
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c ********************************************************************


c ********************************************************************
      SUBROUTINE SLBRadT(nG,error)
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER iY, nG, itnum, itlim
      INTEGER error, Conv, iter, Fconv, Uconv, BolConv, m14
      DOUBLE PRECISION mat0(npL,npY,npY), Em(npL,npY), alpha(npG,npY),
     &    fdsp(npL,npY),fdsm(npL,npY),fdep(npL,npY),fdem(npL,npY),dmaxU,
     &    fbolold(npY),Uold(npL,npY), dmaxF, olderr, oldmaxU
c --------------------------------------------------------------------------
      IF (iInn.eq.1) THEN
        write(38,'(a8,i5)') '    nY= ',nY
        write(38,*) '    iter   maxFerr     dmaxU       dmaxF'
      END IF
c     The slab Tau-profile at the fiducious lambda (needed in PrOut)
      DO iY = 1, nY
        tr(iY) = TAUslb(iLfid,iY)/TAUslb(iLfid,nY)
      END DO
c     generate stellar moments
      CALL SLBStar(error)
c     generate albedo through the envelope
      CALL getOmega(nG)
c     finish when file with the stellar spectrum is not available
      IF (error.EQ.3) goto 999
c     generate the first approximations for Td and alpha
      CALL SLBiniT(nG,alpha)
c     find radiative transfer matrices
      IF (iX.GE.1) write(18,*)' Calculating weight matrices'
      CALL SLBmat(TAUslb,mat0)
      IF (iX.GE.1) THEN
        write(18,*)' Weight matrices OK, calculating Tdust'
      END IF
      itlim = 9000
      itnum = 4
      Conv = 0
      iter = 0
      oldmaxU = 0.
      olderr = 0.
      m14 = 0
c     === Iterations over dust temperature =========
      DO WHILE (Conv.EQ.0.AND.iter.LE.itlim)
        iter = iter + 1
c       find emission term
        CALL Emission(0,nG,Td,alpha,abund,Us,Em)
c       solve for Utot
        CALL Invert(nY,nL,mat0,Us,Em,omega,Utot,Uold,error)
c       find new Td and alpha, and check convergence
        CALL FindTemp(0,Utot,nG,Td,alpha)
c       --------------------------------------
c       every itnum-th iteration check convergence:
c       first find 'old' flux (i.e. in the previous iteration)
        IF (MOD(iter+1,itnum).EQ.0) THEN
c         Find the diffuse scattered flux(fl=1 for scatt. and fl=0 is for emissi
          CALL SLBdifF(1,omega,TAUslb,Utot,nL,nY,fds,fdsp,fdsm)
c         Find the diffuse emitted flux
          CALL SLBdifF(0,omega,TAUslb,Em,nL,nY,fde,fdep,fdem)
          CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
c         find bolometric flux
          CALL Bolom(ftot,fbolold)
        END IF
        IF (MOD(iter,itnum).EQ.0) THEN
c         Find the diffuse scattered flux
          CALL SLBdifF(1,omega,TAUslb,Utot,nL,nY,fds,fdsp,fdsm)
c         Find the diffuse emitted flux
          CALL SLBdifF(0,omega,TAUslb,Em,nL,nY,fde,fdep,fdem)
c         Add them to the stellar flux to find total flux
          CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
c         find bolometric flux
          CALL Bolom(ftot,fbol)
c         check convergence of bolometric flux
          CALL Converg1(nY,accFbol,dynrange,fbolold,fbol,Fconv,dmaxF)
c         check convergence of energy density
          CALL Converg2(nY,nL,accConv,dynrange,Uold,Utot,Uconv,dmaxU)
c         FindErr calculates the err acc. to min/max values
          CALL FindErr(fbol,maxFerr,nY)
c         flag m14 is to prevent unnecessary looping if convergence
c         is extremely slow and err does not improve.
          IF(iter.GE.1000.AND.
     &           dabs(dmaxU-oldmaxU).LE.1.0d-5.AND.
     &             dabs(maxFerr-olderr).LE.1.0d-4) THEN
            m14 = 1
            Conv = 1
          END IF
          olderr = maxFerr
          oldmaxU = dmaxU
c ------  printout of errors and convergence with iter.(inner flag): ----
          IF(iInn.EQ.1) THEN
            write(38,'(i7,1p,3e12.4)') iter, maxFerr, dmaxU, dmaxF
          END IF
c ------------------------------------------------------------------------
          IF (maxFerr.LE.accuracy) THEN
            BolConv = 1
          ELSE
            BolConv = 0
          END IF
c         total criterion for convergence: Utot must converge, and ftot
c         must either converge or have the required accuracy
          IF (Uconv*(Fconv+BolConv).GT.0) Conv = 1
        END IF
      END DO
c     === The End of Iterations over Td ===
      IF (iX.GE.1) THEN
        IF (iter.le.itlim) THEN
          write(18,*)' Convergence achieved, number of'
          write(18,'(a34,i4)')
     &      ' iterations over energy density: ',iter
        ELSE
          write(18,'(a38,i5,a6)')
     &    '  No convergence on energy density in',iter,' iter.'
          iWARNING = iWARNING + 1
        END IF
        write(18,'(a25,1p,E9.2)')
     &    '  Max error in bol.flux:',maxFerr
      END IF
c     calculate the emission term for the converged Td
      CALL Emission(0,nG,Td,alpha,abund,Us,Em)
c     calculate flux
      CALL SLBdifF(1,omega,TAUslb,Utot,nL,nY,fds,fdsp,fdsm)
      CALL SLBdifF(0,omega,TAUslb,Em,nL,nY,fde,fdep,fdem)
      CALL Add(npY,nY,npL,nL,fs,fds,fde,ftot)
      CALL Add2(fdsp,fdep,fpbol,nY)
      CALL Add2(fdsm,fdem,fmbol,nY)
      CALL Bolom(ftot,fbol)
      CALL Bolom(fs,fsbol)
c     Find the err acc. to min/max values of fbol:
      CALL FindErr(fbol,maxFerr,nY)
c     find average value of fbol and some misceleneous quantities
      CALL SLBmisc(fbol,fmax,fmed,AveDev,RMS,nY)
c     calculate additional output quantities
      CALL Multiply(1,npY,nY,npL,nL,mat0,Utot,omega,0,Us,Uds)
      CALL Multiply(0,npY,nY,npL,nL,mat0,Em,omega,0,Us,Ude)
      CALL Add(npY,nY,npL,nL,Us,Uds,Ude,Uchck)
      CALL Bolom(Utot,Ubol)
      CALL Bolom(Uchck,UbolChck)
c     fmed is printed in .out file as f1 = fmed = F/Fe1
c ============ if the inner flag iInn=1:  =========
      IF(iX.GE.1 .AND. iInn.EQ.1) THEN
        write(18,'(a11,1p,E11.3)')'   TAUfid =',TAUfid
        write(18,'(a11,1p,E11.3)')'     fmed =',fmed
        write(18,'(a11,1p,E11.3)')'     fmax =',fmax
        write(18,'(a11,1p,E11.3)')'  MAX err =',maxFerr
        write(18,*)
     &'     tr      fbol       fsbol      fdbol       Ubol     fpbol'
        DO iY = 1, nY
         write(18,'(1p,6E11.3)') tr(iY), fbol(iY), fsbol(iY),
     &               (fpbol(iY)-fmbol(iY)),Ubol(iY),fpbol(iY)
        END DO
      END IF
c ===================================================
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE SLBsolve(model,nG,error)
c =======================================================================
c This subroutine solves the continuum radiative transfer problem in
c planar geometry.                                      [MN, Dec.'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER model, error, nG, iterFbol, FbolOK, grid
      DOUBLE PRECISION devmax, oldFerr, mu, h, k
c --------------------------------------------------------------------------
c     counter for iterations over bolometric flux conservation
      iterFbol = 0
      FbolOK = 0
      oldFerr = 100.
c     make the grid for the smaller mu
      IF (dabs(mu1).LE.dabs(mu2)) THEN
        mu = dabs(mu1)
      ELSE
        mu = dabs(mu2)
      END IF
      IF((mu.LT.0.1).AND.(TAUmax.GE.20.)) THEN
        grid = 1
c      oblique illumination grid (grid=1) with initial parameters
       IF(npY.LT.50) THEN
        iWARNING = iWARNING + 1
        error = 4
        RETURN
       ELSE
        nY = 50
       END IF
        h = 0.5
        k = 5.0
        CALL SLBtrace(TAUmax,TAUTot,TAUslb,Y,mu,h,k,nL,nY)
      ELSE
        grid = 0
c       generate the increment for the initial TAU-grid (grid=0)
        CALL SLBY(TAUmax,Y,nY)
      END IF
c ------------- Loop over bol.flux conservation -------------
      DO WHILE (FbolOK.EQ.0)
       iterFbol = iterFbol + 1
        IF((iterFbol.GE.4).AND.(grid.EQ.1).AND.(iX.GE.1)) THEN
          write(18,*)'  Can not improve the oblique'
          write(18,*)'  illumination grid anymore  '
          iWARNING = iWARNING + 1
          FbolOK = 2
          RETURN
        END IF
        IF (iX.GE.1) THEN
          write(18,*)'  ',iterFbol,' iteration over Fbol'
        END IF
        IF (iVerb.EQ.2) write(*,'(a14,i3,a20)')
     &     ' In SLBsolve: ',iterFbol,' iteration over Fbol'
c       if the illumination angle is too large choose the proper grid
        IF(grid.NE.1) THEN
          CALL SLBtau(TAUTot,TAUslb,Y,nL,nY)
        END IF
        IF (iX.GE.1) THEN
          write(18,'(a28,i3,a12)') '  Calculation for slab with ',
     &                          nY,' grid points'
        END IF
        IF (nY.GT.npY) THEN
         IF (iVerb.EQ.2) write(*,*)' npY needs to be increased!'
         IF (iX.GE.1) THEN
          write(18,*) ' ********** MESSAGE from SOLVE *********'
          write(18,*) ' npY has to be increased. Please, choose'
          write(18,*) ' parameters for slab in file userpar.inc'
          write(18,*) ' ***************************************'
          iWARNING = iWARNING + 1
          RETURN
         END IF
        END IF
c       solve the radiative transfer problem
        CALL SLBRadT(nG,error)
         IF (iVerb.EQ.2) write(*,*)'Done with SLBRadT'
c       for tests of single lambda case:
c       CALL SLBgray(model,nG,error)
        IF(maxFerr.LE.accuracy) THEN
          FbolOK = 1
        ELSE
         IF(grid.EQ.1) THEN
           IF(iterFbol.EQ.1) THEN
c            next try with 104pt grid:
             h = h/1.5
             k = k*1.5
             nY = 104
             CALL SLBtrace(TAUmax,TAUTot,TAUslb,Y,mu,h,k,nL,nY)
           END IF
           IF(iterFbol.EQ.2) THEN
c            last attempt with 160pt grid:
             h = 0.25
             k = 7.5
             nY = 160
             CALL SLBtrace(TAUmax,TAUTot,TAUslb,Y,mu,h,k,nL,nY)
           END IF
         ELSE
           CALL SLBacc(fbol,accuracy,devmax,FbolOK,error)
           IF(iterFbol.GT.1.AND.maxFerr.GT.oldFerr) THEN
            IF(iX.GE.1) THEN
             write(18,*)' ================ WARNING ================= '
             write(18,*)' Error is increasing in spite of grid'
             write(18,*)' improvement. Stopping iterations over Fbol.'
            END IF
            error = 0
            FbolOK = 2
            iWARNING = iWARNING + 1
           END IF
           oldFerr = maxFerr
         END IF
c         if the grid size limit is reached error=2
          IF (error.EQ.2.AND.iterFbol.EQ.1) THEN
c          if this is the first calculation end this model
           IF(iX.GE.1) THEN
            write(18,*)' =========== IMPORTANT WARNING =========== '
            write(18,*)' The limit for grid size is already reached'
            write(18,*)' and flux conservation can not be improved'
            write(18,'(a,1p,e9.2)')'  Max deviation of Fbol ',maxFerr
            write(18,*)' Treat all results with caution!'
           END IF
           error = 0
           FbolOK = 2
           iWARNING = iWARNING + 1
          END IF
c         if this is a higher iteration use previous solution
          IF (error.EQ.2) THEN
            IF (iX.GE.1.AND.iterFbol.GT.1) THEN
              write(18,*)' ======= IMPORTANT WARNING ======== '
              write(18,*)' In trying to conserve Fbol reached'
              write(18,*)' the limit for grid sizes.  '
              write(18,'(a,1p,e9.2)')'  Max deviation of Fbol:',maxFerr
              write(18,*)' Treat all results with caution!'
            END IF
            error = 0
            FbolOK = 2
            iWARNING = iWARNING + 1
          END IF
c         if Fbol not conserved try again with a finer grid
          IF (FbolOK.EQ.0 .AND. iX.GE.1) THEN
            write(18,*)'  ******** MESSAGE from SOLVE ********'
            write(18,'(a,1p,e9.2)')
     &                '  Max deviation of Fbol:', maxFerr
            write(18,*)'  Trying again with finer grids'
          END IF
c        if could not conserve Fbol in 10 trials give it up
         IF (FbolOK.EQ.0 .AND. iterFbol.GE.10) THEN
          IF (iX.GE.1) THEN
          write(18,*)' **********  WARNING from SOLVE  **********'
          write(18,*)' Could not obtain required accuracy in 10 trials.'
          write(18,'(a,1p,e9.2)')'  Max deviation of Fbol:',maxFerr
          write(18,*)' !!!!  Treat all results with caution  !!!!'
          write(18,*)' ******************************************'
          END IF
          iWARNING = iWARNING + 1
          FbolOK = 2
         END IF
        END IF
c     end of loop over flux conservation
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SLBStar(error)
c =======================================================================
c This subroutine generates the stellar moments in case of slab geometry.
c                                                          [MN, Feb.'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      CHARACTER*235 line
      INTEGER iY,iL,ios1,iLs,nLs, k,kstop,i,is, error,isn, Nlambdam
c     Nlambdam is the max number entries for a user supplied stellar spectrum
      PARAMETER (Nlambdam = 10000)
      DOUBLE PRECISION lambdaS(Nlambdam), Llamstar(Nlambdam), Lstar,
     &       Stellar(Nlambdam), llS(Nlambdam), lS(Nlambdam), fsrc(npL),
     &       fpl(npL), Bb(2), arg, EMfunc, a, b, x, Planck, BP,
     &       dyn2, UsL, UsR, Eint2, Eint3
c -----------------------------------------------------------------------
      IF(ksi.GT.0) THEN
        isn = 2
      ELSE
        isn = 1
      END IF
      dyn2 = dynrange*dynrange
      DO is = 1, isn
c      if startyp.GE.4 stellar spectrum is read from file 'nameStar'
       IF (startyp(is).GE.4.AND.startyp(is).LE.6) THEN
        open(3,ERR=998,file=nameStar(is),STATUS='OLD')
        rewind(3)
        read(3,'(a235)',ERR=998) line
        read(3,'(a235)',ERR=998) line
        read(3,'(a235)',ERR=998) line
        ios1 = 0
        iLs = 0
        DO WHILE (ios1.ge.0)
          read(3,*,END=900,ERR=998,iostat=ios1) a,b
          IF (ios1.ge.0) THEN
            iLs = iLs + 1
            lambdaS(iLs) = a
            IF (a.LE.0.0) goto 998
c           it is assumed that Llamstar is L_Lambda, but...
c           if startyp.EQ.3 then file gives lambda*L_lambda
            IF (startyp(is).EQ.4) Llamstar(iLs) = b / a
c           if startyp.EQ.4 then file gives L_lambda
            IF (startyp(is).EQ.5) Llamstar(iLs) = b
c           if startyp.EQ.5 then file gives Lnu=lambda**2*L_lambda
            IF (startyp(is).EQ.6) Llamstar(iLs) = b / a / a
           END IF
        END DO
900     close(3)
        IF (iLs.LT.2) goto 998
        nLs = iLs
c       if input wavelengths in descending order turn them around
        IF (lambdaS(1).GT.lambdaS(2)) THEN
          DO iLs = 1, nLs
            llS(iLs) = lambdaS(iLs)
            lS(iLs) = Llamstar(iLs)
          END DO
          DO iLs = 1, nLs
            lambdaS(iLs) = llS(nLs+1-iLs)
            Llamstar(iLs) = lS(nLs+1-iLs)
          END DO
        END IF
c       normalize stellar spectrum
        CALL Simpson(Nlambdam,1,nLs,lambdaS,Llamstar,Lstar)
c       generate dimensionless stellar spectrum
        DO iLs = 1, nLs
          Stellar(iLs) = lambdaS(iLs) * Llamstar(iLs) / Lstar
        END DO
       ELSE
c       if startyp.EQ.3 generate power-law spectrum
        IF (startyp(is).EQ.3) THEN
          fsrc(is) = 1.0
          IF (Nlamtr(is).GT.1) THEN
            DO i = 2, Nlamtr(is)
              fsrc(i) = fsrc(i-1)*
     &                        (lamtr(is,i-1)/lamtr(is,i))**klam(is,i-1)
            END DO
          END IF
          DO iL = 1, nL
            IF((lambda(iL)-lamtr(is,1))*(lambda(iL)-
     &                             lamtr(is,Nlamtr(is)+1)).LE.0.0) THEN
              kstop = 0
              k = 0
              DO WHILE (kstop.EQ.0)
                k = k + 1
                IF (lambda(iL).GE.lamtr(is,k)) THEN
                  kstop = 1
                  fpl(iL) = fsrc(k)*(lamtr(is,k)/lambda(iL))**klam(is,k)
                END IF
              END DO
            ELSE
              fpl(iL) = 0.0
            END IF
          END DO
        END IF
       END IF
       DO iY = 1, nY
c       loop over wavelengths
        DO iL = 1, nL
         IF (startyp(is).EQ.1) THEN
            Bb(is) = 0.0
            DO k = 1, nBB(is)
              x = 14400.d0 / lambda(iL) / Tbb(is,k)
              Bb(is) = Bb(is) + rellum(is,k)*Planck(x)
            END DO
         ELSE IF (startyp(is).EQ.2) THEN
            Bb(is) = EMfunc(lambda(iL),Tbb(1,1),xSiO)
         ELSE IF (startyp(is).EQ.3) THEN
            Bb(is) = fpl(iL)
         ELSE IF (lambda(iL).GT.lambdaS(nLs)) THEN
c           for lambda longer than the longest entry in nameStar
c           assume Rayleigh-Jeans tail
            Bb(is) = Stellar(nLs)*(lambdaS(nLs)/lambda(iL))**3.
         ELSE IF (lambda(iL).LT.lambdaS(1)) THEN
c           if shorter than the shortest assume 0
            Bb(is) = 0.0
         ELSE
c          from a file: if within limits interpolate
           CALL LinInter(Nlambdam,nLs,lambdaS,Stellar,lambda(iL),iLs,BP)
           Bb(is) = BP
         END IF
c   ----------  done with stellar spectrum ---------------
c        stellar part of flux and en.density
         IF (is.EQ.1) THEN
           IF((mu1+1.).LE.1.0d-5) THEN
             fsL(iL,iY) = Bb(1)*Eint3(TAUslb(iL,iY))
           ELSE
             x = TAUslb(iL,iY) / mu1
             IF(x.GE.50.) THEN
               fsL(iL,iY) = 0.
             ELSE
               fsL(iL,iY) = Bb(1)*exp(-x)
             END IF
           END IF
         END IF
         IF (is.EQ.2) THEN
           IF((mu2+1.).LE.1.0d-5) THEN
            arg = TAUslb(iL,nY)-TAUslb(iL,iY)
            fsR(iL,iY) = Bb(2)*Eint3(arg)
           ELSE
             x = (TAUslb(iL,nY)-TAUslb(iL,iY)) / mu2
             IF(x.GE.50.) THEN
                 fsR(iL,iY) = 0.
             ELSE
               fsR(iL,iY) = Bb(2)*exp(-x)
             END IF
           END IF
         END IF
        END DO
       END DO
c     end do over 'is' - the counter for sources
      END DO

      DO iY = 1, nY
c       loop over wavelengths
        DO iL = 1, nL
          fs(iL,iY) = fsL(iL,iY) - ksi * fsR(iL,iY)
c         find en.density if diffuse illumination on the left (mu1=-1)
          IF((mu1+1.).LE.1.0d-5) THEN
c           to prevent exp. underflow
            IF (TAUslb(iL,iY).GE.300.) THEN
             UsL = 0.
            ELSE
             UsL = fsL(iL,iY)/Eint3(TAUslb(iL,iY))*Eint2(TAUslb(iL,iY))
            END IF
          ELSE
            UsL = fsL(iL,iY)/mu1
          END IF
c         if diffuse illumination from the right
          IF((mu2+1.).LE.1.0d-5) THEN
            arg = TAUslb(iL,nY)-TAUslb(iL,iY)
c           to prevent exp. underflow
            IF (arg.GE.300.) THEN
             UsR = 0.
            ELSE
             UsR = fsR(iL,iY)/Eint3(arg)*Eint2(arg)
            END IF
          ELSE
            UsR = fsR(iL,iY)/mu2
          END IF
           Us(iL,iY) = UsL + ksi * UsR
c         here only Us needs limit from below; fs can be negative though!
          IF (Us(iL,iY).LT.dyn2) Us(iL,iY) = 0.0
        END DO
      END DO

c     normalize stellar quantities with the stellar bolometric flux
      CALL Bolom(fsL,fsbol)
c     fsbol(1) is always non-zero
      DO iY = 1, nY
        DO iL = 1, nL
           Us(iL,iY) = Us(iL,iY) / fsbol(1)
           fs(iL,iY) = fs(iL,iY) / fsbol(1)
           fsL(iL,iY) = fsL(iL,iY) / fsbol(1)
           fsR(iL,iY) = fsR(iL,iY) / fsbol(1)
        END DO
      END DO
      error = 0
      goto 999
998   write(12,*)' *** FATAL ERROR IN DUSTY! *************************'
      write(12,*)' File with the spectral shape of external radiation:'
      write(12,'(a2,a70)')'  ',nameStar(is)
      write(12,*)' is missing or not properly formatted?!'
      write(12,*)' ***************************************************'
      error = 3
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************

c **********************************************************************
      SUBROUTINE SLBTau(TauTot,TAUslb,delT,nL,nY)
c ======================================================================
c It generates TAUslb(npL,npY) grid with given spacing delT, calculated
c in sub SLBy. In the current version it is exp near the slab faces and
c equidistant in the middle.			             [MN,Sep'98]
c ======================================================================
      IMPLICIT none
      INTEGER nL, nY, iY, iL
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      DOUBLE PRECISION TAUslb(npL,npY),TauTot(npL),TAU(npY),delT(npY)
c ----------------------------------------------------------------------
       TAU(1) = 0.
       DO iY = 2, nY
         TAU(iY) = TAU(iY-1) + delT(iY)
       END DO
      DO iL = 1, nL
        DO iY = 1, nY
          TAUslb(iL,iY) = TauTot(iL)*TAU(iY)/TAU(nY)
        END DO
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE SLBtrace(TAUmax,TAUTot,TAUslb,Y,mu,h,k,nL,nY)
c ======================================================================
c     This subroutine generates the TAU-grid for slab in the case of
c     grazing angle of incidence.                            [MN,Jan'99]
c ======================================================================
      IMPLICIT NONE
      INTEGER nL, nY, iY, iL, Nthick, Nskin, iadj
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      DOUBLE PRECISION TAUslb(npL,npY), TAUTot(npL), TAU(npY), Y(npY),
     &              fsort(npY), TAUmax, mu, h, k, step
c ----------------------------------------------------------------------
c     Number of pts. in the skin layer with depth=min{mu1,mu2}:
      Nskin = k/h
c     Counter for the end of the layer adjacent to the skin layer
      iadj = 2*Nskin
c     Number of pts. in the opt.thick inner part:
      Nthick = nY - 4*Nskin
      iY = 1
      TAU(1) = 0.0
      TAU(nY) = 1.0
c     resolve the surface boundary layer, where tau = 0 .. k*mu
      DO WHILE(iY.LT.nY/2)
      iY = iY + 1
        IF((TAU(iY).LE.k*mu).AND.(iY.LE.Nskin)) THEN
          TAU(iY) = TAU(1) + (iY-1)*h*mu/TAUmax
          TAU(nY-iY+1) = TAU(nY) - TAU(iY)
        ELSE
c         resolve the adjacent layer
          IF(iY.LE.iadj) THEN
            TAU(iY) = TAU(iY-1) + h/TAUmax
            TAU(nY-iY+1) = TAU(nY) - TAU(iY)
          ELSE
c           for the opt.thick inner part:
            step = (TAU(nY-iadj+1)-TAU(iadj)) / (Nthick+1)
            TAU(iY) = TAU(iY-1) + step
            TAU(nY-iY+1) = TAU(nY) - TAU(iY)
          END IF
        END IF
      END DO
c     sorting (to avoid overlapping or mismatched pieces)
      DO iY = 1, nY
        fsort(iY) = TAU(iY)
      END DO
      CALL sort(fsort,nY)
      DO iY = 1, nY
        TAU(iY) = fsort(iY)
        Y(iY) = TAU(iY)
      END DO
      DO iL = 1, nL
        DO iY = 1, nY
          TAUslb(iL,iY) = TAUTot(iL)*TAU(iY)
        END DO
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SLBy(TAUmax,dTAU,nY)
c =======================================================================
c     This subroutine generates the increment for the initial TAU-grid.
c     It is equidistant in TAU in the middle and equidistant in log(TAU)
c     near the two faces. It has 15 pts for small (tauV.LE.1) and 30pts
c     for large total opt.depth (tauV.LE.1000). In some cases of tauV.GE.500.
c     80pts grid is better to start with. If this is the case, comment
c     the larger value of lim and uncomment lim=500, which will switch to
c     80pt grid. Be sure you have selected the line for slab calculation
c     in 'userpar.inc'.                                      [MN,Sep'98]
c =======================================================================
      IMPLICIT NONE
      INTEGER nY, iY
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      DOUBLE PRECISION dTAU(npY), TAUmax
c ----------------------------------------------------------------------
      IF(TAUmax.LE.10.) THEN
          nY = 15
          DO iY = 1, nY
           IF(iY.LE.5) THEN
             dTAU(iY) = 0.5*(exp(0.5*iY)-exp(0.5))
           ELSE IF(iY.GT.5.and.iY.LE.12) THEN
             dTAU(iY) = dTAU(iY-1)
           ELSE
             dTAU(iY) = dTAU(2+nY-iY)
           END IF
          END DO
      ELSE
       IF(TAUmax.LE.10000.) THEN
         nY = 30
         DO iY = 1, nY
           IF(iY.LE.10) THEN
             dTAU(iY) = 0.5*(exp(0.5*iY)-exp(0.5))
            ELSE IF(iY.GT.10.and.iY.LE.22) THEN
             dTAU(iY) = dTAU(iY-1)
            ELSE
             dTAU(iY) = dTAU(2+nY-iY)
           END IF
        END DO
       ELSE
        nY = 80
        DO iY = 1, nY
          IF(iY.LE.11) THEN
             dTAU(iY) = 0.5*(exp(0.5*iY)-exp(0.5))
          ELSE IF(iY.GT.11.and.iY.LE.71) THEN
             dTAU(iY) = dTAU(iY-1)
          ELSE
             dTAU(iY) = dTAU(2+nY-iY)
          END IF
        END DO
       END IF
      END IF
c ----------------------------------------------------------------------
      RETURN
      END
c *********************************************************************

c =========================================================================
c     This is are the subroutines analyzing the results of the radiative
c     transfer calculation.                                   [MN, Mar'99]
c =========================================================================
C     Table of Contents
C
C     ANALYSIS
C     ASSPROP
C     BOLOM
C     CHKBOLOM
C     CHKCONV
C     CHKFLUX
C     CONVERG1
C     CONVERG2
C     CONVOLVE
C     CONV2D
C     ETA
C     ETAFUN
C     FINDINT
C     GETBOUT
C     GETOMEGA
C     GETOPTPR
C     GETPROP
C     GETSIZES
C     GETTAU
C     GETETAZP
C     IMAGFN
C     MIE
C     PSFN
C     SETUPETA
C     SIZEDIST
C     SPECTRAL
C     SPFEATUR
C     PHILAM
C     VISIBILI
C     VISI2D
c =======================================================================

c ***********************************************************************
      SUBROUTINE ANALYSIS(model,ETAzp,error)
c =======================================================================
c This subroutine analyzes the solution. It finds the flux conservation
c accuracy and evaluates many output quantites like QF(y), TAUF(y),Psi, F1,
c the rad.pressure force, dynamical quantities etc.
c                                                   [ZI,Mar'96;MN,Mar'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      integer nfit
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nfit= 4)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUslb(npL,npY),fsbol(npY),fpbol(npY),fmbol(npY),
     &                 AveDev, RMS, maxFerr, fmax, fmed
      COMMON /slab/ TAUslb, fsbol, fpbol, fmbol, AveDev, RMS, maxFerr,
     &                 fmax, fmed
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      DOUBLE PRECISION ugas(npY), qF(npY), vrat(npG,npY), Gamma(npY),
     &       I1, I2, I3, CMdot, Cve, CM, Cr1
      COMMON /dyn/ ugas, qF, vrat, Gamma, I1, I2, I3, CMdot, Cve, CM,
     &       Cr1
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iL, iY, model, iP, error
      DOUBLE PRECISION ETAzp(npP,npY), QpTd(npG,npY), QpStar(npY), Psi,
     &        qaux(npL), qaux2(npL), resaux, xP, Planck, QUtot1, r_gd,
     &        Eps1, aux, deltauF, C1,C2,C3, ugas_out, s4,Pi,mx
      double precision qaux3(npL), dumm
c     MG 30.09.09
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      double precision theta2
      common /psf3/ theta2
c -----------------------------------------------------------------------
c     MG 14.07.09
      double precision a(nfit),av,teff,dist,Rst,rinner
      double precision pp(nfit), Router(nfit), scl(nfit)
      integer idum(nfit), npow
      common/needed/rinner,router,pp,scl,av,teff,dist,npow
      common/params/a,idum
      write(80,*) 'ANALYSIS ia= ',  a,idum, theta1
c -----------------------------------------------------------------------
      Pi = 2.0*ASIN(1.0)
      r_gd = 200.0
c     make sure that grids correspond to accepted solution
      nY = nYok
      DO iY = 1, nY
        Y(iY) = Yok(iY)
      END DO
      nP = nPok
      DO iP = 1, nP
        P(iP) = Pok(iP)
      END DO
c -------------
c     spectrum (flux at the outer edge as a function of wavelength)
      DO iL = 1, nL
        Spectrum(iL) = dabs(ftot(iL,nY))
c       added in version dusty16.for - to prevent taking log from zero
c       in Spectral [MN]:
        IF (Spectrum(iL).LE.1.0D-20) Spectrum(iL) = 1.0D-20
      END DO
c -------------
c     analyze bolometric flux error (1/2 of the max spread of fbol)
      CALL FindErr(fbol,maxFerr,nY)
c -------------
c     find the flux averaged optical depth, tauF(y)
      IF (denstyp.NE.0) THEN
c      for spherical shell
       tauF(1) = 0.0
       DO iY = 2, nY
c        generate auxiliary function for integration:
c        loop over iL (wavelength)
         DO iL = 1, nL
          qaux(iL)=TAUtot(iL)*ETAzp(1,iY)*dabs(ftot(iL,iY))/lambda(iL)
         END DO
         CALL Simpson(npL,1,nL,lambda,qaux,resaux)
         aux = resaux / ETAzp(1,iY)
         deltauF = aux * (ETAzp(1,iY) - ETAzp(1,iY-1))
         tauF(iY) = tauF(iY-1) + deltauF
       END DO
      ELSE
c      for slab
       tauF(1) = 0.0
       DO iY = 1, nY
c        generate auxiliary function for integration:
c        loop over iL (wavelength)
         DO iL = 1, nL
           qaux(iL)=TAUslb(iL,iY)*dabs(fTot(iL,iY))/lambda(iL)
           CALL Simpson(npL,1,nL,lambda,qaux,resaux)
           tauF(iY) = resaux
         END DO
       END DO
      END IF
c -------------
c     ratio of gravitational to radiation pressure force (isotropic
c     scattering) per unit volume
c     s4 = (L4sol/Msol)/(4*Pi*G*c*rho_s)/1e-6;
c     rho_s=3000 kg.m-3, grain radius 'a' is in microns, aveV=4/3*Pi*<a^3>
      IF(denstyp.NE.0) THEN
      s4 = 1.925 / (4.0*Pi*6.67d-11*3.0d08*3000.0*1.0D-06)
c      in case of sigma's from a file aveV=1 (initialized in GetOptPr)
       DO iY = 1, nY
        DO iL = 1, nL
          qaux(iL)=(SigmaA(1,iL)+SigmaS(1,iL))/aveV *
     &                             dabs(ftot(iL,iY))/lambda(iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,qaux,resaux)
        rg(1,iY) = s4 * resaux / r_gd
c       If dust drift (dynamics case):
        IF (RDW) rg(1,iY) = rg(1,iY)*vrat(1,iY)
       END DO
      END IF
c -------------
c     find the Planck averaged absorption efficiencies
      DO iY = 1, nY
c     generate auxiliary function for integration over wavelengths:
       DO iL = 1, nL
         qaux(iL) = SigmaA(1,iL) * Us(iL,iY) / lambda(iL)

         qaux3(iL) = (SigmaA(1,iL)+SigmaS(1,iL)) *Us(iL,iY)/ lambda(iL)
         xP = 14400.d0 / Tstar / lambda(iL)
         qaux3(iL) = (SigmaA(1,iL)+SigmaS(1,iL)) *Planck(xP)/ lambda(iL)

         xP = 14400.d0 / Td(1,iY) / lambda(iL)
         qaux2(iL) = SigmaA(1,iL) * Planck(xP) / lambda (iL)
       END DO
       CALL Simpson(npL,1,nL,lambda,qaux,resaux)
       QpStar(iY) = resaux
       CALL Simpson(npL,1,nL,lambda,qaux3,resaux)
       if (iY.eq.1) dumm = resaux
       CALL Simpson(npL,1,nL,lambda,qaux2,resaux)
       QpTd(1,iY) = resaux
      END DO
c ----------
c     find parameter Psi (see Ivezic & Elitzur, 1996)
c     generate auxiliary function for integration:
c     loop over iL (wavelength)
      DO iL = 1, nL
        qaux(iL) = SigmaA(1,iL) * Utot(iL,1) / lambda (iL)
      END DO
      CALL Simpson(npL,1,nL,lambda,qaux,resaux)
      QUtot1 = resaux
      Psi = QUtot1 / QpTd(1,1)
c -------------
      IF(denstyp.NE.0) THEN
c      ratio r1/r* (see Ivezic & Elitzur, 1996, eq. 27)
       r1rs= 0.5d0 * dsqrt(Psi) * (Tstar / Tsub(1))**2.0
       rinner= r1rs

c     MG 14.07.09   estimate ANGULAR DIAMETER inner dust radius in arcsec
c     THETA1 should represent 'luminosity' as given via makedusty
        Rst= sqrt( THETA1 / (Teff/5770.d0)**4)
        if (r1rs .ne. 0)  then
           dumm= Theta1
           theta1= 2.d0* r1rs*Rst* 6.96d5 / (dist *3.0921d16) *206265.d0
c        write(*,*)'update ang. diam',theta1,r1rs,rst,Psi,Tstar,Tsub(1)
        write(80,*)'upda ang.d',theta1,r1rs,rst,Psi,Tstar,Tsub(1),dumm
        endif

      END IF
c -------------
c     Find epsilon - the relative contribution of the diffuse radiation
      DO iY = 1, nY
       aux = QpStar(iY)/QpTd(1,iY)/Psi*(Tsub(1)/Td(1,iY))**4.
       IF (denstyp.NE.0) aux = aux/ Y(iY)/Y(iY)
       Eps(iY) = 1.d0 - aux
      END DO
      Eps1 = 1.0 - QpStar(1) / QUtot1
c     store these parameters in the storage array
      SmC(1,model) = Psi
      SmC(2,model) = Eps1
      SmC(3,model) = QpStar(1)
      SmC(4,model) = QpTd(1,1)
      SmC(5,model) = maxFerr
c      write(66,*)QpStar(1),QpTd(1,1),QpStar(1)/QpTd(1,1),dumm, Td(1,1)
c      write(66,*) Tstar
c -------------
c     additional output quantities
c     bolometric flux at r1 (in W/m2)
c     The constant is 4*Sigma*T^4 (2.27E5 = 4*5.67E-08*(1000**4))
      F1 = 2.27d5 / Psi * (Tsub(1)/1000.d0)**4.0
c     inner radius (in cm)
      Cr1 = 5.53d16 / dsqrt(F1)
      IF (denstyp.NE.0) THEN
c      angular diameter of inner cavity if Fbol=1E-6 W/m2
       theta2= 412.6d0 / dsqrt(F1)
c      check if the pt.source assumption is still obeyed
c      (only for BB-type spectrum including EM-function)
       IF(startyp(1).eq.1.OR.startyp(1).eq.2) THEN
         mx = sqrt(sqrt(F1/5.67d-08))
         Te_min = 2.d0 * DMAX1(Tsub(1), mx)
       END IF
      END IF
      IF (denstyp.EQ.0) THEN
c       Teff for the left illuminating source in slab geometry
c       Teff = (F1/sigma)^0.25
        SmC(7,model) = sqrt(sqrt(F1/5.67d-08))
        IF (ksi.GT.0.) THEN
c       Teff for the right illuminating source in slab geometry
           SmC(8,model) = SmC(7,model)*sqrt(sqrt(ksi))
        ELSE
           SmC(8,model) = 0.
        END IF
      END IF
c     calculate conversion constants for dynamics
      IF (denstyp.eq.4.OR.RDW) THEN
        IF (denstyp.EQ.4) THEN
          I1 = 2.d0 * (1.d0-pow)/(1.d0+pow)/tauF(nY)
          I2 = I1
          I3 = I1 * tauF(nY) / TAUfid
          Gamma(nY) = 0.5d0
        END IF
c       terminal expansion velocity, full formula:
        ugas_out = tauF(nY) * (1.-Gamma(nY)) / (1.-pow)
c       The coefficients come from the units conversion
        C1 = 0.2845d0*TAUfid*sqrt(Psi)/I2/(SigExfid/aveV)*
     &                                        1.0D06/Tsub(1)/Tsub(1)
        C2 = 2.040d0*ugas_out
        C3 = 6.628d0*I3*SigExfid/aveV*Gamma(nY)/I1
c       from version 2.0 stellar mass is defined as the maximal stellar
c       mass which does not quench the wind; the calculation is done
c       with half that mass since any smaller mass will have no effect
c       on the radial velocity and density profile (see IE '99)
c       n.b. Gamma(nY) is removed
        C3 = 6.628d0*I3*SigExfid/aveV/I1
c       new definitions for output
c       mass-loss rate in Msol/yr
        CMdot = 1.0d-05 * sqrt(C1)
c       terminal expansion velocity in km/s
        Cve = 10.d0* C2 / sqrt(C1)
c       stellar mass
        CM = C3
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE AssProp(NN,nin,kin,nout,kout)
c =======================================================================
c This subroutine copies arrays nin and kin to nout and kout,
c respectively.                                        [Z.I., Nov. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER NN, i
      DOUBLE PRECISION nin(NN), kin(NN), nout(NN), kout(NN)
c -----------------------------------------------------------------------
      DO i = 1, NN
        nout(i) = nin(i)
        kout(i) = kin(i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE BOLOM(q,qBol)
c =======================================================================
c This subroutine integrates given radiation field, q (function of
c wavelength and radial coordinate), over wavelength. q is a matrix
c of physical size (npL,npY) [coming from paramet.inc] and real size
c (nL,nY) [coming from grids.inc], and qBol is an array of physical size
c (npY) and real size nY.                              [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iL, iY
      DOUBLE PRECISION q(npL,npY), qaux(npL), qBol(npY), resaux
c -----------------------------------------------------------------------
c    loop over iY (radial coordinate)
      DO iY = 1, nY
c       generate auxiliary function for integration
c       loop over iL (wavelength)
        DO iL = 1, nL
          qaux(iL) = q(iL,iY) / lambda (iL)
        END DO
        CALL Simpson(npL,1,nL,lambda,qaux,resaux)
        qBol(iY) = resaux
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE ChkBolom(qbol,accur,dev,FbolOK)
c =======================================================================
c This subroutine checks if any element of qbol(i), i=1,nY differs for
c more than accuracy from 1.0. If so FbolOK = 0, otherwise FbolOK = 1.
c dev is maximal deviation from 1.0.                   [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iY, FbolOK
      DOUBLE PRECISION qBol(npY), accur, dev
c -----------------------------------------------------------------------
      FbolOK = 1
      dev = 0.0
c     loop over iY (radial coordinate)
      DO iY = 1, nY
        IF (abs(1.0-qBol(iY)).GT.accur) FbolOK = 0
        IF (abs(1.0-qBol(iY)).GT.dev) dev = abs(1.0-qBol(iY))
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE ChkConv(nY,accuracy,Aold,Anew,Aconv)
c =======================================================================
c This subroutine checks convergence of an array A(nY) between values
c given in Aold and Anew. If the relative difference for EVERY element
c is smaller than accuracy, Aconv is assigned 1, otherwise 0.
c                                                      [Z.I., Jul. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, iY, Aconv
      DOUBLE PRECISION accuracy, Aold(npY), Anew(npY), delta
c -----------------------------------------------------------------------
      Aconv = 1
c     loop over radial positions
      DO iY = 1, nY
c       find relative difference
        delta = dabs(Anew(iY)-Aold(iY))
        IF (delta.GT.dabs(Anew(iY))*accuracy) Aconv = 0
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE ChkFlux(flux,tolern,consfl,error,ETAzp)
c =======================================================================
c Checks the bolometric flux conservation at any point of a given Ygrid.
c In case of nonconservation increases the number of points at certain
c places. The current criterion is increasing the flux difference from
c tolern to its maximum value.                         [MN & ZI,July'96]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER iYins(npY), k, kins, iY, consfl, flag, error, istop, iDm
      DOUBLE PRECISION Yins(npY),flux(npY), tolern, ff, Yloc,
     &       delTAUMax, devfac, devmax, ffold, EtaTemp(npY),ee,
     &       ETA, ETAzp(npP,npY)
c -----------------------------------------------------------------------
c     save old grid and values of Eta (important for denstyp = 5 or 6)
      IF (RDW) THEN
        DO iY = 1, nY
          Yprev(iY) = Y(iY)
          EtaTemp(iY) = ETAdiscr(iY)
        END DO
        nYprev = nY
      END IF
      error = 0
      kins = 0
      devmax = 0.0
c     maximal delTAU is no more than 2 times the average value
      delTAUmax = 2.0*TAUtot(1)*ETAzp(1,nY)/nY
c     maximal deviation from 1.0
      DO iY = 2, nY
        IF (abs(flux(iY)-1.0).GT.devmax) devmax = abs(flux(iY)-1.0)
      END DO
      ff = 0.0
      istop = 0
      devfac = 0.1
c     search for places to improve the grid
      DO WHILE (istop.NE.1)
        DO iY = 2, nY
          ffold = ff
          ff = abs(flux(iY)-1.0)
          flag = 0
c         if any of these criteria is satisfied insert a point:
c         1) if error is increasing too fast
          IF (abs(ff-ffold).GT.devfac*devmax) flag = 1
c         2) if delTAU is too large
          IF (TAUtot(1)*(ETAzp(1,iY)-ETAzp(1,iY-1)).GT.
     &                             delTAUmax) flag = 1
          IF(flag.EQ.1.AND.devmax.GE.tolern) THEN
            kins = kins + 1
            Yins(kins) = Y(iY-1)+0.5*(Y(iY)-Y(iY-1))
            iYins(kins) = iY-1
          END IF
        END DO
        IF (devmax.LT.tolern.OR.devfac.LT.0.01) THEN
          istop = 1
          ELSE
          IF (kins.GT.0) istop = 1
        END IF
        devfac = devfac / 2.0
      END DO
      IF (kins.EQ.0) THEN
        IF (consfl.NE.5) consfl = 1
        ELSE
c       Add all new points to Y(nY). This gives the new Y(nY+kins).
c       However, check if npY is large enough to insert all points:
        IF ((nY+kins).GT.npY) THEN
c        consfl.EQ.5 is a signal that Chkflux was called from SetGrids,
c        in this case continue without inserting new points. If this is
c        full problem then give it up.
         IF (consfl.NE.5) THEN
           consfl = 1
           ELSE
           consfl = 7
           goto 777
         END IF
         IF (iX.GE.1) THEN
         write(18,*)' ****************     WARNING   ******************'
         write(18,*)'  The new Y grid can not accomodate more points!'
         write(18,'(a,i3)')'   Specified accuracy would require',nY+kins
         write(18,'(a,i3,a)')'   points, while npY =',npY,'.'
         write(18,*)'  For the required accuracy npY must be increased,'
         write(18,*)'  (see the manual S3.5 Numerical Accuracy).'
         write(18,*)' *************************************************'
         END IF
         kins = npY - nY
         iWARNING = iWARNING + 1
         error = 2
        END IF
        DO k = 1, kins
          CALL SHIFT(Y,npY,nY+k-1,Yins(k),iYins(k)+k-1)
        END DO
      END IF
c     new size of the Y grid
      nY = nY + kins
c     intepolate ETAdiscr to new Y grid for denstyp = 5 or 6
      DO iY = 1, nY
        Yloc = Y(iY)
        IF (iterETA.GT.1) THEN
          CALL LinInter(npY,nYprev,Yprev,EtaTemp,Yloc,iDm,ee)
          ETAdiscr(iY) = ee
          ELSE
          ETAdiscr(iY) = ETA(Yloc)
        END IF
      END DO
c -----------------------------------------------------------------------
777   RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Converg1(nY,accuracy,dynrange,Aold,Anew,Aconv,dmax)
c =======================================================================
c This subroutine checks convergence of an array A(nL,nY) between values
c given in Aold and Anew, when the values are larger than dynrange. If
c the maximum relative difference is smaller than the required accuracy,
c Aconv is assigned 1, otherwise 0.              [Z.I.Jul 96;M.N.Apr.97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, iY, Aconv
      DOUBLE PRECISION accuracy, dynrange, Aold(npY), Anew(npY), delta,
     &       dmax
c -----------------------------------------------------------------------
      Aconv = 1
      dmax = 0.0
c     loop over radial positions
      DO iY = 1, nY
c       do it only for elements larger than dynrange
        IF (Anew(iY).GE.dynrange) THEN
c           find relative difference
            delta = dabs((Anew(iY)-Aold(iY))/Anew(iY))
            IF (delta.GT.dmax) dmax = delta
        END IF
      END DO
      IF (dmax.GT.accuracy) Aconv = 0
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE Converg2(nY,nL,accuracy,dynrange,Aold,Anew,Aconv,dmax)
c =======================================================================
c This subroutine checks convergence of an array A(nL,nY) between values
c given in Aold and Anew, when the values are larger than dynrange. If
c the maximum relative difference is smaller than required accuracy,
c Aconv is assigned 1, otherwise 0.             [Z.I.Jul 96; M.N.Apr.97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nL, iY, iL, Aconv
      DOUBLE PRECISION accuracy, dynrange, Aold(npL,npY), Anew(npL,npY),
     &       delta, dmax
c -----------------------------------------------------------------------
      Aconv = 1
      dmax = 0.0
c     loop over wavelengths
      DO iL = 1, nL
c       loop over radial positions
        DO iY = 1, nY
c         do it only for elements larger than dynrange
          IF (Anew(iL,iY).GE.dynrange) THEN
c           find relative difference
            delta = dabs((Anew(iL,iY)-Aold(iL,iY))/Anew(iL,iY))
            IF (delta.GT.dmax) dmax = delta
          END IF
        END DO
      END DO
      IF (dmax.GT.accuracy) Aconv = 0
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Convolve(IntOut)
c =======================================================================
c This subroutine convolves intensity IntOut with the point spread
c function to produce convolved images ConvInt. The work horse is
c subroutine Conv2D, and this subroutine is used to prepare everything.
c                                                      [Z.I., Jan. 1997]
c =======================================================================
c   MG Aug 09: bigger grid, to better resolve Bessell-fie for convolution
c =======================================================================

      IMPLICIT none
      INTEGER npY, npP, npL, npG, nin
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, nin=600)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      INTEGER i, j
      DOUBLE PRECISION IntOut(20,npP+2), yang(npP+2), Youtang, deltaOff,
     &      Int1D(npP+2), ConvS, Conv(1000+2), FWHM1max, FWHM2max, PSFN
      double precision fwhm1min
      double precision waveint(nin), fwhmint(nin), yint(nin), zint(nin)
      double precision pxl(nin),D1(nin)
      integer intsep(nin), nns
      real pltintm(nin)

      common/intensity/waveint,fwhmint,intsep,yint,zint,pxl,D1,
     c                   pltintm,nns
c -----------------------------------------------------------------------
c     find the largest FWHMs  (MG 25.08.09, and smallest)
      FWHM1max = FWHM1(1)
      FWHM2max = FWHM2(1)
      FWHM1min = FWHM1(1)
c     MG 07.09.10 if there are no intensity profiles (nns=0), make sure that off-set grid is small ('ELSE')
      if (nns .eq. 0) then
         FWHM1max = 9.99
         FWHM2max = 0.0
         FWHM1min = 9.99
      endif
      IF (psftype.LT.4) THEN
c        DO i = 1, NlambdaOut
c        MG 06.10.09 limits only determined by relevant wavelengths, not all
        DO i = 1, NNS
          IF (FWHM1(i).GT.FWHM1max) FWHM1max = FWHM1(i)
          IF (FWHM2(i).GT.FWHM2max) FWHM2max = FWHM2(i)
          IF (FWHM1(i).LT.FWHM1min) FWHM1min = FWHM1(i)
        END DO
      END IF
c     scale angular coordinate to theta1
      DO i = 1, nP+2
        yang(i) = bOut(i) * Theta1 / 2.d0
        write(80,*) i, bout(i), theta1
      END DO
c     generate off-set grid
      Youtang = Y(nY) * Theta1
      write(80,*) 'FWHM ', FWHM1max, FWHM2max, FWHM1min, Youtang
      IF (Youtang.GT.FWHM1max.AND.Youtang.GT.FWHM2max) THEN
c       the envelope is well resolved, take impact parameter grid

c     DUSTY original
c        Nconv = nP + 2
c        DO i = 1, Nconv
c          Offset(i) = yang(i)
c        END DO
c     MG 25.08.09
         Nconv= 0
         do i= 1, nP+2
            Nconv= nconv+1
            Offset(nconv) = yang(i)
            if (yang(i) .gt. 0.25*FWHM1min .AND. i .ne. nP+2) then
c     add mid-point
              Nconv= nconv+1
              Offset(nconv) = yang(i) +0.5d0*(yang(i+1)-yang(i))
            endif
         enddo
      ELSE
c       the envelope is not well resolved, take equidistant grid
c       to 2FWHM1max, i.e. image will be more or less the PSF itself
        Nconv = 30
        deltaOff = 2.d0 * FWHM1max / (Nconv-1)
        IF (FWHM2max.GT.FWHM1max) THEN
          deltaOff = 2.d0 *FWHM2max / (Nconv-1)
        END IF
        DO i = 1, Nconv
          Offset(i) = deltaOff * 1.d0*(i-1)
        END DO
      END IF
c     convolve intensity wavelength by wavelength
      DO j = 1, NlambdaOut
c       needed to specify wavelength in PSFN
        iLambda = j
c       generate 1D intensity vector for subrutine Conv2D
c       take only diffuse emission, stellar contribution will
c       be added below (a shortcut to avoid inaccuracies or too many
c       points in Conv2D)
        DO i = 1, nP+2
          IF (i.LE.2) THEN
            Int1D(i) = IntOut(j,3)
          ELSE
            Int1D(i) = IntOut(j,i)
          END IF
          CALL CHKRANGE(dynrange,Int1D(i))
          IF (Int1D(i).LT.dynrange) Int1D(i)= 0.d0
        END DO

c       convolve
c        write(*,*) 'in Convolve, start Conv2d'
        CALL Conv2D(npP+2,nP+2,yang,Int1D,1000,NConv,Offset,Conv)

c       add stellar contribution
        DO i = 1, nP+2
          ConvS=2.*ASIN(1.0)*(yang(2)**2.)*IntOut(j,1)*PSFN(Offset(i))
          Conv(i) = Conv(i) + ConvS
        END DO

c       scale to 1 at the center
        CALL ScaleTo1(1000,Nconv,Conv)
c       copy 1D convolved intensity to ConvInt
        DO i = 1, Nconv
          CALL CHKRANGE(dynrange,Conv(i))
          ConvInt(j,i) = Conv(i)
          if (j.eq.1) write(80,*) 'conv ' , offset(i), conv(i), nconv
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

      SUBROUTINE Conv2D(NinMax,Nin,Xin,Yin,Noutmax,Nout,Xout,Yout)
c =======================================================================
c This subroutine convolves intensity Yin(Xin[i]), i=1,Nin with
c the point spread function PSFN(x) (provided as a separate function).
c It is assumed that both the intensity yin and PSFN(x) are circularly
c symmetric functions of radial coordinate x, i.e., this subroutine
c performs two-dimensional convolution. Convolved intensity, Yout, is
c evaluated for very position Xout[i], i=1,Nout, as:
c        Yout(Xout) = Int[Yin(yloc)*PSF(xloc)*yloc*dyloc*dphi]
c where xloc = sqrt(yloc **2+Xout**2-2*yloc*Xout*cos(phi), with yloc
c and phi being dummy integration variables. Declared size of Xin is
c NinMax, the one for Xout is NoutMax. The radial integration is done
c using subroutine ROMBY and angular integration is done by using
c Simpson rule.                                        [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      INTEGER NinMax, Nin, NoutMax, Nout, iphi, iXin, Nphi, iXOut
      DOUBLE PRECISION Xin(NinMax), Yin(NinMax), Xout(NoutMax), A, B,
     &       Yout(NoutMax), dphi, phi(1000), fphi(1000), int1, int2,
     &       imagfn
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
      INTEGER ftype
      DOUBLE PRECISION Ckn, Cxout, Cphi, Cqtheta
      COMMON /imfn1/ ftype
      COMMON /imfn2/ Ckn, Cxout, Cphi, Cqtheta
      EXTERNAL imagfn
c -----------------------------------------------------------------------
c     Parameters for integration:
c     number of angular points
      Nphi=  108
c     step in angle phi
      dphi = 2.d0*ASIN(1.d0) / (Nphi-1)
c     flag for imgfn
      ftype = 1
c     Start integrations
c     loop over output positions
      DO iXout = 1, Nout
        Cxout = Xout(iXout)
c       loop over angular wedges (phi integration)
        DO iphi = 1, Nphi
          phi(iphi) = dphi*1.0*(iphi-1)
          Cphi = phi(iphi)
          fphi(iphi) = 0.0
c         loop over input radial positions (radial integration)
          DO iXin = 1, Nin-1
            Ckn = 1.0
            CALL ROMBY(imagfn,Xin(iXin),Xin(iXin+1),int1)
            Ckn = 2.0
            CALL ROMBY(imagfn,Xin(iXin),Xin(iXin+1),int2)
c           contribution from this annulus (lin. approx. for intensity)
            A = Xin(iXin+1)*Yin(iXin) - Xin(iXin)*Yin(iXin+1)
            A = A / (Xin(iXin+1)-Xin(iXin))
            B = (Yin(iXin+1)-Yin(iXin)) / (Xin(iXin+1)-Xin(iXin))
            fphi(iphi) = fphi(iphi) + A*int1 + B*int2
          END DO
        END DO
        CALL Simpson(1000,1,Nphi,phi,fphi,Yout(iXout))
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION ETA(Yy)
c =======================================================================
c This subroutine evaluates the normalized density profile. denstype is
c a type of density law: 1 and 2 - power law, 3 for exponential density law,
c 4 for radiatively driven winds (the gray-body approximation), 5,6 - RDW and
c 7 - d.d.from a file. pow is parameter describing the choosen density law:
c power for 1 and 2, v1/v8 for RDW (the ratio of expansion velocities at the
c inner and outer radii), sigma for 3 [i.e. rho = dexp(-(y/sigma)**2)].
c Yout is the relative thickness, Yout=rout/r1. Y is the radial position.
c                                                          [ZI'95; ZI'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER i, istop, iYdummy
      DOUBLE PRECISION Yy, C, IntAux, powaux, Prod, eps, factEta
c -----------------------------------------------------------------------
c     this is an adjustable value regulating the initial Eta approximation for d
      factEta = 0.5
      IF (Yy.GT.Yout) Yy = Yout
      IF (iterETA.GT.1) THEN
c     if this is iteration over ETA (but not the first one) in the case
c     of dynamical calculation for radiatively driven winds calculate
c     ETA by linear interpolation of ETA from the previous iteration
      CALL LinInter(npY,nYprev,Yprev,ETAdiscr,Yy,iYdummy,ETA)
c     otherwise use prescribed formulae for different cases
      ELSE
c     smooth power-law
      IF (denstyp.EQ.1) THEN
c       find normalization constant
        IF (pow.NE.1.0) THEN
          C = (1.0 - Yout**(1.0-pow)) / (pow - 1.0)
          ELSE
          C = dlog(Yout)
        ENDIF
        IF (Ntr.GE.1) THEN
          DO i = 1, Ntr
            powaux = pow - ptr(i)
            IF (powaux.NE.1.0) THEN
              IntAux = (1.0 - Yout**(1.0-powaux)) / (powaux - 1.0)
            ELSE
              IntAux = dlog(Yout)
            END IF
            C = C + IntAux / Ytr(i)**ptr(i)
          END DO
        ENDIF
        C = 1.0d0 / C
c       calculate density
        IF (Yy.GE.(1.0d0-1.0d-8)) THEN
          ETA = C / Yy**pow
          IF (Ntr.GE.1) THEN
            DO i = 1, Ntr
              ETA = ETA + C * Yy**(ptr(i)-pow) / Ytr(i)**ptr(i)
            END DO
          END IF
          ELSE
          ETA = 0.0
        ENDIF
      END IF
c     broken power-law
c     MG 27.08.09 allow scaling in power-laws
      IF (denstyp.EQ.2) THEN
        Ytr(Ntr+1) = Yout
c       find normalization constants
        IF (pow.NE.1.0d0) THEN
          C = scl0* (1.0d0 - Ytr(1)**(1.0d0-pow)) / (pow - 1.0d0)
          ELSE
          C = scl0* dlog(Ytr(1))
        ENDIF
        IF (Ntr.GE.1) THEN
          DO i = 1, Ntr
            CALL Product(10,Ytr,ptr,scal,pow,scl0,i,Prod)
            IF (ptr(i).NE.1.0) THEN
              IntAux = Ytr(i)**(1.0d0-ptr(i)) - Ytr(i+1)**(1.0d0-ptr(i))
              IntAux = Prod * scal(i) * IntAux / (ptr(i) - 1.0d0)
              ELSE
              IntAux = Prod * scal(i) * dlog(Ytr(i+1)/Ytr(i))
            END IF
            C = C + IntAux
          END DO
        ENDIF
        C = 1.0d0 / C
c       calculate density
        IF (Yy.GE.1.0d0-1.0d-8) THEN
          IF (Yy.LE.Ytr(1)) THEN
            ETA = C * scl0 / Yy**pow
          ELSE
            istop = 0
            i = 0
            DO WHILE (istop.NE.1)
              i = i + 1
              IF (Yy.LE.Ytr(i+1)) istop = 1
            END DO
            CALL Product(10,Ytr,ptr,scal,pow,scl0,i,Prod)
            ETA = C * Prod * scal(i) / Yy**ptr(i)
          END IF
        ELSE
          ETA = 0.0
        ENDIF
      END IF
c     exponential law
      IF (denstyp.EQ.3) THEN
        IF (Yy.GE.1.0d0-1.0d-8) THEN
          ETA = (Yout-1.d0) * (1.d0-exp(-pow)) / pow
          ETA = exp(-pow*(Yy-1.d0)/(Yout-1.d0)) / ETA
        ELSE
          ETA = 0.d0
        END IF
      END IF
c     radiatively driven winds (the gray-body approximation)
      IF (denstyp.EQ.4) THEN
        eps = pow
        IF (Yy.GE.1.d0-1.0d-8) THEN
          ETA = (1.d0+eps)/2.d0/Yy/Yy/sqrt(1.d0-(1.d0-eps*eps)/Yy)
        ELSE
          ETA = 0.d0
        ENDIF
      END IF
c     radiatively driven winds (full calculation)
       IF (RDW) THEN
c       if this is the first iteration use analytic approximation
        IF (iterETA.LT.2) THEN
c         for 5 eps is pow, for 6 assume eps=0.1
          IF (denstyp.EQ.5) THEN
            eps = pow
          ELSE
            eps = 0.1d0
          END IF
          IF (Yy.GE.(1.d0-1.0d-8)) THEN
            ETA = (1.d0+eps)/2.d0/Yy/Yy/sqrt(1.d0-(1.d0-eps*eps)/Yy)
c           empirical improvement for the initial approximation
c           good only for large optical depths, but small ones
c           are fast anyway (ZI, May99)
            IF (Yy.LE.2) THEN
               ETA = ETA / (1.d0 + factEta / Yy**10.d0)
            END IF
          ELSE
            ETA = 0.0d0
          ENDIF
c       or interpolate from the previous solution
        ELSE
          CALL LinInter(npY,nYprev,Yprev,ETAdiscr,Yy,iYdummy,ETA)
        END IF
      END IF
c     user specified function
      IF (denstyp.EQ.7) THEN
        IF (Yy.LT.yEta7(nYEta7)) THEN
          CALL LinInter(npY,nYEta7,yEta7,Eta7,Yy,iYdummy,ETA)
        ELSE
          ETA = Eta7(nYEta7)
        END IF
      END IF
c     done
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c ***********************************************************************
      DOUBLE PRECISION FUNCTION ETAfun(iL,Y)
c =======================================================================
c This subroutine evaluates the normalized density profile as a function
c of position and wavelength (in multigrain case). The MAIN purpose of
c this function is to provide connection between the overall, prescribed
c density distribution, ETA, and wavelength depedent function ETAfun.
c It is NOT FINISHED, this is a trivial case, works only for single
c grains.                                              [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER iL
      DOUBLE PRECISION Y, eta
c -----------------------------------------------------------------------
c     this is temporary, works only for single component grains
c     I need to add subroutines/functions to take care of temperature
c     dependent and thus variable condensation radii for different
c     components
      ETAfun = ETA(Y)
c     this is to avoid warning when compiling:
      iL = iL
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE FindInt(nG,alpha,ETAzp)
c =======================================================================
c This subroutine finds the intensity distribution at outer edge and for
c user specified wavelengths lamOut. It also evaluates the angular size
c of the stellar disk and adds two impact parameters describing the star
c to the P grid, thus producing bOut grid. All intensities are indeed
c dimensionless quantities lambda*I_lambda/F1 where I_lambda is real
c physical quantity defined as usual and F1 is the bolometric flux at
c the dust sublimation radius, r1. For conversion to the physical value
c lambda*I_lambda, I_lambda from the program has to be multiplied by F1.
c F1 can obtained either as:
c      1) F1 = 4*sigma*Tsub**4/Psi (IE96, eq. 15),
c where Tsub is sublimation temperature and parameter Psi is given in
c *.SUM file; or as:
c      2) F1 = Fbol/alpha1**2 (IE96, eq. 34)
c where Fbol is the bolometric flux and alpha1 is the angular size of r1
c at any particular distance from the envelope (i.e. both F1 and alpha1
c correspond to observed quantities). Also note that
c     INT(I_lambda(p)*2Pi*P*dP) = f_lambda
c where I_lambda is the scaled quantity from the program, P is impact
c parameter, and f_lambda is the spectral shape F_lambda/Fbol.
c                                                      [Z.I., Aug. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER iL, nG, k, i, iLout, iLstop, iP, iW, nZ, Nzpt, iZ, izloc
      DOUBLE PRECISION   qaux(npL), Psi,alpha(npG,npY), resaux, QUtot1,
     &       QpTsub, xP, pst, stelfact, Istell(npL), Planck, w1,
     &       IntL, IntR, xx , alb, Ids(npL,npP), Ide(npL,npP),w2, lw12,
     &       ETAzp(npP,npY), numcorr, ETAzpStar, qaux2(npL), z1, z2,
     &       delz, zloc, wloc, resint, pT, Tz, Idboth, tzp(100), pUtot,
     &       Semis(100), Sscat(100), IntETA, palb, palf, alfa, exterm,
     &       Utotloc, Sstem(100), Sstsc(100), Istem(npL,100), Idfront,
     &       Istsc(npL,100), delTau, factaux, UtotL, UtotR, ep1,
     &       tauzp1, tauInf
c -----------------------------------------------------------------------
c     temporary
      IF (nG.GT.1.AND.iX.GE.1) THEN
        write(18,*)' FindInt should be fixed, nG>1 !'
        stop
      END IF
c     find impact parameter tangential to the stellar disk
c     first find the Planck averaged absorption efficiencies at Y=1
      DO iL = 1, nL
        qaux(iL) = SigmaA(1,iL) * Utot(iL,1) / lambda (iL)
        xP = 14400.d0 / Tsub(1) / lambda(iL)
        qaux2(iL) = SigmaA(1,iL) * Planck(xP) / lambda (iL)
      END DO
      CALL Simpson(npL,1,nL,lambda,qaux,resaux)
      QUtot1 = resaux
      CALL Simpson(npL,1,nL,lambda,qaux2,resaux)
      QpTsub = resaux
c     parameter Psi (see Ivezic & Elitzur, 1996, eq. C4)
      Psi = QUtot1 / QpTsub
c     ratio pst = rstar/rsub (see Ivezic & Elitzur, 1996, eq. 27)
      pst = 2.d0 / dsqrt(Psi) * (Tsub(1) / Tstar)**2.0
      IF (pst.GE.0.5) THEN
         IF (iX.GE.1) THEN
            write(18,*)' FindInt: specified dust temperature at the '
            write(18,*)' inner radius results in r*/r1 >= 0.5: '
            write(18,*)'    r*/r1 =', pst
            write(18,*)' This violates some of Dusty`s assumptions'
            write(18,*)'  ------  Please consult the manual ------'
            write(18,*)'  ####  r*/r1 changed by hand to 0.5  ####'
         END IF
         pst = 0.5d0
      END IF
      stelfact = 1.d0 / pst / pst / 3.1415927d0
c     generate bOut, i.e. insert two points such that
c     bOut(k)=0.999*pst and bOut(k+1)=1.001*pst
      CALL GetbOut(npP,nP,P,pst,bOut,k)
c     correction for numerical errors in tau
      numcorr = 1.d0 / TAUtot(1)
c     loop over wavelengths
      DO iL = 1, nL
c        stellar intensity, Istell (extinction already included)
         Istell(iL) = fs(iL,nY) * stelfact
c        total optical depth along a line of sight
         tauOut(iL) = numcorr*TAUtot(iL)
      END DO
c     generate diffuse intensities, Ide (emission) and Ids (scat)
c     loop over wavelengths
      DO iL = 1, nL
        DO iP = 1, nP
c         maximal number of points along tangential position, z
          nZ = nY + 1 - iYfirst(iP)
c         starting value for local radius
          IF (P(iP).GE.1.0) THEN
            w2 = P(iP)
          ELSE
            w2 = 1.0
          END IF
c         initialize intensities
          Ide(iL,iP) = 0.0
          Ids(iL,iP) = 0.0
          IF (iP.LE.k+1) THEN
            Istem(iL,iP) = 0.0
            Istsc(iL,iP) = 0.0
          END IF
c         total optical depth along this impact parameter
          ep1 = ETAzp(iP,nY+1-iYfirst(iP))*TAUtot(iL)
c         loop over z, i.e. steps over points crossing the y grid
          DO iZ = 2, nZ
c           index for the ending local radius
            iW = iYfirst(iP) + iZ - 1
c           local boundary radii
            w1 = w2
            w2 = Y(iW)
c           corresponding displacements along a line of sight
            z1 = sqrt(abs(w1**2.-P(iP)**2.))
            z2 = sqrt(abs(w2**2.-P(iP)**2.))
c           # of pts. for z integration, should increase with deltaTau
c           it is messy because INT function which would do the job is
c           not in F77 standard set
            Nzpt = 5
            delTau = (ETAzp(iP,iW)-ETAzp(iP,iW-1))*TAUtot(iL)
            IF (delTau.GT.1)  Nzpt = 10
            IF (delTau.GT.5)  Nzpt = 20
            IF (delTau.GT.10) Nzpt = 30
            IF (delTau.GT.20) Nzpt = 40
            IF (delTau.GT.50) Nzpt = 50
            delz = (z2-z1) / (Nzpt-1)
c           powers for power-law interpolations between 2 y pts.
            lw12 = dlog(Y(iW-1)/Y(iW))
c           for T
            pT = dlog(Td(1,iW)/Td(1,iW-1)) / lw12
c           for albedo
            IF (omega(iL,iW-1).GT.0.0.AND.omega(iL,iW).GT.0.0) THEN
              palb = dlog(omega(iL,iW)/omega(iL,iW-1)) / lw12
            ELSE
              palb = 0.0
            END IF
c           for Utot
            UtotL = Utot(iL,iW-1)
            UtotR = Utot(iL,iW)
            CALL CHKRANGE(dynrange,UtotL)
            CALL CHKRANGE(dynrange,UtotR)
            IF (UtotL.GT.0.0.AND.UtotR.GT.0) THEN
              pUtot = dlog(UtotR/UtotL) / lw12
            ELSE
              pUtot = 0.d0
            END IF
c           for alpha
            palf = dlog(alpha(1,iW)/alpha(1,iW-1)) / lw12
c           tauzp between z=0 and z=z1
            tauzp1 = ETAzp(iP,iZ-1)*TAUtot(iL)
c           integrate between adjacent grid points
            DO izloc = 1, Nzpt
              zloc = z1 + (izloc-1)*delz
              wloc = sqrt(zloc**2 + P(iP)**2)
c             find local TAUzp(w(z))-TAUzp(w1=w(z1))
              tzp(izloc) = IntETA(P(iP),iW-1,w1,wloc)*TAUtot(iL)
c             find Tz = T(zloc) = T(wloc), this works for single
c             size grains only; for multigrain case one needs to
c             get Semis by summation over all Td
              Tz = Td(1,iW-1) * (Y(iW-1)/wloc)**pT
              xP = 14400.d0/lambda(iL)/Tz
c             power-law interpolation for albedo
              alb = omega(iL,iW-1) * (Y(iW-1)/wloc)**palb
c             power-law interpolation for Utot
              IF (UtotL.GT.0) THEN
                UtotLoc = UtotL * (Y(iW-1)/wloc)**pUtot
              ELSE
                UtotLoc = 0.0d0
              END IF
              CALL CHKRANGE(dynrange,UtotLoc)
c             power-law interpolation for alpha
              alfa = alpha(1,iW-1) * (Y(iW-1)/wloc)**palf
c             source functions (wloc**2 because D uses scaled quant.)
              factaux = 1 / wloc**2 / (4 * 3.14159d0)
              Semis(izloc) = (1-alb) * alfa * Planck(xP) * factaux
              Sscat(izloc) = alb * UtotLoc * factaux
c             check for the dynamic range
              CALL CHKRANGE(dynrange,Semis(izloc))
              CALL CHKRANGE(dynrange,Sscat(izloc))
c             optical depth from infinity along the line of sight
              tauInf = ep1 - tauzp1 - tzp(izloc)
c             for a line of sight terminating on the star find
c             contribution only from the front part of the envelope
              IF (iP.LE.k+1) THEN
                 IF (tauInf.LT.50) THEN
                   exterm = dexp(-tauInf)
                 ELSE
                   exterm = 0.0
                 END IF
                 Sstem(izloc) = Semis(izloc) * exterm
                 Sstsc(izloc) = Sscat(izloc) * exterm
              END IF
c             otherwise take both the front and back contributions
              IF (tauInf.LT.50) THEN
                 exterm = dexp(-tauInf)+dexp(-tauInf-ep1)
              ELSE
                 exterm = 0.0
              END IF
              Semis(izloc) = Semis(izloc) * exterm
              Sscat(izloc) = Sscat(izloc) * exterm
c             end of local loop over z
            END DO
c           integrate and add contribution from this step
            CALL SIMPSON(100,1,Nzpt,tzp,Semis,resint)
            CALL CHKRANGE(dynrange,resint)
            Ide(iL,iP) = Ide(iL,iP) + resint
            CALL SIMPSON(100,1,Nzpt,tzp,Sscat,resint)
            CALL CHKRANGE(dynrange,resint)
            Ids(iL,iP) = Ids(iL,iP) + resint
            IF (iP.LE.k+1) THEN
              CALL SIMPSON(100,1,Nzpt,tzp,Sstem,resint)
              CALL CHKRANGE(dynrange,resint)
              Istem(iL,iP) = Istem(iL,iP) + resint
              CALL SIMPSON(100,1,Nzpt,tzp,Sstsc,resint)
              CALL CHKRANGE(dynrange,resint)
              Istsc(iL,iP) = Istsc(iL,iP) + resint
            END IF
c         end of loop over z
          END DO
c       end of loop over impact parameter, iP
        END DO
c     end of loop over wavelengths, iL
      END DO
c     add all intensities, Istell, Ide, Ids
      DO iL = 1, nL
c       interpolate optical depth  at pstar
        IF (iL.EQ.iLfid) THEN
          ETAzpStar = (ETAzp(k,nY) - ETAzp(k-1,nY))
          ETAzpStar = ETAzpStar * (pst-P(k-1)) / (P(k) - P(k-1))
          ETAzpStar = ETAzp(k-1,nY) + ETAzpStar
        END IF
c       find diffuse contribution at pstar (by linear interpolation)
        Idfront = Istsc(iL,k)+Istem(iL,k)-Istsc(iL,k-1)-Istem(iL,k-1)
        Idfront = Idfront * (pst-P(k-1)) / (P(k) - P(k-1))
        Idfront = Idfront + Istsc(iL,k-1) + Istem(iL,k-1)
        Idboth = Ids(iL,k) + Ide(iL,k) - Ids(iL,k-1) - Ide(iL,k-1)
        Idboth = Idboth * (pst-P(k-1)) / (P(k) - P(k-1))
        Idboth = Idboth + Ids(iL,k-1) + Ide(iL,k-1)
c       first for p<pstar, all three contributions
        DO i = 1, k-1
          Intens(iL,i) = Istell(iL) + Istsc(iL,i) + Istem(iL,i)
          IF (iL.EQ.iLfid)
     &        tauZout(i) = ETAzp(i,nY)/ETAzp(1,nY)
        END DO
c       barely on the stellar disk
        Intens(iL,k) = Istell(iL) + Idfront
        tauZout(k) = ETAzpStar/ETAzp(1,nY)
c       barely off the stellar disk
        Intens(iL,k+1) = Idboth
        tauZout(k+1) = 2. * tauZout(k)
c       all other p>pstar
        DO i = k, nP
          Intens(iL,i+2) = Ids(iL,i)+Ide(iL,i)
          IF (iL.EQ.iLfid) THEN
            nZ = nY + 1 - iYfirst(i)
            tauZout(i+2) = 2. * ETAzp(i,nZ)/ETAzp(1,nY)
          END IF
        END DO
      END DO
c     check dynamic range
      DO iL = 1, nL
        DO i = 1, nP+2
          CALL CHKRANGE(dynrange,Intens(iL,i))
        END DO
      END DO
c     now interpolate Intens(lambda) to lamOut
      DO iLout = 1, NlambdaOut
c       bracket the needed wavelength
        iLstop = 0
        iL = 0
        DO WHILE (iLstop.EQ.0)
          iL = iL + 1
          IF (lambda(iL).GT.LambdaOut(iLout)) iLstop = 1
          IF (iL.EQ.nL) iLstop = 1
        END DO
c       interpolate intensity
        xx = (LambdaOut(iLout)-lambda(iL-1))/(lambda(iL)-lambda(iL-1))
        DO i = 1, nP+2
          IntL = Intens(iL-1,i)
          IntR = Intens(iL,i)
          IntOut(iLout,i) = IntL + xx*(IntR - IntL)
          CALL CHKRANGE(dynrange,IntOut(iLout,i))
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE GetbOut(npP,nP,P,pstar,bOut,k)
c =======================================================================
c This subroutine inserts two impact parameters corresponding to pstar,
c producing bOut(nP+2) from P(nP). The inserted elements are bOut(k) and
c bOut(k+1)                                            [Z.I., Aug. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npP, nP, k, kstop, i
      DOUBLE PRECISION P(npP), bOut(npP+2), pstar
c -----------------------------------------------------------------------
      k = 0
      kstop = 0
      DO WHILE (kstop.NE.1)
        k = k + 1
        bOut(k) = P(k)
        IF (1.001*pstar.LE.P(k).OR.k.EQ.nP) kstop = 1
      END DO
      IF (0.999*pstar.GT.P(k-1)) THEN
        bOut(k) = 0.999*pstar
        ELSE
        bOut(k) = 0.5*(P(k-1)+1.001*pstar)
      END IF
      IF (1.001*pstar.LT.P(k)) THEN
        bOut(k+1) = 1.001*pstar
        ELSE
        bOut(k+1) = 0.5*(P(k)+0.999*pstar)
      END IF
      DO i = k, nP
        bOut(i+2) = P(i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE getOmega(nG)
c =======================================================================
c This subroutine generates albedo omega(iL,iY) from the abs/sca cross-
c sections and the component abundancies. This is temporary (trivial)
c version  for single size grains.                     [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER  iG, nG, iL, iY
c -----------------------------------------------------------------------
c     generate overall albedo through the envelope
c      ** this is for future multigrain code **
c      ** for single grains it is trivial **
      DO iY = 1, nY
c       calculate albedo
        DO iL = 1, nL
          omega(iL,iY) = SigmaS(nG,iL) / (SigmaA(nG,iL) + SigmaS(nG,iL))
        END DO
c       calculate relative abundances
        DO iG = 1, nG
          abund(iG,iY) = 1.d0
        END DO
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c **********************************************************************

c **********************************************************************
      SUBROUTINE getOptPr(nG,nameQ,nameNK,er)
c =====================================================================
c This subroutine calculates the absorption and scattering efficiences
c Qabs and Qsca in the wavelength range of the code or in case of
c user supplied efficiences reads them from a file.
c                                                 [ZI Mar96; MN Aug97]
c =====================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER npLnk
      PARAMETER (npLnk=98)
      DOUBLE PRECISION n_sil_ow(npLnk),k_sil_ow(npLnk),n_sil_oc(npLnk),
     &       k_sil_oc(npLnk), n_sil_dl(npLnk), k_sil_dl(npLnk),
     &       n_amc_hn(npLnk), k_amc_hn(npLnk), n_sic_pg(npLnk),
     &       k_sic_pg(npLnk), n_gr1_dl(npLnk), k_gr1_dl(npLnk),
     &       n_gr2_dl(npLnk), k_gr2_dl(npLnk), lam_nk(npLnk)
      COMMON /nkdat/ n_sil_ow, k_sil_ow, n_sil_oc, k_sil_oc,
     &               n_sil_dl, k_sil_dl, n_amc_hn, k_amc_hn,
     &               n_sic_pg, k_sic_pg, n_gr1_dl, k_gr1_dl,
     &               n_gr2_dl, k_gr2_dl, lam_nk
      CHARACTER*235 nameQ(npG), nameNK(10), Fname, dummy*132
      INTEGER iG, nG, io1, iL, nLin, iLaux, Nprop, Na, iA, iC, iCuser,
     &        er, Nmax, npA
c     Nmax is the number of records in user supplied file with opt.prop.
c     and npA is the dimension of the array of grain sizes
      PARAMETER (Nmax=10000, npA=100)
      DOUBLE PRECISION aa,bb,cc,lambdain(Nmax),Qain(Nmax),Qsin(Nmax),
     &       n(npL),k(npL), aQabs(npA,npL),aQsca(npA,npL), amax, Pi,
     &       nsd(npA), a(npA), faux1(npA), faux2(npA), f(npA), int,
     &       ala(Nmax), SigAbs(npA,npL), SigSca(npA,npL), SizeDist,
     &       aQa(Nmax), aQs(Nmax),  Cnorm, a3ave,
     &       n_int(npL), k_int(npL)
c ----------------------------------------------------------------
c     this should never change
      nL = npL
      Nprop = 7
c ----------------------------------------------------------------
      Pi = 2.0*ASIN(1.0)
      er = 0
c     first check that the user supplied wavelength grid is
c     monotonously increasing
      IF (top.LT.3) THEN
c       calculate efficiencies from n and k by Mie theory
c       generate the size array
        IF (szds.GT.2) THEN
          amax = 5.0*a2
        ELSE
          amax = a2
        END IF
        IF (dabs(a1-a2).LE.1.d-3) THEN
          nA = 1
        ELSE
          nA =50
        END IF
c       Build-up the array of sizes a(nA)
        CALL GETsizes(npA,nA,a1,amax,a)
c       evaluate the normalization constant for the size
c       distribution nsd(nA)
        DO iA = 1, nA
          nsd(iA) = SizeDist(qsd,a(iA),szds,a2)
        END DO
        CALL PowerInt(npA,1,nA,a,nsd,Cnorm)
c       find the average grain volume aveV (needed in dynamics)
        IF(dabs(a1-a2).LE.1.d-3) THEN
          aveV = 4./3.*Pi*a1**3
        ELSE
           DO iA = 1, nA
             faux1(iA)=nsd(iA)*a(iA)**3
           END DO
           CALL PowerInt(npA,1,nA,a,faux1,a3ave)
           aveV = 4./3.*Pi*a3ave/Cnorm
        END IF
c      --  LOOP OVER SUPPORTED COMPONENTS --
        DO iC= 1, Nprop
          f(iC) = xC(iC)
c         assign optical properties
          IF (iC.EQ.1) CALL AssProp(npLnk,n_sil_ow,k_sil_ow,n,k)
          IF (iC.EQ.2) CALL AssProp(npLnk,n_sil_oc,k_sil_oc,n,k)
          IF (iC.EQ.3) CALL AssProp(npLnk,n_sil_dl,k_sil_dl,n,k)
          IF (iC.EQ.4) CALL AssProp(npLnk,n_gr1_dl,k_gr1_dl,n,k)
          IF (iC.EQ.5) CALL AssProp(npLnk,n_gr2_dl,k_gr2_dl,n,k)
          IF (iC.EQ.6) CALL AssProp(npLnk,n_amc_hn,k_amc_hn,n,k)
          IF (iC.EQ.7) CALL AssProp(npLnk,n_sic_pg,k_sic_pg,n,k)
c         interpolate from opt. prop. grid to working grid
          DO iL = 1, nL
             CALL LinInter(npLnk,npLnk,lam_nk,n,lambda(iL),iLaux,aa)
             n_int(iL) = aa
             CALL LinInter(npLnk,npLnk,lam_nk,k,lambda(iL),iLaux,aa)
             k_int(iL) = aa
          END DO
c         calculate Qabs and Qsca (on working grid, i.e. lambda)
          CALL MIE(npL,nL,lambda,n_int,k_int,npA,nA,a,1,aQabs,aQsca)
c         for each lambda integrate Pi*a^2*Qext with n(a)da
          DO iL = 1, nL
            DO iA = 1, nA
              faux1(iA)=nsd(iA)*aQabs(iA,iL)*Pi*a(iA)**2
              faux2(iA)=nsd(iA)*aQsca(iA,iL)*Pi*a(iA)**2
            END DO
            CALL PowerInt(npA,1,nA,a,faux1,int)
            sigAbs(iC,iL) = int/Cnorm
            CALL PowerInt(npA,1,nA,a,faux2,int)
            sigSca(iC,iL) = int/Cnorm
          END DO
        END DO
        IF (top.EQ.2) THEN
c         --  LOOP OVER USER SUPPLIED COMPONENTS --
          DO iCuser = 1, Nfiles
            iC = Nprop + iCuser
            f(iC) = xCuser(iCuser)
c           read in optical properties
            Fname = nameNK(iCuser)
            CALL GetProp(npL,lambda,nL,Fname,n,k,er)
            IF (er.EQ.3) goto 999
c           calculate Qabs and Qsca
            CALL MIE(npL,nL,lambda,n,k,npA,nA,a,1,aQabs,aQsca)
c           for each lambda integrate Pi*a^2*Qext with n(a)da
            DO iL = 1, nL
              DO iA = 1, nA
                faux1(iA)=nsd(iA)*aQabs(iA,iL)*Pi*a(iA)**2
                faux2(iA)=nsd(iA)*aQsca(iA,iL)*Pi*a(iA)**2
              END DO
              CALL PowerInt(npA,1,nA,a,faux1,int)
              sigAbs(iC,iL) = int/Cnorm
              CALL PowerInt(npA,1,nA,a,faux2,int)
              sigSca(iC,iL) = int/Cnorm
            END DO
          END DO
        ELSE
          Nfiles = 0
        END IF
c       mix them together (syntetic grain model)
        DO iL = 1, nL
          SigmaA(1,iL) = 0.0
          SigmaS(1,iL) = 0.0
          DO iC= 1, Nprop+Nfiles
            SigmaA(1,iL) = SigmaA(1,iL) + f(iC) * sigAbs(iC,iL)
            SigmaS(1,iL) = SigmaS(1,iL) + f(iC) * sigSca(iC,iL)
c            if (iC.eq.1)write(66,*)lambda(iL),SigmaA(1,iL),SigmaS(1,iL)
          END DO
        END DO
      ELSE
c     this is for top.GE.3
c      initialize aveV for this case
       aveV = 1.
c       read in lambda grid and optical properties
        DO iG = 1, nG
          open(1,ERR=998,file=nameQ(iG),STATUS='OLD')
          read(1,'(a)',ERR=998)dummy
          read(1,'(a)',ERR=998)dummy
          read(1,'(a)',ERR=998)dummy
          iL = 0
          io1 = 0
          DO WHILE (io1.GE.0)
            read(1,*,END=900,ERR=998,iostat=io1) aa, bb, cc
            IF (io1.GE.0) THEN
              iL = iL + 1
              lambdain(iL) = aa
              Qain(iL) = bb
              Qsin(iL) = cc
            END IF
          END DO
900       close(1)
          IF (iL.LT.2) goto 998
          nLin = iL
c         if input wavelengths in descending order turn them around
          IF (lambdain(1).GT.lambdain(2)) THEN
            DO iL = 1, nLin
              ala(iL) = lambdain(iL)
              aQa(iL) = Qain(iL)
              aQs(iL) = Qsin(iL)
            END DO
            DO iL = 1, nLin
              lambdain(iL) = ala(nLin+1-iL)
              Qain(iL) = aQa(nLin+1-iL)
              Qsin(iL) = aQs(nLin+1-iL)
            END DO
          END IF
c         interpolate to Dusty's wavelength grid
          DO iL = 1, nL
            CALL LinInter(Nmax,nLin,lambdain,Qain,lambda(iL),iLaux,aa)
            SigmaA(iG,iL) = aa
            CALL LinInter(Nmax,nLin,lambdain,Qsin,lambda(iL),iLaux,aa)
            SigmaS(iG,iL) = aa
          END DO
        END DO
      END IF
      goto 999
998   write(12,*)' ***  FATAL ERROR IN DUSTY  ***********'
      write(12,*)' File with optical properties:'
      write(12,'(a2,a70)')'  ',nameQ(iG)
      write(12,*)' is missing or not properly formatted?!'
      write(12,*)' **************************************'
      close(12)
      er = 3
c -----------------------------------------------------------------------

      write(*,*) 'deliberate stop line 8986'
      stop

999   RETURN
      END
c ***********************************************************************

      SUBROUTINE GetProp(npL,lambda,nL,Fname,en,ek,error)
c =======================================================================
c This subroutine reads optical properties en(i,j), ek(i,j) from file
c fname(Nf), with i=Nf, j=1..NLL(Nf), and interpolates them onto
c wavelength grid lambda(1..nL)                        [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      CHARACTER*235 Fname
      CHARACTER*232 line
      INTEGER i, nL, iloc, iL, npL, io1, error, Nmax
c     Nmax is the number of records in the user supplied file
      PARAMETER (Nmax=10000)
      DOUBLE PRECISION en(npL), ek(npL), lambda(npL), pw(Nmax),
     &       pren(Nmax), pimn(Nmax), a(Nmax), b(Nmax), c(Nmax), aa,
     &       bb, cc
c -----------------------------------------------------------------------
      error = 0
      open(2,ERR=998,file=Fname,STATUS='OLD')
c     read in a header from the input file
      DO i = 1, 7
        read(2,'(a)',ERR=998)line
      END DO
c     read in input data
      iL = 0
      io1 = 0
      DO WHILE (io1.GE.0)
        read(2,*,END=900,ERR=998,iostat=io1) aa, bb, cc
        IF (io1.GE.0) THEN
          iL = iL + 1
          pw(iL) = aa
          pren(iL) = bb
          pimn(iL) = cc
        END IF
      END DO
900   close(2)
      IF (iL.LT.2) goto 998
c     if input wavelengths in descending order turn them around
      IF (pw(1).GT.pw(2)) THEN
        DO i = 1, iL
          a(i) = pw(i)
          b(i) = pren(i)
          c(i) = pimn(i)
        END DO
        DO i = 1, iL
          pw(i) = a(iL+1-i)
          pren(i) = b(iL+1-i)
          pimn(i) = c(iL+1-i)
        END DO
      END IF
c     interpolate
      DO i = 1, nL
        CALL LinInter(Nmax,iL,pw,pren,lambda(i),iloc,en(i))
        CALL LinInter(Nmax,iL,pw,pimn,lambda(i),iloc,ek(i))
      END DO
      goto 999
998   write(12,*)' ***  FATAL ERROR IN DUSTY  ***********'
      write(12,*)' File with optical properties:'
      write(12,'(a2,a70)')'  ',Fname
      write(12,*)' is missing or not properly formatted?!'
      write(12,*)' **************************************'
      close(12)
      error = 3
c -----------------------------------------------------------------------
999   RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE GETsizes(NN,N,x1,x2,x)
c =======================================================================
c This subroutine generates an array x(i=1..N) of physical size NN,
c with N elements logarithmically spaced between x1 and x2.
c                                              [ZI,Aug'96;MN,Nov'97]
c =======================================================================
      IMPLICIT none
      INTEGER NN, N, i
      DOUBLE PRECISION x(NN), x1, x2, fac, pw1, pw2
c -----------------------------------------------------------------------
      IF (N.GT.1) THEN
        pw1 = 1.0/(N-1)
        fac = (x2/x1)**pw1
        DO i = 1, N
          pw2 = 1.0*(i-1)
          x(i) = x1*fac **pw2
        END DO
      ELSE
        x(1) = x1
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE getTau(model,nG,TAU1,TAU2,TAUin,Nrec,GridType,Nmodel)
c =======================================================================
c This subroutine generates total optical depth TAUtot.
c                                                      [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER model, Nmodel, nG, iL, GridType, Nrec, iiL
      DOUBLE PRECISION faux1(npL), faux2(npL), SigAfid, SigSfid, q,
     &       TAUin(Nrec), TAU1, TAU2
c -----------------------------------------------------------------------
      IF (nG.GT.1) THEN
        write(18,*)'Fix getTAU, nG>1 !'
        stop
      END IF
      TAUmax = 0.0d0
      IF(GridType.EQ.3) THEN
        TAUfid = TAUin(model)
      ELSE
c      calculate TAUfid for given model
       IF (model.EQ.1) THEN
        TAUfid = TAU1
       ELSE
        IF (model.EQ.Nmodel) THEN
          TAUfid = TAU2
        ELSE
          IF (GridType.EQ.1) THEN
            q =  (TAU2 - TAU1)/(Nmodel-1.0)
            TAUfid = TAU1 + q*(model-1.0)
          ELSE
            q = dexp(log(TAU2/TAU1)/(Nmodel-1.0))
            TAUfid = TAU1 * q**(model-1.0)
          END IF
        END IF
       END IF
      END IF
c     generate TAUtot and find TAUmax
      DO iL = 1, nL
        faux1(iL) = SigmaA(nG,iL)
        faux2(iL) = SigmaS(nG,iL)
      END DO
      IF (lamfid.LT.lambda(1)) THEN
        write(12,*)' Fiducial wavelength was too small.'
        write(12,'(a8,e9.3,a17)')' Using ',lambda(1),' micron instead.'
      END IF
      IF (lamfid.GT.lambda(nL)) THEN
        write(12,*)' Fiducial wavelength was too large.'
        write(12,'(a8,e9.3,a17)')' Using ',lambda(nL),' micron instead.'
      END IF
      CALL LinInter(npL,nL,lambda,faux1,lamfid,iLfid,SigAfid)
      CALL LinInter(npL,nL,lambda,faux2,lamfid,iLfid,SigSfid)
c     extinction efficiency at fiducial wavelength
      SigExfid = SigAfid + SigSfid
      DO iL = 1, nL
        TAUtot(iL) = TAUfid*(SigmaA(nG,iL) + SigmaS(nG,iL)) / SigExfid
        IF (TAUtot(iL).GE.TAUmax) then
           TAUmax = TAUtot(iL)
           write(80,*) 'TAUmax', iL, lambda(iL), TAUmax,
     c       TAUfid, SigmaA(nG,iL), SigmaS(nG,iL), SigExfid
           iil= il+1
        endif
      END DO
      write(80,*) 'TAUmax+1', iiL, lambda(iiL), TAUmax,
     c       TAUfid, TAUtot(iiL)

c -----------------------------------------------------------------------

c      write(*,*) 'deliberate stop line 9238'
c      stop

      RETURN
      END
c ***********************************************************************



c ***********************************************************************
      SUBROUTINE getETAzp(ETAzp)
c =======================================================================
c This function calculates ETAzp(iP,iZ) along the line of sight with
c impact parameter P(iP) and iZ=1, nZ. Here iZ = 1 corresponds to z=0
c and iZ=nZ to the outer edge. Other grid points coincide with the
c radial grid. The method used is spline approximation for normalized
c density distribution ETA, with subsequent z-integration performed
c analytically in function IntETA
c                                               [ZI,Feb'95; MN,Aug'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iYfirst, YPequal, Plast
      DIMENSION iYfirst(npP), YPequal(npP), Plast(npY)
      COMMON /Yfirst/ iYfirst, YPequal, Plast
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER iP, nZ, iZ, iW
      DOUBLE PRECISION ETAzp(npP,npY), IntETA, auxEta, w1, w2
c -----------------------------------------------------------------------
c     loop over impact parameters
      DO iP = 1, nP
c       maximal number of points along tangential position, z
        nZ = nY + 1 - iYfirst(iP)
c       starting values for z and ETAzp(iP,iZ)
        IF (P(iP).GE.1.0) THEN
          w2 = P(iP)
          ELSE
          w2 = 1.0
        END IF
c       initialize ETAzp(iP,iZ)*TAUtot(iL)
        ETAzp(iP,1) = 0.0
c       loop over z
        DO iZ = 2, nZ
c         index for local radius, w2
          iW = iYfirst(iP) + iZ - 1
c         limits for integration
          w1 = w2
          w2 = Y(iW)
c           find next step in ETAzp
            auxEta = IntETA(P(iP),iW-1,w1,w2)
c           add next step in ETAzp
            ETAzp(iP,iZ) = ETAzp(iP,iZ-1) + auxEta
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION IMAGFN(y)
c =======================================================================
c This function evaluates auxiliary functions needed to produce
c visibility curves and convolved images. It is called from the image
c integration subroutine ROMBY.                        [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, y, PSFN, Bessel
      INTEGER ftype
      DOUBLE PRECISION Ckn, Cxout, Cphi, Cqtheta
      COMMON /imfn1/ ftype
      COMMON /imfn2/ Ckn, Cxout, Cphi, Cqtheta
c -----------------------------------------------------------------------
      IF (ftype.EQ.1) THEN
c       this part is for convolution
        x = sqrt(abs(Cxout*Cxout+y*y-2.*Cxout*y*dcos(Cphi)))
        imagfn = PSFN(x) * y**Ckn
      ELSE
c       this part is for visibility
c       argument is Pi*q*y (not 2*Pi*q*y) to account for the fact that
c       theta1 is diameter rather than radius (so V is function of
c       q*theta1, like in IE, '96, MNRAS 279, 1019)
        imagfn = Bessel(2.*ASIN(1.0)*Cqtheta*y) * y**Ckn
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE MIE(npL,nL,lambda,Ere,Eim,npA,nA,a,nG1,Qabs,Qsca)
c =======================================================================
c This subroutine calculates Qabs and Qsca for a given diffractive
c index Ere, Eim, wavelength lambda and size a. Here, lambda is an
c array (1..nL), Ere and Eim are given on this array, a is an array
c of sizes (1..nA). Qabs and Qsca are arrays (nG1..nG1+nA,nL), i.e. for
c each wavelength lambda, Qabs and Qsca are evaluated for nA different
c sizes. The numbering, however, does not start from 1, but rather from
c nG1.                                                [Z.I., Aug. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npL, nL, npA, nA, nG1, iL, iA
      DOUBLE PRECISION lambda(npL), Ere(npL), Eim(npL), a(npA),
     &       Qabs(npA,npL), Qsca(npA,npL)
      REAL xx, Qex, Qsc, Qback
      COMPLEX refrel, s1(200), s2(200)
c -----------------------------------------------------------------------
c     loop over wavelengths
      DO iL = 1, nL
c       complex index of refraction
        refrel = cmplx(Ere(iL),Eim(iL))
c       loop over sizes
        DO iA = 1, nA
c         size parameter
          xx= 2.d0*3.14159265d0*a(iA)/lambda(iL)
c         if size parameter xx>100 use xx=100 (geometrical optics)
          IF (xx.GT.100.0) xx = 100.0
c         calculate efficiencies

c     exact spherical particles
          CALL bhmie(xx,refrel,2,s1,s2,Qex,Qsc,Qback)
c          write(80,*)'SPH ',iL,refrel,lambda(iL),iA,a(iA),xx,Qex-Qsc,Qsc

c     distribution of hollow spheres
c     max. vacuum volume fraction is hardcoded in the subroutine
c          CALL DHS( a(iA), lambda(iL), refrel, Qex,Qsc)
c          write(80,*)'DHS ',iL,refrel,lambda(il),iA,a(iA),xx,Qex-Qsc,Qsc

c         store the result
          Qabs(nG1+iA-1,iL) = Qex - Qsc
          Qsca(nG1+iA-1,iL) = Qsc

        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      DOUBLE PRECISION FUNCTION PSFN(x)
c =======================================================================
c This function evaluates the point spread function. For psftype.EQ.1
c the function is evaluated as a sum of two Gaussians, for psftype.EQ.2
c it is provided by user in a file. psftype and all other relevant
c parameters come from COMMON /psf/ and are initialized in subroutine
c INPUT.                                               [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      DOUBLE PRECISION x
      INTEGER idummy
      INTEGER psftype, Npsf, iLambda
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000), x1, eps
      real bessj1
      COMMON /psf1/ iLambda, psftype, Npsf
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
c -----------------------------------------------------------------------
      eps= kPSF(iLambda)
      x1= 3.141592654d0 * x/fwhm1(iLambda)

c      write(*,*) 'psfn', eps, ilambda, psftype
      IF (psftype.LT.4) THEN
        psfn = dexp(-(1.665d0*x/FWHM1(iLambda))**2.)
        IF (psftype.EQ.2)
     &    psfn = (psfn + kPSF(iLambda) *
     &         dexp(-(1.665d0*x/FWHM2(iLambda))**2.))/(1.+kPSF(iLambda))

        IF (psftype.EQ.3) then
         if (x1 .eq. 0.) x1= 0.001d0
         psfn = (2.d0* ( bessj1(x1)- eps*bessj1(eps*x1) )/ x1 )**2
        endif

      ELSE
        CALL LinInter(1000,Npsf,xpsf,ypsf,x,idummy,psfn)
      ENDIF
c -----------------------------------------------------------------------
c      write(*,*) x, x1, psfn
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE setupETA
c =======================================================================
c This subroutine finds spline coefficients ETAcoef (defined in file
c 'density.inc') such that normalized density function ETA(Y(iY)) is:
c ETAcoef(iY,1)+ETAcoef(iY,2)/Y(iY)+...+ETAcoef(iY,2)/Y(iY)^3
c If spline approximation differs more than maxerr (see below) at the
c midpoint, then a straight line is used instead. (In case of wavelength
c depend. ETA, use ETAfun where any new dens. laws should be described).
c Coefficients ETAcoef are later used in getETAzp to calculate ETAzp.
c                                                [ZI, Feb'96; MN,Aug'97]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iY, iC
      DOUBLE PRECISION coef(npY,4), ETA, maxerr, Ymid, Yinverse(npY),
     &       ETAaux(npY), ETAmid(npY)
c -----------------------------------------------------------------------
c       generate input function for SPLINE2
        DO iY = 1, nY
          Yinverse(iY) = 1. / Y(iY)
          ETAaux(iY) = ETA(Y(iY))
          IF (iY.LT.nY) THEN
            Ymid = dsqrt(Y(iY)*Y(iY+1))
            ETAmid(iY) = ETA(Ymid)
          END IF
        END DO
c       calculate spline coefficients
        CALL SPLINE2(Yinverse,ETAaux,nY,coef)
c       check and fix spline coefficients
        maxerr = 0.1
c       RDW is initialized in Input   	
        CALL CHKSPLIN(Yinverse,ETAaux,ETAmid,nY,coef,maxerr,RDW)
c       copy coefficients to the output array ETAcoef
        DO iY = 1, nY
          DO iC = 1, 4
            ETAcoef(iY,iC) = coef(iY,iC)
          END DO
        END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION SizeDist(q,aa,sdtype,a0)
c =======================================================================
c This subroutine calculates size distribution n(a) for a=aa. The size
c distribution is MRN type n(a)~1/a**q for sdtype.LE.2 and KMH type
c n(a)~dexp(-a/a0)/a**q otherwise
c                                                      [Z.I., Aug. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER sdtype
      DOUBLE PRECISION aa, a0, q
c -----------------------------------------------------------------------
      IF (sdtype.LE.2) THEN
        SizeDist = 1.0/aa**q
        ELSE
        SizeDist = dexp(-aa/a0)/aa**q
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Spectral(model,denstyp,nL,Lambda)
c =======================================================================
c     This subroutine finds the spectral features for spp and zpp files.
c     It employs SpFeatur().		       		     [MN, Jan'99]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nYok, nPok
      DOUBLE PRECISION
     &       Ude(npL,npY), Uds(npL,npY), Us(npL,npY), fde(npL,npY),
     &       fds(npL,npY), fs(npL,npY), Utot(npL,npY), ftot(npL,npY),
     &       Td(npG,npY), Ubol(npY), fbol(npY), Uchck(npL,npY),
     &       UbolChck(npY), Spectrum(npL), SpecChar(30,99), tauF(npY),
     &       Intens(npL,npP+2), IntOut(20,npP+2), SmC(30,99),
     &       Yok(npY), Pok(npP), tauOut(npL), tauZout(npP+2), F1,
     &       tr(npY), rg(npG,npY), fsL(npL,npY), fsR(npL,npY), Eps(npY)
      COMMON /solution/ Ude, Uds, Us, fde, fds, fs, Utot, ftot, Td,
     &       Ubol, fbol, Uchck, UbolChck, Spectrum, SpecChar, tauF,
     &       Intens, IntOut, SmC, Yok, Pok, tauOut, tauZout, F1,
     &       tr, rg, fsL, fsR, Eps, nYok, nPok
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER i, iL, model, nL, denstyp, Nchar
      PARAMETER (Nchar=11)
      DOUBLE PRECISION Charac(Nchar),Spectr(npL),Lambda(npL)
c -----------------------------------------------------------------------
c     find features for *.spp file
      IF (denstyp.EQ.0) THEN
         DO iL = 1, nL
            Spectr(iL) = ftot(iL,nYok) + ksi*fsR(iL,nYok)
       END DO
      ELSE
         DO iL = 1, nL
            Spectr(iL) = Spectrum(iL)
       END DO
      END IF
      CALL SpFeatur(model,nL,Lambda,Spectr,Charac)
      DO i = 1, Nchar
       SpecChar(i,model) = Charac(i)
      END DO
c     find features for *.zpp file
      IF (denstyp.EQ.0) THEN
         DO iL = 1, nL
            Spectr(iL) = dabs(ftot(iL,1) - fsL(iL,1))
         END DO
       CALL SpFeatur(model,nL,Lambda,Spectr,Charac)
         DO i = 1, Nchar
            SpecChar(i+11,model) = Charac(i)
         END DO
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SpFeatur(model,nL,Lambda,Spectr,Charac)
c =======================================================================
c This subroutine calculates IRAS colors and other spectral quantities
c Filters data from Neugebauer et al, 1984, ApJ, 278, L1.
c Procedure described in Bedijn, 1987, A&A, 186, 136.  [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER i, j, iaux, model, nL
      DOUBLE PRECISION  f1(7), f2(7), f3(7), f4(7), w1(7), w2(7), w3(7),
     &        w4(7), phi(4,7), al(4,7), cl(4), prz(4), tinf(4), flxy(9),
     &        wav(9), lambda(npL), Spectr(npL), Charac(11), wmid, flx1,
     &        flx2, faux, B98, B11, rat9818, beta813, beta1422, f12,
     &        f25, f60, f100, an98, f98c, f11c, an11
c -----------------------------------------------------------------------
c     Data for 4 IRAS filters
c     wavelengths
       DATA w1/7.55, 8.0, 10.3, 11.5, 13.4, 14.7, 15.5/
       DATA w2/16.6, 22.5, 25.6, 26.8, 27.5, 29.3, 31.1/
       DATA w3/30.5, 40.1, 40.2, 65.2, 74.2, 83.8, 83.9/
       DATA w4/72.7, 95.4, 111.2, 116.6, 137.4, 137.5, 137.6/
c     transmittivities
       DATA f1/0.000, 0.618, 0.940, 0.750, 1.022, 0.906, 0.000/
       DATA f2/0.235, 0.939, 0.939, 0.745, 0.847, 0.847, 0.000/
       DATA f3/0.000, 0.102, 0.260, 1.026, 0.842, 0.001, 0.000/
       DATA f4/0.000, 0.910, 1.000, 0.330, 0.002, 0.001, 0.000/
c     ------------------------------------------------------------
c     initialization
       DO i = 1, 4
         tinf(i) = 0.d0
         cl(i) = 0.d0
       END DO
       DO j = 1, 7
         al(1,j) = w1(j)
         phi(1,j) = f1(j)
         al(2,j) = w2(j)
         phi(2,j) = f2(j)
         al(3,j) = w3(j)
         phi(3,j) = f3(j)
         al(4,j) = w4(j)
         phi(4,j) = f4(j)
       END DO
c ------------------------------------------------------------------------
c     first find IRAS colors
      DO j = 2, nL
c       middle wavelength
        wmid = 0.5d0*(Lambda(j-1)+Lambda(j))
c       interpolate filters for wmid
        CALL PHILAM(wmid,prz,al,phi)
c       convert Spectrum to Flambda
        flx1 = Spectr(j-1) / Lambda(j-1)
        flx2 = Spectr(j) / Lambda(j)
c       add contribution to the integral (index is over filters)
        DO i = 1, 4
          tinf(i) = tinf(i) + prz(i)*0.5d0*(flx2+flx1)*
     &                                   (Lambda(j)-Lambda(j-1))
          cl(i) = cl(i) + prz(i) * (Lambda(j)-Lambda(j-1))
        END DO
      END DO
      DO i = 1, 4
        tinf(i) = tinf(i) / cl(i)
      END DO
c     Spectrum corrected for IRAS filters
      f12 = tinf(1)*12.0
      f25 = tinf(2)*25.0
      f60 = tinf(3)*60.0
      f100 = tinf(4)*100.0
c     now find  B98, B11, F98/F18, beta 8-13, beta 14-22
c     find fluxes at all needed wavelengths (energy increases with index)
      DATA wav/2.2, 8.0, 9.8, 11.3, 13.0, 14.0, 18.0, 22.0, 0.55/
      DO j = 1, 9
        CALL LinInter(npL,nL,lambda,Spectr,wav(j),iaux,faux)
        flxy(j) = faux
      END DO
c     the feature strength at 9.8 and 11.4 microns
      an98 = log(flxy(5)/flxy(2))/log(wav(5)/wav(2))
      f98c = flxy(2)*(wav(3)/wav(2))**an98
      B98 = log(flxy(3)/f98c)
      an11 = log(flxy(5)/flxy(3))/log(wav(5)/wav(3))
      f11c = flxy(3)*(wav(4)/wav(3))**an11
      B11 = log(flxy(4)/f11c)
c     ratio F9.8/F18
      rat9818 = flxy(3)/flxy(7)*wav(7)/wav(3)
c     beta 8-13 and beta 14-22 (see Neugebauer)
      beta813 = log(flxy(5)/flxy(2))/log(13.0/8.0) - 1.0
      beta1422 = log(flxy(8)/flxy(6))/log(22.0/14.0) - 1.0
c     store SpecChar to output array SpecChar
      Charac(1) = B98
      Charac(2) = B11
      Charac(3) = rat9818
      Charac(4) = beta813
      Charac(5) = beta1422
      Charac(6) = flxy(9)
      Charac(7) = flxy(1)
      Charac(8) = f12
      Charac(9) = log10(25.0*f25/f12/12.0)
      Charac(10) = log10(60.0*f60/f12/12.0)
      Charac(11) = log10(f100*100.0/f60/60.0)
c -------------------------------------------------------------------------
      RETURN
      END
c *******************************************************************

c *******************************************************************
      SUBROUTINE PHILAM(Alam,F,Al,Phi)
c     interpolates IRAS filters [f(4)] for a given wavelength alam
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION Phi(4,7), Al(4,7), F(4)
c -----------------------------------------------
      DO i = 1, 4
        F(i) = 0.d0
        im = 0
        istop = 0
        DO WHILE (istop.NE.1)
              im = im + 1
            IF ( (Alam-Al(i,im))*(Alam-Al(i,im+1)).LE.0) THEN
               a = (Phi(i,im+1)-Phi(i,im))
     &           /log10(Al(i,im+1)/Al(i,im))
               b = Phi(i,im) - a*log10(Al(i,im))
               F(i) = a*log10(Alam) + b
            IF ( F(i).GT.1.0 ) F(i) = 1.0
              END IF
            IF (im.EQ.6) istop = 1
        END DO
      END DO
c ------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Visibili(IntOut)
c =======================================================================
c This subroutine finds visibility functions corresponding to IntOut.
c The work horse is subroutine Visi2D, and this subroutine is used to
c prepare everything.                                  [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG, ns
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1, ns= 2000)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER i, j, N1, N2
      DOUBLE PRECISION  IntOut(20,npP+2), Visi(1000), Int1D(npP+2)
      integer imax, vissep(ns), nnv, svis(ns)
      double precision wavevis(ns), yvis(ns),zvis(ns),fwhmvis(ns)
      common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis
      DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
      COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf
c -----------------------------------------------------------------------
c     generate spatial frequency (q) grid
c     first N1 points up to qtheta1=1.22 (Rayleigh limit for a disk)
      N1 = 80
c     first 2 points manually:
c     there must be 0!
      qtheta1(1) = 0.d0
c     make sure the whole envelope is resolved
      qtheta1(2) = 0.5d0 / bOut(nP+2)
        write(80,*) 'qtheta 1,2', qtheta1(1), qtheta1(2)
c     and the rest on logarithmic grid up to 1.22
      DO i = 1, N1-2
        qtheta1(i+2) = qtheta1(2) *(1.22d0/qtheta1(2))**(i*1.0/(N1-2))
        write(80,*) 'qtheta ',i, qtheta1(i+2)
      END DO
c     envelope is well sampled, now to be sure that the star will be OK
c     for small taus add N2 points on a logarithmic grid up to 1.22/p*
      N2 = 24
      DO i = 1, N2
        qtheta1(N1+i) = 1.22d0 / bOut(2)**(i*1.0/(N2-2))
        write(80,*) 'qtheta ',i, qtheta1(N1+i)
      END DO
      Nvisi = N1 + N2
c     find visibility wavelength by wavelength
      DO j = 1, NlambdaOut

c     MG 06.10.09 FOV of unit telescope or seeing maybe smaller than shell!!
c     number is only available for visibility curves
         if (fwhmvis(j) .le. 0.d0) fwhmvis(j)= 999999.
         do i= 1,np+2
            if (bout(i) .gt. fwhmvis(j)/(0.5*theta1)) goto 111
         enddo
 111     continue
         imax= max(2, min(np+2, i))
         write(80,*) 'fov vis',j,np+2, fwhmvis(j),theta1,imax,bout(imax)


        DO i = 1, imax
          Int1D(i) = IntOut(j,i)
          CALL CHKRANGE(dynrange,Int1D(i))
          IF (Int1D(i).LT.dynrange) Int1D(i)=0.0
        END DO
c     OLD
c        CALL Visi2D(npP+2,nP+2,bOut,Int1D,1000,N1+N2,qtheta1,Visi)
c     MG 23.11.10
        CALL Visi2D(npP+2, imax, bOut,Int1D,1000,N1+N2,qtheta1,Visi)
c       copy 1D convolved visibility to Visib
        DO i = 1, N1+N2
c         check dynamic range
          CALL CHKRANGE(dynrange,Visi(i))
          Visib(j,i) = Visi(i)
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE Visi2D(NinMax,Nin,Xin,Yin,Noutmax,Nout,Xout,Yout)
c =======================================================================
c This subroutine finds the visibility function (the spatial Fourier
c transform of the intensity distribution) corresponding to the
c intensity Yin(Xin[i]), i=1,Nin. Visibility, Yout, is evaluated at q
c positions (spatial frequency) given in Xout[i], i=1,Nout. Maximum size
c of Xin is NinMax, maximum size of Xout is NoutMax. The Bessell function
c of the zeroth order is provided separately. The integration is done by
c calling subroutine ROMBY (Bessell function is called from IMGFN).
c Note:
c The visibility function V(q) for a circularly symmetric intensity
c I(x) is:
c          V(q) = F(q)/F(0)
c where Jo is the Bessell function of the zeroth order, and
c          F(q) = Int[Jo(2Pi*q*x)*I(x)*2Pi*x*dx]
c Note that F(0) is nothing more than flux. For more details see
c Ivezic & Elitzur, 1996, MNRAS, 279, 1019 and ref. therein.
c                                                      [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      INTEGER NinMax, Nin, NoutMax, Nout, iq, iXin
      DOUBLE PRECISION Xin(NinMax), Yin(NinMax), Xout(NoutMax), A, B
      DOUBLE PRECISION Yout(NoutMax), F(1000), F0, int1, int2, imagfn
      INTEGER ftype
      DOUBLE PRECISION Ckn, Cxout, Cphi, Cqtheta
      COMMON /imfn1/ ftype
      COMMON /imfn2/ Ckn, Cxout, Cphi, Cqtheta
      EXTERNAL imagfn
c -----------------------------------------------------------------------
c     loop over spatial frequency q (= Xout)
      DO iq = 1, Nout
        Cqtheta = Xout(iq)
        F(iq) = 0.d0
c       loop over radial positions
c     MG 29.07.09 corrected a bug. Upper index should be Nin-1, not Nin as originally!
        DO iXin = 1, Nin-1
c         find F(q)
          ftype = 2
          Ckn = 1.0
          CALL ROMBY(imagfn,Xin(iXin),Xin(iXin+1),int1)
          Ckn = 2.0
          CALL ROMBY(imagfn,Xin(iXin),Xin(iXin+1),int2)
c         contribution from this annulus (lin. approx. for intensity)
          A = Xin(iXin+1)*Yin(iXin)-Xin(iXin)*Yin(iXin+1)
          A = A /(Xin(iXin+1)-Xin(iXin))
          B = (Yin(iXin+1)-Yin(iXin))/(Xin(iXin+1)-Xin(iXin))
          F(iq) = F(iq) + A*int1 + B*int2
        END DO
      END DO
c     flux
      F0 = F(1)
      DO iq = 1, Nout
       IF(F0.EQ.0.d0) THEN
         Yout(iq) = 0.d0
       ELSE
         Yout(iq) = dabs(F(iq) / F0)
       END IF
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ======================================================================
c This is the file with auxiliary math and number-to-string conversion
c subroutines.                                             [MN, Mar,99]
c ======================================================================
C     Table of Contents
C
C     ADD
C     ADD2
C     ANALINT
C     Attach
C     BESSEL
C     BHMIE
C     CHKRANGE
C     CHKSPLIN
C     Clean
C     EMPTY
C     FileMSG
C     FindErr
C     FINDMAX
C     FINDRMS
C     GETFS
C     H
C     KRON
C     LINE
C     LININTER
C     LINSYS
C     LUBKSB
C     LUDCMP
C     MAKETABLE
C     MAPLE3
C     MIDSQL
C     MPROVE
C     MSG
C     MULTIPLY
C     MULTIP2
C     MYSPLINE
C     POLINT
C     POWERINT
C     PRODUCT
C     ROMBERG2
C     ROMBY
C     SCALETO1
C     SHIFT
C     SIMPSON
C     SORT
C     SPLINE
C     SPLINE2
C     SPLINT
C     TRAPZD
C     WriteOut
C     ZBRAC
C     ZRIDDR
c ======================================================================


c **********************************************************************
      SUBROUTINE ADD(np1,nr1,np2,nr2,q1,q2,q3,qOut)
c ======================================================================
c This subroutine evaluates the following expression:
c [qOut] = [q1] + [q2] + [q3]. qout, q1, q2 and q2 are matrices of
c physical size (np2,np1) and real size (nr2,nr1).     [Z.I., Nov. 1995]
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER  np1, nr1, np2, nr2, i2, i1
      DOUBLE PRECISION  q1(np2,np1), q2(np2,np1), q3(np2,np1),
     &       qOut(np2,np1)
c ----------------------------------------------------------------------
c     loop over index 2
      DO i2 = 1, nr2
c       loop over index 1
        DO i1 = 1, nr1
          qOut(i2,i1) = q1(i2,i1) +  q2(i2,i1) + q3(i2,i1)
        END DO
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c **********************************************************************

c **********************************************************************
      SUBROUTINE ADD2(flxS,flxE,fBSum,nY)
c ======================================================================
c This subroutine is auxiliary for finding the bolometric
c components of the scattered and emitted diffuse flux.   [MN, May'99]
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, iY
      DOUBLE PRECISION flxS(npL,npY), flxE(npL,npY), flxSB(npY),
     &          flxEB(npY), fBSum(npY)
c ----------------------------------------------------------------------
      CALL Bolom(flxS,flxSB)
      CALL Bolom(flxE,flxEB)
      DO iY = 1, nY
        fBSum(iY) = flxSB(iY) + flxEB(iY)
      END DO
c ----------------------------------------------------------------------
      RETURN
      END
c **********************************************************************

c **********************************************************************
      SUBROUTINE ANALINT(Nanal,xaux,yaux,m,aux,error)
c ======================================================================
c This subroutine calculates integral I(x**m*y(x)*dx). Both y and x are
c 1D arrays, y(i), x(i) with i=1,Nanal. The method used is approximation
c of y(x) by y = P(x) + d/sqrt(1-x*x), where P(x) is the polynomial of
c order Nanal-1, and analytic evaluation of the integral. It is assumed
c that xaux(1)=0. Coefficients are determined from the set of Nanal
c linear equations and subsequent call to the linear system solver
c LINSYS.                                              [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER iWARNING, iERROR, iCUMM
      COMMON /status/ iWARNING, iERROR, iCUMM
      INTEGER i, j, Nanal, error
      DOUBLE PRECISION xaux(Nanal), yaux(Nanal), coeff(4), A(npY,npY),
     &               m, aux, b
c ----------------------------------------------------------------------
      error = 0
c     generate matrix A and vector B
      DO i = 1, Nanal
        DO j = 1, Nanal-1
          IF (xaux(i).EQ.0.0.AND.j.EQ.1) THEN
            A(i,j) = 1.d0
          ELSE
            A(i,j) = xaux(i)**(1.0*j-1.0)
          END IF
        END DO
        A(i,Nanal) = 1.d0/sqrt(1.d0-xaux(i)*xaux(i))
      END DO

c     solve for the coefficients
      CALL LINSYS(Nanal,A,yaux,coeff,error)
        IF(error.NE.0) THEN
         CALL MSG(19)
         iERROR = iERROR + 1
         RETURN
        END IF
c     upper limit for integration:
      b = xaux(Nanal)
c     evaluate m-dependent contribution of the last term
      IF (m.GT.0.1) THEN
        IF (m.GT.1.1) THEN
c         this is for m=2
          aux = 0.5d0*(DASIN(b)-b*sqrt(1.-b*b))
        ELSE
c         this is for m=1
          aux = 1.d0 - sqrt(1.d0-b*b)
        ENDIF
      ELSE
c       this is for m=0
        aux = DASIN(b)
      ENDIF
      aux = aux * coeff(Nanal)
c     add contribution from the polynom
      DO i = 1, Nanal-1
        aux = aux + coeff(i) * (b**(m+1.0*i)) / (m+1.0*i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Attach(root,length,ext,fname)
c     Attaches extensions to the root cleaned by Clean
c =======================================================================
      CHARACTER*(*) root, ext, fname
      INTEGER i, length
c -----------------------------------------------------------------------
      DO i = 1, LEN(fname)
        fname(i:i) = ' '
      END DO
      fname(:length) = root(:length)
      fname(length + 1:) = ext
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

      SUBROUTINE AttachFront(root,length,ext,fname)
c     Adds a string in front of the root cleaned by Clean
c =======================================================================
      CHARACTER*(*) root, ext, fname
      INTEGER i, length
c -----------------------------------------------------------------------
      DO i = 1, LEN(fname)
        fname(i:i) = ' '
      END DO
      fname(:LEN(ext)) = ext
      fname(LEN(ext)+1:LEN(ext)+1+length) = root(:length)

      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE Clean(StrIn, StrOut, Length)
c =======================================================================
c     Find meaningful part of StrIn without leading and trailing junk
c     It is returned left-justified in StrOut, right-padded with blanks
c     The number of meaningful characters is returned in Length.
c     In case of any problems, StrOut is empty. This sub should be used to
c     clean every input filename immediately after DUSTY reads it. [ME,'99]
c =======================================================================
      CHARACTER*(*) StrIn, StrOut
      INTEGER i, first, last, Length
c -----------------------------------------------------------------------
      DO i = 1, LEN(StrOut)
        StrOut(i:i) = ' '
      END DO
      first = 1
      last = LEN(StrIn)
      If (first.gt.last) return
c     Find end of leading junk:
      DO WHILE (StrIn(first:first).LE.' ')
       first = first + 1
       if (first.gt.last) return
      END DO
c     Find start of trailing junk:
      DO WHILE (StrIn(last:last).LE.' ')
       last = last - 1
       if (last.lt.first) return
      END DO
c     Now trim all junk:
      StrOut = StrIn(first:last)
      Length = last - first + 1
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION Bessel(x)
c =======================================================================
c This function evaluates the Bessell function of the zeroth kind.
c Formulae are from Abramowitz & Stegun.               [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      INTEGER i
      DOUBLE PRECISION x, c(6), Pi
c -----------------------------------------------------------------------
      Pi = 2.d0*ASIN(1.d0)
      c(1) = -2.2499997d0
      c(2) =  1.2656208d0
      c(3) = -0.3163866d0
      c(4) =  0.0444479d0
      c(5) = -0.0039444d0
      c(6) =  0.00021d0
      Bessel=0.d0
      IF (x.LE.3.d0)THEN
        DO i= 1,6
          Bessel = Bessel + c(i)*(x/3.d0)**(2.0*i)
        END DO
        Bessel = 1.d0 + Bessel
        ELSE
        Bessel = sqrt(2.d0/Pi/x) * dcos(x-Pi/4.d0)
      ENDIF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
c This subroutine obtained from prof. P. Menguc, Dept. of Mechanical
c Eng., University of Kentucky.                        [Z.I., Aug. 1996]
c -----------------------------------------------------------------------
c     __________________________________________________________________
c
c     SUBROUTINE BHMIE CALCULATES AMPLITUDE SCATTERING MATRIX ELEMENTS
C     & EFFICIENCIES FOR EXTINCTION, TOTAL SCATTERING AND BACSCATTERING,
C     FOR A GIVEN SIZE PARAMETER AND RELATIVE REFRACTIVE INDEX
C     __________________________________________________________________
C
      subroutine bhmie (x,refrel,nang,s1,s2,qext,qsca,qback)
      dimension amu(100),theta(100),pi(100),tau(100),pi0(100),pi1(100)
      complex d(3000),y,refrel,xi,xi0,xi1,an,bn,s1(200),s2(200)
      double precision psi0,psi1,psi,dn,dx
      dx=x
      y=x*refrel
c     ___________________________________________________________________
c     series terminated after nstop terms
c     ___________________________________________________________________
      xstop=x+4.*x**.3333 +2.0
      nstop=xstop
      ymod=cabs(y)
      nmx=amax1(xstop,ymod) + 15
      dang=1.570796327/float(nang-1)
      do 555 j = 1,nang
      theta(j)= (float(j)-1.)*dang
555   amu(j)=cos(theta(j))
c     __________________________________________________________________
c     logarithmic derivative d(j) calculated by downward recurrence
c     beginning with initial value 0.0 + i*0.0 at j = nmx
c     __________________________________________________________________
c
      d(nmx)=cmplx(0.0,0.0)
      nn=nmx-1
      do 120 n=1,nn
      rn=nmx-n+1
      d(nmx-n)=(rn/y)-(1./(d(nmx-n+1)+rn/y))
120   continue
      do 666 j=1,nang
      pi0(j)=0.0
      pi1(j)=1.0
666   continue
      nn=2*nang-1
      do 777 j=1,nn
      s1(j)=cmplx(0.0,0.0)
      s2(j)=cmplx(0.0,0.0)
777   continue
c     __________________________________________________________________
c     riccati bessel functions with real argument x calculated by upward
c     recurrence
c     __________________________________________________________________
c
      psi0=cos(dx)
      psi1=sin(dx)
      chi0=-sin(x)
      chi1=cos(x)
      apsi0=psi0
      apsi1=psi1
      xi0=cmplx(apsi0,-chi0)
      xi1=cmplx(apsi1,-chi1)
      qsca=0.0
      n=1
200   dn=n
      rn=n
      fn=(2.*rn+1.)/(rn*(rn+1.))
      psi=(2.*dn-1.)*psi1/dx-psi0
      apsi=psi
      chi=(2.*rn-1.)*chi1/x -  chi0
      xi = cmplx(apsi,-chi)
      an=(d(n)/refrel+rn/x)*apsi - apsi1
      an=an/((d(n)/refrel+rn/x)*xi - xi1)
      bn=(refrel *d(n)+rn/x)*apsi - apsi1
      bn=bn/((refrel*d(n)+rn/x)*xi - xi1)
      qsca=qsca+(2.*rn+1.)*(cabs(an)*cabs(an)+cabs(bn)*cabs(bn))
      do 789 j=1,nang
      jj=2*nang-j
      pi(j)=pi1(j)
      tau(j)=rn*amu(j)*pi(j) - (rn+1.)*pi0(j)
      p=(-1.)**(n-1)
      s1(j)=s1(j)+fn*(an*pi(j)+bn*tau(j))
      t=(-1.)**n
      s2(j)=s2(j) + fn*(an*tau(j)+bn*pi(j))
      if (j .eq. jj) go to 789
      s1(jj)=s1(jj) + fn*(an*pi(j)*p + bn*tau(j)*t)
      s2(jj)=s2(jj) + fn*(an*tau(j)*t + bn*pi(j)*p)
789   continue
      psi0=psi1
      psi1=psi
      apsi1=psi1
      chi0=chi1
      chi1=chi
      xi1=cmplx(apsi1,-chi1)
      n=n+1
      rn=n
      do 999 j=1,nang
      pi1(j)=((2.*rn-1.)/(rn-1.))*amu(j)*pi(j)
      pi1(j)=pi1(j) - rn*pi0(j)/(rn-1.)
      pi0(j) = pi(j)
999   continue
      if (n-1-nstop) 200, 300, 300
300   qsca=(2./(x*x))*qsca
      qext=(4./(x*x))*real(s1(1))
      qback=(4./(x*x))*cabs(s1(2*nang -1))*cabs(s1(2*nang -1))

      return
      end
c ***********************************************************************

*23456789012345678901234567890123456789012345678901234567890123456789012

      subroutine DHS(rad, wl, refrel1, qext, qsca1)

c     calculate Qext, Qsca for a distribution of hollow spheres
c     in the small particle limit.
c     The 'distribution' is one over the vacuum volume fraction, from 0 to fmax.
c     From Min et al 2003 A&A 404, 35


      real qext,qsca1,qabs1
      complex refrel1
      COMPLEX*16 refrel, m2, nom,denom,t1

      refrel= dcmplx( real(refrel1) , imag(refrel1) )
c      write(80,*) refrel, real(refrel1), imag(refrel1)

c     hardcoded value for fmax
c      fmax= 0.01d0
      fmax= 0.8d0

      pi= 3.14159265d0

      vol= 4.d0/3.d0 * pi * rad**3
      waven = 2.0d0 * pi / wl

      m2= refrel**2

      nom= (2.d0*m2+1.d0)*(m2+2.d0)
      denom= nom - 2.d0*fmax*(m2-1.d0)**2

      t1= (6.d0*m2+3.d0)/(2.d0*m2-2.d0)*zlog(nom/denom)

      qabs= waven * vol * dimag( t1 )
      qabs= qabs/(PI*RAD**2) /fmax

      qsca= waven**4 * vol**2 / (2.d0*pi) /(PI*RAD**2) * 3.d0 *
     c      DREAL( t1/3.d0 * DCONJG(t1/3.d0) ) /fmax/fmax


c      write(80,*) m2,t1,qabs,qsca
      qabs1= real(qabs)
      qsca1= real(qsca)

c     MG 19.07.09 Limits imposed for large 2pi a/lambda
c                 which are not correct in small particle limit.
      if (qabs1 .gt. 1.6)   qabs1= 1.6
      if (qsca1 .gt. qabs1) qsca1= qabs1
      qext= qabs1+qsca1

      return
      end
*23456789012345678901234567890123456789012345678901234567890123456789012


c***********************************************************************
      SUBROUTINE CHKRANGE(dr,x)
c=======================================================================
c This subroutine checks if x is within the allowed range defined by
c dr<<1:
c         dr**2 < x < 1/dr**2
c If it is not then x = 0.0                            [Z.I., Jan. 1997]
c=======================================================================
      IMPLICIT none
      DOUBLE PRECISION x, dr
c-----------------------------------------------------------------------
      IF ((x-dr*dr)*(x-1./dr/dr).LT.0.0) THEN
        continue
      ELSE
c        continue
        x = 0.0
      END IF
c-----------------------------------------------------------------------
      RETURN
      END
c***********************************************************************

c ***********************************************************************
      SUBROUTINE CHKSPLIN(x,fun,funmid,N,coef,maxerr,RDW)
c ======================================================================
c This subroutine checks the spline coefficients coef(i,j):
c fun(x)=coef(i,1) + coef(i,2)*x + coef(i,3)*x^2 + coef(i,4)*x^3,
c for x(i).LE.x.LE.x(i+1) with i=1..N. Array funmid(1..N-1) contains the
c values of function fun at mid points defined as
c xmid(i)=SQRT(x(i)*x(i+1). If spline approximation produces error
c greater than maxerr, or funmid<0, a straight line is produced between
c x(i) and x(i+1).
c ======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER N, i, iC
      DOUBLE PRECISION x(npY), fun(npY), funmid(npY), coef(npY,4),
     &       maxerr, error, slope, xmid, funSpline, aux, power, yR, yL
      LOGICAL RDW
c ---------------------------------------------------------
c       check the midpoints
        DO i = 1, N - 1
          xmid = dsqrt(x(i)*x(i+1))
          funSpline = 0.d0
          DO iC= 1,4
            IF (xmid.EQ.0.0.AND.iC.EQ.1) THEN
              aux = 1.d0
              ELSE
              aux = xmid**(float(iC)-1.0)
            END IF
            funSpline = funSpline + coef(i,iC)*aux
          END DO
          error = DABS((funSpline-funmid(i))/funmid(i))
c         check for the deviation at the midpoint
          IF (error.GE.maxerr.OR.funSpline.LE.0.0) THEN
            slope = (fun(i+1) - fun(i)) / (x(i+1)-x(i))
            coef(i,1) = fun(i) - x(i) * slope
            coef(i,2) = slope
            coef(i,3) = 0.d0
            coef(i,4) = 0.d0
          END IF
c         check for the logarithmic derivative (only for RDW)
          IF(RDW) THEN
            yL = fun(i)
            yR = fun(i+1)
            IF (x(i)*x(i+1).GT.0.AND.yL*yR.GT.0) THEN
              power = log(yR/yL)/log(x(i+1)/x(i))
              IF (abs(power).GT.10.d0) THEN
                slope = (yR - yL) / (x(i+1)-x(i))
                coef(i,1) = yL - x(i) * slope
                coef(i,2) = slope
                coef(i,3) = 0.d0
                coef(i,4) = 0.d0
              END IF
            END IF
          END IF
        END DO
c ---------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE CHKSPLINold(x,fun,funmid,N,coef,maxerr)
c =======================================================================
c This subroutine checks the spline coefficients coef(i,j):
c fun(x)=coef(i,1) + coef(i,2)*x + coef(i,3)*x^2 + coef(i,4)*x^3,
c for x(i).LE.x.LE.x(i+1) with i=1..N. Array funmid(1..N-1) contains the
c values of function fun at mid points defined as
c xmid(i)=SQRT(x(i)*x(i+1). If spline approximation produces error
c greater than maxerr, or funmid<0, a straight line is produced between
c x(i) and x(i+1).                                     [Z.I., Feb. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER N, i, iC
      DOUBLE PRECISION x(npY), fun(npY), funmid(npY), coef(npY,4), aux,
     &     funSpline, maxerr, error, slope, xmid
c -----------------------------------------------------------------------
c       check the midpoints
        DO i = 1, N - 1
          xmid = dsqrt(x(i)*x(i+1))
          funSpline = 0.d0
          DO iC= 1,4
            IF (xmid.EQ.0.0.AND.iC.EQ.1) THEN
              aux = 1.d0
              ELSE
              aux = xmid**(float(iC)-1.0)
            END IF
            funSpline = funSpline + coef(i,iC)*aux
          END DO
          error = DABS((funSpline-funmid(i))/funmid(i))
          IF (error.GE.maxerr.OR.funSpline.LE.0.0) THEN
            slope = (fun(i+1) - fun(i)) / (x(i+1)-x(i))
            coef(i,1) = fun(i) - x(i) * slope
            coef(i,2) = slope
            coef(i,3) = 0.d0
            coef(i,4) = 0.d0
          END IF
        END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      INTEGER FUNCTION EMPTY(line)
c =======================================================================
c This function is 1 if string 'line' is empty, or if it contains only
c '%', and 0 otherwise.
c                                                      [Z.I., Nov. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER i, iTeX, l
      CHARACTER ch
      CHARACTER*(*) line
c -----------------------------------------------------------------------
      l = LEN(line)
      EMPTY = 1
      iTeX = 0
      DO i = 1, l
        ch = line(i:i)
        IF(EMPTY.EQ.1.AND.ch.EQ.'%') iTeX = 1
         IF (ch.NE.' ') EMPTY = 0
      END DO
      IF (iTeX.EQ.1) EMPTY = 1
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE FileMSG(fname,strg)
c =======================================================================
c     Prints a message in *.out file in case of error opening the user
c     supplied files.
c =======================================================================
      IMPLICIT NONE
      CHARACTER aux*230, strg*(*), fname*(*)
      INTEGER length, Empty
c -----------------------------------------------------------------------
1     read(1,'(a)') aux
      IF (Empty(aux).EQ.1) goto 1
      CALL Clean(aux,fname,length)

      open(10, ERR=100, FILE=fname, STATUS='OLD')
      close(10)
	RETURN

100   write(12,*)' *** FATAL ERROR IN DUSTY! **************************'
      write(12,*)' File with the ',strg
      write(12,'(a2,a)')'  ',fname
      write(12,*)' is missing ?!'
      write(12,*)' ****************************************************'
      close(12)
c -----------------------------------------------------------------------
      STOP
      END
c ***********************************************************************

c *************************************************************************
      SUBROUTINE FindErr(fbol,maxFerr,nY)
c ========================================================================
c This subroutine finds maximum err in flux conservation for both
c spherical and slab case as (fmax-fmin)/(fmax+fmin)   [MN,Aug'99]
c =========================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER nY, iY
      DOUBLE PRECISION fbol(npY), maxFerr, fmin, fmax, aux
c -----------------------------------------------------------------------
c     Find the min and max of fbol values
c     The abs and lower limit on fbol are protection for the case
c     of completely symmetric slab illumination. The lower limit
c     is bound by the numerical accuracy of the flux calculation
        fmin = 1.d5
        fmax = 0.d0
        DO iY = 1, nY
           aux = fbol(iY)
           IF (ksi.eq.1.d0) aux = dabs(aux)
           IF (dabs(aux).LE.accFbol) aux = accFbol
           IF(aux.LT.fmin) fmin = aux
           IF(aux.GT.fmax) fmax = aux
        END DO
        if (fmax.LT.0.d0) then
c     bad solution; overall flux cannot be negative
            maxFerr = 1
        else
            maxFerr = (fmax - fmin)/(fmax + dabs(fmin))
        end if
c -----------------------------------------------------------------------
      RETURN
      END
c *************************************************************************


c ***********************************************************************
      SUBROUTINE FindMax(NN,i1,i2,A,Amax)
c =======================================================================
c This subroutine finds maximum values, Amax, of an array A(nY) between
c values A(i1) and A(i2).                              [Z.I., Jul. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER NN, i1, i2, i
      DOUBLE PRECISION A(NN), Amax
c -----------------------------------------------------------------------
      Amax = A(i1)
c     loop over radial positions
      DO i = i1, i2
        IF (A(i).GT.Amax) Amax = A(i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c =======================================================================



c ***********************************************************************
      SUBROUTINE FindRMS(typ,X,val,accur,N)
c =======================================================================
c Finds relative deviations 'accur' of an array X(N) from a given value val.
c For typ=1 accur is maximal deviation, and for typ=2 the rms deviation.
c                                                         [ZI'95; MN'99]
c =======================================================================
      IMPLICIT NONE
      INTEGER N, i, typ
      DOUBLE PRECISION X(N), val, accur, ss, dev
c -----------------------------------------------------------------------
      IF (typ.EQ.1) THEN
        accur = 0.d0
        DO i = 1, N
          dev = (X(i)-val)/val
          IF (DABS(dev).GT.accur) accur = DABS(dev)
        END DO
      ELSE
        ss = 0.d0
        DO i = 1, N
          dev = X(i)-val
          ss = ss + dev*dev
        END DO
        accur = sqrt(ss/N/(N-1.))
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE GetFS(xx,nm,flag,str)
c =======================================================================
c This subroutine writes number xx to a string str according to a format
c f?.nm. Here ? stands for the number of needed places. A blank is
c inserted at the beginning, and for flag.NE.1 another one if number is
c positive. If xx<0 second blank is replaced by '-'. For example, for
c flag=0 and xx = -0.1234E+02, calling this subroutine with nm=1 will
c result in str = ' -12.3', while xx = 0.0123 with nm=3 gives '  0.012'.
c If flag=1 minus will be ignored, for example xx = -0.1234E+02 and nm=1
c will result in str = ' 12.3',                        [Z.I., Nov. 1996]
c =======================================================================
      IMPLICIT none
      CHARACTER ch
      CHARACTER*(*) str
      INTEGER  flag, nm, db, i, d(20), j, k, dnmp1
      DOUBLE PRECISION xx, x, rest
c -----------------------------------------------------------------------
      DO i = 1, len(str)
        str(i:i) = ' '
      END DO

      x = xx
      str(1:1) = ' '
      i = 2
      IF (flag.NE.1) THEN
         IF (x.LT.0.0) THEN
           str(i:i) = '-'
         ELSE
           str(i:i) = ' '
         END IF
         i = i + 1
      END IF
      IF (x.LT.0.0) x = -x
c     first check if x will have to be rounded up
c     find (nm+1)-th decimal digit
      dnmp1 = int(x*10.**(nm+1)-int(x*10.**nm)*10.)
      IF (dnmp1.GE.5) x = x + 1./10.0**nm
      IF (x.GE.1.0) THEN
c       number of digits before the decimal sign
        db = int(log10(x)) + 1
c       copy all these digits to str
        DO j = 1, db
          rest = x
          IF (j.GT.1) THEN
            DO k = 1, j-1
              rest = rest - d(k)*10.**(db-k)
            END DO
          END IF
          d(j) = int(rest/10.**(db-j))
          write(ch,'(i1)')d(j)
          str(i:i) = ch
          i = i + 1
        END DO
        rest = rest - d(db)
        IF (nm.GT.0) THEN
          str(i:i) = '.'
          i = i + 1
        END IF
      ELSE
        str(i:i) = '0'
        i = i + 1
        IF (nm.GT.0) THEN
          str(i:i) = '.'
          i = i + 1
        END IF
        rest = x
      END IF
c     now copy all nm remaining decimal digits to str
      IF (nm.GT.0) THEN
        DO j = 1, nm
          d(j) = int(rest*10.**j)
          IF (j.GT.1) THEN
            DO k = 1, j-1
              d(j)=d(j)-int(d(k)*10.**(j-k))
            END DO
          END IF
          write(ch,'(i1)')d(j)
          str(i:i) = ch
          i = i + 1
        END DO
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      DOUBLE PRECISION FUNCTION H(x1,x2)
c =======================================================================
c This function calculates the step function: H=1 for x1 >= x2 and H=0
c for x1 < x2.                                         [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      DOUBLE PRECISION x1, x2
c -----------------------------------------------------------------------
      IF (x1.GE.x2) THEN
        H = 1.d0
      ELSE
        H = 0.d0
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      INTEGER FUNCTION Kron(i1,i2)
c =======================================================================
c This function is Kronecker delta-function defined as:
c Kron(i1,i2) = 1 for i1=i2
c Kron(i1,i2) = 0 otherwise.                           [Z.I., Dec. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER i1, i2
c -----------------------------------------------------------------------
      IF (i1.EQ.i2) THEN
        Kron = 1
      ELSE
        Kron = 0
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c ***********************************************************************
      SUBROUTINE LINE(com,typ,unt)
c =======================================================================
c This subroutine writes a line into file open as unt. For type = 1
c the line is '---', and for type = 2 '==='.If com=1 a comment sign # is
c added in the beginning (this is when line is used in file headers)
c =======================================================================
      IMPLICIT none
      INTEGER com, typ, unt
c -----------------------------------------------------------------------
      IF(typ.EQ.1) THEN
       IF(com.eq.1) THEN
        write(unt,'(a50)')
     &   '# ------------------------------------------------'
       ELSE
        write(unt,*)'--------------------------------------------------'
       END IF
      ELSE
       IF(com.eq.1) THEN
        write(unt,'(a50)')
     &   '# ================================================'
       ELSE
        write(unt,*)'=================================================='
       END IF
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE LinInter(NN,N,x,y,xloc,iNloc,yloc)
c =======================================================================
c This subroutine performs linear interpolation for y(x) such that
c yloc = y(xloc). It is assumed that x is monotonously increasing.
c                                                      [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER NN, N, i, istop, iNloc
      DOUBLE PRECISION x(NN), y(NN), xloc, yloc
c -----------------------------------------------------------------------
      IF (N.GT.1) THEN
        IF ((x(1)-xloc)*(x(N)-xloc).LE.0.d0) THEN
          istop = 0
          i = 1
          DO WHILE (istop.NE.1)
            i = i + 1
            IF (i.GT.N) stop 'LinInter ???'
            IF (x(i).GE.xloc) THEN
              istop = 1
              iNloc = i
              yloc = y(i-1) + (y(i)-y(i-1))/(x(i)-x(i-1))*(xloc-x(i-1))
            END IF
          END DO
          ELSE
          IF (xloc.LE.x(1)) yloc = y(1)
          IF (xloc.GE.x(N)) yloc = y(N)
        END IF
        ELSE
        yloc = y(1)
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c ***********************************************************************
      SUBROUTINE LINSYS(Nreal,A,B,X,error)
c =======================================================================
c This subroutine solves the set of linear equations [A]*[X] = [B] for
c X [A(k,1)*X(1)+A(k,2)*X(2)+...+A(k,Nreal)*X(Nreal) = B(k), k=1,Nreal).
c The real size of matrix A is Nreal x Nreal and its physical dimension
c is npY x npY, where npY comes from INCLUDE 'userpar.inc'. Both vectors
c B and X have real lengths Nreal. The set is solved by calls to LUDCMP
c and LUBKSB and the solution is improved subsequently by a call to
c MPROVE. These three subroutines are taken from Numerical Recipes.
c                                                      [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER Nreal, indx(npY), i, j, error
      DOUBLE PRECISION A(npY,npY), B(npY), X(npY)
      DOUBLE PRECISION A1(npY,npY), B1(npY), A2(npY,npY), B2(npY), d
c -----------------------------------------------------------------------
      error = 0
c generate DOUBLE PRECISION copies of A and B (two copies because they
c are changed in LUDCMP and LUBKSB, but still needed for MPROVE)
      DO i = 1, Nreal
        B1(i) = B(i)
        B2(i) = B(i)
        DO j = 1, Nreal
           A1(i,j) = A(i,j)
           A2(i,j) = A(i,j)
        END DO
      END DO
c     solve the system
      CALL LUDCMP(A1,Nreal,npY,indx,d,error)
      IF (error.NE.0) RETURN
      CALL LUBKSB(A1,Nreal,npY,indx,B1)
c     improve the solution (saved in B)
      CALL MPROVE(A2,A1,Nreal,npY,indx,B2,B1)
c     copy the improved solution to output vector X
      DO i = 1, Nreal
        X(i) = B1(i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
c =======================================================================
      DIMENSION INDX(NP)
      DOUBLE PRECISION A(NP,NP),B(NP), sum
c -------------------------------------------------------------------
      II=0
      DO 12 I=1,N
      LL=INDX(I)
      SUM=B(LL)
      B(LL)=B(I)
      IF (II.NE.0)THEN
        DO 11 J=II,I-1
          SUM=SUM-A(I,J)*B(J)
11        CONTINUE
      ELSE IF (SUM.NE.0.) THEN
        II=I
      ENDIF
      B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
      SUM=B(I)
      IF(I.LT.N)THEN
        DO 13 J=I+1,N
          SUM=SUM-A(I,J)*B(J)
13        CONTINUE
      ENDIF
      B(I)=SUM/A(I,I)
14    CONTINUE
c -------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE LUDCMP(A,N,NP,INDX,D,error)
c =======================================================================
      PARAMETER (NMAX=10000,TINY=1.0d-20)
      DIMENSION INDX(NP)
      INTEGER error
      DOUBLE PRECISION A(NP,NP),VV(NMAX), D, SUM
c -------------------------------------------------------------------
      error = 0
      D = 1.
      DO I = 1, N
       AAMAX=0.d0
       DO J = 1, N
        IF (DABS(A(I,J)).GT.AAMAX) AAMAX=DABS(A(I,J))
       END DO
c       IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
       IF (AAMAX.EQ.0.) THEN
        error = 5
        RETURN
       ENDIF
       VV(I)=1.d0/AAMAX
      END DO
      DO J = 1 , N
       IF (J.GT.1) THEN
        DO I = 1, J-1
          SUM= A(I,J)
          IF (I.GT.1)THEN
            DO K = 1, I-1
             SUM= SUM-A(I,K)*A(K,J)
            END DO
            A(I,J)=SUM
          ENDIF
        END DO
       ENDIF
       AAMAX=0.
       DO I = J, N
        SUM= A(I,J)
        IF (J.GT.1)THEN
          DO K = 1, J-1
            SUM= SUM-A(I,K)*A(K,J)
          END DO
          A(I,J)= SUM
        ENDIF
        DUM=VV(I)*DABS(SUM)
        IF (DUM.GE.AAMAX) THEN
          IMAX=I
          AAMAX=DUM
        ENDIF
       END DO
       IF (J.NE.IMAX)THEN
        DO K = 1, N
          DUM=A(IMAX,K)
          A(IMAX,K)=A(J,K)
          A(J,K)=DUM
        END DO
        D=-D
        VV(IMAX)=VV(J)
       ENDIF
       INDX(J)=IMAX
       IF(J.NE.N)THEN
        IF(A(J,J).EQ.0.)A(J,J)=TINY
        DUM=1./A(J,J)
        DO I = J+1, N
          A(I,J)=A(I,J)*DUM
        END DO
       ENDIF
      END DO
      IF(A(N,N).EQ.0.)A(N,N)=TINY
c -------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE MakeTable(Elems,rows,cols,unt)
c =======================================================================
c     This is an auxiliary subroutine for print out of tables
c     of Elems(cols,rows) in output unit 'unt'. rows = max{npL,npY}.
c     This array is defined in PrOut as well and if you change its size
c     make sure you do this in both places.                 [MN, Mar'98]
c =======================================================================
      IMPLICIT NONE
      INTEGER npY, npP, npL
      INCLUDE 'userpar.inc'
      INTEGER rows, cols, unt, k, i
      DOUBLE PRECISION Elems(25,1000)
c -----------------------------------------------------------------------
      DO i = 1, rows
        write(unt,'(1p,21E11.3)') (Elems(k,i),k=1,cols)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Maple3(w,z,p,MpInt)
c =======================================================================
c This function calculates indefinite integral:
c    MpInt(iC) = INT(w^(2-iC) / sqrt(w^2-p^2) * dw), for iC=1,2,3,4.
c                                                      [Z.I., Apr. 1996]
c =======================================================================
      IMPLICIT none
      DOUBLE PRECISION w, z, p, MpInt(4)
c -----------------------------------------------------------------------
c     integrals
      MpInt(1) = z
      MpInt(2) = dlog(w+z)
      IF (p.GT.0.d0) THEN
        MpInt(3) = dacos(p/w)/p
        MpInt(4) = z/w/p/p
        ELSE
        MpInt(3) = -1.d0 / w
        MpInt(4) = -0.5d0 / w / w
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE midsql(funk,aa,bb,s,n)
c =======================================================================
      INTEGER n
      DOUBLE PRECISION aa,bb,s,funk
      EXTERNAL funk
      INTEGER it,j
      DOUBLE PRECISION ddel,del,sum,tnm,x,func,a,b
c -----------------------------------------------------------------------
      func(x)=2.*x*funk(aa+x**2)
      b=dsqrt( max(bb-aa, 0.d0) )
      a=0.d0
      if (n.eq.1) then
        s=(b-a)*func(0.5d0*(a+b))
      else
        it=3**(n-2)
        tnm=it
        del=(b-a)/(3.*tnm)
        ddel=del+del
        x=a+0.5d0*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+ddel
          sum=sum+func(x)
          x=x+del
11      continue
        s=(s+(b-a)*sum/tnm)/3.
      endif
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE MPROVE(A,ALUD,N,NP,INDX,B,X)
c =======================================================================
      PARAMETER (NMAX=10000)
      DIMENSION INDX(N)
      DOUBLE PRECISION SDP,A(NP,NP),ALUD(NP,NP),B(N),X(N),R(NMAX)
c -----------------------------------------------------------------------
      DO i = 1, N
       SDP = -B(i)
       DO j = 1, N
         SDP = SDP + A(i,j)*X(j)
       END DO
       R(i) = SDP
      END DO
      CALL LUBKSB(ALUD,N,NP,INDX,R)
      DO i = 1, N
       X(i) = X(i) - R(i)
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE MSG(msgno)
c =======================================================================
c This subroutine writes runtime messages to auxiliary file fname.m##
c or to the output file fname.out.             [ZI,Feb'96; MN,Jul'99]
c =======================================================================
      IMPLICIT none
      CHARACTER*100 zline(999)
      INTEGER iINP, iSUM, iOUT, iVerb, iSPP, iA, iB, iC, iX, NlambdaOut,
     &         iInn, iPsf, iV, Nconv, Nvisi
      DOUBLE PRECISION LambdaOut(20), ConvInt(20,1000), Visib(20,1000),
     &       Offset(1000), qtheta1(1000), Te_min
      COMMON /output/ LambdaOut, ConvInt, Visib, Offset, qtheta1,
     &      Te_min, iPSF, NlambdaOut, iINP, iSUM, iOUT, iVerb, iSPP,
     &      iA, iB, iC, iX, iInn, iV, Nconv, Nvisi, zline
      INTEGER  msgno
c -----------------------------------------------------------------------
      IF (msgno.EQ.1.AND.iX.GT.0) THEN
       write(18,*)' ************  WARNING  ************'
       write(18,*)' Temperature calculation in FindTemp'
       write(18,*)' achieved the limit of 500 iterations'
      END IF
      IF (msgno.EQ.2.AND.iX.GT.0) THEN
       write(18,*)' ************  WARNING  ************'
       write(18,*)' Energy density iterations in RADTRANSF'
       write(18,*)' achieved the limit of 10000 iterations'
      END IF
      IF (msgno.EQ.3) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * Denstyp is not between 1 and 7!*'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.4.AND.iX.GT.0) THEN
       write(18,*)' ************  WARNING  *****************'
       write(18,*)' Could not bracket in Zbrac (in sub FindTemp)'
       write(18,*)' Something might be wrong in your input.     '
      END IF
      IF (msgno.EQ.5) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' *  All abundances must be >= 0!  *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.6) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * Wavelengths for the power-law  *'
       write(12,*)' * spectrum must be ascending!    *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.7) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * Relative luminosities must add *'
       write(12,*)' * up to a number >0!!!           *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.8) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' *    A black body temperature    *'
       write(12,*)' *        should be > 0 !!!       *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.9) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * Flag for optical properties    *'
       write(12,*)' * should be between 1 and 3!!!   *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.10) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * Flag for size distribution     *'
       write(12,*)' * should be between 1 and 3!!!   *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.11) THEN
       write(12,*)' ********** A BIG ERROR ***********'
       write(12,*)' * The flag for external spectrum *'
       write(12,*)' * should be between 1 and 6 !!!  *'
       write(12,*)' * Check input file and try again *'
       write(12,*)' ***********************************'
      END IF
      IF (msgno.EQ.12) THEN
       write(12,*)' ***  FATAL ERROR IN DUSTY  **********'
       write(12,*)' Only three types of the point spread '
       write(12,*)' function are allowed: 1, 2 or 3 !!!  '
       write(12,*)' Check input file and try again       '
       write(12,*)' ***********************************'
      END IF
c     msg 14 is not called in this version.
      IF (msgno.EQ.14.AND.iX.GT.0) THEN
       write(18,*)' ******** MESSAGE FROM SLBSolve *******'
       write(18,*)' Convergence on en.density is too slow.'
       write(18,*)' If the accuracy is not reached yet    '
       write(18,*)' will increase grid size and try again.'
       write(18,*)' **************************************'
      END IF
      IF (msgno.EQ.15) THEN
       write(12,*) ' **************** WARNING ******************'
       write(12,*) '  NO calculation in this case. Parameter npY'
       write(12,*) '  needs to be at least 50. Use of the slab  '
       write(12,*) '  parameters is suggested (see userpar.inc) '
       write(12,*) ' *******************************************'
      END IF
      IF (msgno.EQ.16) THEN
       write(12,*)' ****************  WARNING  ******************'
       write(12,*)'  The density profile Eta is too steep and the'
       write(12,*)'  code can not handle this. Try decreasing the'
       write(12,*)'  outer radius Y (see Manual, 3.3.3).         '
       write(12,*)' *********************************************'
       IF(iX.GT.0) THEN
       write(18,*)' ****************  WARNING  ******************'
       write(18,*)'  The density profile Eta is too steep and the'
       write(18,*)'  code can not handle this. Try decreasing the'
       write(18,*)'  outer radius Y (see Manual, 3.3.3).         '
       write(18,*)' *********************************************'
       END IF
      END IF
      IF (msgno.EQ.17) THEN
       write(12,*)' *****************  WARNING  ********************'
       write(12,*)'  Eta is too steep and reaches values less than  '
       write(12,*)'  1e-12. Try decreasing the outer radius Y.      '
       write(12,*)'  (see Manual,3.3.3)                             '
       write(12,*)' ************************************************'
       IF(iX.GT.0) THEN
       write(18,*)' *****************  WARNING  ********************'
       write(18,*)'  Eta is too steep and reaches values less than  '
       write(18,*)'  1e-12. Try decreasing the outer radius Y.      '
       write(18,*)'  (see Manual,3.3.3)                             '
       write(18,*)' ************************************************'
       END IF
      END IF
      IF (msgno.EQ.18) THEN
       write(12,*)' ************  WARNING  ************************ '
       write(12,*)'  Dynamical range of Eta more than 1.E-12.       '
       write(12,*)'  The outer radius Y must be decreased so that   '
       write(12,*)'  Eta does not go below 1.E-12 (see Manual,3.3.3)'
       write(12,*)' *********************************************** '
       IF(iX.GT.0) THEN
       write(18,*)' ************  WARNING  ************************ '
       write(18,*)'  Dynamical range of Eta more than 1.E-12.       '
       write(18,*)'  The outer radius Y must be decreased so that   '
       write(18,*)'  Eta does not go below 1.E-12 (see Manual,3.3.3)'
       write(18,*)' *********************************************** '
       END IF
      END IF
      IF (msgno.EQ.19) THEN
       write(12,*)' ************ A BIG ERROR!!!************* '
       write(12,*)'  Singular matrix in LUDCMP when called   '
       write(12,*)'  from ANALINT. Stopping the calculation. '
       write(12,*)' **************************************** '
      END IF
      IF (msgno.EQ.20) THEN
       write(12,*)' ************ A BIG ERROR!!! ************ '
       write(12,*)'  Singular matrix in LUDCMP when called   '
       write(12,*)'  from INVERT. Stopping the calculation.  '
       write(12,*)' **************************************** '
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE MULTIPLY(type,np1,nr1,np2,nr2,mat,vec1,omat,flag,q1,q2)
c =======================================================================
c This subroutine evaluates the following expression:
c [q2] = flag*[q1] + [mat]*[tt*vec1]. Here tt is [omat] for type=1 and
c 1-[omat] for type=2. mat is matrix of physical size (np2,np1,np1) and
c real size (nr2,nr1,nr1). omat, vec1, q1 and q2 are matrices of
c physical size (np2,np1) and real size (nr2,nr1).     [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER type, np1, nr1, np2, nr2, flag, i2, i1, idum
      DOUBLE PRECISION mat(np2,np1,np1), vec1(np2,np1), omat(np2,np1),
     &       aux, q1(np2,np1), q2(np2,np1)
c -----------------------------------------------------------------------
c     loop over index 2
      DO i2 = 1, nr2
c       loop over index 1
        DO i1 = 1, nr1
          q2(i2,i1) = flag * q1(i2,i1)
c         loop over dummy index (multiplication)
          DO idum = 1, nr1
            IF (type.EQ.1) THEN
              aux = omat(i2,idum)
              ELSE
              aux = 1.d0 - omat(i2,idum)
            END IF
            q2(i2,i1) = q2(i2,i1) + mat(i2,i1,idum)*aux*vec1(i2,idum)
          END DO
          IF (q2(i2,i1).LT.dynrange*dynrange) q2(i2,i1) = 0.d0
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************



c ***********************************************************************
      SUBROUTINE MULTIP2(type,np1,nr1,np2,nr2,nr3,np3,mat,vec1,omat,q1)
c =======================================================================
c This subroutine evaluates the following expression:
c [q1] = [mat]*[tt*vec1] / 4Pi. Here tt is [omat] for type=1 and
c 1-[omat] for type=2. mat is matrix of physical size (np2,np3,np1) and
c real size (nr2,nr3,nr1). omat and vec1 are matrices of physical size
c (np2,np1) and real size (nr2,nr1). q1 is a matrix of physical size
c (np2,np3) and real size (nr2,nr3)
c 1, 2 and 3 correspond to nY, nL and nP.              [Z.I., Nov. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER nY, nYprev, nP, nL, nPcav
      DOUBLE PRECISION Y(npY), Yprev(npY), P(npP), lambda(npL),
     &       bOut(npP+2)
      COMMON /grids1/ nY, nYprev, nP, nPcav, nL
      COMMON /grids2/ Y, Yprev, P, lambda, bOut
      INTEGER type, np1, nr1, np2, nr2, np3, nr3, i2, i3, idum
      DOUBLE PRECISION mat(np2,np3,np1), vec1(np2,np1), omat(np2,np1),
     &       aux, q1(np2,np3)
c -----------------------------------------------------------------------
c     loop over index 2 (wavelength)
      DO i2 = 1, nr2
c       loop over index 3 (impact parameter)
        DO i3 = 1, nr3
          q1(i2,i3) = 0.d0
c         loop over dummy index (multiplication)
          DO idum = 1, nr1
            IF (type.EQ.1) THEN
              aux = omat(i2,idum)
            ELSE
              aux = 1.d0 - omat(i2,idum)
            END IF
            q1(i2,i3) = q1(i2,i3) + mat(i2,i3,idum)*aux*vec1(i2,idum)
          END DO
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE MYSPLINE(x,N,alpha,beta,gamma,delta)
c =======================================================================
c This subroutine finds arrays alpha, beta, gamma and delta describing
c a cubic spline approximation of an unknown function f(x) given as an
c array f(i)=f(x(i)) with i=1..N. The cubic spline approximation is:
c f(x)=a(i) + b(i)*t + c(i)*t^2 + d(i)*t^3  for x(i).LE.x.LE.x(i+1)
c and t = (x-x(i))/(x(i+1)-x(i)), i=1..N-1. Coefficients a,b,c,d are
c equal to:
c a(i) = alpha(i,1)*f(1) + alpha(i,2)*f(2) + ... + alpha(i,N)*f(N)
c and b,c,d analogously.                               [Z.I., Dec. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER N, i, j, dummy, Kron
      DOUBLE PRECISION x(npY), alpha(npY,npY), beta(npY,npY),
     &       delta(npY,npY), secnder(npY,npY), yaux(npY), deraux(npY),
     &       y2at1, y2atN, D, gamma(npY,npY)
      EXTERNAL Kron
c -----------------------------------------------------------------------
c     generate second derivatives, secnder(j,l)
      DO j = 1, N
        DO dummy = 1, N
          IF (dummy.EQ.j) THEN
            yaux(dummy) = 1.d0
            ELSE
            yaux(dummy) = 0.d0
          END IF
        END DO
        y2at1 = (yaux(2)-yaux(1))/(x(2)-x(1))
        y2atN = (yaux(N)-yaux(N-1))/(x(N)-x(N-1))
        CALL SPLINE(x,yaux,N,y2at1,y2atN,deraux)
        DO i = 1, N
          secnder(i,j) =  deraux(i)
c          secnder(i,j) = 0.0
        END DO
      END DO
c     generate alpha, beta, gamma, delta
      DO i = 1, N-1
        D = (x(i+1) - x(i))*(x(i+1) - x(i)) / 6.d0
        DO j = 1, N
          alpha(i,j) = Kron(i,j)*1.d0
          beta(i,j) = Kron(i+1,j) - Kron(i,j)
          beta(i,j) = beta(i,j) - D*(2.*secnder(i,j)+secnder(i+1,j))
          gamma(i,j) = 3.d0 * D * secnder(i,j)
          delta(i,j) = D*(secnder(i+1,j)-secnder(i,j))
        END DO
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE polint(xa,ya,n,x,y,dy)
c =======================================================================
      INTEGER n,NMAX
      DOUBLE PRECISION dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      DOUBLE PRECISION den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
c -----------------------------------------------------------------------
      ns=1
      dif=DABS(x-xa(1))
      do 11 i=1,n
        dift=DABS(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE PowerInt(N,N1,N2,x,y,integral)
c =======================================================================
c This subroutine calculates integral I(y(x)*dx). Both y and x are
c 1D arrays, y(i), x(i) with i=1,N (declared with NN). Lower and upper
c integration limits are x(N1) and x(N2), respectively. The method used
c is a power-law approximation for y(x) between any two points .
c                                                      [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER i, N, N1, N2
      DOUBLE PRECISION x(N), y(N), integral, pow, C, delint
c -----------------------------------------------------------------------
c     set integral to 0 and accumulate result in the loop
      integral = 0.0d0
c     calculate weight, wgth, and integrate in the same loop
      IF (N2.GT.N1) THEN
        DO i = N1, N2-1
          pow = dlog(y(i+1)/y(i)) / dlog(x(i+1)/x(i))
          C = y(i) / x(i)**pow
          delint = (x(i+1)**(pow+1)-x(i)**(pow+1.))*C/(pow+1.)
c         add contribution to the integral
          integral = integral + delint
        END DO
        ELSE
c        integral = 0.0
        integral = y(1)
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE Product(NN,Yt,pt,sc,p0,s0,j,Prd)
c =======================================================================
c This is an auxiliary subroutine which evaluates a messy expression
c needed to calculate normalization constants for a broken power law
c density.                                             [Z.I., Aug. 1996]
c =======================================================================
c MG 27.08.09 Changed to allow scaling factor in power laws
c =======================================================================
      IMPLICIT none
      INTEGER NN, i, j
      DOUBLE PRECISION Yt(NN), pt(NN), sc(NN), Prd, p0,s0
c -----------------------------------------------------------------------
      Prd = s0 * Yt(1)**(pt(1) - p0)
      IF (j.GT.1) THEN
        DO i = 2, j
          Prd = Prd * sc(i-1) * Yt(i)**(pt(i) - pt(i-1))
        END DO
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE ROMBERG2(a,b,ss8)
c =======================================================================
c This subroutine performs Romberg integration of 8 functions calculated
c in trapzd2 (by calling subroutine TWOFUN) on interval [a,b].
c The results are returned in ss8(1..8). Desired accuracy accRomb is
c user supplied and comes through COMMON /numerics/ read in from
c 'numerics.inc'. This subroutine is based on slightly changed versions
c of 'qromb' and 'qromo' from Numerical Recipes.
c                                                    [MN & ZI,Aug'96]
c =======================================================================
      INTEGER Ncav, Nins
      DOUBLE PRECISION accRomb, accuracy, accConv, delTAUsc, facc,
     &                 dynrange, EtaRat, accFbol
      COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins
      INTEGER fconv(8),JMAX,JMAXP,K,KM, J, iC, idone, kaux
      PARAMETER (JMAX=50, JMAXP=JMAX+1, K=5, KM=K-1)
      DOUBLE PRECISION ss, ss8(8), S2D(8,JMAXP), h(JMAXP), sjKM(JMAXP),
     &                 a, b, EPS, h0, dss, s8(8), chk(8)
c -----------------------------------------------------------------------
      EPS = accRomb
      h0 = 0.d0
      h(1)= 1.d0
c     intialize convergence flags
      DO iC = 1, 8
         fconv(iC) = 0
      END DO
c     integrate until all 8 intergrals converge
      idone = 0
      j = 0
      DO WHILE(idone.NE.1.and.j.LE.JMAX)
        j = j + 1
c       integrate with j division points
        call trapzd2(a,b,s8,j)
        DO iC = 1, 8
           S2D(iC,j) = S8(iC)
        END DO
c       check if any of 8 integrals has converged
        IF (j.ge.K) THEN
           idone = 1
           DO iC = 1, 8
             IF (fconv(iC).EQ.0) THEN
c              generate array for polint
               DO kaux = 1, j
                 sjKM(kaux) = S2D(iC,kaux)
               END DO
c              predict the integral for stepsize h->h0=0.0
               CALL polint(h(j-KM),sjKM(j-KM),K,h0,ss,dss)
               IF (dabs(dss).le.EPS*dabs(ss)) THEN
                 SS8(iC) = ss
                 fconv(iC) = 1
               ELSE
                 chk(iC) = dabs(dss)/dabs(ss)
               END IF
             END IF
             idone = idone*fconv(iC)
           END DO
        END IF
        h(j+1)=0.25*h(j)
      END DO
      IF (j.GE.jMAX) THEN
        write(*,*)' Reached the limiting number of steps in ROMBERG2'
        write(*,*)'You might want to change accRomb in the input file'
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE ROMBY(fnc,a,b,ss)
c =======================================================================
c This subroutine performs Romberg integration of function func on
c interval [a,b]. The result is returned in ss. Desired accuracy is set
c to 0.002.                                            [Z.I., Feb. 1996]
c =======================================================================
      INTEGER JMAX,JMAXP,K,KM, J
      PARAMETER (JMAX=30, JMAXP=JMAX+1, K=3, KM=K-1)
      DOUBLE PRECISION a,b,fnc,ss,EPS, aux, dss,h(JMAXP),s(JMAXP)
      EXTERNAL fnc
c -----------------------------------------------------------------------
      EPS = 0.002d0
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd(fnc,a,b,s(j),j)
        if (j.ge.K) then
          aux = 0.d0
          call polint(h(j-KM),s(j-KM),K,aux,ss,dss)
          IF (dabs(dss).le.EPS*dabs(ss)) RETURN
        endif
        s(j+1)=s(j)
        h(j+1)=0.25d0*h(j)
11    continue
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE ScaleTo1(Nmax,N,Y)
c =======================================================================
c This subroutine scales vector Y such that Y(1) = 1.0
c                                                      [Z.I., Jan. 1997]
c =======================================================================
      IMPLICIT none
      INTEGER Nmax, N, i
      DOUBLE PRECISION Y(Nmax), Scale
c -----------------------------------------------------------------------
      Scale = Y(1)
      DO i = 1, N
        Y(i) = Y(i) / Scale
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SHIFT(X,Nmax,N,Xins,i)
c =======================================================================
c Rearranges a vector X by inserting a new element Xins.    [MN, Aug'96]
c =======================================================================
      implicit none
      integer Nmax, N, i,j
      DOUBLE PRECISION X(Nmax),Xins
c -----------------------------------------------------------------------
      DO j = N+1, i+2, -1
        x(j) = x(j-1)
      END DO
      x(i+1) = xins
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE SIMPSON(N,N1,N2,x,y,integral)
c =======================================================================
c This subroutine calculates integral I(y(x)*dx). Both y and x are
c 1D arrays, y(i), x(i) with i=1,N (declared with NN). Lower and upper
c integration limits are x(N1) and x(N2), respectively. The method used
c is Simpson (trapezoid) approximation. The resulting integral is sum of
c y(i)*wgth, i=N1,N2.                                  [Z.I., Mar. 1996]
c =======================================================================
      IMPLICIT none
      INTEGER i, N, N1, N2
      DOUBLE PRECISION x(N), y(N), wgth, integral
c -----------------------------------------------------------------------
c     set integral to 0 and accumulate result in the loop
      integral = 0.0d0
c     calculate weight, wgth, and integrate in the same loop
      IF (N2.GT.N1) THEN
        DO i = N1, N2
c         weigths
          IF (i.NE.N1.AND.i.NE.N2) THEN
            wgth = 0.5d0 * (x(i+1)-x(i-1))
          ELSE
            IF (i.eq.N1) wgth= 0.5d0 * (x(N1+1)-x(N1))
            IF (i.eq.N2) wgth= 0.5d0 * (x(N2)-x(N2-1))
          END IF
c         add contribution to the integral
          integral = integral + y(i) * wgth
        END DO
      ELSE
        integral = 0.0d0
      END IF
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE SORT(RA,N)
c =======================================================================
      INTEGER N
      DOUBLE PRECISION RA(N)
c -----------------------------------------------------------------------
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
c -----------------------------------------------------------------------
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE Spline(x,y,n,yp1,ypn,y2)
c =======================================================================
      INTEGER n,NMAX
      DOUBLE PRECISION yp1,ypn,x(n),y(n),y2(n)
      PARAMETER (NMAX=500)
      INTEGER i,k
      DOUBLE PRECISION p,qn,sig,un,u(NMAX)
c -----------------------------------------------------------------------
      if (yp1.gt. .99d30) then
        y2(1)=0.
        u(1)=0.
      else
        y2(1)=-0.5
        u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do 11 i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.
        y2(i)=(sig-1.)/p
        u(i)=(6.*((y(i+1)-y(i))/(x(i+
     *1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*
     *u(i-1))/p
11    continue
      if (ypn.gt. .99d30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
      do 12 k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************


c ***********************************************************************
      SUBROUTINE SPLINE2(x,fun,N,coef)
c =======================================================================
c This subroutine finds coefficients coef(i,j) such that
c fun(x)=coef(i,1) + coef(i,2)*x + coef(i,3)*x^2 + coef(i,4)*x^3
c for x(i).LE.x.LE.x(i+1) is a cubic spline approximation of fun(x),
c with i=1..N.                                         [Z.I., Feb. 1995]
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER N, i
      DOUBLE PRECISION x(npY), coef(npY,4), secnder(npY), y2at1, y2atN,
     &       Dd, xL, xR, dR, dL, fun(npY), fL, fR
c -----------------------------------------------------------------------
c     find second derivative, secnder
        y2at1 = (fun(2)-fun(1))/(x(2)-x(1))
        y2atN = (fun(N)-fun(N-1))/(x(N)-x(N-1))
        CALL SPLINE(x,fun,N,y2at1,y2atN,secnder)
c     generate coef(i,j), j=1,2,3,4
      DO i = 1, N-1
        Dd = x(i+1) - x(i)
        xL = x(i)
        xR = x(i+1)
        dL = secnder(i)
        dR = secnder(i+1)
        fL = fun(i)
        fR = fun(i+1)
        coef(i,1) = (xR*fL-xL*fR)/Dd + dL*xR*Dd/6.*((xR/Dd)**2.-1.)
        coef(i,1) = coef(i,1) - dR*xL*Dd/6. *((xL/Dd)**2.-1.)
        coef(i,2) = (fR-fL)/Dd + dL*Dd/6.*(1.-3.*(xR/Dd)**2.)
        coef(i,2) = coef(i,2) - dR*Dd/6.*(1.-3.*(xL/Dd)**2.)
        coef(i,3) = (dL*xR-dR*xL)/Dd/2.
        coef(i,4) = (dR-dL)/6./Dd
      END DO
c -----------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE splint(xa,ya,y2a,n,x,y)
c =======================================================================
      INTEGER n
      DOUBLE PRECISION x,y,xa(n),y2a(n),ya(n)
      INTEGER k,khi,klo
      DOUBLE PRECISION a,b,h
c -------------------------------------------------------------------------
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**
     *2)/6.
c -------------------------------------------------------------------------
      return
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE trapzd(func,a,b,s,n)
c =======================================================================
      INTEGER n
      DOUBLE PRECISION a,b,s,func
      EXTERNAL func
      INTEGER it,j
      DOUBLE PRECISION del,sum,tnm,x
c -------------------------------------------------------------------------
      IF (n.eq.1) THEN
        s=0.5d0*(b-a)*(func(a)+func(b))
      ELSE
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        DO j = 1, it
          sum=sum+func(x)
          x=x+del
        END DO
        s=0.5*(s+(b-a)*sum/tnm)
      END IF
c -------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE WriteOut(is,nG,nameQ,nameNK)
c =======================================================================
      IMPLICIT none
      INTEGER npY, npP, npL, npG
      INCLUDE 'userpar.inc'
      PARAMETER (npG=1)
      INTEGER denstyp, Ntr, iterETA, Eta7OK, nYEta7
      CHARACTER*235 nameETA
      LOGICAL RDW
      DOUBLE PRECISION pow, Yout, ETAcoef(npY,4), ptr(10), Ytr(10),
     &       ETAdiscr(npY), yEta7(1000), Eta7(1000), scl0, scal(10)
      COMMON /density1/ denstyp, Ntr, iterETA, nYEta7, Eta7OK, nameETA
      COMMON /density2/ pow, Yout, ETAcoef, Ytr, ptr, ETAdiscr, Eta7,
     &                  yEta7, scl0, scal, RDW
      INTEGER iLfid, szds, top, Nfiles
      DOUBLE PRECISION TAUtot(npL), SigmaA(npG,npL), SigmaS(npG,npL),
     &     omega(npL,npY), Tsub(npG), abund(npG,npY), TAUmax,
     &     xC(10), xCuser(10), SigExfid, TAUfid, lamfid, qsd,
     &     a1, a2, aveV
      COMMON /optprop/ TAUtot, SigmaA, SigmaS, omega, Tsub, abund,
     &            TAUmax, xC, xCuser, SigExfid, TAUfid, lamfid, qsd,
     &            a1, a2, aveV, iLfid, szds, top, Nfiles
      INTEGER startyp(2), Nlamtr(2), nBB(2)
      CHARACTER nameStar(2)*235
      DOUBLE PRECISION Tstar, lamtr(2,101), klam(2,100), Tbb(2,10),
     &                 rellum(2,10), mu1, ksi, mu2, xSiO, r1rs
      COMMON /source/ Tstar, lamtr, klam, Tbb, rellum, mu1, ksi, mu2,
     &                xSiO, r1rs, startyp, Nlamtr, nBB, nameStar
      INTEGER is, iG, nG, i, length
      CHARACTER*72 strpow, aux, src, chaux*3
      CHARACTER*(*) nameQ(npG), nameNK(10)
c -------------------------------------------------------------------------
      IF (denstyp.eq.0) THEN
       IF (is.eq.1) THEN
        src = 'Left-side source spectrum described by'
       ELSE
        src = 'Right-side source spectrum described by'
       END IF
      ELSE
        src = 'Central source spectrum described by'
      END IF
      CALL Clean(src, aux, length)

c     #1: black body(ies) for startyp=1
      IF (startyp(is).EQ.1) THEN
       IF (nBB(is).GT.1) THEN
         CALL ATTACH(aux, length, ' ', src)
c        multiple black bodies
         write(12,'(a2,a37,i2,a13)')'  ', src, nBB(is),' black bodies'
         write(12,'(a27)')' with temperatures (in K):'
         write(12,'(2x,1p,10e10.3)')(Tbb(is,i),i=1,nBB(is))
         write(12,'(a42)')' and relative luminosities, respectively:'
         write(12,'(1p,10e10.1)')(rellum(is,i),i=1,nBB(is))
       ELSE
c       for a single black body:
        CALL ATTACH(aux,length,' a black body',src)
         write(12,'(a2,a)') '  ',src
         IF (Tstar.LT.9999.999) THEN
           CALL getfs(Tstar,0,1,strpow)
           write(12,'(a19,a5,a2)')' with temperature:',strpow,' K'
         ELSE
           CALL getfs(Tstar,0,1,strpow)
           write(12,'(a19,a6,a2)')' with temperature:',strpow,' K'
         END IF
       END IF
      END IF

c     #2: Engelke-Marengo function for startyp=2
      IF (startyp(is).EQ.2) THEN
         CALL ATTACH(aux, length,' Engelke-Marengo function', src)
         write(12,'(a2,a)') '  ',src
         CALL getfs(Tbb(is,1),0,1,strpow)
         write(12,'(a13,a5,a16)')' with Teff =',strpow,' K and depth of'
         write(12,'(a30,F6.1,a2)')' the SiO absorption feature =',
     &                              xSiO,' %'
      END IF

c     #3: power-law(s) for startyp=3
      IF (startyp(is).EQ.3) THEN
       IF (Nlamtr(is).GT.0) THEN
         CALL ATTACH(aux,length,' power law:',src)
         write(12,'(a2,a)') '  ',src
         write(12,*)'    lambda      k'
         DO i = 1, Nlamtr(is)
           write(12,'(1x,1p,e10.3)')lamtr(is,i)
           write(12,'(11x,1p,e10.3)')klam(is,i)
         END DO
         write(12,'(1x,1p,e10.3)')lamtr(is,Nlamtr(is)+1)
       ELSE
         write(12,*)
     &      ' Input data for the source spectrum is not good.'
         write(12,*)' Changed to a 10000 K black body'
       END IF
      END IF

c     spectrum from a file for startyp=4,5,6
      IF (startyp(is).GE.4.AND.startyp(is).LE.6) THEN
        write(12,*)' Stellar spectrum supplied from file:'
        write(12,'(a2,a110)') '  ',nameStar(is)
      END IF
      IF(is.eq.1)
     &  write(12,*)' --------------------------------------------'

      IF(is.eq.1) THEN
c      2) DUST PROPERTIES
c      2.1 Chemical Composition
        write(12,*)' Abundances for supported grains:'
        write(12,*)' Sil-Ow Sil-Oc Sil-DL grf-DL amC-Hn SiC-Pg'
        write(12,'(6f7.3)')(xC(i),i=1,3),xC(4)+xC(5),(xC(i),i=6,7)
        IF (top.EQ.2) THEN
          write(12,*)' Abundances for user supplied grains:'
          write(12,'(i6,9i7)')(i,i=1,Nfiles)
          write(12,'(10f7.3)')(xCuser(i),i=1,Nfiles)
          write(12,*)' User supplied n and k from:'
          DO i = 1, Nfiles
            write(12,'(a2,i1,a2,a70)')'  ',i,') ',nameNK(i)
          END DO
        END IF
c      user supplied cross-sections:
       IF (top.EQ.3) THEN
        DO iG = 1, nG
          write(12,*)' Optical properties from file:'
          write(12,'(a2,a70)')'  ',nameQ(iG)
        END DO
       END IF
c      2.2 Grain size distribution
       IF (top.NE.3) THEN
         IF (szds.EQ.3) THEN
          chaux = 'KMH'
         ELSE
          chaux = 'MRN'
         END IF
         write(12,'(a2,a3,a19)')'  ',chaux,'size distribution:'
         CALL getfs(qsd,1,0,strpow)
         write(12,'(a15,a5)')'      Power q:',strpow
         write(12,'(a15,1p,e9.2,a8)')
     &                         ' Minimal size:',a1,' microns'
         IF (szds.EQ.3) THEN
            write(12,'(a22,1p,e9.2,a8)')
     &                            ' Characteristic size:',a2,' microns'
         ELSE
           write(12,'(a15,1p,e9.2,a8)')' Maximal size:',a2,' microns'
         END IF
       END IF
       write(12,*)' --------------------------------------------'
c      2.3 Dust temperature on inner boundary
       DO iG = 1, nG
        CALL getfs(Tsub(iG),0,1,strpow)
        IF (denstyp.eq.0) THEN
          write(12,'(a45,a5,a2)')
     &      ' Dust temperature on the slab left boundary:', strpow,' K'
        ELSE
          CALL getfs(Tsub(iG),0,1,strpow)
          write(12,'(a41,a5,a2)')
     &      ' Dust temperature on the inner boundary:', strpow,' K'
        END IF
       END DO
       write(12,*)' --------------------------------------------'
      END IF
c -------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      SUBROUTINE zbrac(func,x1,x2,Ntry,succes)
c =======================================================================
      INTEGER NTRY, succes
      DOUBLE PRECISION x1,x2,func,FACTOR
      EXTERNAL func
      PARAMETER (FACTOR=1.6)
      INTEGER j
      DOUBLE PRECISION f1,f2
c -------------------------------------------------------------------------
      IF(x1.eq.x2) PAUSE 'you have to guess an initial range in zbrac'
      f1=func(x1)
      f2=func(x2)
      succes=1
      DO j = 1, NTRY
        IF(f1*f2.lt.0.) RETURN
        IF(DABS(f1).lt.DABS(f2)) THEN
          x1=x1+FACTOR*(x1-x2)
c         f1=func(x1)
c     IF's added to prevent breaking of slab case on DEC [MN,Jun'99]
          IF (x1.LT.(-100.)) THEN
            f1 = 5.0e5
          ELSE
            f1=func(x1)
          END IF
        ELSE
          x2=x2+FACTOR*(x2-x1)
          f2=func(x2)
        END IF
      END DO
      succes=0
c -------------------------------------------------------------------------
      RETURN
      END
c ***********************************************************************

c ***********************************************************************
      DOUBLE PRECISION FUNCTION zriddr(func,x1,x2,MAXIT,xacc)
c =======================================================================
      INTEGER MAXIT
      DOUBLE PRECISION x1,x2,xacc,func,UNUSED
      PARAMETER (UNUSED=-1.11d30)
      EXTERNAL func
      INTEGER j
c     aux will be used as argument for SIGN function few lines below.
c     It needs to be REAL to conform to FORTRAN90
      REAL aux
      DOUBLE PRECISION fh,fl,fm,fnew,s,xh,xl,xm,xnew
c -------------------------------------------------------------------------
c      fl=func(x1)
c     IF's added to prevent breaking of slab case on DEC [MN,Jun'99]
      IF (x1.LT.(-100.)) THEN
        fl = 5.0d5
      ELSE
        fl=func(x1)
      END IF
      fh=func(x2)
      if((fl.gt.0..and.fh.lt.0.).or.(fl.lt.0..and.fh.gt.0.))then
        xl=x1
        xh=x2
        zriddr=UNUSED
        do 11 j=1,MAXIT
          xm=0.5*(xl+xh)
          fm=func(xm)
          s=sqrt(fm**2.-fl*fh)
          if(s.eq.0.)return
          aux = fl-fh
          xnew=xm+(xm-xl)*(sign(1.,aux)*fm/s)
          if (DABS(xnew-zriddr).le.xacc) return
          zriddr=xnew
          fnew=func(zriddr)
          if (fnew.eq.0.) return
          if(dsign(fm,fnew).ne.fm) then
            xl=xm
            fl=fm
            xh=zriddr
            fh=fnew
          else if(dsign(fl,fnew).ne.fl) then
            xh=zriddr
            fh=fnew
          else if(dsign(fh,fnew).ne.fh) then
            xl=zriddr
            fl=fnew
          else
            pause 'never get here in zriddr'
          endif
          if(dabs(xh-xl).le.xacc) return
11      continue
        pause 'zriddr exceed maximum iterations'
      else if (fl.eq.0.) then
        zriddr=x1
      else if (fh.eq.0.) then
        zriddr=x2
      else
        pause 'root must be bracketed in zriddr'
      endif
      RETURN
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

       subroutine makedusty(p)

c subroutine that makes input file for Dusty.

       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       IMPLICIT INTEGER(I-N)
       parameter (nfit= 4, nin=600, no=189, ns= 2000)

       double precision afin(nfit), erra(nfit), adum(nfit), D1(nin)
       double precision waveint(nin), fwhmint(nin), yint(nin), zint(nin)
       double precision pxl(nin)
       integer intsep(nin), vissep(ns),svis(ns)
       integer ia(nfit)
       double precision pp(nfit), Router(nfit), scl(nfit)
       double precision wavevis(ns), yvis(ns), zvis(ns), fwhmvis(ns)
       double precision av,teff,dist, bic
       double precision allchisq(no+ns+nin)
       double precision aa, Psi, Vexp, rhod
       real pltintm(nin)

       character*80 name,starname,path,absscafile
       character*200 modelatmos

       double precision p(nfit), wavecut, MLR
       double precision chiphot,chispec,chiint,chivis

       common/fnames/starname,modelatmos,absscafile,wavecut
       common/final/afin,erra,chichi,bic,ifinal,npar
       common/needed/rinner,router,pp,scl,av,teff,dist,npow

       common/params/adum,ia
       common/intensity/waveint,fwhmint,intsep,yint,zint,pxl,D1,
     c                   pltintm,nns
       common/allchi/allchisq,chiphot,chispec,chiint,chivis
       common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis

       DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
       COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf

       write(80,*) 'makedusty ia= ',  p,ia

       CALL Clean(starname, path, lpath)
       CALL ATTACH(path,lpath,'.inp',name)

       write(*,*) path, lpath, name

       open(21, file= name)

c     I PHYSICAL PARAMETERS
c       1) External radiation:

c     Input spectrum
       write(21,*) 'Spectrum = 5'
       write(21,'(a200)') modelatmos

c     BBs
c       write(21,*) 'Spectrum = 1'
c       write(21,*) 'Number of BB = 1'
c       write(21,*) 'Temperature = ', 10**p(6)

c       2) Dust Properties
c       write(21,*) 'optical properties index = 1'
c                       Sil-Ow  Sil-Oc  Sil-DL  grf-DL  amC-Hn  SiC-Pg % standard
c       write(21,*) 'x =  0.000    0.00    0.0    0.00    0.9     0.1 '
c       write(21,*) 'x =  0.000    1.00    0.0    0.00    0.0     0.0 '

       write(21,*) 'optical properties index = 3'
c       write(21,*) 'qabsdustytest'
c       write(21,*) 'qabsdusty_vk'
       write(21,'(a80)') absscafile

c       2.2 Grain size distribution

c       write(21,*) 'Size distribution = 2'
c       write(21,*) 'q = 3.5, a(min) =', 10**p(5), ' a(max) =', 10**p(5)
c       write(21,*) 'q = 3.5, a(min) = 0.32 micron, a(max) = 0.32 '

c        2.3 Dust temperature on inner boundary:

       write(21,*) 'temperature = ', 10**p(3)

c        3) Density Distribution

       write(21,*) 'density type = 1 '
       write(21,*) 'N = ', npow
       write(21,*) 'shells relative thickness = ', (Router(i), i=1,npow)
c     07.10.09 version 9
c       write(21,*) 'p =  ', (pp(i), i=1,npow)
c       write(21,*) 'p =  ', 10**p(4), (pp(i), i=2,npow)
       write(21,*) 'p =  ', p(4), (pp(i), i=2,npow)

       write(21,*) 'scaling =  ', (scl(i), i=1,npow)


c        4) Optical Depth
       write(21,*)  'grid type = 1 '
       write(21,*)  'lambda0 = 0.55 micron '

       write(21,*)  'tau(min) = ', 10**p(2), ' tau(max) =', 10**p(2)
       write(21,*)  'number of models = 1'


c  II NUMERICS

       write(21,*)  'accuracy for flux conservation = 0.01'

c  III OUTPUT PARAMETERS

       write(21,*) 'verbosity flag                   verbose = 2 '
       write(21,*) 'properties of emerging spectra;  fname.spp = 1 '
       write(21,*) 'detailed spectra for each model; fname.s### = 1 '

c     if there is a intensity or visibility distribution to fit
       if (nns .ne. 0 .or. nnv .ne. 0) then
          write(21,*) 'images at specified wavelengths; fname.i### = -1'
          write(21,*) 'number of wavelengths  =  ', nns+nnv
          write(21,'(a7,20f7.1)') 'wvl = ',
     c                      (waveint(i),i= 1,nns), (wavevis(i),i= 1,nnv)
          write(21,*) 'ipsf = 1 '
c     MG 30.09.09 use Luminosity as relevant input, to calculate angular diameter later!
          write(21,*) 'theta1 = ', 10**p(1)

c     Bessell function PSF
c          write(21,*) 'psftype = 3 '
c          write(21,'(a7,20f7.2)') 'D0 = ', (fwhmint(i),i=1,nns+nnv)
c          write(21,'(a7,20f7.2)') 'D1 = ', (D1(i),i=1,nns+nnv)

c     Gaussian PSF
          write(21,*) 'psftype = 1 '
          write(21,'(a7,20f7.2)') 'fwhm = ', (fwhmint(i),i=1,nns+nnv)
       else
          write(21,*) 'images at specified wavelengths; fname.i### = -1'
          write(21,*) 'number of wavelengths  =  ', 1
          write(21,'(a7,20f7.1)') 'wvl = ', -9.9
          write(21,*) 'ipsf = 1 '
          write(21,*) 'theta1 = ', 10**p(1)

c     Bessell function PSF
c          write(21,*) 'psftype = 3 '
c          write(21,'(a7,20f7.2)') 'D0 = ', (fwhmint(i),i=1,nns+nnv)
c          write(21,'(a7,20f7.2)') 'D1 = ', (D1(i),i=1,nns+nnv)

c     Gaussian PSF
          write(21,*) 'psftype = 1 '
          write(21,'(a7,20f7.2)') 'fwhm = ', -9.9
       endif


       write(21,*) 'visibilities at spec. wavelengths fname.v### = 1'
       write(21,*) 'radial profiles;                  fname.r### = 1'
       write(21,*) 'detailed run-time messages;       fname.m### = 1'

c     if final results
       if (ifinal .eq. 1) then

c     Non-Dusty: to keep output and input in one file for further reference
  	 write(21,*) 'chi2 ', chichi, bic, npar
	 do i= 1,nfit
  	      write(21,*) afin(i), erra(i), ia(i)
         enddo
         write(21,111) 'allchi ',chiphot,chispec,chiint,chivis
         write(21,*) 'outer radius (arcmin)', theta1/2.*Router(npow)/60.

         Rst= sqrt(10** p(1) / (Teff/5770.d0)**4)
         dum= Rst* 6.96d5 / (dist * 3.0921d16) *206265.d0
         write(21,*)'stellar radius (Rsun & mas)', Rst, dum*1000.
         write(21,*)'inner radius (Rstar)', Rinner

c     logg= 4.437745+ alog10(Mass) -2.0* alog10(Radius)
         write(21,*)'log g= ',4.437745 -2.d0*log10(Rst),' +log(M/Msol)' 
         call MLrate(MLR, aa, Psi, Vexp, rhod)
         write(21,112) 'For: a= ', aa,' DTG= ', Psi, 
     c    ' Vexp= ', Vexp, ' grain_density= ', rhod , 
     c    ' then MasslossRate= ', MLR

       endif
       close(21)

c 111   format(a6,1x,4(e15.8,1x))
 111   format(a6,1x,4(f9.2,1x))
 112   format(a8,f4.2, a6,e8.2, a7,f5.2, a17,f4.2, a20,e10.3)
 
       return
       end
*23456789012345678901234567890123456789012345678901234567890123456789012

       subroutine PSCfold(a)

       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       IMPLICIT INTEGER(I-N)
       parameter(npL=573, npL1=npL+1, nfit=4, ns= 2000,no=189,nin=600)

       character*80 starname,name, path, absscafile
       character*200 cdum, modelatmos

       double precision wve(npL1), flx(npL1), a(nfit), xspec(ns)
       integer xsel(no), nism
       double precision xint(nin),xvis(ns), wavecut
       double precision pp(nfit), Router(nfit), scl(nfit)
       double precision av,teff,dist

       common/fnames/starname,modelatmos,absscafile,wavecut
       common/needed/rinner,router,pp,scl,av,teff,dist,npow
       common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint

       double precision wism(ns),avism(ns)
       common/chiar/ wism,avism,nism


       write(80,*) 'PSCfold a= ', a, 'nsel ', nsel

c     DUSTY file with fluxes
       CALL Clean(starname, path, lpath)
       CALL ATTACH(path,lpath,'.stb',name)

       write(*,*) 'PSCfold ', name

       open(21, file= name)

       do i=1,4
          read(21, '(a200)') cdum
       enddo

        j=0
 200    j=j+1
        read(21, * ,err=201,end=201) wve(j), flx(j)
        if (flx(j) .eq. 0.d0) flx(j)= 1.d-21
        flx(j)= flx(j)/wve(j)
	goto 200
 201	continue
        nfl= j-1
        if (nfl .gt. npL) then
           write(*,*) 'INCREASE NPL'
           STOP
        endif

        close(21)

c     check integral
        sum= 0.d0
        do j= 2,nfl
           sum= sum+ 0.5d0*(wve(j)-wve(j-1))*(flx(j)+flx(j-1))
        enddo
        write(*,*)  'flux integral', nfl, sum
        write(80,*) 'flux integral', nfl, sum

c     reddening correction
        sum= 0.d0
        do i= 1,nfl

c     ISM 
           avi= 0.d0
           if (wve(i) .gt. wism(1) .and. wve(i) .lt. wism(nism)) then
c     get index
              do j= 1,nism-1
              if ((wve(i).ge.wism(j)).and.(wve(i).le.wism(j+1))) then
                 xx=(wve(i)-wism(j))/(wism(j+1)-wism(j))
                 avi= avism(j) + xx*(avism(j+1)-avism(j))
              endif
              enddo
           endif
           if (wve(i) .ge. wism(nism)) then
              avi= avism(nism)*(wve(i)/wism(nism))**(-2.1)
           endif

	aa= 0.d0
	bb= 0.d0

	x=1.d0/wve(i)

	if (x.le.1.1) then
		aa=  0.574*x**1.61
		bb= -0.527*x**1.61
	endif

	if ((x.gt.1.1).and.(x.le.3.3)) then
		y=x-1.82
		z=x-1.82

c       Cardelli et al. ApJ 345,245 + O'Donnell ApJ 422, 158 between 1.1 and 3.3 mu-1
		aa=1.0+z*(0.104+z*(-0.609+z*(0.701+z*(1.137+
     c	              z*(-1.718+z*(-0.827+z*(1.647-z*0.505)))))))
		bb=z*(1.952+z*(2.908+z*(-3.989+z*(-7.958+z*(
     c              11.102+z*(5.491+z*(-10.805+z*3.347)))))))

	endif

	if ((x.gt.3.3).and.(x.le.8.0)) then
		fa=0.
		fb=0.
		if (x.ge.5.9) then
			y=x-5.9
			fa=(-0.04473-0.009779*y)*y**2
			fb=(0.2130  +0.1207*y)*y**2
		endif
		aa= 1.752-0.316*x-0.104/((x-4.67)**2+0.341)+fa
		bb=-3.090+1.825*x+1.206/((x-4.62)**2+0.263)+fb
	endif

c	if ((x.gt.8.0).and.(x.le.10.)) then
	if ((x.gt.8.0).and.(x.le.100.)) then
		y=x-8.0
		aa=-1.073-0.628*y+0.137*y**2-0.070*y**3
		bb=13.670+4.257*y-0.420*y**2+0.374*y**3
	endif

	r= 3.10
c       A(l)/A(V)
        alav= (aa+bb/r)
c       Chiar & Tielens, and extrapolation, beyond 1.5 mu
        if (wve(i) .gt. 1.5) alav= avi
	al= av*alav
	if (al.lt.0.d0) al= 0.d0

	flx(i)= flx(i)*10**(-0.4*al)
        write(*,*)  'redd. corr. ',wve(i),flx(i),al,(aa+bb/r),avi
        write(80,*) 'redd. corr. ',wve(i),flx(i),al,(aa+bb/r),avi

        if (i.ge.2)sum= sum+ 0.5*(wve(i)-wve(i-1))*(flx(i)+flx(i-1))
        enddo
        write(*,*)  'flux integral after reddening', nfl, sum
        write(80,*) 'flux integral after reddening', nfl, sum

c     conversion to flux at earth: L= 4 pi R^2 sigma T^4
c                                  f_l = 4 pi R^2 pi B_l / (4 pi d^2)
	pi= 3.1415927d0
        conv= 3.826d26 * 10** a(1) / (4.* pi * (dist * 3.0921d19)**2)
        write(*,*) a(1), Teff, conv

        do i= 1,nfl
  	   flx(i)= flx(i)* conv
        enddo

        call PSCfoldORIG(wve,flx,nfl)

c     write observed flux at Earth to a file
c     format is (lambda F_l) to comply with expected input to plotirs.f
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)
        CALL ATTACHfront(path,lpath,'rted_',name)
        open(21, file= name)
        do i= 1,nfl
  	   write(21,*) wve(i), wve(i)*flx(i)
        enddo
        close(21)

        return
        end

*23456789012345678901234567890123456789012345678901234567890123456789012

      subroutine PSCfoldORIG(wl,f,n)

C       !!!!!!!! IF USED AS SUBROUTINE WITHIN RTassub.f
C                a) fix 'flouxout.dat' in line 150
C                b) search 'call p' and remove all pgplot calls  !!!!


c       changed jan 94; keep IRAS part put add
c       magnitude calculation of other bands
c
c
c        !! WAVELENGTHs in  Filter responses should be in NANOMETERS !!
c
c       jan 94: further change in including a cubic spline interpolation
c       of the IRAS response curves at more wavelength points
c
C	PROGRAM TO CALCULATE THE IRAS FLUXES FROM AN INPUT SPECTRUM.
C	THE SPECTRAL RESPONSE IS TAKEN FROM TABLE II.C.5 OF THE
C	EXPLANATORY SUPPLEMENTS.
C	THE PROGRAM REQUIRES THE NAME OF THE INPUTFILE.
C	THIS FILE SHOULD LOOK LIKE THIS:
C
C	N             !NUMBER OF INPUT POINTS
C	WAVE(1) F(1)  !WAVELENGTH (IN ASCENDING ORDER!)
C	WAVE(I) F(I)  !AND FLUX (W/m2/mu)
C	WAVE(N) F(N)
C
C	WAVE(1) SHOULD BE <= 7 MU, WAVE(N) >= 140 MU.
C	
C	WRITTEN BY      M.A.T. GROENEWEGEN JAN. 1990
c
c	changed to integration in frequency domain: S.Slijkhuis 910328
c	IRAS fluxes calculated according to Expl.Suppl. p.VI-27
c                         2
c       F   = I { (wl/wl0) *f  * R d(wl0/wl) }/ I { (wl/wl0) * R d(wl0/wl) }
c        wl0                 wl   nu                            nu

c	double precision x12(20),x25(35),x60(23),x100(19)
c	double precision phi12(18),phi25(33),phi60(21),phi100(17)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)
        parameter (npL=573, npl1=npl+1, no=189)

	real x12(84),x25(160),x60(63),x100(80)
	double precision phi12(82),phi25(158),phi60(61),phi100(78)
	
*23456789012345678901234567890123456789012345678901234567890123456789012
	double precision xor(5901),ro(5901,5),xir(421),ri(421,5)
	double precision rd(1720,3),xtim(1070),rtim(1070,5),xsr(1465)
	double precision rs(1465,4),xdr(1720)
	double precision xl(20000),fx(20000),wl(npL1),f(npL1)
	double precision zo(5),zi(5),zd(3),ztim(5),zs(4)
	double precision xcam(2000),rcam(2000,1), ypl(2000)
	double precision imag, jmag, hmag, kmag
	double precision mips24, mips70, mips160
	double precision irac36, irac45, irac58, irac80
	double precision ircn2, ircn3, ircn4, mirs7, mirs11, mirs9
	double precision mirl15, mirl18, mirl24
        double precision Jmass,Hmass,Kmass,Jwf,Hwf,Kwf,Jnic,Hnic,Knic
        double precision Jirsf, Hirsf, Kirsf
        double precision Jcaspir, Hcaspir, Kcaspir,Lcaspir
	double precision Jbessell, Hbessell, Kbessell
	double precision Rcousins, Icousins
	double precision fisn60, fisws, fiswl, fisn160
	double precision iSl
	double precision l0, wavecut, fluxx, fluxS
	double precision Zvis,Yvis,Jvis,Hvis,Kvis
        double precision wise1,wise2,wise3,wise4
        double precision Opg, Epg, V495, BJ, RF, INm
        double precision splam(no),spmag(no),sperrmag(no)
        double precision CNFK, tioFK, halpha, CNeso, tioeso
        double precision galfuv,galnuv, MachoB, MachoR, ErosB, ErosR

	character*80 starname
	character*80 absscafile
        character*200 modelatmos
        character csp*4

        real xx, ff
        common/a/ xx(20000),ff(20000)
	common/fnames/starname,modelatmos,absscafile,wavecut
        common/special/splam,spmag,sperrmag,nsp

        character*80 path,name
	character*80 txt
        character ap*3, bs*5

        ap = ' & '
        bs = ' \\\\'

c       VI, JHK, IRAC, MIPS
c	open(30,file= 'magnitude1.dat')
c       ASTRO-F: IRC N2,N3,N4 - MIR S7, S9W, S11 - MIR L15, L20W, L24
c	open(31,file= 'magnitude2.dat')
c       PACS 70, 110, 170 - SPIRE 250, 350, 500:
c	open(32,file= 'magnitude3.dat')
c       UB - ISOCAM
c	open(33,file= 'magnitude4.dat')

c       'everything' in magnitudes, for Leo
c	open(39,file= 'magnitudeall.dat')

c	open(40, file='phot.out')


         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'_allmags.dat',name)

	open(41, file= name)


*23456789012345678901234567890123456789012345678901234567890123456789012

*	data x12/7.0,7.5,8.0,8.5,9.0,9.5,10.0,10.5,11.0,11.5,12.0,12.5
*     c  ,13.0,13.5,14.0,14.5,15.0,15.5/
*	data x25/15.5,16.0,16.5,17.0,17.5,18.0,18.5,19.0,19.5,20.0,20.5
*     c  ,21.0,21.5,22.0,22.5,23.0,23.5,24.0,24.5,25.0,25.5,26.0,26.5,
*     c  27.0,27.5,28.0,28.5,29.0,29.5,30.0,30.5,31.0,31.5/
*	data x60/27.,30.,33.,36.,39.,42.,45.,48.,51.,54.,57.,60.,63.,66.,
*     c  69.,72.,75.,78.,81.,84.,87./
*	data x100/65.,70.,75.,80.,85.,90.,95.,100.,105.,110.,115.,120.,125.
*     c  ,130.,135.,140.,145./
c*** spectral response on frequency grid Table II.C.5
c	data phi12/0.,0.008,0.535,0.689,0.735,0.815,0.900,0.904,0.834,0.816,
c     c  0.793,0.854,0.938,0.991,1.000,0.934,0.388,0./
c	data phi25/0.,0.007,0.101,0.288,0.388,0.452,0.521,0.562,0.626,0.683
c     c  ,0.729,0.778,0.832,0.912,0.914,0.938,0.933,0.875,0.910,1.0,0.911
c     c  ,0.84,0.763,0.749,0.829,0.914,0.79,0.877,0.558,0.274,0.069,0.012
c     c  ,0.0/
c	data phi60/0.,0.010,0.036,0.068,0.174,0.315,0.483,0.585,0.658,0.716,
c     c  0.824,0.915,0.987,0.990,1.000,0.946,0.713,0.531,0.174,0.047,0./
c	data phi100/0.,0.010,0.113,0.306,0.505,0.695,0.824,0.947,0.939,1.,
c     c  0.631,0.319,0.195,0.106,0.053,0.01,0./


	open(66,file=
     c  '/home/marting/GRAINS/irasrp.dat')
c     c  'irasrp.dat')
	read(66,20) txt
	do i=1,250
	if (i.le.5) read(66,*) idum,dum,dum,dum
	if ((i.ge.6).and.(i.le.87))read(66,*) idum,dum,phi12(i-5),dum
	if ((i.ge.88).and.(i.le.89)) read(66,*)idum,dum,dum,dum
	if ((i.ge.90).and.(i.le.247))read(66,*)idum,dum,dum,phi25(i-89)
	if (i.ge.248) read(66,*) idum,dum,dum,dum
	end do
	do i=1,125
	 if (i.le.1) read(66,*) idum,dum,dum,dum
	 if ((i.ge.2).and.(i.le.42))read(66,*)idum,dum,phi60(i-1),dum
	 if ((i.ge.43).and.(i.le.62))read(66,*)
     c    idum,dum,phi60(i-1),phi100(i-42)
	 if ((i.ge.63).and.(i.le.120))read(66,*)
     c    idum,dum,dum,phi100(i-42)
	end do
	close(66)

*23456789012345678901234567890123456789012345678901234567890123456789012

c	  do i=1,82
c	  write(6,*) i,(7.4+(i-1)*0.1),phi12(i)
c	  end do

c	  do i=1,158
c	  write(6,*) i,(15.8+(i-1)*0.1),phi25(i)
c	  end do

c	  do i=1,61
c	  write(6,*) i,(27.+(i-1)*1.),phi60(i)
c	  end do

c          do i=1,78
c	  write(6,*) i,(68.+(i-1)*1.),phi100(i)
c	  end do

 20	format(a80)

	do i= 1,n
c           in [micron] and [w/m2/mu]
c              xl and fx for all bands except IRAS; need [nm] !
	     xl(i)=wl(i)*1000.d0
	     fx(i)=f(i)/1000.d0

c              x and f for IRAS; IRAS needs mu !
	  ff(n+1-i)=f(i)
	  xx(n+1-i)=1.d0/wl(i)
	end do

c	calculate integrated flux (W/m2)
	tflux=0.
	do i=1,n-1
c	log interpolation in F
c	tflux=tflux+(x(i+1)-x(i))*10**(0.5*(alog10(f(i+1))+alog10(f(i))))
c	linear interpolation in F
	tflux=tflux+0.5*(1./xx(i) - 1./xx(i+1))*(ff(i+1)+ff(i))
	end do

	f12=0.
	index=1
C	n12=18
	n12=82
	fold=0.
	suml=0.
	sumf=0.
c** fgrid is frequency halfway between the gridpoints given in Expl.Suppl.
c   frequency in ascending order -> wavelength in descending order
	do k=1,(n12+2)
C	  wavek=16.5- 0.5*k
	  wavek=15.7- 0.1*k
	  x12(k)= 12./wavek
	enddo
	do i=2,(n12+1)
	  call flux(12.,index,x12(i),fl)
	  if (i.eq.1) nmin=index
	  fgrid1= 0.5*( x12(i)+ x12(i-1) )
	  fgrid2= 0.5*( x12(i+1)+ x12(i) )
	  sumf= sumf+ (fgrid2-fgrid1)* fl* phi12(n12+2-i)/ x12(i)**2.
	  suml= suml+ (fgrid2-fgrid1)*     phi12(n12+2-i)/ x12(i)
c	 WRITE(15,'(2F9.4, 6E11.4)')
c     &     12./X12(I),PHI12(n12+2-I),X12(I),FGRID1,FGRID2,sumf,suml,fl
	enddo
	f12=sumf/suml   ! *12.0

	f25=0.
	index=1 !nmin
C	n25=33
	n25=158
	fold=0.
	suml=0.
	sumf=0.
	do k=1,(n25+2)
C	  wavek=32.5- 0.5*k
	  wavek=31.7- 0.1*k

	  x25(k)= 25./wavek
*	  fgrid1(k)= 25./(wavek+0.25)
*	  fgrid2(k)= 25./(wavek-0.25)
	enddo
	do i=2,(n25+1)
	  call flux(25.,index,x25(i),fl)
	  if (i.eq.1) nmin=index
	  fgrid1= 0.5*( x25(i)+ x25(i-1) )
	  fgrid2= 0.5*( x25(i+1)+ x25(i) )
	  sumf= sumf+ (fgrid2-fgrid1)*fl* phi25(n25+2-i)/ x25(i)**2.
	  suml= suml+ (fgrid2-fgrid1)*    phi25(n25+2-i)/ x25(i)
c	 WRITE(15,'(2F9.4,4E11.4)')
c     &     25./X25(I),PHI25(n25+2-I),X25(I),FGRID1,FGRID2,FL
	enddo
	f25=sumf/suml

	f60=0.
	index=1  !nmin
C	n60=21
	n60=61
	fold=0.
	suml=0.
	sumf=0.
	do k=1,(n60+2)
C	  wavek=93.0- 3.*k
	  wavek=89.0- 1.0*k
	  x60(k)= 60./wavek
*	  fgrid1(k)= 60./(wavek+1.5)
*	  fgrid2(k)= 60./(wavek-1.5)
	enddo
	do i=2,(n60+1)
	  call flux(60.,index,x60(i),fl)
	  if (i.eq.1) nmin=index
	  fgrid1= 0.5*( x60(i)+ x60(i-1) )
	  fgrid2= 0.5*( x60(i+1)+ x60(i) )
	  sumf= sumf+ (fgrid2-fgrid1)*fl* phi60(n60+2-i)/ x60(i)**2.
	  suml= suml+ (fgrid2-fgrid1)*    phi60(n60+2-i)/ x60(i)
c	 WRITE(15,'(2F9.4,4E11.4)')
c     &     60./X60(I),PHI60(n60+2-I),X60(I),FGRID1,FGRID2,FL
	enddo
	f60=sumf/suml

	f100=0.
	index=1  !nmin
C	n100=16
	n100=78
	fold=0.
	suml=0.
	sumf=0.
	do k=1,(n100+2)
C	  wavek=150.- 5.*k
	  wavek=147.0- 1.0*k
	  x100(k)= 100./wavek
*	  fgrid1(k)= 100./(wavek+2.5)
*	  fgrid2(k)= 100./(wavek-2.5)
	enddo
	do i=2,(n100+1)
	  call flux(100.,index,x100(i),fl)
	  if (i.eq.1) nmin=index
	  fgrid1= 0.5*( x100(i)+ x100(i-1) )
	  fgrid2= 0.5*( x100(i+1)+ x100(i) )
	  sumf= sumf+ (fgrid2-fgrid1)*fl*phi100(n100+2-i)/ x100(i)**2.
	  suml= suml+ (fgrid2-fgrid1)*   phi100(n100+2-i)/ x100(i)
c	 WRITE(15,'(2F9.4,4E11.4)')
c     &     100./X100(I),PHI100(n100+2-I),X100(I),FGRID1,FGRID2,FL
	enddo
	f100=sumf/suml

	print*,tflux,'    (W/m2) '
	print*,f12,f25,f60,f100,'  (W/m2/mu)'

	f12jy=f12*(3.33556e11*12.**2)
	f25jy=f25*(3.33556e11*25.**2)
	f60jy=f60*(3.33556e11*60.**2)
	f100jy=f100*(3.33556e11*100.**2)

c       original
c	xm12=-2.5*alog10(f12jy/41.0)
c	xm25=-2.5*alog10(f25jy/9.49)
c	xm60=-2.5*alog10(f60jy/1.57)
c	xm100=-2.5*alog10(f100jy/0.47)

c       based on my results for Vega MG 23.11.06
c	xm12= -2.5*log10(f12jy/40.1)
c	xm25= -2.5*log10(f25jy/8.81)
c	xm60= -2.5*log10(f60jy/1.44)
c	xm100= -2.5*log10(f100jy/0.405)
c       based on my results for Vega MG 20.07.2016
	xm12=-2.5*log10(f12jy/40.5)
	xm25=-2.5*log10(f25jy/8.97)
	xm60=-2.5*log10(f60jy/1.45)
	xm100=-2.5*log10(f100jy/0.423)

	print*,f12jy,f25jy,f60jy,f100jy,'  (Jy)'
	print*,xm12,xm25,xm60,xm100,'  (mag)'
*	write(*,'(3F9.5,A11)')
	print*,log10(f25jy/f12jy), log10(f60jy/f25jy),
     &        log10(f100jy/f60jy),'  (R21 R32 R43)'

C          END OF IRAS PART

C          START OF OTHER BANDS

	open(10,file=
     c  '/home/marting/GRAINS/optresp.dat')
c     c  'optresp.dat')
	open(11,file=
     c  '/home/marting/GRAINS/esoresp.dat')
c     c  'esoresp.dat')
	open(12,file=
     c  '/home/marting/GRAINS/denisrp.dat')
c     c  'denisrp.dat')
	open(13,file=
     c  '/home/marting/GRAINS/timmirp.dat')
c     c  'timmirp.dat')
	open(14,file=
     c  '/home/marting/GRAINS/saaoresp.dat')
c     c  'saaoresp.dat')
	
c       read grid of responses; resp. Johnson B, V Cousins V, R, I
	do i=1,3
	   read(10,20) txt
	end do
	do i=1,5901
	  read(10,*) dum,xor(i),ro(i,1),ro(i,2),ro(i,3),ro(i,4),ro(i,5)
	enddo
	close(10)

*23456789012345678901234567890123456789012345678901234567890123456789012

c       read grid of responses; resp. ESO JHKLM
	do i=1,5
	   read(11,20) txt
	end do
	do i=1,421
	   read(11,*) dum,xir(i),ri(i,1),ri(i,2),ri(i,3),ri(i,4),ri(i,5)
	enddo
	close(11)

c       read grid of responses; resp. DENIS I,J,K
	do i=1,1
	   read(12,20) txt
	end do
	do i=1,1720
	   read(12,*) dum,xdr(i),rd(i,1),rd(i,2),rd(i,3)
	enddo
	close(12)

c       read grid of responses; resp. SAAO J,H,K,L
	do i=1,1
	   read(14,20) txt
	end do
	do i=1,1465
	   read(14,*) idum,xsr(i),rs(i,1),rs(i,2),rs(i,3),rs(i,4)
	   xsr(i)=xsr(i)*1000.
c	   write(*,*) xsr(i),rs(i,1),rs(i,2),rs(i,3),rs(i,4)
	enddo
        close(14)

c       read grid of responses; resp. TIMMI M,N,N1,N2,N3
	do i=1,1
	   read(13,20) txt
	end do
	do i=1,1070
	  read(13,*) dum,xtim(i),rtim(i,1),rtim(i,2),rtim(i,3),
     c      rtim(i,4),rtim(i,5)
	   xtim(i)=xtim(i)*1000.
	enddo
        close(13)

c	for each (optical) band
	nr=5901
c       zeropoints for 0-mag star [w/m2/mu]
	zo(1)=7.20e-8
	zo(2)=3.92e-8
	zo(3)=3.609e-8
	zo(4)=2.258e-8
	zo(5)=1.227e-8

	do i=1,5
           l0= 1.0
	   call rp(i,xor,ro,nr,xl,fx,n,fluxx, l0)

	xmag=-2.5*log10(fluxx*1.d3/zo(i))

c	if(i.eq.1) write(6,*) 'Johnson B: ',xmag
c	if(i.eq.2) write(6,*) 'Johnson V: ',xmag
c	if(i.eq.3) write(6,*) 'Cousins V: ',xmag
c	if(i.eq.4) write(6,*) 'Cousins R: ',xmag
c	if(i.eq.5) write(6,*) 'Cousins I: ',xmag
	end do


c	for each (infrared) ESO band
c       zeropoints for 0-mag star [w/m2/mu]
	zi(1)=2.907d-9
	zi(2)=1.146d-9
	zi(3)=4.025d-10
	zi(4)=5.125d-11
	zi(5)=2.217d-11

	nr=421

	i=1
	l0= 1.228
	call rp(i,xir,ri,nr,xl,fx,n,fluxx, l0)
	xesoj=-2.5*log10(fluxx*1.d3/zi(i))

	i=2
	l0= 1.651
	call rp(i,xir,ri,nr,xl,fx,n,fluxx, l0)
	xesoh=-2.5*log10(fluxx*1.d3/zi(i))

	i=3
	l0= 2.216
	call rp(i,xir,ri,nr,xl,fx,n,fluxx, l0)
	xesok=-2.5*log10(fluxx*1.d3/zi(i))

	i=4
	l0= 3.771
	call rp(i,xir,ri,nr,xl,fx,n,fluxx, l0)
	xesol=-2.5*log10(fluxx*1.d3/zi(i))

	i=5
	l0= 4.772
	call rp(i,xir,ri,nr,xl,fx,n,fluxx, l0)
	xesom=-2.5*log10(fluxx*1.d3/zi(i))


c	for each (infrared) SAAO band
c       zeropoints for 0-mag star [w/m2/mu]
	zs(1)= 3.255d-9
	zs(2)= 1.145d-9
	zs(3)= 3.892d-10
	zs(4)= 7.499d-11

	nr=1465

	i=1
	l0= 1.23
	call rp(i,xsr,rs,nr,xl,fx,n,fluxx, l0)
	xmagsj=-2.5*log10(fluxx*1.d3/zs(i))

	i=2
	l0= 1.66
	call rp(i,xsr,rs,nr,xl,fx,n,fluxx, l0)
	xmagsh=-2.5*log10(fluxx*1.d3/zs(i))

	i=3
	l0= 2.23
	call rp(i,xsr,rs,nr,xl,fx,n,fluxx, l0)
	xmagsk=-2.5*log10(fluxx*1.d3/zs(i))

	i=4
	l0= 3.44
	call rp(i,xsr,rs,nr,xl,fx,n,fluxx, l0)
	xmagsl=-2.5*log10(fluxx*1.d3/zs(i))

        write(*,*) 'SAAO : ',xmagsj, xmagsh, xmagsk, xmagsl

cccccccccccccccccccccccccccccc OLD DENIS ccccccccccccccccccccccccccccccccc

c	for each denis filter
	nr=1720
c       zeropoints for 0-mag star [w/m2/mu]

c         if denis I = cousins I; denis J = eso J and denis K = eso K
	zd(1)=12.64d-9
	zd(2)=3.34d-9
	zd(3)=4.46d-10

c        article of Fouque, Chevallier, Duc, Bertin, Cohen (1997)
        zd(1)= 12.5d-9
        zd(2)= 3.21d-9
        zd(3)= 4.34d-10


c        0-mag for A0V star according to offset off Cohen
	zd(1)=11.59d-9
	zd(2)= 3.091d-9
	zd(3)= 4.407d-10

	do i= 1,3
	   if (i.eq.1) l0= 0.791
	   if (i.eq.2) l0= 1.228
	   if (i.eq.3) l0= 2.145
	   call rp(i,xdr,rd,nr,xl,fx,n,fluxx, l0)

c	xmag= -2.5*log10(fluxx*1.d3/zd(i))
c	flux1= fluxx*3.3356e14* l0*l0

c	if(i.eq.1) then
c	   write(6,*) 'Denis I: ',xmag, flux1
c	   xmagi=xmag
c	endif
c	if(i.eq.2) then
c	   write(6,*) 'Denis J: ',xmag, flux1
c	   xmagj=xmag
c	endif
c	if(i.eq.3) then
c	   write(6,*) 'Denis K: ',xmag, flux1
c	   xmagk=xmag
c	endif
	end do

cccccccccccccccccccccccccccccc OLD DENIS ccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccc NEW DENIS ccccccccccccccccccccccccccccccccc

	open(15,file=
     c  '/home/marting/GRAINS/DENIS_I.fad')
c       read grid of responses
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 11.82d-9
c       AB test
c	zcam=3.927e-8
	i=1
	l0= 0.791
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmagi= -2.5*log10(fluxx*1.d3/zcam)
	fluxDi= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/DENIS_J.fad')
c       read grid of responses
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.19d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.228
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmagj= -2.5*log10(fluxx*1.d3/zcam)
	fluxDj= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/DENIS_Ks.fad')
c       read grid of responses
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.38d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.145
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmagk= -2.5*log10(fluxx*1.d3/zcam)
	fluxDk= fluxx*3.3356e14* l0*l0
	close(15)



c	for each TIMMI band
c       zeropoints for 0-mag star [w/m2/mu] based on standard ESO bolometer
	ztim(1)=2.437d-11
	ztim(2)=1.214d-12
	ztim(3)=2.221d-12
	ztim(4)=1.221d-12
	ztim(5)=4.575d-13

	ntim=1070
	do i=1,5
           l0= 1.
	   call rp(i,xtim,rtim,ntim,xl,fx,n,fluxx, l0)

	xmag=-2.5*log10(fluxx*1.d3/ztim(i))

c	if(i.eq.1) write(6,*) 'TIMMI M: ',xmag
c	if(i.eq.2) write(6,*) 'TIMMI N: ',xmag
c	if(i.eq.3) write(6,*) 'TIMMI N1: ',xmag
c	if(i.eq.4) write(6,*) 'TIMMI N2: ',xmag
c	if(i.eq.5) write(6,*) 'TIMMI N3: ',xmag
	end do

c       ESO VISIR Narrow-band filters
	open(15,file=
     c  '/home/marting/GRAINS/PAH1VIS.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=2.110d-12
	l0= 8.59
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xpah1=-2.5*log10(fluxx*1.e3/zcam)
	flxpah1=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/PAH2VIS.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=7.296d-13
	l0= 11.25
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xpah2=-2.5*log10(fluxx*1.e3/zcam)
	flxpah2=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/SICVIS.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=6.148d-13
	l0= 11.85
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xsic=-2.5*log10(fluxx*1.e3/zcam)
	flxsic=fluxx*3.3356e17* l0*l0
	close(15)

	write(*,'(a15,5F7.3)') 'VISIR PAH1 PAH2 SiC: ', 
     c      xpah1,xpah2,xsic
	write(*,*)'VISIR mJy',flxpah1,flxpah2,flxsic


c       ESO Mid-IR bolometer
	open(15,file=
     c  '/home/marting/GRAINS/esoN.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.202d-12
	i=1
        l0= 9.68
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xeson0=-2.5*log10(fluxx*1.d3/zcam)
	flux_eson0=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/esoN1.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.420d-12
	i=1
        l0= 8.36
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xeson1=-2.5*log10(fluxx*1.d3/zcam)
	flux_eson1=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/esoN2.dat')
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=0.1302d-11
	i=1
        l0=9.79
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xeson2=-2.5*log10(fluxx*1.d3/zcam)
	flux_eson2=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/esoN3.dat')
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.213e-13
	i=1
        l0= 12.82
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xeson3=-2.5*log10(fluxx*1.d3/zcam)
	flux_eson3=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/esoQ0.dat')
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.016e-13
	i=1
        l0= 18.67
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xesoq0=-2.5*log10(fluxx*1.d3/zcam)
	flux_esoq0=fluxx*3.3356e17* l0*l0
	close(15)

	write(*,*) 'ESO N123,Q0: ', xeson1,xeson2,xeson3,xesoq0
	write(*,*)'ESO mJy',flux_eson1,flux_eson2,flux_eson3,flux_esoq0


c       ISOCAM

	open(15,file=
     c  '/home/marting/GRAINS/cam_sw1.dat')
c     c  'cam_sw1.dat')
c       read grid of responses; CAM SW1

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.508d-11
	i=1
        l0= 3.6
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag11=-2.5*log10(fluxx*1.d3/zcam)
	flux11=fluxx*3.3356e17* l0*l0
c	write(40,*) 'ISOCAM SW1: ', xmag11, 'mag', flux11, 'mJy'
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/cam_lw1.dat')
c     c  'cam_lw1.dat')
c       read grid of responses; CAM LW1

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.692d-11
	i=1
        l0= 4.5
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag1=-2.5*log10(fluxx*1.d3/zcam)
	flux1=fluxx*3.3356e17* l0*l0
c	write(*,*) 'ISOCAM LW1: ', xmag1
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw2.dat')
c     c  'cam_lw2.dat')
c       read grid of responses; CAM LW2

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.028d-12
	i=1
        l0= 6.7
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag2=-2.5*log10(fluxx*1.d3/zcam)
	flux2=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw3.dat')
c     c  'cam_lw3.dat')
c       read grid of responses; CAM LW3

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.906e-13
	i=1
        l0= 14.3
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag3=-2.5*log10(fluxx*1.d3/zcam)
	flux3=fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw4.dat')
c     c  'cam_lw4.dat')
c       read grid of responses; CAM LW4

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=8.793d-12
	i=1
        l0= 6.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag4=-2.5*log10(fluxx*1.d3/zcam)
	flux4=fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw5.dat')
c     c  'cam_lw5.dat')
c       read grid of responses; CAM LW5

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=5.338d-12
	i=1
        l0= 6.8
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag5=-2.5*log10(fluxx*1.d3/zcam)
	flux5=fluxx*3.3356e17* l0*l0
c	write(40,99) 'ISOCAM LW1-5:', xmag1, xmag2, xmag3, xmag4, xmag5
c	write(40,98) 'LW1-5 in mJy:', flux1, flux2, flux3, flux4, flux5

	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw6.dat')
c     c  'cam_lw6.dat')
c       read grid of responses; CAM LW6

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.252d-12
	i=1
        l0= 7.7
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag6=-2.5*log10(fluxx*1.d3/zcam)
	flux6=fluxx*3.3356e17* l0*l0
c	write(*,*) 'ISOCAM LW1: ', xmag6
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw7.dat')
c     c  'cam_lw7.dat')
c       read grid of responses; CAM LW7

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.384d-12
	i=1
        l0= 9.6
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag7=-2.5*log10(fluxx*1.d3/zcam)
	flux7=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw8.dat')
c     c  'cam_lw8.dat')
c       read grid of responses; CAM LW8

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=7.154e-13
	i=1
        l0= 11.3
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag8=-2.5*log10(fluxx*1.d3/zcam)
	flux8=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw9.dat')
c     c  'cam_lw9.dat')
c       read grid of responses; CAM LW9

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.408e-13
	i=1
        l0= 14.9
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag9=-2.5*log10(fluxx*1.d3/zcam)
	flux9=fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/cam_lw10.dat')
c     c  'cam_lw10.dat')
c       read grid of responses; CAM LW10

	   read(15,20) txt
	   read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
c	  rcam(i,1)=rcam(i,1)*xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
c       gives +0.027 for Vega, and used in paper
c	zcam=7.415e-13
c       used for Leo MG 23.11.06
	zcam=7.233e-13
	i=1
        l0= 12.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmag10=-2.5*log10(fluxx*1.d3/zcam)
	flux10=fluxx*3.3356e17* l0*l0
	close(15)

c 99	format(1x,a14,1x,5(f8.3,1x))
c 98	format(1x,a14,1x,5(f9.1,1x))
c	write(40,99) 'ISOCAM LW6-10:', xmag6, xmag7, xmag8,xmag9,xmag10
c	write(40,98) 'LW6-10 in mJy:', flux6, flux7, flux8,flux9,flux10


c       COBE
	open(15,file=
     c  '/home/marting/GRAINS/COBE1.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=2.935d-9
	l0=1.25
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xcobe1= -2.5*log10(fluxx*1.e3/zcam)
	flxcobe1= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/COBE2.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=3.937d-10
	l0=2.2
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xcobe2= -2.5*log10(fluxx*1.e3/zcam)
	flxcobe2= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/COBE3.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=6.711d-11
	l0=3.57
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xcobe3= -2.5*log10(fluxx*1.e3/zcam)
	flxcobe3= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/COBE4.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=1.897d-11
	l0=4.93
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xcobe4= -2.5*log10(fluxx*1.e3/zcam)
	flxcobe4= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/COBE5.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam=5.567d-13
	l0=12.71
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xcobe5= -2.5*log10(fluxx*1.e3/zcam)
	flxcobe5= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	write(*,'(a15,5F7.3)') 'COBE filters 3 4 5: ', 
     c      xcobe3, xcobe4,xcobe5
	write(*,*)'COBE mJy',flxcobe1,flxcobe2,flxcobe3,flxcobe4,flxcobe5


c       MSX
	open(15,file=
     c  '/home/marting/GRAINS/mso96.a')
c     c  'mso96.a')
c       read grid of responses; MSX A-filter

	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.364d-12
	i=1
        l0= 8.28
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmaga= -2.5*log10(fluxx*1.d3/zcam)
	fluxa= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/mso96.c')
c     c  '/home/marting/GRAINS/mso96.c')
c       read grid of responses; MSX C-filter

	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=5.422e-13
	i=1
        l0= 12.12
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmagc= -2.5*log10(fluxx*1.d3/zcam)
	fluxc= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/mso96.d')
c     c  'mso96.d')
c       read grid of responses; MSX D-filter

	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.555e-13
	i=1
        l0= 14.65
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmagd= -2.5*log10(fluxx*1.d3/zcam)
	fluxd= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/mso96.e')
c     c  'mso96.e')
c       read grid of responses; MSX E-filter

	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=5.641e-14
	i=1
        l0= 21.34
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	xmage= -2.5*log10(fluxx*1.d3/zcam)
	fluxe= fluxx*3.3356e17* l0*l0
	close(15)

c	write(40,99) 'MSX ACDE:', xmaga, xmagc, xmagd, xmage
c	write(40,98) 'in mJy  :', fluxa, fluxc, fluxd, fluxe

c       W F I -filters /wfi

	open(15,file='/home/marting/GRAINS/u_wfi841.dat')
c       read grid of responses; WFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.345e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	umag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/b_wfi842.dat')
c       read grid of responses; WFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.001e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	bmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/v_wfi843.dat')
c       read grid of responses; WFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.936e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	vmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/r_wfi844.dat')
c       read grid of responses; WFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.24e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	rmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/i_wfi845.dat')
c       read grid of responses; WFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=9.50d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	imag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

c	write(*,*) 'WFI UBVRI:', umag, bmag, vmag, rmag, imag

c       S O F I  -filters /sofi

	open(15,file=
     c  '/home/marting/GRAINS/j_sofi.dat')
c       read grid of responses; SOFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.21d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0=1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	jmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/h_sofi.dat')
c       read grid of responses; SOFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.14d-9
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/k_sofi.dat')
c       read grid of responses; SOFI
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.33d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	kmag= -2.5*log10(fluxx*1.d3/zcam)
	close(15)

c	write(*,*) 'SOFI JHK:', jmag, hmag, kmag


c       MIPS  -filters /mips

	open(15,file=
     c  '/home/marting/GRAINS/MIPS_24.dat')
c       read grid of responses; MIPS
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.81e-14
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 24.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mips24= -2.5*log10(fluxx*1.d3/zcam)
	flux24= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/MIPS_70.dat')
c       read grid of responses; MIPS
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.84e-16
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 70.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mips70= -2.5*log10(fluxx*1.d3/zcam)
	flux70= fluxx*3.3356e17* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/MIPS_160.dat')
c       read grid of responses; MIPS
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.958e-17
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 160.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mips160= -2.5*log10(fluxx*1.d3/zcam)
	flux160= fluxx*3.3356e17* l0*l0
	close(15)

c	write(40,*) 'MIPS 24/70/160:', mips24, mips70, mips160
c	write(40,*) 'MIPS in mJy:', flux24, flux70, flux160


c       IRAC  -filters /irac


	open(15,file=
     c  '/home/marting/GRAINS/IRAC_36.dat')
c       read grid of responses; IRAC 3.6 mu
	read(15,20) txt
	read(15,20) txt
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1) /0.65
c	  rcam(i,1)= rcam(i,1) /xcam(i)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.63d-11
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 3.55
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	irac36= -2.5*log10(fluxx*1.d3/zcam)
	flux36= fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRAC_45.dat')
c       read grid of responses; IRAC 4.5 mu
	read(15,20) txt
	read(15,20) txt
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1) /0.74
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.67d-11
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 4.49
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	irac45= -2.5*log10(fluxx*1.d3/zcam)
	flux45= fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRAC_58.dat')
c       read grid of responses; IRAC 5.8 mu
	read(15,20) txt
	read(15,20) txt
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1) /0.28
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=10.81d-12
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 5.73
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	irac58= -2.5*log10(fluxx*1.d3/zcam)
	flux58= fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRAC_80.dat')
c       read grid of responses; IRAC 8.0 mu
	read(15,20) txt
	read(15,20) txt
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum, dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1) /0.42
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.08d-12
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 7.87
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	irac80= -2.5*log10(fluxx*1.d3/zcam)
	flux80= fluxx*3.3356e17* l0*l0
	close(15)

	write(*,*) 'IRAC 3.6/4.5/5.8/8.0:',irac36,irac45,irac58,irac80
	write(*,*) 'IRAC in mJy:', flux36, flux45, flux58, flux80

c	write(40,*) 'IRAC 3.6/4.5/5.8/8.0:',irac36,irac45,irac58,irac80
c	write(40,*) 'IRAC in mJy:', flux36, flux45, flux58, flux80


c       PACS  -filters /pacs
	open(15,file=
     c  '/home/marting/GRAINS/pacs_b1.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.87e-16
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 70.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	pacs_b1= -2.5*log10(fluxx*1.d3/zcam)
	flux_b1= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/pacs_b2.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=11.62e-17
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 100.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	pacs_b2= -2.5*log10(fluxx*1.d3/zcam)
	flux_b2= log10( fluxx*3.3356e17* l0*l0 )
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/pacs_r.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.77e-17
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 160.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	pacs_r= -2.5*log10(fluxx*1.d3/zcam)
	flux_r= log10( fluxx*3.3356e17* l0*l0 )
	close(15)


c       SPIRE  -filters /pacs

	open(15,file=
     c  '/home/marting/GRAINS/spire_psw.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.843e-18
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 250.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	spire_1= -2.5*log10(fluxx*1.d3/zcam)
	flux_s1= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/spire_pmw.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.89e-19
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 350.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	spire_2= -2.5*log10(fluxx*1.d3/zcam)
	flux_s2= log10( fluxx*3.3356e17*l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/spire_plw.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.51e-19
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 500.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	spire_3= -2.5*log10(fluxx*1.d3/zcam)
	flux_s3= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

c	write(32, 52) massloss, ap, tau, ap, flux_b1, ap, flux_b2, ap,
c     c         flux_r,ap, flux_s1,ap, flux_s2,ap, flux_s3, bs
c 52	format(e8.2,a3, f9.6,a3, 5(f7.3,a3), f6.3,a5)


c       sub-mm   Log10(milli Jansky)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_2000.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.96e-22
	i=1
        l0= 1921.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_1= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt1= log10(fluxx*3.3356e17* l0*l0)
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/ukt14_1300.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.44e-21
	i=1
        l0= 1259.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_2= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt2= log10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_1100.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=5.96e-21
	i=1
        l0= 1102.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_3= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt3= log10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_850.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.80e-20
	i=1
        l0= 850.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_4= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt4= log10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_800.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.40e-20
	i=1
        l0= 790.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_5= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt5= log10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_600.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=5.53e-20
	i=1
        l0= 647.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_6= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt6= log10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/ukt14_450.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.64e-19
	i=1
        l0= 443.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_7= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt7= log10(fluxx*3.3356e17* l0*l0)
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/ukt14_350.dat')
	read(15,*) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=6.95e-19
	i=1
        l0= 350.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ukt14_8= -2.5*log10(fluxx*1.d3/zcam)
	flux_ukt8= log10(fluxx*3.3356e17* l0*l0)
	close(15)



	open(15,file=
     c  '/home/marting/GRAINS/apex_450.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=2.39e-19
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 450.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	apex_1= -2.5*log10(fluxx*1.d3/zcam)
	flux_a1= log10(fluxx*3.3356e17* l0*l0 )
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/apex_870.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=1.63e-20
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 870.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	apex_2= -2.5*log10(fluxx*1.d3/zcam)
	flux_a2= log10(fluxx*3.3356e17* l0*l0 )
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/apex_1200.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=4.34e-21
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1200.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	apex_3= -2.5*log10(fluxx*1.d3/zcam)
	flux_a3= LOG10(fluxx*3.3356e17* l0*l0)
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/sest_1300.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam=3.31e-21

	i=1
        l0= 1300.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	apex_4= -2.5*log10(fluxx*1.d3/zcam)
	flux_a4= log10( fluxx*3.3356e17* l0*l0 )
	close(15)

c	write(*,*) 'Sub-mm 450/870/1200:', apex_1, apex_2, apex_3
	write(*,*) 'Sub-mm in mJy:',10**flux_a1,10**flux_a2,10**flux_a3

c       ASTRO-F /Akari

	open(15,file=
     c  '/home/marting/GRAINS/IRC_N2.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.09d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.4
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ircn2= -2.5*log10(fluxx*1.d3/zcam)
	flux_akn2= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRC_N3.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 0.973d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 3.2
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ircn3= -2.5*log10(fluxx*1.d3/zcam)
	flux_akn3= fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRC_N4.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.147d-11
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 4.1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ircn4= -2.5*log10(fluxx*1.d3/zcam)
	flux_akn4= fluxx*3.3356e17*l0*l0
	close(15)

c	write(40,*) 'ASTRO-F IRC N2,N3,N4:', ircn2, ircn3, ircn4
c	write(40,*) 'in mJy:', flux_1, flux_2, flux_3

	open(15,file=
     c  '/home/marting/GRAINS/MIRS_S7.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.49d-12
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 7.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirs7= -2.5*log10(fluxx*1.d3/zcam)
	flux_aks7= fluxx*3.3356e17*l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/MIRS_S9W.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.93d-12
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 9.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirs9= -2.5*log10(fluxx*1.d3/zcam)
	flux_aks9= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/MIRS_S11.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 9.076e-13
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 11.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirs11= -2.5*log10(fluxx*1.d3/zcam)
	flux_aks11= fluxx*3.3356e17* l0*l0
	close(15)

c	write(40,*) 'ASTRO-F MIR S7, S9W, S11:', mirs7, mirs9, mirs11
c	write(40,*) 'in mJy:', flux_4, flux_5, flux_6


	open(15,file=
     c  '/home/marting/GRAINS/MIRL_L15.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 2.043e-13
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 15.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirl15= -2.5*log10(fluxx*1.d3/zcam)
	flux_akl15= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/MIRL_L18W.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.019e-13
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 18.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirl18= -2.5*log10(fluxx*1.d3/zcam)
	flux_akl18= fluxx*3.3356e17* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/MIRL_L24.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.010e-14
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 24.0
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	mirl24= -2.5*log10(fluxx*1.d3/zcam)
	flux_akl24= fluxx*3.3356e17* l0*l0
	close(15)

c	write(40,*) 'ASTRO-F MIR L15, L20W, L24:', mirl15, mirl20,mirl24
c	write(40,*) 'in mJy:', flux_7, flux_8, flux_9


	open(15,file=
     c  '/home/marting/GRAINS/FIS-N60.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.72e-16
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 65.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	fisn60= -2.5*log10(fluxx*1.d3/zcam)
	flux_akn60= fluxx*3.3356e17* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/FIS-WS.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 2.24e-16
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 90.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	fisws= -2.5*log10(fluxx*1.d3/zcam)
	flux_akws= fluxx*3.3356e17* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/FIS-WL.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 2.71e-17
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 140.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	fiswl= -2.5*log10(fluxx*1.d3/zcam)
	flux_akwl= fluxx*3.3356e17* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/FIS-N160.FAD')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.73e-17
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 160.
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	fisn160= -2.5*log10(fluxx*1.d3/zcam)
	flux_akn160= fluxx*3.3356e17* l0*l0
	close(15)


c	write(40,*) 'ASTRO-F FIS N60, wide-S, wide-L, N160:',
c     c                        fisn60, fisws, fiswl, fisn160
c	write(40,*) 'in mJy:', flux_60, flux_ws, flux_wl, flux_160


c	write(31, 51) massloss, ap, tau, ap, flux_1, ap, flux_2, ap,
c     c         flux_3,ap, flux_4,ap, flux_5,ap, flux_6,ap, flux_7,ap,
c     c         flux_8,ap, flux_9,ap,
c     c          flux_60,ap, flux_ws,ap, flux_wl,ap, flux_160, bs

c 51	format(e8.2,a3, f9.6,a3, 9(f6.1,a3), 3(f7.2,a3), f7.2,a5)


c       WISE  #FIRST NUMBER IS BASED ON QE-based RSRs from Wright et al. 2010
c             #second number is photom-counting RSR from Jarrett et al. 2011
	open(15,file=
     c  '/home/marting/GRAINS/WISEW1.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1) , dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
c	zcam= 8.28e-11
	zcam= 8.12e-11
	i=1
        l0= 3.353
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	wise1= -2.5*log10(fluxx*1.e3/zcam)
	flux_w1= fluxx*3.3356e17 *l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WISEW2.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1) , dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
c	zcam= 2.43e-11
	zcam= 2.39e-11
	i=1
        l0= 4.603
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	wise2= -2.5*log10(fluxx*1.e3/zcam)
	flux_w2= fluxx*3.3356e17 *l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WISEW3.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1) , dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
c	zcam= 6.984e-13
	zcam= 6.100e-13
	i=1
        l0= 11.56
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	wise3= -2.5*log10(fluxx*1.e3/zcam)
	flux_w3= fluxx*3.3356e17 *l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WISEW4.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1) , dum
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
c	zcam= 5.00e-14
	zcam= 4.93e-14
	i=1
        l0= 22.09
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	wise4= -2.5*log10(fluxx*1.e3/zcam)
	flux_w4= fluxx*3.3356e17 *l0*l0
	close(15)


c       Bessell filtercurves
	open(15,file=
     c  '/home/marting/GRAINS/u_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.214e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.366
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BesU= -2.5*log10(fluxx*1.d3/zcam)
	fluxU= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/b_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.255e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.438
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BesB= -2.5*log10(fluxx*1.d3/zcam)
	fluxB= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/v_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.627e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.545
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BesV= -2.5*log10(fluxx*1.d3/zcam)
	fluxV= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/r_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 2.205e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.641
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BesR= -2.5*log10(fluxx*1.d3/zcam)
	fluxR= fluxx*3.3356e14* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/i_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.142e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.798
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BesI= -2.5*log10(fluxx*1.d3/zcam)
	fluxI= fluxx*3.3356e14* l0*l0
	close(15)

	write(*,'(a15,5F7.3)') 'Bessell UBVRI:',BesU,BesB,BesV,BesR,BesI
       write(*,*) 'Bessell UBVRI: (Jy) ', fluxU, fluxB,fluxV,fluxR,fluxI

c	write(40,*) 'Bessell UBVRI:', BesU, BesB, BesV, BesR, BesI
c       write(40,*)'Bessell UBVRI: (Jy) ', fluxU,fluxB,fluxV,fluxR,fluxI

c       Cousins R I
	open(15,file=
     c  '/home/marting/GRAINS/RCousins.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.165e-8
c       AB test
c	zcam=3.927e-8
	i=1
	l0= 0.6470
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Rcousins= -2.5*log10(fluxx*1.d3/zcam)
	fluxR= fluxx*3.3356e14* l0*l0
	close(15)
        call pgline(ncam, xcam, ypl)

	open(15,file=
     c  '/home/marting/GRAINS/ICousins.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.200e-8
c       AB test
c	zcam=3.927e-8
	i=1
	l0= 0.7865
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Icousins= -2.5*log10(fluxx*1.d3/zcam)
	fluxI= fluxx*3.3356e14* l0*l0
	close(15)
        call pgline(ncam, xcam, ypl)

c	write(*,'(a15,5F7.3)') 'Cousins RI:',Rcousins,Icousins
c        write(*,*) 'Cousins RI: (Jy) ', fluxR,fluxI
c	write(40,*) 'Cousins RI:', Rcousins,Icousins
c        write(40,*)'Cousins RI: (Jy) ', fluxR,fluxI


c       OGLE UBVI
	open(15,file='/home/marting/GRAINS/u_ogle.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.358e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.372
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	OgleU= -2.5*log10(fluxx*1.d3/zcam)
	fluxU= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/b_ogle.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.229e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.431
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	OgleB= -2.5*log10(fluxx*1.d3/zcam)
	fluxB= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/v_ogle.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.784e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.536
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	OgleV= -2.5*log10(fluxx*1.d3/zcam)
	fluxV= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/i_ogle.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.060e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.820
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	OgleI= -2.5*log10(fluxx*1.d3/zcam)
	fluxI= fluxx*3.3356e14* l0*l0
	close(15)

	write(*,'(a15,4F7.3)') 'OGLE UBVI:', OgleU, OgleB, OgleV, OgleI
	write(*,*) 'OGLE UBVI: (Jy) ', fluxU, fluxB, fluxV, fluxR, fluxI


C       HST Holtzmann

	open(15,file=
     c  '/home/marting/GRAINS/f300w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.808e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.297
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst300= -2.5*log10(fluxx*1.d3/zcam)
	flux300= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/f439w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.951e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.429
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst439= -2.5*log10(fluxx*1.d3/zcam)
	flux439= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/f450w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.003e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.444
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst450= -2.5*log10(fluxx*1.d3/zcam)
	flux450= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/f555w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.966e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.518
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst555= -2.5*log10(fluxx*1.d3/zcam)
	flux555= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/f606w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 2.958e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.573
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst606= -2.5*log10(fluxx*1.d3/zcam)
	flux606= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/f814w.mod')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.156e-8
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.819
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst814= -2.5*log10(fluxx*1.d3/zcam)
	flux814= fluxx*3.3356e14* l0*l0
	close(15)


C       SLOAN filters  3631 Jy for m=0; used that to compute AB-correction
	open(15,file=
     c  '/home/marting/GRAINS/SLOAN_u.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum,dum,dum
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 40.66d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.3581
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Usl= -2.5*log10(fluxx*1.d3/zcam)  +0.799
	fluxU= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/SLOAN_g.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum,dum,dum
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 55.82d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.4686
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	gSl= -2.5*log10(fluxx*1.d3/zcam) -0.129
	fluxG= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/SLOAN_r.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum,dum,dum
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 25.52d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.6165
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	rSl= -2.5*log10(fluxx*1.d3/zcam) +0.125
	fluxR= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/SLOAN_i.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum,dum,dum
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 14.23d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.7481
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	iSl= -2.5*log10(fluxx*1.d3/zcam) +0.340
	fluxI= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/SLOAN_z.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1), dum,dum,dum
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 8.527d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.8931
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	zSl= -2.5*log10(fluxx*1.d3/zcam) +0.511
	fluxZ= fluxx*3.3356e14* l0*l0
	close(15)

c	write(40,*) 'Sloan ugriz:', uSl, gSl, rSl, iSl, zSl
c	write(40,*) 'Sloan ugriz (Jy): ', fluxU,fluxG,fluxR,fluxI,fluxZ


c       VISTA  ETC-version
	open(15,file=
     c  '/home/marting/GRAINS/VISTAZ.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 8.905e-9
	l0= 0.876
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Zvis= -2.5*log10(fluxx*1.e3/zcam)
	fluxZ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/VISTAY.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.053e-9
	l0= 1.018
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Yvis= -2.5*log10(fluxx*1.e3/zcam)
	fluxY= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/VISTAJ.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.022e-9
	l0= 1.246
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jvis= -2.5*log10(fluxx*1.e3/zcam)
	fluxJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/VISTAH.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.164e-9
	l0= 1.631
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hvis= -2.5*log10(fluxx*1.e3/zcam)
	fluxH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/VISTAK.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.467e-10
	l0= 2.133
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kvis= -2.5*log10(fluxx*1.e3/zcam)
	fluxK= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a8,5F7.3)')'VISTA ZYJHK:', Zvis,Yvis,Jvis,Hvis,Kvis
c	write(*,*) 'ZYJHK: (Jy) ', fluxZ, fluxY, fluxJ, fluxH, fluxK


C       WFCAM UKIRT
	open(15,file=
     c  '/home/marting/GRAINS/WFCAM_Z.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 8.807d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 0.8817
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Zwf= -2.5*log10(fluxx*1.d3/zcam)
	fluxZ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WFCAM_Y.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 5.834d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.0305
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Ywf= -2.5*log10(fluxx*1.d3/zcam)
	fluxY= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WFCAM_J.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.022d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.2483
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jwf= -2.5*log10(fluxx*1.d3/zcam)
	fluxJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WFCAM_H.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.179d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.6313
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hwf= -2.5*log10(fluxx*1.d3/zcam)
	fluxH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WFCAM_K.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.018d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.2010
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kwf= -2.5*log10(fluxx*1.d3/zcam)
	fluxK= fluxx*3.3356e14* l0*l0
	close(15)

	write(*,'(a6,5F7.3)') ' WFCAM ZYJHK:', Zwf, Ywf, Jwf, Hwf, Kwf
	write(*,*) 'ZYJHK(Jy):', fluxZ, fluxY, fluxJ, fluxH, fluxK

C       IRTF - IRSF
c       new ``Mauna Kea'' infrared filter
c       http://irtfweb.ifa.hawaii.edu/~nsfcam/filters.html

	open(15,file=
     c  '/home/marting/GRAINS/IRSF_J.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.036d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.25
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jirsf= -2.5*log10(fluxx*1.d3/zcam)
	fluxJirsf= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRSF_H.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.184d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.644
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hirsf= -2.5*log10(fluxx*1.d3/zcam)
	fluxHirsf= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IRSF_Ks.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.45d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.149
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kirsf= -2.5*log10(fluxx*1.d3/zcam)
	fluxKirsf= fluxx*3.3356e14* l0*l0
	close(15)


c       NICMOS
	open(15,file=
     c  '/home/marting/GRAINS/nicmos_f110w.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.882d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.02
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jnic= -2.5*log10(fluxx*1.d3/zcam)
	fluxJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/nicmos_f160w.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.284d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.57
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hnic= -2.5*log10(fluxx*1.d3/zcam)
	fluxH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/nicmos_f205w.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 5.402d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.98
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Knic= -2.5*log10(fluxx*1.d3/zcam)
	fluxK= fluxx*3.3356e14* l0*l0
	close(15)


c       2MASS
	open(15,file=
     c  '/home/marting/GRAINS/j_2mass.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.137d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.235
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jmass= -2.5*log10(fluxx*1.d3/zcam)
	fluxJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/h_2mass.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.130d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.662
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hmass= -2.5*log10(fluxx*1.d3/zcam)
	fluxH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/k_2mass.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.312d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.159
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kmass= -2.5*log10(fluxx*1.d3/zcam)
	fluxK= fluxx*3.3356e14* l0*l0
	close(15)



c       Bessell NIR
	open(15,file=
     c  '/home/marting/GRAINS/j_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.198d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.22
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jbessell= -2.5*log10(fluxx*1.d3/zcam)
	fluxBJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/h_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.14d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.63
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hbessell= -2.5*log10(fluxx*1.d3/zcam)
	fluxBH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/k_bessell.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 4.031d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.19
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kbessell= -2.5*log10(fluxx*1.d3/zcam)
	fluxBK= fluxx*3.3356e14* l0*l0
	close(15)


        write(6,*) 'Denis IJK:(mag) ',xmagi, xmagj, xmagk
        write(6,*) 'Denis IJK (Jy): ',fluxDi, fluxDj, fluxDk

	write (6,*) 'denis I-J,J-K,I-K: ',(xmagi-xmagj),
     c    (xmagj-xmagk),(xmagi-xmagk)


c        write(40,*) 'Denis IJK:(mag) ',xmagi, xmagj, xmagk
c        write(40,*) 'Denis IJK (Jy): ',fluxDi, fluxDj, fluxDk

c	write (40,*) 'denis I-J,J-K,I-K: ',(xmagi-xmagj),
c     c    (xmagj-xmagk),(xmagi-xmagk)


	write(*,*) '2MASS JHK:', Jmass, Hmass, Kmass, (Jmass-Kmass)
c	write(*,*) '2MASS JHK: (Jy) ', fluxJ, fluxH, fluxK
c	write(40,*) '2MASS JHK:', Jmass, Hmass, Kmass, (Jmass-Kmass)
c	write(40,*) '2MASS JHK: (Jy) ', fluxJ, fluxH, fluxK

	write(*,*) 'Bessell JHK:', Jbessell, Hbessell, Kbessell,
     c                             (Jbessell-Kbessell)
	write(*,*) 'Bessell JHK: (Jy) ', fluxBJ, fluxBH, fluxBK




	open(15,file=
     c  '/home/marting/GRAINS/j_caspir.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.182d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.24
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Jcaspir= -2.5*log10(fluxx*1.d3/zcam)
	fluxJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/h_caspir.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 1.101d-9
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 1.68
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hcaspir= -2.5*log10(fluxx*1.d3/zcam)
	fluxH= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/k_caspir.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 3.993d-10
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 2.22
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Kcaspir= -2.5*log10(fluxx*1.d3/zcam)
	fluxK= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/l_caspir.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu]
	zcam= 6.306d-11
c       AB test
c	zcam=3.927e-8
	i=1
        l0= 3.59
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Lcaspir= -2.5*log10(fluxx*1.d3/zcam)
	fluxL= fluxx*3.3356e14* l0*l0
	close(15)

c	write(40,*) 'CASPIR JHKL:', Jcaspir, Hcaspir, Kcaspir, Lcaspir
c	write(40,*) 'CASPIR JHKL: (Jy) ', fluxJ, fluxH, fluxK, fluxL


c       GAIA G-band for astrometric instrument, BP, RP, RVS
	open(15,file=
     c  '/home/marting/GRAINS/GAIA_G.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  rcam(i,1)= rcam(i,1)* xcam(i)
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.182e-8
	l0= 0.673
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	GAIAGband= -2.5*log10(fluxx*1.e3/zcam)
	fluxGband= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/GAIA_Bp.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  rcam(i,1)= rcam(i,1)* xcam(i)
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.891e-8
	l0= 0.532
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	GAIABp= -2.5*log10(fluxx*1.e3/zcam)
	fluxBp= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/GAIA_Rp.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  rcam(i,1)= rcam(i,1)* xcam(i)
	  ypl(i)= rcam(i,1) 
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.218e-8
	l0= 0.797
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	GAIARp= -2.5*log10(fluxx*1.e3/zcam)
	fluxRp= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/GAIA_RVS.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  rcam(i,1)= rcam(i,1)* xcam(i)
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 0.9088e-8
	l0= 0.860
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	GAIARVS= -2.5*log10(fluxx*1.e3/zcam)
	fluxRVS= fluxx*3.3356e14* l0*l0
	close(15)

	write(*,'(a10,4F7.3)')'GAIA G:',GAIAGband,GAIABp,GAIARp,GAIARVS
	write(*,*) 'GAIA G: (Jy) ', fluxGband, fluxBp, fluxRp, fluxRVS



c       special filters CN TiO [FK], Halpha, CN TiO [ESO]

	open(15,file=
     c  '/home/marting/GRAINS/CNFK.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.258e-8
        l0= 0.770
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	CNFK= -2.5*log10(fluxx*1.d3/zcam)
	fluxCN= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/TiOFK.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.095e-8
        l0= 0.810
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	tioFK= -2.5*log10(fluxx*1.d3/zcam)
	fluxtio= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/WFCH6568.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.870e-8
        l0= 0.6568
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	halpha= -2.5*log10(fluxx*1.d3/zcam)
	fluxha= fluxx*3.3356e14* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/CNeso.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.287e-8
        l0= 0.770
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	CNeso= -2.5*log10(fluxx*1.d3/zcam)
	fluxCN= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/TiOeso.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.072e-8
        l0= 0.816
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	tioeso= -2.5*log10(fluxx*1.d3/zcam)
	fluxtio= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a15,4F7.3)') 'CN TiO Halpha: ', cnfk, tiofk,(tiofk-cnfk), halpha
c	write(*,'(a15,4F7.3)') 'CN TiO : ',      cneso, tioeso, (tioeso-cneso)


c     GALEX
	open(15,file=
     c  '/home/marting/GRAINS/galex_fuv.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.74e-8
        l0= 0.155
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	galfuv= -2.5*log10(fluxx*1.d3/zcam)
	fluxgalfuv= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/galex_nuv.dat')
	read(15,20) txt
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.36e-8
        l0= 0.235
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	galnuv= -2.5*log10(fluxx*1.d3/zcam)
	fluxgalnuv= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,*)'GALEX FUV NUV ', galfuv,fluxgalfuv,galnuv,fluxgalnuv


c       MACHO B R
	open(15,file='/home/marting/GRAINS/MACHOB.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.067e-8
	l0= 0.5225
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	MachoB= -2.5*log10(fluxx*1.d3/zcam)
	fluxMachoB= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file='/home/marting/GRAINS/MACHOR.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.8016e-8
	l0= 0.6950
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	MachoR= -2.5*log10(fluxx*1.d3/zcam)
	fluxMachoR= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a15,4F7.3)') 'MACHO BR:', MachoB, MachoR
c	write(*,*) 'MACHO BR (Jy) ', fluxMachoB, fluxMAchoR

c       EROS B R
	open(15,file='/home/marting/GRAINS/EROSB.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.468e-8
	l0= 0.54
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ErosB= -2.5*log10(fluxx*1.d3/zcam)
	fluxErosB= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file='/home/marting/GRAINS/EROSR.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.4219e-8
	l0= 0.74
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	ErosR= -2.5*log10(fluxx*1.d3/zcam)
	fluxErosR= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a15,4F7.3)') 'EROS BR:', ErosB, ErosR
c	write(*,*) 'EROS BR (Jy) ', fluxErosB, fluxErosR


c       photographic filters
	open(15,file=
     c  '/home/marting/GRAINS/Opg_POSSI-O-103aO-clear.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 5.69d-8
	i=1
	l0= 0.42
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Opg= -2.5*log10(fluxx*1.e3/zcam)
	fluxOpg= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/Epg_POSSI-E-103aE-plexi.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.21d-8
	i=1
	l0= 0.64
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Epg= -2.5*log10(fluxx*1.e3/zcam)
	fluxEpg= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/V495_UKSTU-V-IIaD-GG495.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.33d-8
	i=1
	l0= 0.56
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	V495= -2.5*log10(fluxx*1.e3/zcam)
	fluxV495= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/BJ_POSSII-J-IIIaJ-GG395.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 5.31d-8
	i=1
	l0= 0.47
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BJ= -2.5*log10(fluxx*1.e3/zcam)
	fluxBJ= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/RF_POSSII-F-IIIaF-RG610.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.08d-8
	i=1
	l0= 0.66
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	RF= -2.5*log10(fluxx*1.e3/zcam)
	fluxRF= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/IN_POSSII-N-IVN-RG9.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.03d-8
	i=1
	l0= 0.83
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	INm= -2.5*log10(fluxx*1.e3/zcam)
	fluxIN= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a22,6F7.3)') 'Opg Epg V495 BJ RF IN', 
c     c                          Opg,Epg,V495,BJ,RF,INm
c	write(*,*) 'in mJy:', fluxOpg, fluxEpg, fluxV495, fluxBJ, fluxRF,fluxIN

c       Hipparcos & Tycho
	open(15,file='/home/marting/GRAINS/Hp.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.916d-8
	i=1
	l0= 0.5275
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	Hp= -2.5*log10(fluxx*1.e3/zcam)
	fluxHp= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file='/home/marting/GRAINS/BT.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.586d-8
	i=1
	l0= 0.4203
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	BT= -2.5*log10(fluxx*1.e3/zcam)
	fluxBT= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file='/home/marting/GRAINS/VT.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.949d-8
	i=1
	l0= 0.5319
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	VT= -2.5*log10(fluxx*1.e3/zcam)
	fluxVT= fluxx*3.3356e14* l0*l0
	close(15)

c	write(*,'(a15,5F7.3)') 'Hp BT VT:',Hp, BT, VT
c        write(*,*) 'Hipp Tycho: (Jy) ', fluxHp, fluxBT, fluxVT

C       HST ACS
	open(15,file=
     c  '/home/marting/GRAINS/HST_ACS_WFC.F475W_81.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 5.260e-8
c       AB test
c	zcam=3.927e-8
	l0= 0.475
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst475= -2.5*log10(fluxx*1.e3/zcam)
	flux475= fluxx*3.3356e14* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/HST_ACS_WFC.F555W_81.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.879e-8
c       AB test
c	zcam=3.927e-8
	l0= 0.540
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst555= -2.5*log10(fluxx*1.e3/zcam)
	flux555= fluxx*3.3356e14* l0*l0
	close(15)


	open(15,file=
     c  '/home/marting/GRAINS/HST_ACS_WFC.F814W_81.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.127e-8
c       AB test
c	zcam=3.927e-8
	l0= 0.814
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst814= -2.5*log10(fluxx*1.e3/zcam)
	flux814= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/HST_WFC3_IR.F110W.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.311e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.10
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst110= -2.5*log10(fluxx*1.e3/zcam)
	flux110= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/HST_WFC3_IR.F160W.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.454e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.53
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst160= -2.5*log10(fluxx*1.e3/zcam)
	flux160= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/HST_WFC3_IR.F127M.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.760e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.273
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst127= -2.5*log10(fluxx*1.e3/zcam)
	flux127= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/HST_WFC3_IR.F139M.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.104e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.383
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst139= -2.5*log10(fluxx*1.e3/zcam)
	flux139= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/HST_WFC3_IR.F153M.dat')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*0.1
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.460e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.532
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	hst153= -2.5*log10(fluxx*1.e3/zcam)
	flux153= fluxx*3.3356e14* l0*l0
	close(15)



c      JWST filters
	open(15,file=
     c  '/home/marting/GRAINS/F070W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.758e-8
c       AB test
c	zcam=3.927e-8
	l0= 0.70
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F070W= -2.5*log10(fluxx*1.e3/zcam)
	flux070W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F090W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 8.445e-9
c       AB test
c	zcam=3.927e-8
	l0= 0.90
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F090W= -2.5*log10(fluxx*1.e3/zcam)
	flux090W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F115W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.083e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.15
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F115W= -2.5*log10(fluxx*1.e3/zcam)
	flux115W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F150W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.594e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.5
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F150W= -2.5*log10(fluxx*1.e3/zcam)
	flux150W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F200W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 5.929e-10
c       AB test
c	zcam=3.927e-8
	l0= 2.00
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F200W= -2.5*log10(fluxx*1.e3/zcam)
	flux200W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F277W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.701e-10
c       AB test
c	zcam=3.927e-8
	l0= 2.77
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F277W= -2.5*log10(fluxx*1.e3/zcam)
	flux277W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F356W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.660e-11
c       AB test
c	zcam=3.927e-8
	l0= 3.56
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F356W= -2.5*log10(fluxx*1.e3/zcam)
	flux356W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F444W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.836e-11
c       AB test
c	zcam=3.927e-8
	l0= 4.44
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F444W= -2.5*log10(fluxx*1.e3/zcam)
	flux444W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F560W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.123e-11
c       AB test
c	zcam=3.927e-8
	l0= 5.60
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F560W= -2.5*log10(fluxx*1.e3/zcam)
	flux560W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F770W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.416e-12
c       AB test
c	zcam=3.927e-8
	l0= 7.70
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F770W= -2.5*log10(fluxx*1.e3/zcam)
	flux770W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F1000W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.196e-12
c       AB test
c	zcam=3.927e-8
	l0= 10.0
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F1000W= -2.5*log10(fluxx*1.e3/zcam)
	flux1000W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F1130W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 7.193e-13
c       AB test
c	zcam=3.927e-8
	l0= 11.3
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F1130W= -2.5*log10(fluxx*1.e3/zcam)
	flux1130W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F1280W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.430e-13
c       AB test
c	zcam=3.927e-8
	l0= 12.8
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F1280W= -2.5*log10(fluxx*1.e3/zcam)
	flux1280W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F1500W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.318e-13
c       AB test
c	zcam=3.927e-8
	l0= 15.0
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F1500W= -2.5*log10(fluxx*1.e3/zcam)
	flux1500W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F1800W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.145e-13
c       AB test
c	zcam=3.927e-8
	l0= 18.0
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F1800W= -2.5*log10(fluxx*1.e3/zcam)
	flux1800W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F2100W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.396e-14
c       AB test
c	zcam=3.927e-8
	l0= 21.0
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F2100W= -2.5*log10(fluxx*1.e3/zcam)
	flux2100W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F2550W.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.899e-14
c       AB test
c	zcam=3.927e-8
	l0= 25.5
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F2550W= -2.5*log10(fluxx*1.e3/zcam)
	flux2550W= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F140M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.024e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.40
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F140M= -2.5*log10(fluxx*1.e3/zcam)
	flux140M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F158M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.31e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.58
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F158M= -2.5*log10(fluxx*1.e3/zcam)
	flux158M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F162M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.198e-9
c       AB test
c	zcam=3.927e-8
	l0= 1.62
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F162M= -2.5*log10(fluxx*1.e3/zcam)
	flux162M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F182M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 7.877e-10
c       AB test
c	zcam=3.927e-8
	l0= 1.82
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F182M= -2.5*log10(fluxx*1.e3/zcam)
	flux182M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F210M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.862e-10
c       AB test
c	zcam=3.927e-8
	l0= 2.10
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F210M= -2.5*log10(fluxx*1.e3/zcam)
	flux210M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F250M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.489e-10
c       AB test
c	zcam=3.927e-8
	l0= 2.50
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F250M= -2.5*log10(fluxx*1.e3/zcam)
	flux250M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F300M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 1.257e-10
c       AB test
c	zcam=3.927e-8
	l0= 3.0
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F300M= -2.5*log10(fluxx*1.e3/zcam)
	flux300M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F335M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 8.183e-11
c       AB test
c	zcam=3.927e-8
	l0= 3.35
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F335M= -2.5*log10(fluxx*1.e3/zcam)
	flux335M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F360M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 6.151e-11
c       AB test
c	zcam=3.927e-8
	l0= 3.60
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F360M= -2.5*log10(fluxx*1.e3/zcam)
	flux360M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F380M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 4.894e-11
c       AB test
c	zcam=3.927e-8
	l0= 3.80
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F380M= -2.5*log10(fluxx*1.e3/zcam)
	flux380M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F410M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.838e-11
c       AB test
c	zcam=3.927e-8
	l0= 4.10
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F410M= -2.5*log10(fluxx*1.e3/zcam)
	flux410M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F430M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 3.187e-11
c       AB test
c	zcam=3.927e-8
	l0= 4.30
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F430M= -2.5*log10(fluxx*1.e3/zcam)
	flux430M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F460M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.373e-11
c       AB test
c	zcam=3.927e-8
	l0= 4.60
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F460M= -2.5*log10(fluxx*1.e3/zcam)
	flux460M= fluxx*3.3356e14* l0*l0
	close(15)

	open(15,file=
     c  '/home/marting/GRAINS/F480M.txt')
	read(15,*) ncam
	do i=1,ncam
	  read(15,*) xcam(i),dum,dum,rcam(i,1)
	  xcam(i)=xcam(i)*1000.
	  ypl(i)= rcam(i,1)
	enddo
c       zeropoints for 0-mag star [w/m2/mu] 
	zcam= 2.005e-11
c       AB test
c	zcam=3.927e-8
	l0= 4.80
	i=1
	call rp(i,xcam,rcam,ncam,xl,fx,n,fluxx, l0)
	F480M= -2.5*log10(fluxx*1.e3/zcam)
	flux480M= fluxx*3.3356e14* l0*l0
	close(15)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	write(41,'(A6,1x,f7.3)') '  BesU', BesU
	write(41,'(A6,1x,f7.3)') '  BesB', BesB
	write(41,'(A6,1x,f7.3)') '  BesV', BesV
	write(41,'(A6,1x,f7.3)') '  BesR', BesR
	write(41,'(A6,1x,f7.3)') '  BesI', BesI

	write(41,'(A6,1x,f7.3)') 'wfcamZ', Zwf
	write(41,'(A6,1x,f7.3)') 'wfcamY', Ywf
	write(41,'(A6,1x,f7.3)') 'wfcamJ', Jwf
	write(41,'(A6,1x,f7.3)') 'wfcamH', Hwf
	write(41,'(A6,1x,f7.3)') 'wfcamK', Kwf

 	write(41,'(A6,1x,f7.3)') 'denisI', xmagi
	write(41,'(A6,1x,f7.3)') 'denisJ', xmagj
	write(41,'(A6,1x,f7.3)') 'denisK', xmagk

 	write(41,'(A6,1x,f7.3)') '2massJ', Jmass
	write(41,'(A6,1x,f7.3)') '2massH', Hmass
	write(41,'(A6,1x,f7.3)') '2massK', Kmass

	write(41,'(A6,1x,f7.3)') 'irac36', irac36
	write(41,'(A6,1x,f7.3)') 'irac45', irac45
	write(41,'(A6,1x,f7.3)') 'irac58', irac58
	write(41,'(A6,1x,f7.3)') 'irac80', irac80

	write(41,'(A6,1x,f7.3)') 'iras12', xm12
	write(41,'(A6,1x,f7.3)') 'iras25', xm25
	write(41,'(A6,1x,f7.3)') 'iras60', xm60
	write(41,'(A6,1x,f7.3)') 'ira100', xm100

 	write(41,'(A6,1x,f7.3)') ' irsfJ', Jirsf
 	write(41,'(A6,1x,f7.3)') ' irsfH', Hirsf
 	write(41,'(A6,1x,f7.3)') ' irsfK', Kirsf

 	write(41,'(A6,1x,f7.3)') '  MSXA', xmaga

 	write(41,'(A6,1x,f7.3)') 'caspiJ', Jcaspir
 	write(41,'(A6,1x,f7.3)') 'caspiH', Hcaspir
 	write(41,'(A6,1x,f7.3)') 'caspiK', Kcaspir
 	write(41,'(A6,1x,f7.3)') 'caspiL', Lcaspir

	write(41,'(A6,1x,f7.3)') 'mips24', mips24
	write(41,'(A6,1x,f7.3)') 'mips70', mips70
	write(41,'(A6,1x,f7.3)') 'mip160', mips160

	write(41,'(A6,1x,f7.3)') ' ogleU', ogleU
	write(41,'(A6,1x,f7.3)') ' ogleB', ogleB
	write(41,'(A6,1x,f7.3)') ' ogleV', ogleV
	write(41,'(A6,1x,f7.3)') ' ogleI', ogleI

	write(41,'(A6,1x,f7.3)') ' casw1', xmag11
	write(41,'(A6,1x,f7.3)') ' calw1', xmag1
	write(41,'(A6,1x,f7.3)') ' calw2', xmag2
	write(41,'(A6,1x,f7.3)') ' calw7', xmag7
	write(41,'(A6,1x,f7.3)') 'calw10', xmag10

	write(41,'(A6,1x,f7.3)') ' saaoJ', xmagsj
	write(41,'(A6,1x,f7.3)') ' saaoH', xmagsh
	write(41,'(A6,1x,f7.3)') ' saaoK', xmagsk
	write(41,'(A6,1x,f7.3)') ' saaoL', xmagsl

	write(41,'(A6,1x,f7.3)') 'apx450', flux_a1
	write(41,'(A6,1x,f7.3)') 'apx870', flux_a2
	write(41,'(A6,1x,f7.3)') 'ap1200', flux_a3

	write(41,'(A6,1x,f7.3)') 'sloanu', uSl
	write(41,'(A6,1x,f7.3)') 'sloang', gSl
	write(41,'(A6,1x,f7.3)') 'sloanr', rSl
	write(41,'(A6,1x,f7.3)') 'sloani', iSl
	write(41,'(A6,1x,f7.3)') 'sloanz', zSl

	write(41,'(A6,1x,f7.3)') '  esoJ', xesoj
	write(41,'(A6,1x,f7.3)') '  esoH', xesoh
	write(41,'(A6,1x,f7.3)') '  esoK', xesok
	write(41,'(A6,1x,f7.3)') '  esoL', xesol
	write(41,'(A6,1x,f7.3)') '  esoM', xesom

	write(41,'(A6,1x,f7.3)') 'ukt350', flux_ukt8
	write(41,'(A6,1x,f7.3)') 'ukt450', flux_ukt7
	write(41,'(A6,1x,f7.3)') 'ukt600', flux_ukt6
	write(41,'(A6,1x,f7.3)') 'ukt800', flux_ukt5
	write(41,'(A6,1x,f7.3)') 'ukt850', flux_ukt4
	write(41,'(A6,1x,f7.3)') 'uk1100', flux_ukt3
	write(41,'(A6,1x,f7.3)') 'uk1300', flux_ukt2
	write(41,'(A6,1x,f7.3)') 'uk2000', flux_ukt1

	write(41,'(A6,1x,f7.3)') 'se1300', flux_a4

	write(41,'(A6,1x,f7.3)') '  esoN', xeson0
	write(41,'(A6,1x,f7.3)') ' esoN1', xeson1
	write(41,'(A6,1x,f7.3)') ' esoN2', xeson2
	write(41,'(A6,1x,f7.3)') ' esoN3', xeson3
	write(41,'(A6,1x,f7.3)') ' esoQ0', xesoq0

	write(41,'(A6,1x,f7.3)') ' pacsb', flux_b1
	write(41,'(A6,1x,f7.3)') ' pacsg', flux_b2
	write(41,'(A6,1x,f7.3)') ' pacsr', flux_r

	write(41,'(A6,1x,f7.3)') 'spire1', flux_s1
	write(41,'(A6,1x,f7.3)') 'spire2', flux_s2
	write(41,'(A6,1x,f7.3)') 'spire3', flux_s3

	write(41,'(A6,1x,f7.3)') 'AkarN2', ircn2
	write(41,'(A6,1x,f7.3)') 'AkarN3', ircn3
	write(41,'(A6,1x,f7.3)') 'AkarN4', ircn4
	write(41,'(A6,1x,f7.3)') 'AkarS7', mirs7
	write(41,'(A6,1x,f7.3)') 'AkaS9W', mirs9
	write(41,'(A6,1x,f7.3)') 'AkaS11', mirs11
	write(41,'(A6,1x,f7.3)') 'AkaL15', mirl15
	write(41,'(A6,1x,f7.3)') 'AkL18W', mirl18
	write(41,'(A6,1x,f7.3)') 'AkaL24', mirl24
	write(41,'(A6,1x,f7.3)') 'AkaN60', fisn60
	write(41,'(A6,1x,f7.3)') 'AkarWS', fisws
	write(41,'(A6,1x,f7.3)') 'AkarWL', fiswl
	write(41,'(A6,1x,f7.3)') 'AkN160', fisn160

	write(41,'(A6,1x,f7.3)') 'vistaZ', Zvis
	write(41,'(A6,1x,f7.3)') 'vistaY', Yvis
	write(41,'(A6,1x,f7.3)') 'vistaJ', Jvis
	write(41,'(A6,1x,f7.3)') 'vistaH', Hvis
	write(41,'(A6,1x,f7.3)') 'vistaK', Kvis

	write(41,'(A6,1x,f7.3)') 'WISE1 ', wise1
	write(41,'(A6,1x,f7.3)') 'WISE2 ', wise2
	write(41,'(A6,1x,f7.3)') 'WISE3 ', wise3
	write(41,'(A6,1x,f7.3)') 'WISE4 ', wise4

	write(41,'(A6,1x,f7.3)') 'Opg   ', Opg
	write(41,'(A6,1x,f7.3)') 'Epg   ', Epg
	write(41,'(A6,1x,f7.3)') 'V495  ', V495
	write(41,'(A6,1x,f7.3)') 'JpgBJ ', BJ
	write(41,'(A6,1x,f7.3)') 'FpgRF ', RF
	write(41,'(A6,1x,f7.3)') 'NmagIN', INm

	write(41,'(A6,1x,f7.3)') 'PAH1VI', xpah1
	write(41,'(A6,1x,f7.3)') 'PAH2VI', xpah2
	write(41,'(A6,1x,f7.3)') 'SICVI ', xsic

	write(41,'(A6,1x,f7.3)') 'COBE3 ', flxcobe3
	write(41,'(A6,1x,f7.3)') 'COBE4 ', flxcobe4
	write(41,'(A6,1x,f7.3)') 'COBE5 ', flxcobe5

	write(41,'(A6,1x,f7.3)') 'Hippac', HP
	write(41,'(A6,1x,f7.3)') 'TychoB', BT
	write(41,'(A6,1x,f7.3)') 'TychoV', VT

	write(41,'(A6,1x,f7.3)') 'CNFK  ', CNFK
	write(41,'(A6,1x,f7.3)') 'CNESO ', CNESO
	write(41,'(A6,1x,f7.3)') 'TiOFK ', tioFK
	write(41,'(A6,1x,f7.3)') 'TiOESO', tioESO
	write(41,'(A6,1x,f7.3)') 'Halpha', Halpha

	write(41,'(A6,1x,f7.3)') 'GALFUV', galfuv
	write(41,'(A6,1x,f7.3)') 'GALNUV', galnuv

	write(41,'(A6,1x,f7.3)') 'MACHOB', machoB
	write(41,'(A6,1x,f7.3)') 'MACHOR', machoR

	write(41,'(A6,1x,f7.3)') 'EROSB ', erosB
	write(41,'(A6,1x,f7.3)') 'EROSR ', erosR

	write(41,'(A6,1x,f7.3)') 'CousR ', RCousins
	write(41,'(A6,1x,f7.3)') 'CousI ', ICousins

	write(41,'(A6,1x,f7.3)') 'F070W ', F070W
	write(41,'(A6,1x,f7.3)') 'F090W ', F090W
	write(41,'(A6,1x,f7.3)') 'F115W ', F115W
	write(41,'(A6,1x,f7.3)') 'F150W ', F150W
	write(41,'(A6,1x,f7.3)') 'F200W ', F200W
	write(41,'(A6,1x,f7.3)') 'F277W ', F277W
	write(41,'(A6,1x,f7.3)') 'F356W ', F356W
	write(41,'(A6,1x,f7.3)') 'F444W ', F444W
	write(41,'(A6,1x,f7.3)') 'F770W ', F770W
	write(41,'(A6,1x,f7.3)') 'F1000W', F1000W
	write(41,'(A6,1x,f7.3)') 'F1130W', F1130W
	write(41,'(A6,1x,f7.3)') 'F1280W', F1280W
	write(41,'(A6,1x,f7.3)') 'F1500W', F1500W
	write(41,'(A6,1x,f7.3)') 'F1800W', F1800W
	write(41,'(A6,1x,f7.3)') 'F2100W', F2100W
	write(41,'(A6,1x,f7.3)') 'F2550W', F2550W

	write(41,'(A6,1x,f7.3)') 'F140M ', F140M
	write(41,'(A6,1x,f7.3)') 'F158M ', F158M
	write(41,'(A6,1x,f7.3)') 'F162M ', F162M 
	write(41,'(A6,1x,f7.3)') 'F182M ', F182M 
	write(41,'(A6,1x,f7.3)') 'F210M ', F210M
	write(41,'(A6,1x,f7.3)') 'F250M ', F250M
	write(41,'(A6,1x,f7.3)') 'F380M ', F380M
	write(41,'(A6,1x,f7.3)') 'F300M ', F300M
	write(41,'(A6,1x,f7.3)') 'F335M ', F335M
	write(41,'(A6,1x,f7.3)') 'F360M ', F360M
	write(41,'(A6,1x,f7.3)') 'F410M ', F410M
	write(41,'(A6,1x,f7.3)') 'F430M ', F430M
	write(41,'(A6,1x,f7.3)') 'F460M ', F460M
	write(41,'(A6,1x,f7.3)') 'F480M ', F480M
	write(41,'(A6,1x,f7.3)') 'F560W ', F560W

	write(41,'(A6,1x,f7.3)') 'COBE1 ', flxcobe1
	write(41,'(A6,1x,f7.3)') 'COBE2 ', flxcobe2

	write(41,'(A6,1x,f7.3)') 'AF475W', hst475
	write(41,'(A6,1x,f7.3)') 'AF555W', hst555
	write(41,'(A6,1x,f7.3)') 'AF814W', hst814
	write(41,'(A6,1x,f7.3)') 'AF110W', hst110
	write(41,'(A6,1x,f7.3)') 'AF160W', hst160
	write(41,'(A6,1x,f7.3)') 'AF127M', hst127
	write(41,'(A6,1x,f7.3)') 'AF139M', hst139
	write(41,'(A6,1x,f7.3)') 'AF153M', hst153

	write(41,'(A6,1x,f7.3)') 'GAIAG ', GAIAGband
	write(41,'(A6,1x,f7.3)') 'GAIABp', GAIABp
	write(41,'(A6,1x,f7.3)') 'GAIARp', GAIARp
	write(41,'(A6,1x,f7.3)') 'GAIRVS', GAIARVS

        do i= 1,nsp
           call getFlux(fluxS, splam(i), wl,f,n)
           write( csp ,'(i4)') (1000+i)
           write(41,'(A4,3x,f7.3)') csp, log10(fluxS)
        enddo


	close(41)
	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012
c       *****************************************************

	subroutine flux(wl0,ind,gridn,fl)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

        real xx, ff, wl0, gridn
	common/a/ xx(20000),ff(20000)
 10	z1= wl0*xx(ind)
	z2= wl0*xx(ind+1)
	if( z1.le.gridn .and. z2.ge.gridn ) then
	  ra=(gridn-z1)/ (z2-z1)
	  fl=(log10(ff(ind+1))- log10(ff(ind)))*ra+ log10(ff(ind))
	  fl=10.**fl
c	 WRITE(15,'(10X,I4,2F9.4,2E11.4)')
c     &    ind,z1,z2,gridn,ra
	else
	  ind=ind+1
	  goto 10
	endif
*	return
	end


c       *********************************************************

	subroutine rp(ib,xor1,ro1,nr,xl,fx,n,flux, l0)

        implicit double precision(a-h,o-z)
        IMPLICIT INTEGER(I-N)

	double precision xor1(nr),ro1(nr,5)
        double precision xl(20000),fx(20000),fint(20000)
	double precision l0,flux

        imin=0
        do i=1,nr
           if(ro1(i,ib).eq.0.) then
	      imin=i
           else
	      goto 100
	   endif
        enddo
 100    imin=imin+1

        imax=0
        do i=imin,nr
           if(ro1(i,ib).gt.0.) then
	      imax=i
           else
	      goto 101
	   endif
        enddo
 101    imax=imax


c       you need flux at wavelengths xor(i)
        ifn= 0
	do i=imin,imax
	   wl= xor1(i)
	   do j=1,n
	      if (xl(j).lt.wl) ifn=j
	   end do
	  fint(i)=(wl-xl(ifn))/(xl(ifn+1)-xl(ifn))*
     c             (fx(ifn+1)-fx(ifn))+fx(ifn)

c       	if (l0 .gt. 400. and. l0.lt. 500.)
c     c         write(80,*) 'rp imin,max: ',imin,imax, wl,ifn, fint(i),i
	end do

	top= 0.d0
	top1= 0.d0
	bot= 0.d0
	do i= imin,imax-1
	   bot=bot+(xor1(i+1)-xor1(i))*(ro1(i+1,ib)+ro1(i,ib))
c	   bot=bot+(xor1(i+1)-xor1(i))*
c     c                  (ro1(i+1,ib)/xor1(i+1)+ro1(i,ib)/xor1(i))
	   top1=top1+(xor1(i+1)-xor1(i))*(ro1(i+1,ib)*fint(i+1)
     c      +ro1(i,ib)*fint(i))
c	   top=top+(xor1(i+1)-xor1(i))*(ro1(i+1,ib)*fint(i+1)/xor1(i+1)
c     c      +ro1(i,ib)*fint(i)/xor1(i))
	   top=top+(xor1(i+1)-xor1(i))*(ro1(i+1,ib)*fint(i+1)*xor1(i+1)
     c      +ro1(i,ib)*fint(i)*xor1(i))
	end do

c	write(*,*) 'imin,max: ', imin,imax, top, bot
c	write(*,*) 'effective l= ', top/top1

	flux=top/bot /(l0* 1000.d0)
c	flux=top/bot *(l0* 1000.)

	if (flux .eq. 0.d0) flux= 1.d-40

	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readphot(x,mago,errmag,nobs)

c       read in observed data, and link to predicted ones.
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(no=189)
	double precision mago(no), errmag(no), l0, wavecut,dmag
        double precision splam(no),spmag(no),sperrmag(no)
	character*6 philnameo(no), cdum
        character fmt*6
	integer x(no)

	character*80 name1,starname,path,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/special/splam,spmag,sperrmag,nsp
        dmag= 0.d0

c       observed data
c       file name that needs to exist is called   sed_<starname>.dat
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name1)
        CALL Clean(name1, path, lpath)
        CALL ATTACHfront(path,lpath,'sed2_',name1)

	open(23, file= name1)
        write(*,*) 'readphot ',  name1, path
	
c 5	format(a6,1x, f6.3,1x, f5.3)
 5	format(a6,1x, f11.3,1x, f10.3)

        nsp= 0
        j=0
 100    j=j+1
        read(23, 5 ,err=101,end=101) philnameo(j), mago(j), errmag(j)

        cdum= philnameo(j)
        if ( (cdum(1:1).eq.'1').or.(cdum(1:1).eq.'2').or.
     c       (cdum(1:1).eq.'3').or.(cdum(1:1).eq.'4').or.
     c       (cdum(1:1).eq.'5').or.(cdum(1:1).eq.'6').or.
     c       (cdum(1:1).eq.'7').or.(cdum(1:1).eq.'8').or.
     c       (cdum(1:1).eq.'9').or.(cdum(1:1).eq.'0') ) then

        if ( (cdum(2:2).eq.'1').or.(cdum(2:2).eq.'2').or.
     c       (cdum(2:2).eq.'3').or.(cdum(2:2).eq.'4').or.
     c       (cdum(2:2).eq.'5').or.(cdum(2:2).eq.'6').or.
     c       (cdum(2:2).eq.'7').or.(cdum(2:2).eq.'8').or.
     c       (cdum(2:2).eq.'9').or.(cdum(2:2).eq.'0').or.
     c       (cdum(2:2).eq.'.') ) then

           nsp= nsp+1
           do i= 2,6
              if (cdum(i:i) .eq. '.') k= i
           enddo
           if (k.eq.6) fmt='(f6.0)'
           if (k.eq.5) fmt='(f6.1)'
           if (k.eq.4) fmt='(f6.2)'
           if (k.eq.3) fmt='(f6.3)'
           if (k.eq.2) fmt='(f6.4)'
           read( cdum, fmt) splam(nsp)
           dum= mago(j)+errmag(j)
           spmag(nsp)= log10(mago(j))
           sperrmag(nsp)= log10(dum)-spmag(nsp)
           x(j)= 1000+nsp
           mago(j)= spmag(nsp)
           errmag(j)= sperrmag(nsp)
        endif
        endif

	if (philnameo(j) .eq. '  BesU') x(j)=1
	if (philnameo(j) .eq. '  BesB') x(j)=2
	if (philnameo(j) .eq. '  BesV') x(j)=3
	if (philnameo(j) .eq. '  BesR') x(j)=4
	if (philnameo(j) .eq. '  BesI') x(j)=5

	if (philnameo(j) .eq. 'wfcamZ') x(j)=6
	if (philnameo(j) .eq. 'wfcamY') x(j)=7
	if (philnameo(j) .eq. 'wfcamJ') x(j)=8
	if (philnameo(j) .eq. 'wfcamH') x(j)=9
	if (philnameo(j) .eq. 'wfcamK') x(j)=10

	if (philnameo(j) .eq. 'denisI') x(j)=11
	if (philnameo(j) .eq. 'denisJ') x(j)=12
	if (philnameo(j) .eq. 'denisK') x(j)=13

	if (philnameo(j) .eq. '2massJ') x(j)=14
	if (philnameo(j) .eq. '2massH') x(j)=15
	if (philnameo(j) .eq. '2massK') x(j)=16

	if (philnameo(j) .eq. 'irac36') x(j)=17
	if (philnameo(j) .eq. 'irac45') x(j)=18
	if (philnameo(j) .eq. 'irac58') x(j)=19
	if (philnameo(j) .eq. 'irac80') x(j)=20

	if (philnameo(j) .eq. 'iras12') x(j)=21
	if (philnameo(j) .eq. 'iras25') x(j)=22
	if (philnameo(j) .eq. 'iras60') x(j)=23
	if (philnameo(j) .eq. 'ira100') x(j)=24

	if (philnameo(j) .eq. ' irsfJ') x(j)=25
	if (philnameo(j) .eq. ' irsfH') x(j)=26
	if (philnameo(j) .eq. ' irsfK') x(j)=27

	if (philnameo(j) .eq. '  MSXA') x(j)=28

	if (philnameo(j) .eq. 'caspiJ') x(j)=29
	if (philnameo(j) .eq. 'caspiH') x(j)=30
	if (philnameo(j) .eq. 'caspiK') x(j)=31
	if (philnameo(j) .eq. 'caspiL') x(j)=32

	if (philnameo(j) .eq. 'mips24') x(j)=33
	if (philnameo(j) .eq. 'mips70') x(j)=34
	if (philnameo(j) .eq. 'mip160') x(j)=35

	if (philnameo(j) .eq. ' ogleU') x(j)=36
	if (philnameo(j) .eq. ' ogleB') x(j)=37
	if (philnameo(j) .eq. ' ogleV') x(j)=38
	if (philnameo(j) .eq. ' ogleI') x(j)=39

	if (philnameo(j) .eq. ' casw1') x(j)=40
	if (philnameo(j) .eq. ' calw1') x(j)=41
	if (philnameo(j) .eq. ' calw2') x(j)=42
	if (philnameo(j) .eq. ' calw7') x(j)=43
	if (philnameo(j) .eq. 'calw10') x(j)=44

	if (philnameo(j) .eq. ' saaoJ') x(j)=45
	if (philnameo(j) .eq. ' saaoH') x(j)=46
	if (philnameo(j) .eq. ' saaoK') x(j)=47
	if (philnameo(j) .eq. ' saaoL') x(j)=48

c     I adopted the convention to work in log10(Flux in mJy) for submm/mm wavelenghts
c       (and not in magnitudes; the log is to get a number of same order as magnitudes)
	if (philnameo(j) .eq. 'apx450') then
           x(j)=49
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'apx870') then
           x(j)=50
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ap1200') then
           x(j)=51
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'sloanu') x(j)=52
	if (philnameo(j) .eq. 'sloang') x(j)=53
	if (philnameo(j) .eq. 'sloanr') x(j)=54
	if (philnameo(j) .eq. 'sloani') x(j)=55
	if (philnameo(j) .eq. 'sloanz') x(j)=56

	if (philnameo(j) .eq. '  esoJ') x(j)=57
	if (philnameo(j) .eq. '  esoH') x(j)=58
	if (philnameo(j) .eq. '  esoK') x(j)=59
	if (philnameo(j) .eq. '  esoL') x(j)=60
	if (philnameo(j) .eq. '  esoM') x(j)=61


	if (philnameo(j) .eq. 'ukt350') then
           x(j)=62
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt450') then
           x(j)=63
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt600') then
           x(j)=64
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt800') then
           x(j)=65
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'ukt850') then
           x(j)=66
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk1100') then
           x(j)=67
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk1300') then
           x(j)=68
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'uk2000') then
           x(j)=69
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'se1300') then
           x(j)=70
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. '  esoN') x(j)=71
	if (philnameo(j) .eq. ' esoN1') x(j)=72
	if (philnameo(j) .eq. ' esoN2') x(j)=73
	if (philnameo(j) .eq. ' esoN3') x(j)=74
	if (philnameo(j) .eq. ' esoQ0') x(j)=75


	if (philnameo(j) .eq. ' pacsb') then
           x(j)=76
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. ' pacsg') then
           x(j)=77
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. ' pacsr') then
           x(j)=78
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire1') then
           x(j)=79
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire2') then
           x(j)=80
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'spire3') then
           x(j)=81
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'AkarN2') x(j)=82
	if (philnameo(j) .eq. 'AkarN3') x(j)=83
	if (philnameo(j) .eq. 'AkarN4') x(j)=84
	if (philnameo(j) .eq. 'AkarS7') x(j)=85
	if (philnameo(j) .eq. 'AkaS9W') x(j)=86
	if (philnameo(j) .eq. 'AkaS11') x(j)=87
	if (philnameo(j) .eq. 'AkaL15') x(j)=88
	if (philnameo(j) .eq. 'AkL18W') x(j)=89
	if (philnameo(j) .eq. 'AkaL24') x(j)=90
	if (philnameo(j) .eq. 'AkaN60') x(j)=91
	if (philnameo(j) .eq. 'AkarWS') x(j)=92
	if (philnameo(j) .eq. 'AkarWL') x(j)=93
	if (philnameo(j) .eq. 'AkN160') x(j)=94

	if (philnameo(j) .eq. 'vistaZ') x(j)=95
	if (philnameo(j) .eq. 'vistaY') x(j)=96
	if (philnameo(j) .eq. 'vistaJ') x(j)=97
	if (philnameo(j) .eq. 'vistaH') x(j)=98
	if (philnameo(j) .eq. 'vistaK') x(j)=99

	if (philnameo(j) .eq. 'WISE1') x(j)=100
	if (philnameo(j) .eq. 'WISE2') x(j)=101
	if (philnameo(j) .eq. 'WISE3') x(j)=102
	if (philnameo(j) .eq. 'WISE4') x(j)=103

	if (philnameo(j) .eq. 'Opg   ') x(j)=104
	if (philnameo(j) .eq. 'Epg   ') x(j)=105
	if (philnameo(j) .eq. 'V495  ') x(j)=106
	if (philnameo(j) .eq. 'JpgBJ ') x(j)=107
	if (philnameo(j) .eq. 'FpgRF ') x(j)=108
	if (philnameo(j) .eq. 'NmagIN') x(j)=109

	if (philnameo(j) .eq. 'PAH1VI') x(j)=110
	if (philnameo(j) .eq. 'PAH2VI') x(j)=111
	if (philnameo(j) .eq. 'SICVI ') x(j)=112

	if (philnameo(j) .eq. 'COBE1 ') then
           x(j)=163
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE2 ') then
           x(j)=164
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE3 ') then
           x(j)=113
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE4 ')  then
           x(j)=114
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif
	if (philnameo(j) .eq. 'COBE5 ')  then
           x(j)=115
           dum= mago(j)+errmag(j)
           mago(j)= log10(mago(j))
           errmag(j)= log10(dum)-mago(j)
        endif

	if (philnameo(j) .eq. 'Hippac') x(j)=116
	if (philnameo(j) .eq. 'TychoB') x(j)=117
	if (philnameo(j) .eq. 'TychoV') x(j)=118

	if (philnameo(j) .eq. 'CNFK  ') x(j)=119
	if (philnameo(j) .eq. 'CNESO ') x(j)=120
	if (philnameo(j) .eq. 'TiOFK ') x(j)=121
	if (philnameo(j) .eq. 'TiOESO') x(j)=122
	if (philnameo(j) .eq. 'Halpha') x(j)=123

	if (philnameo(j) .eq. 'GALFUV') x(j)=124
	if (philnameo(j) .eq. 'GALNUV') x(j)=125

	if (philnameo(j) .eq. 'MACHOB') x(j)=126
	if (philnameo(j) .eq. 'MACHOR') x(j)=127

	if (philnameo(j) .eq. 'EROSB ') x(j)=128
	if (philnameo(j) .eq. 'EROSR ') x(j)=129

	if (philnameo(j) .eq. 'CousR ') x(j)=130
	if (philnameo(j) .eq. 'CousI ') x(j)=131

	if (philnameo(j) .eq. 'F070W ') x(j)=132
	if (philnameo(j) .eq. 'F090W ') x(j)=133
	if (philnameo(j) .eq. 'F115W ') x(j)=134
	if (philnameo(j) .eq. 'F150W ') x(j)=135
	if (philnameo(j) .eq. 'F200W ') x(j)=136
	if (philnameo(j) .eq. 'F277W ') x(j)=137
	if (philnameo(j) .eq. 'F356W ') x(j)=138
	if (philnameo(j) .eq. 'F444W ') x(j)=139
	if (philnameo(j) .eq. 'F560W ') x(j)=140
	if (philnameo(j) .eq. 'F770W ') x(j)=141
	if (philnameo(j) .eq. 'F1000W') x(j)=142
	if (philnameo(j) .eq. 'F1130W') x(j)=143
	if (philnameo(j) .eq. 'F1280W') x(j)=144
	if (philnameo(j) .eq. 'F1500W') x(j)=145
	if (philnameo(j) .eq. 'F1800W') x(j)=146
	if (philnameo(j) .eq. 'F2100W') x(j)=147
	if (philnameo(j) .eq. 'F2550W') x(j)=148

	if (philnameo(j) .eq. 'F140M ') x(j)=149
	if (philnameo(j) .eq. 'F158M ') x(j)=150
	if (philnameo(j) .eq. 'F162M ') x(j)=151
	if (philnameo(j) .eq. 'F182M ') x(j)=152
	if (philnameo(j) .eq. 'F210M ') x(j)=153
	if (philnameo(j) .eq. 'F250M ') x(j)=154
	if (philnameo(j) .eq. 'F300M ') x(j)=155
	if (philnameo(j) .eq. 'F335M ') x(j)=156
	if (philnameo(j) .eq. 'F360M ') x(j)=157
	if (philnameo(j) .eq. 'F380M ') x(j)=158
	if (philnameo(j) .eq. 'F410M ') x(j)=159
	if (philnameo(j) .eq. 'F430M ') x(j)=160
	if (philnameo(j) .eq. 'F460M ') x(j)=161
	if (philnameo(j) .eq. 'F480M ') x(j)=162

	if (philnameo(j) .eq. 'AF475W') x(j)=165
	if (philnameo(j) .eq. 'AF555W') x(j)=166
	if (philnameo(j) .eq. 'AF814W') x(j)=167
	if (philnameo(j) .eq. 'AF110W') x(j)=168
	if (philnameo(j) .eq. 'AF160W') x(j)=169
	if (philnameo(j) .eq. 'AF127M') x(j)=170
	if (philnameo(j) .eq. 'AF139M') x(j)=171
	if (philnameo(j) .eq. 'AF153M') x(j)=172

	if (philnameo(j) .eq. 'GAIAG ') x(j)=173
	if (philnameo(j) .eq. 'GAIABp') x(j)=174
	if (philnameo(j) .eq. 'GAIARp') x(j)=175
	if (philnameo(j) .eq. 'GAIRVS') x(j)=176

c      check if wavelength is not too small for fitting. Uset getphot from PlotMyDusty.f
        call getphot( x(j), dmag, dmag, l0, flux, eflux )
        if (l0 .lt. wavecut) then
c      DO NOT INCLUDE IN FITTING !!
           j= j-1
           goto 100
        endif

c     some futching to account for variability (based on CWLEO)
c        scerr= -17.* dlog10(l0) +25.821
c        if (scerr .lt. 1.) scerr= 1.0
c        errmag(j)= errmag(j)* scerr

	if (philnameo(j) .eq. '!') goto 101
	if (philnameo(j) .eq. '#') goto 101
	goto 100
 101	continue
	nobs= j-1
	if (j .gt. no) then
           write(*,*) 'INCREASE no'
           STOP
        endif

	close(23)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine comparephot(mago)

c       read in predicted magnitudes, link to observed ones

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573, npL1=npL+1,nfit=4,no=189,ns= 2000,nin=600)
	double precision mag(no), mago(no), xspec(ns), wavecut
        double precision wve(npL1), flx(npL1), xint(nin), xvis(ns)
        double precision splam(no),spmag(no),sperrmag(no)

	integer xsel(no),i,j, isp

c	character*6 philname(no)
	character*4 philname(no), cdum

	character*80 starname,name,path,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint
        common/special/splam,spmag,sperrmag,nsp



c       predicted magnitudes
         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'_allmags.dat',name)

	open(23, file= name)

        write(80,*) 'comparephot ' , name, 'nsel ', nsel
	
 6	format(A6,1x,f7.3)
 7      format(A4,3x,f7.3)

        j=0
 200    j=j+1
        read(23, 7 ,err=201,end=201) philname(j), mag(j)

        isp= 0
        cdum= philname(j)
        if ( (cdum(1:1).eq.'1').or.(cdum(1:1).eq.'2').or.
     c       (cdum(1:1).eq.'3').or.(cdum(1:1).eq.'4').or.
     c       (cdum(1:1).eq.'5').or.(cdum(1:1).eq.'6').or.
     c       (cdum(1:1).eq.'7').or.(cdum(1:1).eq.'8').or.
     c       (cdum(1:1).eq.'9') ) then

        if ( (cdum(2:2).eq.'1').or.(cdum(2:2).eq.'2').or.
     c       (cdum(2:2).eq.'3').or.(cdum(2:2).eq.'4').or.
     c       (cdum(2:2).eq.'5').or.(cdum(2:2).eq.'6').or.
     c       (cdum(2:2).eq.'7').or.(cdum(2:2).eq.'8').or.
     c       (cdum(2:2).eq.'9').or.(cdum(2:2).eq.'0') ) then

           write(87,*) j, philname(j), mag(j)
           read( philname(j), '(i4)') isp
           write(87,*) isp
        endif
        endif

	do i= 1,nsel
	   if (xsel(i) .eq. j) mago(i)= mag(j)
           do k= 1,nsp
c              if (isp .eq. 1000+k) mago(i)= mag(j)
              if (xsel(i) .eq. 1000+k .and. xsel(i) .eq. isp) 
     c                                                 mago(i)= mag(j)
           enddo
	enddo

	goto 200
 201	continue
	if (j-1 .gt. no) then
           write(*,*) 'INCREASE no'
           STOP
        endif

	close(23)

	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readspec(x,mago,errmag,nob)

c       read in observed spectral data
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(ns= 2000)
	double precision mago(ns), errmag(ns), errmin
	double precision x(ns), xlow(ns), xup(ns), wavecut
	double precision dumx(ns), dumy(ns), dumz(ns), ord(ns), dumm(ns)
	integer in, idx(ns)

	data xlow /ns*0.d0/
	data xup  /ns*9999.d0/

	character*80 starname,specname,path
        character*80 absscafile,name,cdum
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut

c       observed data
c       file name that needs to exist is called   spec_<starname>.dat
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)
        CALL ATTACHfront(path,lpath,'spec_',name)

        write(*,'(A)') 'readspec ',  name, path

	nob= 0
	write(80,*) 'readspec'

c       observed data
	open(23, file= name)

c       number of spectra
	read(23,*) nns
	write(80,*) nns

	do I= 1,NNS

c       filename
	read(23,'(a80)') specname
	write(80,*) '|',specname,'|'

c	read CODE, scaling flux, scaling errorbar
c       CODE gives option to have different input formats, hardcoded later
	read(23,*) IC, sf, se
	write(80,*) IC, sf, se

c       read number of excluded segments
	read(23,*) nex
c       read lower and upper wavelength interval, in units of inputfile
	do  J= 1,NEX
	   read(23,*) xlow(j), xup(j)
	   write(80,*) j,xlow(j), xup(j)
	enddo

	open(33, FILE= specname)

	if (IC .eq. 1) then
c       IRS spectra
c       format: wave(mu), flux(Jy), errflux(Jy), order
	k=1
        l=0
 111	read(33,*, err=112,end=112) dumx(k), dumy(k), dumz(k),ord(k)
	write(80,*) k,dumx(k), dumy(k), dumz(k), ord(k)
        if (dumy(k) .gt. 0. .and. dumz(k) .gt. 0. ) then
           l=l+1
           dumm(l)= dumz(k)
        endif

	k=k+1
	goto 111
 112	continue
	np= k-1

        call indexx(l, dumm, idx)
c        write(*,*) l, dumm(idx(int(0.3*l))),dumm(idx(int(0.2*l)))
        errmin= dumm( idx(int(0.2*l)) )

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

c       MG 20.08.08 require positive flux, and non-zero errorbar as well
	   if ((in .eq. 1) .and. (dumz(k) .gt. 0.0)
     c                     .and. (dumy(k) .gt. 0.0)
     c                     .and. (dumx(k) .gt. wavecut)) then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
              if (dumz(k) .lt. errmin)  dumz(k)= errmin
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)     *2.99792458d-12/dumx(k)/dumx(k)
              dum= (dumy(k)+dumz(k)) *2.99792458d-12/dumx(k)/dumx(k)
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0d5
	      errmag(nob)= errmag(nob) *se *1.0d5
	   endif
	enddo

c       end IRS spectra
	endif

	if (IC .eq. 2) then
c       SWS LWS spectra
c       format: wave(mu), flux(Jy), error(Jy)
	k=1
        l=0
 211	read(33,*, err=212,end=212) dumx(k), dumy(k), dumz(k)
c        if (dumz(k) .le. 0.) dumz(k)= abs(0.05* dumy(k))
c        dumz(k)= 0.01* dumy(k)
        dumz(k)= max(dumz(k), 0.03* abs(dumy(k)))
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)
        if (dumy(k) .gt. 0.) then
           l=l+1
           dumm(l)= dumz(k)
        endif

	k=k+1
	goto 211
 212	continue
	np= k-1

        call indexx(l, dumm, idx)
c        write(*,*) l, dumm(idx(int(0.3*l))),dumm(idx(int(0.2*l)))
        errmin= dumm( idx(int(0.2*l)) )

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

	   if ((in .eq. 1) .and. (dumy(k) .gt. 0.0)
     c                     .and. (dumx(k) .gt. wavecut) )  then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
              if (dumz(k) .lt. errmin)  dumz(k)= errmin
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)      *2.99792458d-12/dumx(k)/dumx(k)
              dum= (dumy(k)+dumz(k))  *2.99792458d-12/dumx(k)/dumx(k)
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0d5
	      errmag(nob)= errmag(nob) *se *1.0d5
	   endif
	enddo

c       end SWS LWS spectra
	endif

	if (IC .eq. 3) then
c       IRAS LRS spectra, as from Calgary database ("raw text"); assume 5% errorbar
c       format: wave(mu), flux (W/m2/mu)                 NEW FORMAT website W/m2
c       first part spectrum
	read(33,*) cdum
	k=1
        l=0
 311	read(33,*, err=312,end=312) dumx(k), dumy(k)
        dumy(k)= dumy(k)/  dumx(k)
        dumz(k)= abs(0.05*dumy(k))
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)
        if (dumy(k) .gt. 0.) then
           l=l+1
           dumm(l)= 0.05*dumy(k)
        endif

	k=k+1
	goto 311
 312	continue
c     second part
 313	read(33,*, err=314,end=314) dumx(k), dumy(k)
        dumy(k)= dumy(k)/  dumx(k)
        dumz(k)= abs(0.05*dumy(k))
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)
        if (dumy(k) .gt. 0.) then
           l=l+1
           dumm(l)= 0.05*dumy(k)
        endif

	k=k+1
	goto 313
 314	continue
	np= k-1

        call indexx(l, dumm, idx)
c        write(*,*) l, dumm(idx(int(0.3*l))),dumm(idx(int(0.2*l)))
        errmin= dumm( idx(int(0.2*l)) )

c       check if point is in excluded wavelength region
	do k= 1,np
	   in= 1
	   do j= 1,nex
	      if((dumx(k) .gt. xlow(j)).and.(dumx(k) .lt. xup(j))) in=0
	   enddo

	   if ((in .ge. -1) .and. (dumy(k) .gt. 0.0))  then
c       OK, convert (if needed) wavelength to micron, and flux(error) to W/m2/mu,
c           scale flux and errors according to inputfile, and add this point.
	      nob= nob+1
              if (dumz(k) .lt. errmin)  dumz(k)= errmin
	      x(nob)= dumx(k)
	      mago(nob)= dumy(k)
              dum= dumy(k)+dumz(k)
              errmag(nob)= dum-mago(nob)
c       MG 20.08.08 scale flux and error with 1.e5 to avoid underflows
	      mago(nob)= mago(nob)     *sf *1.0d5
	      errmag(nob)= errmag(nob) *se *1.0d5
	   endif
	enddo

c       end IRAS LRS spectra
	endif



	close(33)
	if (nob .gt. ns) then
           write(*,*) 'INCREASE ns'
           STOP
        endif

c       end loop spectra
	ENDDO


	close(23)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine comparespec(mago)

c       read in predicted spectrum, compare to observed one(s)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573, npL1=npL+1, no=189, ns= 2000, nin=600)
	double precision mag(ns), mago(ns), wave(ns), xspec(ns),xvis(ns)
        double precision wve(npL1), flx(npL1), xint(nin), wavecut
	integer i,j,k, xsel(no)

	character*80 starname,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint

        write(*,*) 'comparespec; nsel ', nsel

c       predicted spectrum (*1.e5 to avoid underflow, see MG 20.08)
	do j= 1,nfl
            wave(j)= wve(j)
       	    mag(j)= 1.0e5 *flx(j)
	 write(*,*) 'predicted spect ', j, wave(j), mag(j)
	enddo
	
	if (nfl .gt. ns) then
           write(*,*) 'INCREASE ns'
           STOP
        endif

c       for given observed spectrum, calculate predicted flux at those wvl
	do i= 1,nspec

	if (xspec(i) .gt. wave(nfl)) write(*,*) 'xspec > wave'
	if (xspec(i) .lt. wave(1  )) write(*,*) 'xspec < wave'

           k= -1
	   do j= 1,nfl
   	      if ( (xspec(i) .ge. wave(j)  ) .and.
     c             (xspec(i) .le. wave(j+1)) )   k= j
	   enddo

           ratio= (xspec(i)-wave(k))/(wave(k+1)-wave(k))
	   mago(i)= mag(k) + ratio*( mag(k+1)-mag(k) )
c	   write(*,*) i,k,xspec(i), mag(k),ratio
	enddo

	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,
     *funcs,alamda, BIC)

c     Based on the mrqmin routine from NUMERICAL RECIPES

      INTEGER ma,nca,ndata,ia(ma),MMAX

c     MMAX, treat as nfit=
      PARAMETER (MMAX= 4)

      DOUBLE PRECISION alamda,chisq,funcs,a(ma),alpha(nca,nca)
      double precision covar(nca,nca)
      double precision sig(ndata),y(ndata), BIC
      integer x(ndata)
      INTEGER j,k,l,mfit
      DOUBLE PRECISION ochisq,atry(MMAX),beta(MMAX),da(MMAX)
      SAVE ochisq,atry,beta,da,mfit

      if (alamda.lt.0.) then
        mfit=0
        do 11 j=1,ma
          if (ia(j).ne.0) mfit=mfit+1
11      continue
        alamda=0.001d0
c        write(*,*) 'mrqcof 1'
       call mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nca,chisq,funcs,BIC)
        ochisq=chisq
        do 12 j=1,ma
          atry(j)=a(j)
12      continue
      endif


      do 14 j=1,mfit
        do 13 k=1,mfit
          covar(j,k)=alpha(j,k)
13      continue
        covar(j,j)=alpha(j,j)*(1.+alamda)
        da(j)=beta(j)
14    continue

c        write(*,*) 'gaussj 1', nca
      call gaussj(covar,mfit,nca,da,1,1)
      if(alamda.eq.0.)then
        call covsrt(covar,nca,ma,ia,mfit)
        call covsrt(alpha,nca,ma,ia,mfit)
        return
      endif
      j= 0
      do 15 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          atry(l)=a(l)+da(j)
	  write(80,*) 'new guess: ', l,j,a(l), da(j), ia(l)
        endif
15    continue

c        write(*,*) 'mrqcof 2'
      call mrqcof(x,y,sig,ndata,atry,ia,ma,covar,da,nca,chisq,funcs,BIC)

      if(chisq.lt.ochisq)then
        alamda=0.1*alamda
        ochisq=chisq
        do 17 j=1,mfit
          do 16 k=1,mfit
            alpha(j,k)=covar(j,k)
16        continue
          beta(j)=da(j)
17      continue
        do 18 l=1,ma
          a(l)=atry(l)
18      continue
      else
        alamda=10.*alamda
        chisq=ochisq
      endif
      return
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE covsrt(covar,npc,ma,ia,mfit)

c     Based on the covsrt routine from NUMERICAL RECIPES

      INTEGER ma,mfit,npc,ia(ma)
      double precision covar(npc,npc)
      INTEGER i,j,k
      double precision swap

      do 12 i= mfit+1,ma
        do 11 j= 1,i
          covar(i,j)= 0.d0
          covar(j,i)= 0.d0
11      continue
12    continue
      k= mfit
      do 15 j=ma,1,-1
        if(ia(j).ne.0)then
          do 13 i=1,ma
            swap=covar(i,k)
            covar(i,k)=covar(i,j)
            covar(i,j)=swap
13        continue
          do 14 i=1,ma
            swap=covar(k,i)
            covar(k,i)=covar(j,i)
            covar(j,i)=swap
14        continue
          k=k-1
        endif
15    continue
      return
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE gaussj(a,n,np,b,m,mp)

c     Based on the gaussj routine from NUMERICAL RECIPES

      INTEGER m,mp,n,np,NMAX
      PARAMETER (NMAX=60)
      INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      double precision a(np,np),b(np,mp)
      double precision big,dum,pivinv

      do i=1, max(n,np)
         do j=1, max(n,np)
c            if (a(i,j) .eq. 0.) write(*,*) i,j, a(i,j), b(i,j)
         enddo
      enddo

      do 11 j= 1,n
        ipiv(j)= 0
11    continue

      do 22 i=1,n
        big= 0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)) .ge. big)then
                  big= abs(a(j,k))
                  irow=j
                  icol=k
                endif
              endif
12          continue
          endif
13      continue
        ipiv(icol)= ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l= 1,n
            dum= a(irow,l)
            a(irow,l)= a(icol,l)
            a(icol,l)= dum
14        continue
          do 15 l= 1,m
            dum= b(irow,l)
            b(irow,l)= b(icol,l)
            b(icol,l)= dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.) pause 'singular matrix in gaussj'
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue

22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue

      return
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,
     *funcs,BIC)

c     Based on the mrqcof routine from NUMERICAL RECIPES

      INTEGER ma,nalp,ndata,ia(ma),MMAX
c     MMAX, treat as nfit=
      PARAMETER (MMAX= 4)
      parameter (no=189, ns= 2000, nin=600)

      DOUBLE PRECISION chisq,a(ma),alpha(nalp,nalp),beta(ma)
      double precision sig(ndata),y(ndata), BIC
      integer x(ndata)

      EXTERNAL funcs

      INTEGER mfit,i,j,k,l,m
      DOUBLE PRECISION dy,sig2i,wt,ymod(ndata),dyda(MMAX,ndata)
      double precision allchisq(no+ns+nin)
      double precision chiphot,chispec,chiint,chivis

      common/allchi/allchisq,chiphot,chispec,chiint,chivis


      mfit= 0
      do 11 j= 1,ma
        if (ia(j).ne.0) mfit= mfit+1
11    continue
      do 13 j= 1,mfit
        do 12 k= 1,j
          alpha(j,k)= 0.d0
12      continue
        beta(j)= 0.d0
13    continue

      chisq= 0.d0
      bic= 0.d0

c      write(*,*) 'in mrqcof: ', ndata, mfit, ma

      call funcs(x,a,ymod,dyda, ma)

      do 16 i= 1,ndata
         write(80,*) 'i y ym sig ', i, y(i), ymod(i), sig(i)

        sig2i= 1.d0/(sig(i)*sig(i))
        dy= y(i)-ymod(i)
        j= 0
        do 15 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            wt=dyda(l,i)*sig2i
            k=0
            do 14 m=1,l
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=alpha(j,k)+wt*dyda(m,i)
c               if (alpha(j,k).eq.0) write(*,*)i,l,m,dyda(l),dyda(m)
              endif
14          continue
            beta(j)=beta(j)+dy*wt
c	    if (j.eq.1)write(80,*)'beta ',beta(j),i,l,dy,wt,
c     c                                    dyda(l,i),sig2i
          endif
15      continue
        chisq=chisq+dy*dy*sig2i
        bic=  bic  +dy*dy*sig2i + 2.d0*dlog(sig(i)) +1.838d0
        allchisq(i)= chisq
        write(80,*) 'allchi ', i, allchisq(i),bic, y(i),ymod(i),sig(i)
16    continue

      do 18 j=2,mfit
        do 17 k=1,j-1
          alpha(k,j)= alpha(j,k)
17      continue
18    continue

      return
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

      subroutine funcs(x,a0,ymodobs,dydaobs,ma)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

        parameter (nfit= 4,no=189,ns= 2000,npL=573,npL1=npL+1,nin=600)

        double precision a(nfit), a0(nfit)
        double precision dyda(ma,no), dydas(ma,ns), dydai(ma,nin)
	double precision ymod(no), y(no),xspec(ns), dydav(ma,2*nin)
        double precision ymods(ns), ys(ns), yi(nin), yv(ns)
	double precision ymodobs(ns+no), dydaobs(ma, ns+no), eps(nfit)
        double precision wve(npL1), flx(npL1), xint(nin), ymodint(nin)
        double precision pp(nfit), Router(nfit), scl(nfit)
        double precision ymodvis(ns), xvis(ns)
        double precision av,teff,dist

	integer x(no),xsel(no),nsel

        DATA ymod /no *0.0/
        DATA ymods /ns *0.0/
        DATA ymodint /nin *0.0/
        DATA ymodvis /ns *0.0/
        DATA y  /no *0.0/
        DATA ys /ns *0.0/
        DATA yi /nin *0.0/
        DATA yv /ns *0.0/

        common/needed/rinner,router,pp,scl,av,teff,dist,npow
        common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint

        write(80,*) 'funcs a= ', a0, ma, 'nsel ', nsel

	do i= 1,nfit
	   a(i)= a0(i)
c       default value for f(x+eps)
	   eps(i)= 0.01d0
	enddo

	call makedusty(a)
	write(80,*) 'end makedusty'

	call Dusty
	write(80,*) 'end Dusty0', a,a0

c        write(*,*) 'deliberate STOP line 16495'
c        stop

	call pscfold(a)
	write(80,*) 'end pscfold'

	call comparephot(ymod)
	write(80,*) 'end comparephot', ymod
	write(80,*) nsel,xsel

	call comparespec(ymods)
	write(80,*) 'end comparespec', ymods
	write(80,*) 'compare spec ', nspec,xspec

	call compareint(ymodint)
	write(80,*) 'end compareint', ymodint
	write(80,*) 'compare int ', nint,xint

	call comparevis(ymodvis)
	write(80,*) 'end comparevis', ymodvis
	write(80,*) 'compare vis ', nvisib,xvis

c        write(*,*) 'deliberate STOP line 16470'
c        stop

	do i= 1,nsel
	   ymodobs(i)= ymod(i)
	enddo
	do i= 1,nspec
	   ymodobs(nsel+i)= ymods(i)
	enddo
	do i= 1,nint
	   ymodobs(nsel+nspec+i)= ymodint(i)
	enddo
	do i= 1,nvisib
	   ymodobs(nsel+nspec+nint+i)= ymodvis(i)
	enddo

	do i= 1,nfit
	   a(i)= a0(i) +eps(i)

  	   call makedusty(a)
           call Dusty
           write(80,*) 'end Dusty',a,a0
 	   call pscfold(a)
   	   call comparephot(y)
	   call comparespec(ys)
	   call compareint(yi)
	   call comparevis(yv)

c       derivative
	   do j= 1,nsel
	      dyda(i,j)= (y(j)-ymod(j))/eps(i)
	      write(80,*) 'deriv pht ', i,j, dyda(i,j),y(j),ymod(j)
	      dydaobs(i,j)= dyda(i,j)
	   enddo

	   do j= 1,nspec
	      dydas(i,j)= (ys(j)-ymods(j))/eps(i)
	      write(80,*) 'deriv spc ',i,j, dydas(i,j),ys(j),ymods(j)
	      dydaobs(i,nsel+j)= dydas(i,j)
	   enddo

	   do j= 1,nint
	      dydai(i,j)= (yi(j)-ymodint(j))/eps(i)
	      write(80,*) 'deriv int ',i,j, dydai(i,j),yi(j),ymodint(j)
	      dydaobs(i,nsel+nspec+j)= dydai(i,j)
	   enddo

	   do j= 1,nvisib
	      dydav(i,j)= (yv(j)-ymodvis(j))/eps(i)
	      write(80,*) 'deriv vis ',i,j, dydav(i,j),yv(j),ymodvis(j)
	      dydaobs(i,nsel+nspec+nint+j)= dydav(i,j)
	   enddo

	   a(i)= a0(i)
	enddo

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readint(x,mago,errmag,nob)

c       read in observed intensity profiles
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(nin=600)
	double precision mago(nin), errmag(nin)
	double precision waveint(nin), x(nin), fwhmint(nin)
        double precision yintd(nin), zintd(nin), wavecut
	double precision dumx(nin),dumy(nin),dumz(nin),pxl(nin),D1(nin)
	integer intsep(nin)
        real pltintm(nin)

	character*80 starname,specname,path
        character*80 name,cdum,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut

c     keep track of: how many intensity profiles,
c                    the wavelength, FWHM (arcsec), and index where they start in obs. array
        common/intensity/waveint,fwhmint,intsep,yintd,zintd,pxl,D1,
     c                   pltintm,nns

c       observed data
c       file name that needs to exist is called   int_<starname>.dat
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)
        CALL ATTACHfront(path,lpath,'int_',name)

        write(*,'(A)') 'readint ',  name, path

	nob= 0
        intsep(1)= 0
	write(80,*) 'readint'

c       observed data
	open(23, file= name)

c       number of intensity profiles
	read(23,*) nns
	write(80,*) nns

	do I= 1,NNS

c       filename of intensity profile
	read(23,'(a80)') specname
	write(80,*) '|',specname,'|'
	write(*,*) '|',specname,'|'

c	read: Code, WAVELENGTH, Diameter primary mirror, diameter hole,
c             scaling of errorbar,
c             number of headerlines in inputfile, pixelsize in original data
c     Gaussian psf
	read(23,*) IC, waveint(i),fwhmint(i),sce,nhead,pxl(i),pltintm(i)
c     Bessell fie
c	read(23,*) IC, waveint(i), fwhmint(i), D1(i), sce, nhead, pxl(i)
        write(*,*) IC, waveint(i), fwhmint(i), D1(i), sce, nhead, pxl(i)


	open(33, FILE= specname)

        IF (IC .EQ. 1) THEN

        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: offset, intensity, dummy
	k=1
 111	read(33,*, err=112,end=112) dumx(k), dumy(k), dumz(k)
	write(80,*) k,dumx(k), dumy(k), dumz(k)

	k=k+1
	goto 111
 112	continue
	np= k-1

        ENDIF

c        IF (IC .EQ. 2) THEN
c        ENDIF

	close(33)

c     select 'significant' part of the profile.
c     determine the flux in the region where it is far below the peak flux.
c     iterate on this using the rms
        crit= 0.01*dumy(1)
        xmean= 0.0
        DO J= 1,4

        sum= 0.d0
        nse= 0
        do k= 1,np
           if (dumy(k) .lt. crit) then
              sum= sum+ dumy(k)
              nse= nse +1
c              write(*,*) k,nse, crit
           endif
        enddo
c     determine the mean, and now the rms
        xmean= sum/real(nse)
        sum= 0.d0
        do k= 1,np
           if (dumy(k) .lt. crit) then
              sum= sum+ (dumy(k)-xmean)**2
           endif
        enddo
        rms= sqrt(sum/nse)
        write(*,*) 'intensity bkg: ', J, xmean, rms, np, nse
        write(80,*) 'intensity bkg: ', J, crit, xmean, rms, np, nse

        crit= 3.*rms
        ENDDO

        nlow= 0
        do k= 1,np
c     MG 16.10.09: bug corrected: ABS (flux); 21.10 another (treatment NLOW)
           if (abs(dumy(k)) .gt. rms .OR. nlow .le. 2) then
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)/dumy(1)
             error= max(0.03*dumy(k), rms)
             errmag(nob)= (dumy(k)+error)/dumy(1) - mago(nob)

             errmag(nob)= errmag(nob) * sce
           endif
           if (abs(dumy(k)) .le. rms) then
c     skip when flux drops for third time below rms
              nlow= nlow+1
              if (nlow .eq. 3) goto 211
           endif
        enddo

 211    continue
        intsep(i+1)= nob

c       end loop spectra
	ENDDO

	if (nob .gt. nin) then
           write(*,*) 'INCREASE nin'
           STOP
        endif

	close(23)

	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readint1(x,mago,errmag,nob)

c       read in observed intensity profiles
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(nin=600)
	double precision mago(nin), errmag(nin)
	double precision waveint(nin), x(nin), fwhmint(nin)
        double precision yintd(nin), zintd(nin), wavecut
	double precision dumx(nin),dumy(nin),dumz(nin),pxl(nin),D1(nin)
        double precision dum1,dum2
	integer intsep(nin)
        real pltintm(nin)

	character*80 starname,specname,path
        character*80 name,cdum,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut

c     keep track of: how many intensity profiles,
c                    the wavelength, FWHM (arcsec), and index where they start in obs. array
        common/intensity/waveint,fwhmint,intsep,yintd,zintd,pxl,D1,
     c                   pltintm,nns

c       observed data
c       file name that needs to exist is called   int_<starname>.dat
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)
        CALL ATTACHfront(path,lpath,'int_',name)

        write(*,'(A)') 'readintI ',  name, path

	nob= 0
        intsep(1)= 0
	write(80,*) 'readint1'

c       observed data
	open(23, file= name)

c       number of intensity profiles
	read(23,*) nns
	write(80,*) nns

	do I= 1,NNS

c       filename of intensity profile
	read(23,'(a80)') specname
	write(80,*) '|',specname,'|'
	write(*,*) '|',specname,'|'

c	read: Code, WAVELENGTH, Diameter primary mirror, diameter hole,
c             scaling of errorbar,
c             number of headerlines in inputfile, pixelsize in original data
c     Gaussian psf
	read(23,*) IC,waveint(i),fwhmint(i),sce,nhead,pxl(i),pltintm(i)
c     Bessell fie
c	read(23,*) IC, waveint(i), fwhmint(i), D1(i), sce, nhead, pxl(i)
        write(*,*) IC, waveint(i), fwhmint(i), D1(i), sce, nhead, pxl(i)


	open(33, FILE= specname)

        IF (IC .EQ. 1) THEN

        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: offset, intensity, dummy
	k=1
 111	read(33,*, err=112,end=112) dumx(k), dumy(k), dumz(k)
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)
c       assume 3% error
        dumz(k)= 0.03d0*abs(dumy(k))

	k=k+1
	goto 111
 112	continue
	np= k-1

        ENDIF

        IF (IC .EQ. 2) THEN

        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: offset, intensity, error
	k=1
 211	read(33,*, err=212,end=212) dumx(k), dumy(k), dumz(k)
	write(80,*) IC, k,dumx(k), dumy(k), dumz(k)

	k=k+1
	goto 211
 212	continue
	np= k-1
        ENDIF

c        IF (IC .EQ. 3) THEN
c        ENDIF

	close(33)

        do k= 1,np
c     MG 16.10.09: bug corrected: ABS (flux); 21.10 another (treatment NLOW)
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)/dumy(1)
c             error= max(0.03*dumy(k), rms)
c             error= 0.03*dumy(k)
             error= max( dumz(k) , -dumy(k) )

             IF (IC .EQ. 1) 
     c       errmag(nob)=max( (dumy(k)+error)/dumy(1)-mago(nob), 0.01d0)
             IF (IC .EQ. 2) THEN 
                dum1= ((dumy(k)+error)/dumy(1)    -mago(nob) )**2
                dum2= (dumy(k)/(dumy(1) +dumz(1)) -mago(nob) )**2
                errmag(nob)= sqrt(dum1+dum2)
             ENDIF   
             errmag(nob)= errmag(nob) * sce
        enddo

 911    continue
        intsep(i+1)= nob

c       end loop spectra
	ENDDO

	if (nob .gt. nin) then
           write(*,*) 'INCREASE nin'
           STOP
        endif

	close(23)

	return
	end

*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine compareint(mago)

c       read in predicted convolved intensity profile, compare to observed one(s)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573,npL1=npL+1,no=189, ns= 2000, nin=600,nfit=4)

	double precision mago(nin),xspec(ns),xvis(ns)
        double precision wve(npL1), flx(npL1)
        double precision xint(nin), yintd(nin), zintd(nin)
        double precision fwhmint(nin), waveint(nin), off(2*nin), D1(nin)
        double precision pxl(nin), SB(nin), wavevis(ns), fwhmvis(ns)
        double precision cimage(2*nin,21), dumi(ns,nin), dumo(nin)
        double precision afin(nfit), erra(nfit)
        double precision beforec(nin), afterc(nin), deconsize(nin)
        double precision pp(nfit), Router(nfit), scl(nfit)
        double precision yvis(ns),zvis(ns), wavecut
        double precision av,teff,dist,bic
        real pltintm(nin)

	integer i,j,k, xsel(no), intsep(nin), vissep(ns),svis(ns)

	character*80 starname,path,cdum,name,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint

        common/intensity/waveint,fwhmint,intsep,yintd,zintd,pxl,D1,
     c                   pltintm,nns
        common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis
	common/final/afin,erra,chichi,bic,ifinal,npar
        common/needed/rinner,router,pp,scl,av,teff,dist,npow
        COMMON /numerics/ accRomb, accuracy, accConv, delTAUsc, facc,
     &                  dynrange, EtaRat, accFbol, Ncav, Nins


        DOUBLE PRECISION kPSF(20), FWHM1(20), FWHM2(20), theta1,
     &       xpsf(1000), ypsf(1000)
        COMMON /psf2/ kPSF, FWHM1, FWHM2, Theta1, xpsf, ypsf

        pi= 3.14159265d0

c       predicted intensity profiles
         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'.itb',name)

         open(23, file= name)
         write(*,*) 'intensity file ',  name, nns, 'nsel ', nsel

 99      format(21E11.3)
c     SKIP header RAW IMAGE
       do i= 1,4
          read(23, '(a80)') cdum
       enddo

c     SKIP data RAW IMAGE
        j=0
 200    j=j+1
        read(23,99 ,err=201,end=201)dumo(j),dum,(dumi(j,i),i= 1,nns+nnv)
	goto 200
 201	continue
        ni= j-1

c    Check flux integral. Should agree with flux as derived from rted_* file
        if (ifinal.eq.1) then

c     scale impact parameter from units of Rc to arcseconds
        do j= 1,ni
           dumo(j)=dumo(j)* theta1/2.d0
           if (j.le.12) then
              write(80,*) 'innerpart ',j, dumi(j,50),dumo(j),nins,ncav
           endif
        enddo

        do ii= 1,nns
c     flux= integral{ I(p) 2 pi p dp} = I(0) pi Rstar*2 + (rest of integral)
c     check *.itb file, but stellar radius should be second entry in array
        sum= dumi(1,ii) * pi * dumo(2)**2
c     force to let the dust shell start where star ends
        dumi(2,ii)= dumi(3,ii)
c     integrate over the dust shell
        do j= 2,ni-1
           sum= sum +pi* (dumo(j+1)-dumo(j))*
     c                   (dumo(j+1)*dumi(j+1,ii) + dumo(j)*dumi(j,ii))
           write(80,*) 'flux buildup ', dumo(j+1), sum
        enddo

        write(80,*) 'check flux ', waveint(ii), theta1/2., sum
        beforec(ii)= sum
        enddo
        endif


c     SKIP header CONVOLVED IMAGE (4 lines, but already read one above that caused the goto201!)
       do i=1,3
          read(23, '(a80)') cdum
c          write(*,*) cdum
       enddo

c     data CONVOLVED IMAGE
        j=0
 300    j=j+1
        read(23, 99 ,err=301,end=301) off(j),
     c                    (cimage(j,i),i = 1,nns), (dumi(j,i),i = 1,nnv)
        if (nns .ne. 0)
     c     write(*,*) 'predicted Int ',j,off(j), cimage(j,1),cimage(j,2)

c     normalise to peak [convolution is already normalised]
c        do i=1,nns
c             cimage(j,i)= cimage(j,i)/cimage(1,i)
c        enddo

	goto 300
 301	continue
        ni= j-1

        close(23)


        if (ifinal.eq.1) then
        do ii= 1,nns
c     The intensity profile of the convoled image should be smooth.
c     integrate over the shell. 'off' is already in arcseconds
        sum= 0.d0
        ll= -1
        do j= 1,ni-1
           sum= sum +pi* (off(j+1)-off(j))*
     c                   (off(j+1)*cimage(j+1,ii) + off(j)*cimage(j,ii))

c     look for FWHM
           if ( cimage(j,ii) .gt. 0.5d0 ) ll= j
        enddo

        afterc(ii)= sum

        ratio= (0.5d0-cimage(ll,ii))/(cimage(ll+1,ii)-cimage(ll,ii))
	test= off(ll) + ratio*( off(ll+1)-off(ll) )
c     determine the deconvolved size
        test= (2.d0*test)**2 - fwhmint(ii)**2
        if (test .gt. 0.d0) then
           deconsize(ii)= sqrt(test)
        else
           deconsize(ii)= 0.d0
        endif
        write(80,*) 'check flux ', waveint(ii), sum, ll,ratio,test

        enddo
        endif



c     compare model and observed intensity profiles
      	do i= 1,nns
           do k= intsep(i)+1, intsep(i+1)

c     Interpolate model array to observed one.
c     This ignores the effect that the  surface brightness is measured in a pixel
              l= -1
	      do j= 1,ni-1
   	         if ( (xint(k) .ge. off(j)  ) .and.
     c                (xint(k) .le. off(j+1)) )    l= j
	      enddo
              if (xint(k) .gt. off(ni)) l= ni-1
              if (l .le. 0) then
                 write(*,*) i, k ,xint(k),off(1),off(ni)
                 stop
              endif

              ratio= (xint(k)-off(l))/(off(l+1)-off(l))
	      mago(k)= cimage(l,i) + ratio*( cimage(l+1,i)-cimage(l,i) )
              if (xint(k) .gt. off(ni)) mago(k)= cimage(ni,i)
      write(*,*)i,k,intsep(i),intsep(i+1),xint(k),l,off(l),ratio,mago(k)

c     MG 09.08.09
c     negative pixelsize indicates that the effect of averaging over the finite pixel size
c     is NOT taken into account (default approach in versions 1-3)
              IF (PXL(I) .GE. 0.) THEN
                 if (xint( intsep(i)+1 ) .ne. 0.0) then
                   write(*,*) 'First point in I(r) file must be at zero'
                   STOP
                 endif
c     integrate over a pixel that runs from (xint +- pix/2 ; 0 +- pix/2). Adopted from DustytoImage.f
                 call integrate(off,cimage,ni,i, pxl(i),xint(k), SB(k))
              ENDIF

           enddo

           IF (PXL(I) .GE. 0.) THEN
              do k= intsep(i)+1, intsep(i+1)
                 write(*,*) 'alt int', SB(k), SB( intsep(i)+1 )
c      09.08: UNCOMMENT WHEN fully tested !
                 mago(k)= SB(k)/SB( intsep(i)+1 )
              enddo
           ENDIF

	enddo

 97     format(11x,21E11.4)

        if (ifinal .eq. 1) then
c     Make plot if the solution converged
         write(*,*) 'final intensity plot'
         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'_int.ps/vcps',name)
         call pgbegin(0, name , 1,1)
         call pgscf(2)
         call pgsch(0.75)

         do i= 1,nns
             call plotint(i, cimage,off,ni)
         enddo

         call pgend

c     Write convolved intensity profile to additional file, *.itbc
c     arcsec versus Jy/arcsec2 and MJy/sr
c     Deconvolved fwhm size in arcsec
         CALL ATTACH(path,lpath,'.itbc',name)
         open(23, file= name)
         write(23,*) 'offset(arcsec)      I(Jy/arcsec2)       I(MJy/sr)'
         write(23,*)  nns
         write(23,97) (waveint(i),i= 1,nns),(waveint(i),i = 1,nns)
         write(23,97) (deconsize(i),i= 1,nns)
         write(23,*) '#'

         do j= 1,ni
         write(23, 98) off(j),
     c        (cimage(j,i)/afterc(i)*beforec(i) , i = 1,nns),
     c        (cimage(j,i)/afterc(i)*beforec(i)*4.2545d4 , i = 1,nns)
         enddo
         close(23)

        endif

 98     format(21E11.4)
	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine integrate(off, cimage,ni,iL, pix, x0, sum1 )

c       Perform integral I(p) dx dy over a pixel by Monte Carlo method
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)
        REAL ran3

        parameter (nl= 21, nin=600)

        double precision cimage(2*nin,nl), off(2*nin)
        integer iseed,nii
        integer npoints, nmax
        double precision sum,var,pix,x0,sum1

c        open(80, file= 'test.dat')

c       seed for random generation [0,1]
        iseed= -1
        RR= ran3(iseed)

c         write(*,*) ni,iL,pix,ix,jy

c        desired accuracy 0.001 slow; 0.005 OK
c	rel_des= 0.004
	rel_des= 0.001d0
c        maximum number of points
	nmax= 10000000

c        draw random points inside box dx dy
c        first iteration
	npoints= 1000
	nitt= 0

 200	nitt= nitt+1

    	sum= 0.0d0
	var= 0.0d0
	nii= 0

	do i= 1, npoints

        RR= ran3(iseed)
c     ORIGINAL CODING in DustytoImage.f
c	x= (ix*pix -pix/2.) + pix *RR
c        RR= ran3(iseed)
c	y= (jy*pix -pix/2.) + pix *RR
c     Now we assume an x-value of x0, and y=0
	x= (   x0 -pix/2.d0) + pix *RR
        RR= ran3(iseed)
	y= (      -pix/2.d0) + pix *RR

	 nii= nii+1
c        impact parameter for that point
	 rad= sqrt( x**2 + y**2 )

c        exit if any point is outside data array.
         if (rad .ge. off(ni)) then
            sum= 0.0d0
            goto 301
         endif

c        interpolate I(p) for that impact parameter
         l= -1
         do j= 1,ni
   	      if ( (rad .ge. off(j)  ) .and.
     c             (rad .le. off(j+1)) )    l= j
	 enddo

         ratio= (rad-off(l))/(off(l+1)-off(l))
	 result= cimage(l,iL) + ratio*( cimage(l+1,iL)-cimage(l,iL) )

    	 sum= sum+ result
	 var= var+ result**2

c       end loop random
	enddo
	
	rel_max= 0.d0

	var= var/dble(nii)
    	sum= sum/dble(nii)

        if ( sum**2  .gt.  var ) then
           write(80,*)'STOP', sum,var,sum**2, nii
           var= sum**2 + nii*(sum* rel_des* 1.01)**2
           write(80,*)'STOP', sum,var,sum**2
           write(*,*)'STOP in integrate'
           STOP
        endif

	var= dsqrt( (var - sum**2)/dble(nii) )
        if (sum .ne. 0.) then
           rel_max= max(rel_max, dble(var/sum) )
        else
c     force to increase npoints by 10...
           rel_max= 10* rel_des
        endif

	write(80,*)
     c   'IT: ', iL,pix,x0,x,y, nitt, sum,var,npoints,rel_max,var,sum

c       check for relative accuracy and update number random points
	if (rel_max .lt. rel_des) goto 300
	if (nitt .eq. 4) goto 300
	npoints= int(1.1* real(npoints)* (rel_max/rel_des)**2)
	if (npoints .gt. nmax) npoints= nmax
	goto 200

 300	continue

	write(80,*) 'end ' , iL,pix,x0, nitt, nii, sum, var, (var/sum)

c        close(80)

 301    sum1= real(sum)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

        FUNCTION ran3(idum)

c      Original ran1 of NumRec version 2.1
c       Renamed ran3 because of historical reasons of
c       using calls to "ran3" in the code.

        INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
        REAL ran3,AM,EPS,RNMX
        PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *  NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
        INTEGER j,k,iv(NTAB),iy
        SAVE iv,iy
        DATA iv /NTAB*0/, iy /0/
        if (idum.le.0.or.iy.eq.0) then
         idum=max(-idum,1)
         do 11 j=NTAB+8,1,-1
           k=idum/IQ
           idum=IA*(idum-k*IQ)-IR*k
           if (idum.lt.0) idum=idum+IM
           if (j.le.NTAB) iv(j)=idum
11       continue
         iy=iv(1)
        endif
        k=idum/IQ
        idum=IA*(idum-k*IQ)-IR*k
        if (idum.lt.0) idum=idum+IM
        j=1+iy/NDIV
        iy=iv(j)
        iv(j)=idum
        ran3=min(AM*iy,RNMX)
        return
        END
*23456789012345678901234567890123456789012345678901234567890123456789012

      FUNCTION bessj1(x1)
      DOUBLE PRECISION x1
      REAL bessj1,x
      REAL ax,xx,z
      DOUBLE PRECISION p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,
     *s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,
     *s5,s6
      DATA r1,r2,r3,r4,r5,r6/72362614232.d0,-7895059235.d0,
     *242396853.1d0,-2972611.439d0,15704.48260d0,-30.16036606d0/,s1,s2,
     *s3,s4,s5,s6/144725228442.d0,2300535178.d0,18583304.74d0,
     *99447.43394d0,376.9991397d0,1.d0/
      DATA p1,p2,p3,p4,p5/1.d0,.183105d-2,-.3516396496d-4,
     *.2457520174d-5,-.240337019d-6/, q1,q2,q3,q4,q5/.04687499995d0,
     *-.2002690873d-3,.8449199096d-5,-.88228987d-6,.105787412d-6/

      x= real(x1)

      if(abs(x).lt.8.)then
        y=x**2
        bessj1=x*(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+
     *y*(s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8./ax
        y=z**2
        xx=ax-2.356194491
        bessj1=sqrt(.636619772/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*
     *p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))*sign(1.,x)
      endif
      return
      END
*23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE indexx(n,arr,indx)

      INTEGER n,indx(n),M,NSTACK
      double precision arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=0
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine plotint(i, cimage, off, ni)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573,npL1=npL+1,no=189,ns= 2000,nin=600,nl= 21)
	double precision xspec(ns)
        double precision wve(npL1), flx(npL1)
        double precision xint(nin), yint(nin), zint(nin), D1(nin)
        double precision fwhmint(nin), waveint(nin), off(2*nin),pxl(nin)
        double precision cimage(2*nin,nl), xvis(ns)
        real xpl(nin), ypl(nin), zpl(nin), xpl1(nin*2), ypl1(nin*2)
        real xmin, xmax, ymin, ymax
	real vsminx,vsmaxx,vsminy,vsmaxy
	real vsminxi,vsmaxxi,vsminyi,vsmaxyi,x1,x2,y1,y2
        real pltintm(nin), tickmark

	integer i,k, xsel(no), intsep(nin), symbol(nin),symbol1(nin)

	character*80 starname,absscafile
        character*12 cwave
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis,xsel,
     c                nvisib,nfl,nspec,nsel,nint
        common/intensity/waveint,fwhmint,intsep,yint,zint,pxl,D1,
     c                   pltintm,nns

        if (i .eq. 1) then
	 vsminx=0.5
	 vsmaxx=3.5
	 vsminy=7.0
	 vsmaxy=9.0
        endif
        if (i .eq. 2) then
	 vsminx=0.5
	 vsmaxx=3.5
	 vsminy=4.7
	 vsmaxy=6.7
        endif
        if (i .eq. 3) then
	 vsminx=0.5
	 vsmaxx=3.5
	 vsminy=2.4
	 vsmaxy=4.4
        endif
        if (i .eq. 4) then
	 vsminx=4.0
	 vsmaxx=7.0
	 vsminy=7.0
	 vsmaxy=9.0
        endif
        if (i .eq. 5) then
	 vsminx=4.0
	 vsmaxx=7.0
	 vsminy=4.7
	 vsmaxy=6.7
        endif
        if (i .eq. 6) then
	 vsminx=4.0
	 vsmaxx=7.0
	 vsminy=2.4
	 vsmaxy=4.4
        endif

        call pgvsize(vsminx,vsmaxx,vsminy,vsmaxy)

        xmax=  xint(intsep(i+1)) * 1.1
        xmax= 80.
        xmin= -0.05*xmax
        ymin= -0.05
        ymax= 1.15

c     model
        nplt1= 0
        do k= 1,ni
           nplt1=nplt1+1
           xpl1(nplt1)= off(k)
           ypl1(nplt1)= cimage(k,i)
        enddo

         call pgwindow(xmin, xmax, ymin, ymax)
         call pgbox('bcnst',0.0,0,'bcnst',0.0,0)
         call pgline(nplt1, xpl1, ypl1)

c     observations
        nplt= 0
        do k= intsep(i)+1, intsep(i+1)
           nplt= nplt+1
           xpl(nplt)= xint(k)
           ypl(nplt)= yint(k)
           zpl(nplt)= zint(k)
           symbol(nplt)= 4
           symbol1(nplt)= -1
        enddo
         call pgpnts(nplt, xpl, ypl, symbol,nplt)
         call pgerrb(6, nplt, xpl, ypl, zpl, 0.0)

c         call pglabel('offset (arcsec)', 'Normalised Intensity' , ' ')
         if (i.eq. 3 .or. i. eq. nns) then
           call pglabel('offset (arcsec)', 'Normalised Intensity' , ' ')
         else
           call pglabel(' ', 'Normalised Intensity' , ' ')
         endif

         if (i.eq.1) then
c          call pglabel('offset (arcsec)','Normalised Intensity',starname)
          call pgtext( 0.5*xmax, ymax*1.05 , starname)
         endif

         write( cwave ,'(f6.1)') waveint(i)
         call pgtext( 0.8*xmax, ymax*0.85 , cwave)

c     inset
        if (pltintm(i) .ge. 0. .and. pltintm(i) .lt. 1.) then

c	 x1= 3.0 * fwhmint(i)
c	 x1= 1.5 * fwhmint(i)
	 x1= 0.5*fwhmint(i) + 6.0
         ratio= (x1-xmin)/(xmax-xmin)
         vsminxi=vsminx+ratio*(vsmaxx-vsminx)
         x2= xmax*0.9
         ratio= (x2-xmin)/(xmax-xmin)
         vsmaxxi=vsminx+ratio*(vsmaxx-vsminx)
         y1=  0.35
         ratio= (y1-ymin)/(ymax-ymin)
         vsminyi=vsminy+ratio*(vsmaxy-vsminy)
         y2=  0.85
         ratio= (y2-ymin)/(ymax-ymin)
         vsmaxyi=vsminy+ratio*(vsmaxy-vsminy)
	 write(*,*) 'inset', x1, vsminxi
	 write(*,*) 'inset', x2, vsmaxxi
	 write(*,*) 'inset', y1, vsminyi
	 write(*,*) 'inset', y2, vsmaxyi
	
         call pgsch(0.60)
         call pgvsize(vsminxi,vsmaxxi,vsminyi,vsmaxyi)
         call pgwindow(x1,x2, -pltintm(i)/10. , pltintm(i))
c         call pgwindow(x1,x2, -0.005 , pltintm(i))
         tickmark=  0.0001*int(10000.*  0.9*pltintm(i))
         call pgbox('bcst',0.0,0,'bmcst', tickmark, 2 )
c     reset to value set at initialization outside this routine....!
         call pgsch(0.75)
         call pgpnts(nplt, xpl, ypl, symbol1 , nplt)
         call pgerrb(6, nplt, xpl, ypl, zpl, 0.0)
         call pgline(nplt1, xpl1, ypl1)

        endif

         return
         end
*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine plotvis(i, cimage, off, ni)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573,npL1=npL+1, no=189,ns= 2000,nin=600,nl= 21)

	double precision xspec(ns), xint(nin)
        double precision wve(npL1), flx(npL1)
        double precision wavevis(ns), off(2*nin)
        double precision cimage(2*nin,nl), fwhmvis(ns)
        double precision xvis(ns),yvis(ns),zvis(ns)
        real xpl(ns), ypl(ns), zpl(ns)
        real xmin, xmax, ymin, ymax

	integer i,k, xsel(no), vissep(ns), symbol(nin),svis(ns)

	character*80 starname,absscafile
        character*12 cwave
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis,xsel,
     c                nvisib,nfl,nspec,nsel,nint
        common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis

        if (i .eq. 1) then
         call pgvsize(0.5,3.5,7.0,9.0)
        endif
        if (i .eq. 2) then
         call pgvsize(0.5,3.5,4.7,6.7)
        endif
        if (i .eq. 3) then
         call pgvsize(0.5,3.5,2.4,4.4)
        endif
        if (i .eq. 4) then
         call pgvsize(4.0,7.0,7.0,9.0)
        endif
        if (i .eq. 5) then
         call pgvsize(4.0,7.0,4.7,6.7)
        endif
        if (i .eq. 6) then
         call pgvsize(4.0,7.0,2.4,4.4)
        endif


        xmax= -1.
        do k= vissep(i)+1, vissep(i+1)
           if (xvis(k) .gt. xmax) xmax= xvis(k)
        enddo
c        xmax=  xvis(vissep(i+1)) * 1.1
        xmax=  xmax * 1.1
        xmin= -0.03*xmax
        ymin= -0.03
        ymax= 1.05

c     model
        nplt= 0
        do k= 1,ni
           nplt= nplt+1
           xpl(nplt)= off(k)
           ypl(nplt)= cimage(k,i)
        enddo

         call pgwindow(xmin, xmax, ymin, ymax)

         call pgbox('bcnst',0.0,0,'bcnst',0.0,0)

         call pgline(nplt, xpl, ypl)

c     observations
        nplt= 0
        do k= vissep(i)+1, vissep(i+1)
c           nplt= nplt+1
           nplt=1

           xpl(nplt)= xvis(k)
           ypl(nplt)= yvis(k)
           zpl(nplt)= zvis(k)
c           symbol(nplt)= 4
           symbol(nplt)= svis(k)

           call pgpnts(nplt, xpl, ypl, symbol,nplt)
           call pgerrb(6, nplt, xpl, ypl, zpl, 0.0)
        enddo
c         call pgpnts(nplt, xpl, ypl, symbol,nplt)
c         call pgerrb(6, nplt, xpl, ypl, zpl, 0.0)

         if (i.eq. 3 .or. i. eq. nnv) then
           call pglabel('q(arcsec\u-1\d)','Visibility', '')
         else
           call pglabel(' ','Visibility', '')
         endif


         if (i.eq.1) then
          call pgtext( 0.5*xmax, ymax*1.05 , starname)
         endif


         write( cwave ,'(f6.2)') wavevis(i)
         call pgtext( 0.75*xmax, ymax*0.85 , cwave)

         return
         end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine comparevis(mago)

c       read in predicted visibility curve, compare to observed one(s)
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(npL=573,npL1=npL+1, no=189, ns= 2000,nin=600,nfit= 4)
	double precision mago(ns), xspec(ns)
        double precision wve(npL1), flx(npL1),xvis(ns),yvis(ns),zvis(ns)
        double precision fwhmint(nin), wavevis(ns), off(2*nin), D1(nin)
        double precision waveint(nin), xint(nin),yint(nin),zint(nin)
        double precision pxl(nin), fwhmvis(ns)
        double precision cimage(2*nin,21), dumi(ns,nin), dumo(nin)
        double precision afin(nfit), erra(nfit)
        double precision pp(nfit), Router(nfit), scl(nfit), wavecut
        double precision av,teff,dist,bic
        real pltintm(nin)

	integer i,j,k, xsel(no), vissep(ns),intsep(nin),svis(ns)

	character*80 starname,path,name,absscafile
        character*200 cdum, modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/fluxes/wve,flx,xspec,xint,xvis, xsel,
     c                nvisib,nfl,nspec,nsel,nint
        common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis
        common/intensity/waveint,fwhmint,intsep,yint,zint,pxl,D1,
     c                   pltintm,nns
	common/final/afin,erra,chichi,bic,ifinal,npar
        common/needed/rinner,router,pp,scl,av,teff,dist,npow


        if (nnv .eq. 0.) goto 111

        pi= 3.14159265d0

c       predicted intensity profiles
         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'.itb',name)

         open(23, file= name)
         write(*,*) 'visibility file ',  name, nns, nnv

 99      format(21E11.3)
c     SKIP header RAW IMAGE
       do i= 1,4
          read(23, '(a200)') cdum
       enddo

c     SKIP data RAW IMAGE
        j=0
 200    j=j+1
        read(23,99 ,err=201,end=201)dumo(j),dum,(dumi(j,i),i= 1,nns+nnv)
	goto 200
 201	continue
        ni= j-1


c     SKIP header CONVOLVED IMAGE (4 lines, but already read one above that caused the goto201!)
       do i=1,3
          read(23, '(a200)') cdum
       enddo

c     SKIP data CONVOLVED IMAGE
        j=0
 300    j=j+1
        read(23, 99 ,err=301,end=301) dum, (dumi(j,i),i = 1,nns+nnv)
	goto 300
 301	continue

c     SKIP header visibilities
       do i= 1,3
          read(23, '(a200)') cdum
          write(*,*) cdum
       enddo

c     data VISIBILITIES
       j=0
 400   j=j+1
       read(23, 99 ,err=401,end=401) off(j),
     c                    (dumi(j,i),i = 1,nns),(cimage(j,i),i = 1,nnv)
       goto 400
 401   continue
       ni= j-1

       close(23)

       write(*,*) 'visi here', vissep,ni
       do i=1,nnv
          do j=1,ni
             write(*,*) 'visi data', i,j, off(j), cimage(j,i)
          enddo
       enddo

c     compare model and observed visibility profiles
      	do i= 1,nnv
           do k= vissep(i)+1, vissep(i+1)

c     Interpolate model array to observed one.
              l= -1
	      do j= 1,ni-1
   	         if ( (xvis(k) .ge. off(j)  ) .and.
     c                (xvis(k) .le. off(j+1)) )    l= j
	      enddo

              ratio= (xvis(k)-off(l))/(off(l+1)-off(l))
	      mago(k)= cimage(l,i) + ratio*( cimage(l+1,i)-cimage(l,i) )
              if (xvis(k) .gt. off(ni)) mago(k)= cimage(ni,i)
      write(*,*)i,k,vissep(i),vissep(i+1),xvis(k),l,off(l),ratio,mago(k)

           enddo
	enddo

        if (ifinal .eq. 1) then
c     Make plot if the solution converged
         write(*,*) 'final visibility plot'
         CALL Clean(starname, path, lpath)
         CALL ATTACH(path,lpath,'_vis.ps/vcps',name)
         call pgbegin(0, name ,1,1)
         call pgscf(2)
         call pgsch(0.75)

         do i=1,nnv
             call plotvis(i, cimage,off,ni)
         enddo
         call pgend

        endif

 111    continue
	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

	subroutine readvis(x,mago,errmag,nob)

c       read in observed visibility curves

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

	parameter(ns= 2000, nin=600)
	double precision mago(ns), errmag(ns), fwhmvis(ns)
        double precision waveint(nin), yintd(nin), zintd(nin)
	double precision wavevis(ns), x(ns), fwhmint(nin)
        double precision wavecut
	double precision dumx(ns), dumy(ns), dumz(ns), pxl(nin), D1(nin)
        double precision yvis(ns), zvis(ns)
	integer vissep(ns), intsep(nin), svis(ns), idum(ns)
        real pltintm(nin)

	character*80 starname,specname,path
        character*80 name,cdum,absscafile
        character*200 modelatmos

	common/fnames/starname,modelatmos,absscafile,wavecut

c     keep track of: how many visibility curves,
c                    the wavelength, 1.22 l/D of telescope (06.10)
        common/visibility/wavevis,vissep,yvis,zvis,fwhmvis,nnv,svis
        common/intensity/waveint,fwhmint,intsep,yintd,zintd,pxl,D1,
     c                   pltintm,nns

c       observed data
c       file name that needs to exist is called   vis_<starname>.dat
        CALL Clean(starname, path, lpath)
        CALL ATTACH(path,lpath,'.dat',name)
        CALL Clean(name, path, lpath)
        CALL ATTACHfront(path,lpath,'vis_',name)

        write(*,'(A)') 'readvis ',  name, path

	nob= 0
        vissep(1)= 0
	write(80,*) 'readvis'

c       observed data
	open(23, file= name)

c       number of intensity profiles
	read(23,*) nnv
	write(80,*) nnv

	do I= 1,nnv

c       filename of intensity profile
	read(23,'(a80)') specname
	write(80,*) '|',specname,'|'
	write(*,*) '|',specname,'|'

c	read: Code, WAVELENGTH, number of headerlines in inputfile, scale errorbars,
c         MAX(0.5*seeing  or  1.22 l/D of unit telescope IN ARCSECONDS =  0.25* lambda(micron)/D(m) )
c       fwhmvis will be defined for Nlambdaout (nns+nnv) values, and is interpreted as a RADIUS!
	read(23,*) IC, wavevis(i), nhead, sce, fwhmvis(nns+i)
        write(*,*) IC, wavevis(i), nhead, sce, fwhmvis(nns+i)


	open(33, FILE= specname)

c       format: spatial frequencies in units of 10^5/rad, visibility, error
        IF (IC .EQ. 1) THEN

        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: spatial frequencies in units of 10^5/rad, visibility, error
	k=1
 111	read(33,*, err=112,end=112) dumx(k), dumy(k), dumz(k), idum(k)
c     to arcsec^-1
        dumx(k)= dumx(k)/2.06265d0
        if (dumz(k) .lt. 0.01*dumy(k)) dumz(k)= 0.01*dumy(k)
        if (idum(k) .eq. 0)  idum(k)= 4
	write(80,*) k,dumx(k), dumy(k), dumz(k), idum(k)

	k=k+1
	goto 111
 112	continue
	np= k-1

c     order by visibility
c        call indexx(np, dumx, idx)
c        do i= 1,np
c            dum1(i)= dumx(idx(i))
c            dum2(i)= dumy(idx(i))
c            dum3(i)= dumz(idx(i))
c        enddo
c        do i= 1,np
c            dumx(i)= dum1(i)
c            dumy(i)= dum2(i)
c            dumz(i)= dum3(i)
c        enddo
c     order by visibility



        do k= 1,np
           if (dumx(k) .gt. -1.) then
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)
             errmag(nob)= dumz(k) *sce
             svis(nob)= idum(k)
           endif
        enddo

        ENDIF



c       format: spatial frequencies in units of arcsec^-1 , visibility, (NO error)
        IF (IC .EQ. 2) THEN

        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: spatial frequencies in units of arcsec^-1 , visibility, (NO error)
	k=1
 211	read(33,*, err=212,end=212) dumx(k), dumy(k), idum(k)
        dumz(k)= 0.03
        if (idum(k) .eq. 0)  idum(k)= 4

	write(80,*) k,dumx(k), dumy(k), dumz(k), idum(k)

	k=k+1
	goto 211
 212	continue
	np= k-1

        do k= 1,np
           if (dumx(k) .gt. -1.) then
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)
             errmag(nob)= dumz(k) *sce
             svis(nob)= idum(k)
           endif
        enddo

        ENDIF


c       format: spatial frequencies in units of arcsec^-1 , visibility, error
        IF (IC .EQ. 3) THEN
        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: spatial frequencies in units of arcsec^-1 , visibility, error
	k=1
 311	read(33,*, err=312,end=312) dumx(k), dumy(k), dumz(k), idum(k)
        if (dumz(k) .le. 0.) dumz(k)= 0.03
        if (dumz(k) .lt. 0.01*dumy(k)) dumz(k)= 0.01*dumy(k)
        if (idum(k) .eq. 0)  idum(k)= 4
	write(80,*) k,dumx(k), dumy(k), dumz(k), idum(k)

	k=k+1
	goto 311
 312	continue
	np= k-1

        do k= 1,np
           if (dumx(k) .gt. -1.) then
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)
             errmag(nob)= dumz(k) *sce
             svis(nob)= idum(k)
           endif
        enddo
        ENDIF


c       format: spatial frequencies in units of rad^-1 , visibility^2, error in V^2
        IF (IC .EQ. 4) THEN
        do k= 1,nhead
           read(33, '(a80)') cdum
        enddo

c       format: spatial frequencies in units of rad^-1 , visibility^2, error in V^2
	k=1
 411	read(33,*, err=412,end=412) dumx(k), dumy(k), dumz(k), idum(k)
        dumx(k)= dumx(k)/2.06265d5
        dumy(k)= sqrt( dumy(k) )
        dumz(k)= sqrt( dumy(k)**2 + dumz(k) ) - dumy(k)
        if (idum(k) .eq. 0)  idum(k)= 4
	write(80,*) k,dumx(k), dumy(k), dumz(k), idum(k)

	k=k+1
	goto 411
 412	continue
	np= k-1

        do k= 1,np
           if (dumx(k) .gt. -1.) then
 	     nob= nob+1
	     x(nob)= dumx(k)
	     mago(nob)= dumy(k)
             errmag(nob)= dumz(k) *sce
             svis(nob)= idum(k)
           endif
        enddo
        ENDIF




	close(33)
        vissep(i+1)= nob

c       end loop visibility curves
	ENDDO


	if (nob .gt. ns) then
           write(*,*) 'INCREASE ns'
           STOP
        endif

	close(23)

	return
	end
*23456789012345678901234567890123456789012345678901234567890123456789012

        subroutine getphot( xsel, mag, emag, l0, flux, eflux )

c     based on index of available filters, magnitude and error, return
c     the effective wavelength and flux with error.

c     available filters, effective wavelengths and zeropoints have to be in sync
c     with PSCfoldORIG

        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        IMPLICIT INTEGER(I-N)

        integer xsel
        double precision mag, l0, emag

        l0=    1.d9
        flux=  1.d9
        eflux= 0.

c     1-5 Bessell UBVRI
        if (xsel .eq. 1) then
           l0= 0.366
           zp= 4.214d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 2) then
           l0= 0.438
           zp= 6.255d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 3) then
           l0= 0.545
           zp= 3.627d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 4) then
           l0= 0.641
           zp= 2.205d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 5) then
           l0= 0.798
           zp= 1.142d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     6-10 WFCAM ZYJHK
        if (xsel .eq. 6) then
           l0= 0.8817
           zp= 8.807d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 7) then
           l0= 1.0305
           zp= 5.834d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 8) then
           l0= 1.2483
           zp= 3.022d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 9) then
           l0= 1.6313
           zp= 1.165d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 10) then
           l0= 2.2010
           zp= 4.018d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     11-13 DENIS IJK
        if (xsel .eq. 11) then
           l0= 0.791
           zp= 11.82d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 12) then
           l0= 1.228
           zp= 3.19d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 13) then
           l0= 2.145
           zp= 4.38d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     14-16 2MASS JHK
        if (xsel .eq. 14) then
           l0= 1.235
           zp= 3.137d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 15) then
           l0= 1.662
           zp= 1.130d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 16) then
           l0= 2.159
           zp= 4.312d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     17-20 IRAC 36 45 58 80
        if (xsel .eq. 17) then
           l0= 3.55
           zp= 6.63d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 18) then
           l0= 4.49
           zp= 2.67d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 19) then
           l0= 5.73
           zp= 10.81d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 20) then
           l0= 7.87
           zp= 3.08d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     21-24 IRAS 12 25 60 100
        if (xsel .eq. 21) then
           l0= 12.
           zp= 40.5 *2.998d-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 22) then
           l0= 25.
           zp= 8.97 *2.998d-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
         endif

        if (xsel .eq. 23) then
           l0= 60.
           zp= 1.45 *2.998d-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 24) then
           l0= 100.
           zp= 0.423 *2.998d-12/l0/l0

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     25-27 IRSF JHK
        if (xsel .eq. 25) then
           l0= 1.250
           zp= 3.036d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 26) then
           l0= 1.644
           zp= 1.184d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 27) then
           l0= 2.149
           zp= 4.45d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     28    MSX A
        if (xsel .eq. 28) then
           l0= 8.28
           zp= 2.364d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     29-32 CASPIR JHKL
        if (xsel .eq. 29) then
           l0= 1.24
           zp= 3.182d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 30) then
           l0= 1.68
           zp= 1.101d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 31) then
           l0= 2.22
           zp= 3.993d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 32) then
           l0= 3.59
           zp= 6.306d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     33-35 MIPS 24 70 160
        if (xsel .eq. 33) then
           l0= 24.0
           zp= 3.81d-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 34) then
           l0= 70.0
           zp= 4.84d-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 35) then
           l0= 160.0
           zp= 1.958d-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     36-39 OGLE UBVI
        if (xsel .eq. 36) then
           l0= 0.372
           zp= 4.358d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 37) then
           l0= 0.431
           zp= 6.229d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 38) then
           l0= 0.536
           zp= 3.784d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 39) then
           l0= 0.820
           zp= 1.060d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     40-44 ISOCAM SW1 LW1,2,7,10
        if (xsel .eq. 40) then
           l0= 3.6
           zp= 6.508d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 41) then
           l0= 4.5
           zp= 2.692d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 42) then
           l0= 6.7
           zp= 6.028d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 43) then
           l0= 9.6
           zp= 1.384d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 44) then
           l0= 12.0
           zp= 7.233d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     45-48 SAAO JHKL
        if (xsel .eq. 45) then
           l0= 1.23
           zp= 3.255d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 46) then
           l0= 1.66
           zp= 1.145d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 47) then
           l0= 2.23
           zp= 3.892d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 48) then
           l0= 3.44
           zp= 7.499d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     49-51 'APEX' 450, 870, 1200 (scuba 450/ LABOCCA 870/ MAMBO 1200) [milliJy]
        if (xsel .eq. 49) then
           l0= 450.
           zp= 1.d-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 50) then
           l0= 870.
           zp= 1.d-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 51) then
           l0= 1200.
           zp= 1.d-21

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif


c     52-56 Sloan ugriz
        if (xsel .eq. 52) then
           l0= 0.3581
           zp= 40.66d-9

           dum=10**(-0.4*(mag-0.799))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.799-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 53) then
           l0= 0.4686
           zp= 55.82d-9

           dum=10**(-0.4*(mag+0.129))
           flux= zp*dum
           dum=10**(-0.4*(mag+0.129-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 54) then
           l0= 0.6165
           zp= 25.52d-9

           dum=10**(-0.4*(mag-0.125))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.125-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 55) then
           l0= 0.7482
           zp= 14.23d-9

           dum=10**(-0.4*(mag-0.340))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.340-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 56) then
           l0= 0.8931
           zp= 8.526d-9

           dum=10**(-0.4*(mag-0.511))
           flux= zp*dum
           dum=10**(-0.4*(mag-0.511-emag))
           eflux= zp*dum - flux
        endif


c     57-61 ESO JHKLM
        if (xsel .eq. 57) then
           l0= 1.228
           zp= 2.907d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 58) then
           l0= 1.651
           zp= 1.146d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 59) then
           l0= 2.216
           zp= 4.025d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 60) then
           l0= 3.771
           zp= 5.125d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 61) then
           l0= 4.772
           zp= 2.217d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     62-69 UKT14 350,450,600,800,850,1100,1300,2000 micron [milliJy]
        if (xsel .eq. 62) then
           l0= 350.
           zp= 1.d-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 63) then
           l0= 443.
           zp= 1.d-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 64) then
           l0= 647.
           zp= 1.d-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 65) then
           l0= 790.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 66) then
           l0= 850.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 67) then
           l0= 1102.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 68) then
           l0= 1259.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 69) then
           l0= 1921.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       70 SEST single-channel
        if (xsel .eq. 70) then
           l0= 1300.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       71-75 ESO mid-IR bolometer
        if (xsel .eq. 71) then
           l0= 9.68
           zp= 1.202d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 72) then
           l0= 8.36
           zp= 2.420d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 73) then
           l0= 9.79
           zp= 1.302d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 74) then
           l0= 12.82
           zp= 4.213d-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 75) then
           l0= 18.67
           zp= 1.016d-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c       76-81 PACS blue, green, red; SPIRE band 1,2,3
        if (xsel .eq. 76) then
           l0= 70.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 77) then
           l0= 100.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 78) then
           l0= 160.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 79) then
           l0= 250.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 80) then
           l0= 350.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 81) then
           l0= 500.
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c       Akari  IRC (82-84) MIR-S MIR-L FIS
        if (xsel .eq. 82) then
           l0= 2.4
           zp= 3.09d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 83) then
           l0= 3.2
           zp= 0.973d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 84) then
           l0= 4.1
           zp= 3.147d-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 85) then
           l0= 7.0
           zp= 4.49d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 86) then
           l0= 9.0
           zp= 1.93d-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 87) then
           l0= 11.0
           zp= 9.073d-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 88) then
           l0= 15.0
           zp= 2.043d-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 89) then
           l0= 18.0
           zp= 1.019d-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 90) then
           l0= 24.0
           zp= 4.010d-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 91) then
           l0= 65.
           zp= 6.72e-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 92) then
           l0= 90.
           zp= 2.24d-16

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 93) then
           l0= 140.
           zp= 2.71d-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 94) then
           l0= 160.
           zp= 1.73d-17

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     95-99 VISTA ZYJHK
        if (xsel .eq. 95) then
           l0= 0.876
           zp= 8.905d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 96) then
           l0= 1.018
           zp= 6.053d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 97) then
           l0= 1.246
           zp= 3.022d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 98) then
           l0= 1.631
           zp= 1.164d-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 99) then
           l0= 2.133
           zp= 4.476d-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     100-103 WISE 1,2,3,4 filters
        if (xsel .eq. 100) then
           l0= 3.353
           zp= 8.12e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 101) then
           l0= 4.603
           zp= 2.39e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 102) then
           l0= 11.56
           zp= 6.100e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 103) then
           l0= 22.09
           zp= 4.93e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     Photographic magnitudes 104-109
        if (xsel .eq. 104) then
           l0= 0.42
           zp= 5.69e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 105) then
           l0= 0.64
           zp= 2.21e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 106) then
           l0= 0.56
           zp= 3.33e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 107) then
           l0= 0.47
           zp= 5.31e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 108) then
           l0= 0.66
           zp= 2.08e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

        if (xsel .eq. 109) then
           l0= 0.83
           zp= 1.03e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     ESO VISIR 110-112
        if (xsel .eq. 110) then
           l0= 8.59
           zp= 2.110e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 111) then
           l0= 11.25
           zp= 7.296e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 112) then
           l0= 11.85
           zp= 6.148e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     COBE filters 3,4,5: 113-115; 1,2: 163-164
        if (xsel .eq. 163) then
           l0= 1.25
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 164) then
           l0= 2.2
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 113) then
           l0= 3.57
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 114) then
           l0= 4.93
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif
        if (xsel .eq. 115) then
           l0= 12.71
           zp= 1.e-19

           dum= 2.9979d-15/l0/l0* 10**mag
           flux= dum
           dum= 2.9979d-15/l0/l0* 10**(mag+emag)
           eflux= dum - flux
        endif

c     116-118 Hipparcos Hp, Tycho B,V 
        if (xsel .eq. 116) then
           l0= 0.5275
           zp= 3.916d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 117) then
           l0= 0.4203
           zp= 6.586d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 118) then
           l0= 0.5319
           zp= 3.949d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     119-123 CN TiO Halpha filters
        if (xsel .eq. 119) then
           l0= 0.770
           zp= 1.258d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 120) then
           l0= 0.770
           zp= 1.287d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 121) then
           l0= 0.810
           zp= 1.095d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 122) then
           l0= 0.816
           zp= 1.072d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 123) then
           l0= 0.6568
           zp= 1.870d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


c     124-125 GALEX
        if (xsel .eq. 124) then
           l0= 0.155
           zp= 6.74d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 125) then
           l0= 0.235
           zp= 4.36d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     126-127 MACHO
        if (xsel .eq. 126) then
           l0= 0.5225
           zp= 4.067d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 127) then
           l0= 0.6950
           zp= 1.8016d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     128-129 EROS
        if (xsel .eq. 128) then
           l0= 0.54
           zp= 3.468d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 129) then
           l0= 0.74
           zp= 1.4219d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     130-131 Cousins RI
        if (xsel .eq. 130) then
           l0= 0.6470
           zp= 2.137d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 131) then
           l0= 0.7865
           zp= 1.200d-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     132-162  JWST
        if (xsel .eq. 132) then
           l0= 0.70
           zp= 1.758e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 133) then
           l0= 0.90
           zp= 8.445e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 134) then
           l0= 1.15
           zp= 4.083e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 135) then
           l0= 1.50
           zp= 1.594e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 136) then
           l0= 2.00
           zp= 5.929e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 137) then
           l0= 2.77
           zp= 1.701e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 138) then
           l0= 3.56
           zp= 6.660e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 139) then
           l0= 4.44
           zp= 2.836e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 140) then
           l0= 5.60
           zp= 1.123e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 141) then
           l0= 7.70
           zp= 3.416e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 142) then
           l0= 10.0
           zp= 1.196e-12

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 143) then
           l0= 11.3
           zp= 7.193e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 144) then
           l0= 12.8
           zp= 4.430e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 145) then
           l0= 15.0
           zp= 2.318e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 146) then
           l0= 18.0
           zp= 1.145e-13

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 147) then
           l0= 21.0
           zp= 6.396e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 148) then
           l0= 25.5
           zp= 2.899e-14

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 149) then
           l0= 1.40
           zp= 2.024e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 150) then
           l0= 1.58
           zp= 1.33e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 151) then
           l0= 1.62
           zp= 1.198e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 152) then
           l0= 1.82
           zp= 7.877e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 153) then
           l0= 2.10
           zp= 4.862e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 154) then
           l0= 2.50
           zp= 2.489e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 155) then
           l0= 3.00
           zp= 1.257e-10

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 156) then
           l0= 3.35
           zp= 8.183e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 157) then
           l0= 3.60
           zp= 6.151e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 158) then
           l0= 3.80
           zp= 4.894e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 159) then
           l0= 4.10
           zp= 3.838e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 160) then
           l0= 4.30
           zp= 3.187e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 161) then
           l0= 4.60
           zp= 2.373e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 162) then
           l0= 4.80
           zp= 2.005e-11

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c     HST ACS
        if (xsel .eq. 165) then
           l0= 0.475
           zp= 5.260e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 166) then
           l0= 0.540
           zp= 3.788e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 167) then
           l0= 0.814
           zp= 1.127e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 168) then
           l0= 1.10
           zp= 4.311e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 169) then
           l0= 1.53
           zp= 1.454e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 170) then
           l0= 1.273
           zp= 2.760e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 171) then
           l0= 1.383
           zp= 2.104e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 172) then
           l0= 1.532
           zp= 1.460e-9

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif

c       GAIA G Bp Rp RVS
        if (xsel .eq. 173) then
           l0= 0.673
           zp= 2.182e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 174) then
           l0= 0.532
           zp= 3.891e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 175) then
           l0= 0.797
           zp= 1.218e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif
        if (xsel .eq. 176) then
           l0= 0.860
           zp= 0.9088e-8

           dum=10**(-0.4*mag)
           flux= zp*dum
           dum=10**(-0.4*(mag-emag))
           eflux= zp*dum - flux
        endif


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     convert to W/m2
        flux=  flux *l0
        eflux= eflux*l0

        return
        end

*23456789012345678901234567890123456789012345678901234567890123456789012

        Subroutine MLrate(MLR, aa, Psi, Vexp, rhod)

        IMPLICIT none

        integer nfit, ns
        parameter (ns= 2000, nfit= 4)

        double precision wavecut, lambda0, MLR
        double precision Psi, vexp, xx, Qt, sum, aa, ri,ro
        double precision afin(nfit), erra(nfit), rhod, Rst
        double precision av,teff,dist,chichi, bic, rinner
        double precision pp(nfit), Router(nfit), scl(nfit)
        double precision w1(ns), q1(ns), q2(ns), q3(ns)

        integer i,j,k,kk,l, nfl, ifinal, npow, npar, lst

	character*80 starname,absscafile
        character*200 modelatmos, cdum
        character c*1, cgrain*4, crho*251

	common/fnames/starname,modelatmos,absscafile,wavecut
        common/needed/rinner,router,pp,scl,av,teff,dist,npow
	common/final/afin,erra,chichi,bic,ifinal,npar


c     reference wavelength (micron) for the optical depth
c      hardcoded in the 'makedusty' subroutine
        lambda0= 0.55d0

c     dust-to-gas ratio
        psi= 0.005d0

c     expansion velocity (km/s)
        vexp= 10.d0

c     length of the crho string; CHANGE FORMAT BELOW!
        lst= 251

	open(10, file= absscafile)
        read(10,*) cdum
        read(10,'(a251)') crho
        read(10,*) cdum
        j=0
 200    j=j+1
        read(10, * ,err=201,end=201) w1(j), q1(j), q2(j)
        q3(j)= q1(j)+q2(j)
        if (w1(j) .lt. lambda0) kk= j 
	goto 200
 201	continue
        nfl= j-1
        close(10)

c     tau= 5.405e8 (MLrate Psi Q_l/a) / (Rst Vexp rho_d R_c) INTEGRAL ( 1./x^p dp)
c     with a in cm!

c     try to get  grain size and grain density from the input file
        write(88,*) '|',crho,'|'

c     first grain size; look for last 'a='
        do i=1,lst-1
           if (crho(i:i+1) .eq. 'a=') k= i
        enddo
        do j=k+1, lst-1
           c=crho(j:j)
           if ( (c.eq.'1').or.(c.eq.'2').or.(c.eq.'3').or.(c.eq.'4')
     c      .or.(c.eq.'5').or.(c.eq.'6').or.(c.eq.'7').or.(c.eq.'8')
     c      .or.(c.eq.'9').or.(c.eq.'0') ) then
              goto 400
           else
              l= i 
              goto 401
           endif
 400       continue
        enddo
 401    continue
        cgrain= crho(k+4: l-2)
        read( cgrain, '(f4.2)') aa

        write(88,*) 'k,l', k, l, cgrain, aa, aa

c     MG 12.02.2016 using LAST 'a=' did not work when olivines and AlOx of same, correct, size were mixed
c                   with cdeFe of a= 0.01 mu
c     determine grain size from the filename itself
        do i= 1,79
           if (absscafile(i:i+1) .eq. '_a') k= i
        enddo
        cgrain= absscafile(k+2: k+5)
        read( cgrain, '(f4.2)') aa

        write(88,*) 'k from name', k, cgrain, aa, aa

c     Now look for last 'rho='
        do i=1,lst-4
           if (crho(i:i+3) .eq. 'rho=') k= i
        enddo
        read( crho(k+5:k+8), '(f4.2)' ) rhod

        write(88,*) 'k ', crho(k+5:k+8), rhod

c     OVERWRITE IN CASE THAT INPUT FILE IS DIFFERENT
c        aa= 0.1d0
c        rhod= 3.0d0
c     OVERWRITE IN CASE THAT INPUT FILE IS DIFFERENT

c     get Q(abs+sca) at reference wvl
        xx= log( q3(kk+1) / q3(kk) ) / log( w1(kk+1) / w1(kk) )
        Qt= q3(kk)* (lambda0 / w1(kk))**xx
        write(88,*) kk, q3(kk+1),q3(kk), w1(kk+1),w1(kk)
        write(88,*) xx, Qt, npow
        
c     calculate the integral
        sum= 0.d0
        do i= 1,npow
           if (i.eq.1) pp(i)= afin(4)
           if (i.eq.1) then
              ri= 1.d0
              ro= router(i)
           else
              ri= router(i-1)
              ro= router(i)
           endif

           if (pp(i) .eq. 1.d0) then
              sum= sum+ log( ro / ri) 
           else
              sum= sum + ( ro**(1.d0-pp(i)) - ri**(1.d0-pp(i)) ) 
     c                       / (1.d0-pp(i)) * scl(i)
           endif
           write(88,*) 'sum ', i,ri,ro, pp(i),scl(i), sum
        enddo

c     stellar radius in solar units
        Rst= dsqrt(afin(1) / (Teff/5770.d0)**4.d0)


        write(88,*) afin(1), Teff, Rst
        write(88,*) afin(2), Rst,Vexp,rhod,Rinner,sum,Psi,Qt,aa

        MLR= afin(2)/ 5.405d12 *Rst *Vexp *rhod *Rinner /
     c      (sum *Psi *Qt /aa)

        return
        end
*23456789012345678901234567890123456789012345678901234567890123456789012

        Subroutine getFlux(flux,lam, wl,fl,nl)

c     from input Flux versus lambda, interpolate the flux in mJy at a given wavelength
        IMPLICIT none

        integer nl, i,j
        double precision wl(nl), fl(nl), lam, flux, xx

        j= -1
        do i= 1,nl
           if (wl(i) .gt. lam) then
              j= i
              goto 100
           endif
        enddo
 100    continue
        j= j-1

        if (j .eq. -1) then
           write(*,*) 'in getFlux is ', lam, ' out of range SED'
           STOP
        endif

        xx= log( fl(j+1) / fl(j) ) / log( wl(j+1) / wl(j) )
        Flux= fl(j)* (lam / wl(j))**xx 
c     fl is in W/m2/mu;  goto mJy
        Flux= Flux * lam*lam / 2.99792e-12 * 1000.
        write(87,*) lam, j, fl(j+1),fl(j), wl(j+1),wl(j), xx, Flux

        return
        end
*23456789012345678901234567890123456789012345678901234567890123456789012

c readcol,'rfor.psf.gauss',off,g870,g70,g100,g160,g250,g350

c plot, off,g870,xrange=[0,30]

c readcol,'rfor.psf',off1,b870,b70,b100,b160,b250,b350

c oplot, off1,b870

*23456789012345678901234567890123456789012345678901234567890123456789012

